import 'dart:convert';
import 'dart:io';

import 'package:dio/dio.dart';
import 'package:flutter_image_compress/flutter_image_compress.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leooappconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leoonetconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoodaoresultjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoobaseentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leooconfigentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoodataentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoodeductionentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoodetailentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoogiftentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoolanguageentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoomatentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoomyassetentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoorechargeentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leooroomentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoosignentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leootalkentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leootokenentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leootopentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoouploadentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoouserentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoouserlistentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoovideoendentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoovideolistentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leoonetjunpro/leooapphostjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoonetjunpro/leoohttpmanagerjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooproviderjunpro/leoouserproviderjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoomediautilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoovideoutilsjunpro.dart';
import 'package:path_provider/path_provider.dart';
import 'package:sp_util/sp_util.dart';
import 'package:video_compress/video_compress.dart';

class LeooMainDaoJunPro {
  static String? leooBaseTokenJunPro;
  static int? leooUserTypeJunPro;

  static leooInitUserInfoJunPro(LeooUserProviderJunPro userProvider) async {
    int? userId = SpUtil.getInt(LeooAppConfigJunPro.leooUserIdJunPro);
    LeooUserEntity? userEntity;
    if (userId != null) {
      userEntity = await LeooVideoUtilsJunPro.instance.userDbProvider
          .getUserInfo(userId);
      if (userEntity != null) {
        LeooMainDaoJunPro.leooBaseTokenJunPro = userEntity.token;
        LeooMainDaoJunPro.leooUserTypeJunPro = userEntity.userType;
        userProvider.setUserEntityNotify(userEntity);
      } else {
        userProvider.setUserEntityNotify(LeooUserEntity());
      }
    } else {
      userProvider.setUserEntityNotify(LeooUserEntity());
    }
    bool isLogin = userEntity != null &&
        SpUtil.getBool(LeooAppConfigJunPro.leooLoginJunPro)!;
    return LeooDataResultJunPro(userEntity, isLogin);
  }

  static Future<LeooDataResultJunPro> leooFromBaseJsonJunPro(map, String url,
      {bool cancel = false,
      bool token = true,
      bool query = false,
      bool card = true,
      String option = 'post'}) async {
    var headers = await leooRequestParamsJunPro();
    if (token) {
      if (leooBaseTokenJunPro?.isEmpty != false) {
        leooBaseTokenJunPro =
            SpUtil.getString(LeooAppConfigJunPro.leooTokenJunPro);
      }
      headers['token'] = leooBaseTokenJunPro;
    }
    var res = await httpManager.netFetch(
        url, map, headers, Options(method: option),
        cancel: cancel, query: query, card: card);
    if (res.result && res.data is Map) {
      var baseEntity = LeooBaseEntity.fromJson(res.data);
      if (baseEntity.status == 413) {
        LeooCommonUtilsJunPro.leooShowErrorToastJunPro(baseEntity);
        LeooNavigatorUtilsJunPro.leooGoSplash2JunPro();
        return LeooDataResultJunPro(baseEntity, false);
      }
      if (baseEntity.success) {
        return LeooDataResultJunPro(baseEntity.data, true);
      } else {
        return LeooDataResultJunPro(baseEntity, false);
      }
    }
    return LeooDataResultJunPro(res, false, dataError: true);
  }

  static Future<String> leooCompressImageJunPro(String image) async {
    try {
      File imageFile = File(image);
      int length = imageFile.lengthSync();
      int max = 1024 * 1024 * 2;
      if (length > max) {
        Directory tempDir = await getTemporaryDirectory();
        String targetPath =
            '${tempDir.absolute.path}/Image_leoo_${DateTime.now().millisecondsSinceEpoch}.jpg';
        File? result = await (FlutterImageCompress.compressAndGetFile(
            image, targetPath,
            quality: 100 - ((max / length) * 100).round()));
        if ((result?.lengthSync() ?? 0) > max) {
          return leooCompressImageJunPro(result!.path);
        }
        return result?.path ?? image;
      } else {
        return image;
      }
    } catch (e) {
      return image;
    }
  }

  static Future<String> leooCompressVideoJunPro(String video) async {
    try {
      File videoFile = File(video);
      int length = videoFile.lengthSync();
      int max = 1024 * 1024 * 10;
      if (length > max) {
        MediaInfo? mediaInfo = await VideoCompress.compressVideo(video);
        return mediaInfo?.path ?? video;
      } else {
        return video;
      }
    } catch (e) {
      return video;
    }
  }

  ///上传图片
  static Future<LeooDataResultJunPro> leooUploadJunPro(String imageUrl) async {
    String image = await leooCompressImageJunPro(imageUrl);
    FormData formData =
        FormData.fromMap({'file': MultipartFile.fromFileSync(image)});
    var res = await LeooMainDaoJunPro.leooFromBaseJsonJunPro(
        formData, LeooAppHostJunPro.leooUploadJunPro());
    if (res.result) {
      return LeooDataResultJunPro(res.data, true);
    }
    return res;
  }

  ///上传图片
  static Future<LeooDataResultJunPro> leooUploadListJunPro(
      List<String> list) async {
    int position = -1;
    next() async {
      position++;
      String imageUrl = list[position];
      if (!imageUrl.startsWith('http')) {
        String image = await leooCompressImageJunPro(imageUrl);
        FormData formData =
            FormData.fromMap({'file': MultipartFile.fromFileSync(image)});
        var res = await LeooMainDaoJunPro.leooFromBaseJsonJunPro(
            formData, LeooAppHostJunPro.leooUploadJunPro());
        if (res.result) {
          list[position] = res.data;
          if (position != list.length - 1) {
            return await next();
          }
          return LeooDataResultJunPro(list, true);
        }
        return res;
      } else if (position != list.length - 1) {
        return await next();
      }
      return LeooDataResultJunPro(list, true);
    }

    return await next();
  }

  ///上传视频
  static Future<LeooDataResultJunPro> leooUploadVideoJunPro(
      String videoUrl) async {
    if (!videoUrl.startsWith('http')) {
      String video = await leooCompressVideoJunPro(videoUrl);
      FormData formData =
          FormData.fromMap({'file': MultipartFile.fromFileSync(video)});
      var res = await LeooMainDaoJunPro.leooFromBaseJsonJunPro(
          formData, LeooAppHostJunPro.leooUploadVideoJunPro());
      if (res.result) {
        var entity = LeooUploadEntity.fromJson(res.data);
        return LeooDataResultJunPro(entity, true);
      }
      return res;
    }
    var entity = LeooUploadEntity();
    entity.videoPath = videoUrl;
    return LeooDataResultJunPro(entity, true);
  }

  static Future<LeooDataResultJunPro> leooConfigJunPro() async {
    Map<String, dynamic> other = {
      'version': LeooMediaUtilsJunPro.instance.packageInfo.version,
      'type': Platform.isAndroid ? 1 : 2,
      'pkgName': LeooNetConfigJunPro.leooPkgNameJunPro
    };
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooConfigJunPro(),
        token: false, option: 'get', card: false);
    if (res.result) {
      var entity = LeooConfigEntity.fromJson(res.data);
      return LeooDataResultJunPro(entity, true);
    }
    return res;
  }

  ///基本参数
  static Future<Map<String, dynamic>> leooRequestParamsJunPro() async {
    return {
      'appId': Platform.isAndroid
          ? LeooMediaUtilsJunPro.instance.androidDeviceInfo.androidId
          : LeooAppConfigJunPro.leooAppIdJunPro,
      'version': LeooMediaUtilsJunPro.instance.packageInfo.version,
      'packageName': LeooNetConfigJunPro.leooPkgNameJunPro,
      'deviceType': Platform.isAndroid ? 1 : 2
    };
  }

  ///更新本地数据库
  static leooUpdateUserInfoJunPro(LeooUserEntity userEntity) async {
    LeooVideoUtilsJunPro.instance.userDbProvider
        .insert(userEntity.id, jsonEncode(userEntity.toJson()));
    return userEntity;
  }

  static Future<LeooDataResultJunPro> leooUserLoginJunPro(
      LeooUserProviderJunPro userProvider,
      {String? nickname,
      String? header,
      String? thirdId}) async {
    Map<String, dynamic> other = {
      'thirdId':
          thirdId ?? SpUtil.getString(LeooAppConfigJunPro.leooThirdJunPro),
      'nickname': nickname ?? '',
      'header': header ?? '',
    };
    other.addAll(await leooRequestParamsJunPro());
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooUserLoginJunPro(),
        token: false);
    if (res.result) {
      var entity = LeooUserEntity.fromJson(res.data);
      SpUtil.putInt(LeooAppConfigJunPro.leooUserIdJunPro, entity.id!);
      LeooMainDaoJunPro.leooBaseTokenJunPro = entity.token;
      LeooMainDaoJunPro.leooUserTypeJunPro = entity.userType;
      SpUtil.putString(LeooAppConfigJunPro.leooTokenJunPro, entity.token ?? '');
      if (thirdId?.isEmpty == false) {
        SpUtil.putString(LeooAppConfigJunPro.leooThirdJunPro, thirdId ?? '');
      }
      var userEntity = await LeooVideoUtilsJunPro.instance.userDbProvider
          .getUserInfo(entity.id);
      entity.have = userEntity != null ? 1 : 0;
      userEntity = await leooUpdateUserInfoJunPro(entity);
      userProvider.setUserEntityNotify(userEntity!);
      return LeooDataResultJunPro(entity, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooUserInfoJunPro(
      LeooUserProviderJunPro userProvider) async {
    var res = await leooFromBaseJsonJunPro(
        null, LeooAppHostJunPro.leooUserInfoJunPro(),
        option: 'get');
    if (res.result) {
      var entity = LeooUserEntity.fromJson(res.data);
      SpUtil.putInt(LeooAppConfigJunPro.leooUserIdJunPro, entity.id!);
      LeooMainDaoJunPro.leooBaseTokenJunPro = entity.token;
      LeooMainDaoJunPro.leooUserTypeJunPro = entity.userType;
      SpUtil.putString(LeooAppConfigJunPro.leooTokenJunPro, entity.token ?? '');
      var userEntity = await LeooVideoUtilsJunPro.instance.userDbProvider
          .getUserInfo(entity.id);
      entity.have = userEntity != null ? 1 : 0;
      userEntity = await leooUpdateUserInfoJunPro(entity);
      userProvider.setUserEntityNotify(userEntity!);
      return LeooDataResultJunPro(entity, true);
    }
    return res;
  }

  static void leooOnlineHeartbeatJunPro(int status) {
    Map<String, dynamic> other = {'status': status};
    leooFromBaseJsonJunPro(other, LeooAppHostJunPro.leooOnlineHeartbeatJunPro(),
        query: true);
  }

  static Future<LeooDataResultJunPro> leooLoginUserByEmailJunPro(
      LeooUserProviderJunPro userProvider,
      String? email,
      String? password) async {
    Map<String, dynamic> other = {
      'email': email ?? '',
      'password': password ?? '',
    };
    other.addAll(await leooRequestParamsJunPro());
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooLoginUserByEmailJunPro(),
        token: false);
    if (res.result) {
      var entity = LeooUserEntity.fromJson(res.data);
      SpUtil.putInt(LeooAppConfigJunPro.leooUserIdJunPro, entity.id!);
      LeooMainDaoJunPro.leooBaseTokenJunPro = entity.token;
      LeooMainDaoJunPro.leooUserTypeJunPro = entity.userType;
      SpUtil.putString(LeooAppConfigJunPro.leooTokenJunPro, entity.token ?? '');
      var userEntity = await LeooVideoUtilsJunPro.instance.userDbProvider
          .getUserInfo(entity.id);
      entity.have = userEntity != null ? 1 : 0;
      userEntity = await leooUpdateUserInfoJunPro(entity);
      userProvider.setUserEntityNotify(userEntity!);
      return LeooDataResultJunPro(entity, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooRegistUserByEmailJunPro(
      LeooUserProviderJunPro userProvider,
      String? email,
      String? password) async {
    Map<String, dynamic> other = {
      'email': email ?? '',
      'password': password ?? '',
    };
    other.addAll(await leooRequestParamsJunPro());
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooRegistUserByEmailJunPro(),
        token: false);
    if (res.result) {
      var entity = LeooUserEntity.fromJson(res.data);
      SpUtil.putInt(LeooAppConfigJunPro.leooUserIdJunPro, entity.id!);
      LeooMainDaoJunPro.leooBaseTokenJunPro = entity.token;
      LeooMainDaoJunPro.leooUserTypeJunPro = entity.userType;
      SpUtil.putString(LeooAppConfigJunPro.leooTokenJunPro, entity.token ?? '');
      var userEntity = await LeooVideoUtilsJunPro.instance.userDbProvider
          .getUserInfo(entity.id);
      entity.have = userEntity != null ? 1 : 0;
      userEntity = await leooUpdateUserInfoJunPro(entity);
      userProvider.setUserEntityNotify(userEntity!);
      return LeooDataResultJunPro(entity, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooUpdateJunPro(
      LeooUserEntity userEntity, LeooUserProviderJunPro userProvider,
      [bool update = true]) async {
    Map<String, dynamic> other = userEntity.toJson();
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooUpdateJunPro());
    if (res.result) {
      var entity = LeooUserEntity.fromJson(res.data);
      if (update) {
        var userEntity = await LeooVideoUtilsJunPro.instance.userDbProvider
            .getUserInfo(entity.id);
        entity.have = userEntity != null ? 1 : 0;
        userEntity = await leooUpdateUserInfoJunPro(entity);
        userProvider.setUserEntityNotify(userEntity!);
      }
      return LeooDataResultJunPro(entity, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooUpdatePhotosJunPro(
      LeooUserEntity userEntity) async {
    Map<String, dynamic> other = {
      'lifePictures': userEntity.lifePictures ?? [],
    };
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooUpdatePhotosJunPro());
    if (res.result) {
      return LeooDataResultJunPro(res.data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooApplyBeAnchorJunPro(
      LeooUserEntity userEntity, LeooUserProviderJunPro userProvider) async {
    Map<String, dynamic> other = userEntity.toJson();
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooApplyBeAnchorJunPro());
    if (res.result) {
      return LeooDataResultJunPro(res.data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooFeedBackJunPro(String content) async {
    Map<String, dynamic> other = {'content': content};
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooFeedbackJunPro());
    if (res.result) {
      return LeooDataResultJunPro(res.data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooDeleteJunPro(String content) async {
    Map<String, dynamic> other = {'content': content};
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooDeleteJunPro());
    if (res.result) {
      return LeooDataResultJunPro(res.data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooAddBlacklistJunPro(int? userId,
      {String? nickname,
      int? age,
      int? gender,
      String? country,
      String? header,
      String? description}) async {
    Map<String, dynamic> other = {
      'userId': userId ?? 0,
      'nickname': nickname ?? '',
      'age': age ?? 0,
      'gender': gender ?? 0,
      'country': country ?? '',
      'header': header ?? '',
      'description': description ?? '',
    };
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooAddBlacklistJunPro());
    if (res.result) {
      return LeooDataResultJunPro(res.data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooCancelBlacklistJunPro(
      int? userId) async {
    Map<String, dynamic> other = {'userId': userId ?? 0};
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooCancelBlacklistJunPro());
    if (res.result) {
      return LeooDataResultJunPro(res.data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooListBlacklistJunPro(int page) async {
    Map<String, dynamic> other = {
      'page': page,
      'size': LeooAppConfigJunPro.leooListSizeJunPro,
    };
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooListBlacklistJunPro(),
        option: 'get');
    if (res.result) {
      var data = (res.data['data'] as List)
          .map((v) => LeooUserEntity.fromJson(v))
          .toList();
      return LeooDataResultJunPro(data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooReportJunPro(
      int? userId, String content) async {
    Map<String, dynamic> other = {
      'userId': userId ?? 0,
      'content': content,
    };
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooReportJunPro());
    if (res.result) {
      return LeooDataResultJunPro(res.data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooFollowingJunPro(int? userId,
      {String? nickname,
      int? age,
      int? gender,
      String? country,
      String? header,
      String? description}) async {
    Map<String, dynamic> other = {
      'userId': userId ?? 0,
      'nickname': nickname ?? '',
      'age': age ?? 0,
      'gender': gender ?? 0,
      'country': country ?? '',
      'header': header ?? '',
      'description': description ?? '',
    };
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooFollowingJunPro());
    if (res.result) {
      return LeooDataResultJunPro(res.data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooCancelFollowingJunPro(
      int? userId) async {
    Map<String, dynamic> other = {'userId': userId ?? 0};
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooCancelFollowingJunPro());
    if (res.result) {
      return LeooDataResultJunPro(res.data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooListFollowerJunPro(int page) async {
    Map<String, dynamic> other = {
      'page': page,
      'size': LeooAppConfigJunPro.leooListSizeJunPro,
    };
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooListFollowerJunPro(),
        option: 'get');
    if (res.result) {
      var data = (res.data['data'] as List)
          .map((v) => LeooUserEntity.fromJson(v))
          .toList();
      return LeooDataResultJunPro(data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooListFollowingJunPro(int page) async {
    Map<String, dynamic> other = {
      'page': page,
      'size': LeooAppConfigJunPro.leooListSizeJunPro,
    };
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooListFollowingJunPro(),
        option: 'get');
    if (res.result) {
      var data = (res.data['data'] as List)
          .map((v) => LeooUserEntity.fromJson(v))
          .toList();
      return LeooDataResultJunPro(data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooListFriendJunPro(int page) async {
    Map<String, dynamic> other = {
      'page': page,
      'size': LeooAppConfigJunPro.leooListSizeJunPro
    };
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooListFriendJunPro(),
        option: 'get');
    if (res.result) {
      var data = (res.data['data'] as List)
          .map((v) => LeooUserEntity.fromJson(v))
          .toList();
      return LeooDataResultJunPro(data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooCheckFollowersJunPro(
      int? userId) async {
    Map<String, dynamic> other = {'userId': userId};
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooCheckFollowersJunPro());
    if (res.result) {
      return LeooDataResultJunPro(res.data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooListMatchedJunPro(int page) async {
    Map<String, dynamic> other = {
      'page': page,
      'size': LeooAppConfigJunPro.leooListSizeJunPro
    };
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooListMatchedJunPro());
    if (res.result) {
      var data = (res.data['data'] as List)
          .map((v) => LeooTalkEntity.fromJson(v))
          .toList();
      return LeooDataResultJunPro(data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooListTalkedJunPro(int page) async {
    Map<String, dynamic> other = {
      'page': page,
      'size': LeooAppConfigJunPro.leooListSizeJunPro
    };
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooListTalkedJunPro());
    if (res.result) {
      var data = (res.data['data'] as List)
          .map((v) => LeooTalkEntity.fromJson(v))
          .toList();
      return LeooDataResultJunPro(data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooDeductionMessageJunPro(
      int? targetUserId) async {
    Map<String, dynamic> other = {'targetUserId': targetUserId};
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooDeductionMessageJunPro());
    if (res.result) {
      var entity = LeooDeductionEntity.fromJson(res.data);
      return LeooDataResultJunPro(entity, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooDeductionVideoJunPro(int? talkingId,
      {int? userId, int? matchingId}) async {
    Map<String, dynamic> other = {
      'userId': userId ?? 0,
      'talkingId': talkingId ?? 0,
      'matchingId': matchingId ?? 0
    };
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooDeductionVideoJunPro());
    if (res.result) {
      var entity = LeooDeductionEntity.fromJson(res.data);
      return LeooDataResultJunPro(entity, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooGiftListJunPro() async {
    Map<String, dynamic> other = {
      'page': 1,
      'size': LeooAppConfigJunPro.leooListSizeJunPro
    };
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooGiftListJunPro(),
        option: 'get');
    if (res.result) {
      var data = (res.data['data'] as List)
          .map((v) => LeooGiftEntity.fromJson(v))
          .toList();
      return LeooDataResultJunPro(data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooDeductionGiftJunPro(
      int? giftId, int? userId) async {
    Map<String, dynamic> other = {'giftId': giftId, 'userId': userId};
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooDeductionGiftJunPro());
    if (res.result) {
      var entity = LeooDeductionEntity.fromJson(res.data);
      return LeooDataResultJunPro(entity, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooCallEndJunPro(
      int? talkingId, int? type, int? rate) async {
    Map<String, dynamic> other = {
      'talkingId': talkingId ?? 0,
      'type': type ?? 0,
      'rate': rate ?? 0
    };
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooCallEndJunPro());
    if (res.result) {
      return LeooDataResultJunPro(res.data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooCallReportJunPro(
      int? talkingId, int? type) async {
    Map<String, dynamic> other = {
      'talkingId': talkingId ?? 0,
      'type': type ?? 0
    };
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooCallReportJunPro());
    if (res.result) {
      return LeooDataResultJunPro(res.data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooListJunPro(int page,
      {List<int>? userIds}) async {
    Map<String, dynamic> other = {
      'page': page,
      'size': LeooAppConfigJunPro.leooListSizeJunPro
    };
    if (userIds != null) {
      other['userIds'] = userIds;
    }
    var res =
        await leooFromBaseJsonJunPro(other, LeooAppHostJunPro.leooListJunPro());
    if (res.result) {
      var data = (res.data['data'] as List).map((v) {
        var item = LeooUserEntity.fromJson(v);
        LeooVideoUtilsJunPro.instance.userDbProvider
            .insert(item.id, jsonEncode(item.toJson()));
        return item;
      }).toList();
      return LeooDataResultJunPro(data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooDetailJunPro(int? userId) async {
    Map<String, dynamic> other = {'userId': userId ?? 0};
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooDetailJunPro(),
        option: 'get');
    if (res.result) {
      var entity = LeooUserEntity.fromJson(res.data);
      LeooVideoUtilsJunPro.instance.userDbProvider
          .insert(entity.id, jsonEncode(entity.toJson()));
      return LeooDataResultJunPro(entity, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooRtcTokenJunPro(int? userId, int type,
      {String? channelName}) async {
    Map<String, dynamic> other = {
      'userId': userId ?? 0,
      'type': type,
      'channelName': channelName ?? ''
    };
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooRtcTokenJunPro());
    if (res.result) {
      var entity = LeooTokenEntity.fromJson(res.data);
      return LeooDataResultJunPro(entity, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooRtmTokenJunPro() async {
    var res = await leooFromBaseJsonJunPro(
        null, LeooAppHostJunPro.leooRtmTokenJunPro());
    if (res.result) {
      var entity = LeooTokenEntity.fromJson(res.data);
      return LeooDataResultJunPro(entity, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooListConfigJunPro(
      [int first = 0]) async {
    Map<String, dynamic> other = {
      'type': Platform.isAndroid ? 1 : 2,
      'first': first,
      'pkgName': LeooNetConfigJunPro.leooPkgNameJunPro
    };
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooListConfigJunPro(),
        option: 'get');
    if (res.result) {
      var data = (res.data as List)
          .map((v) => LeooRechargeEntity.fromJson(v))
          .toList();
      return LeooDataResultJunPro(data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooCheckBillJunPro(String? token,
      {String? productId, String? googleToken}) async {
    Map<String, dynamic> other = {
      'pkgName': LeooNetConfigJunPro.leooPkgNameJunPro
    };
    String url;
    if (Platform.isAndroid) {
      url = LeooAppHostJunPro.leooCheckGoogleJunPro();
      other['token'] = token;
      other['productId'] = productId;
      other['packageName'] = LeooNetConfigJunPro.leooAppIdJunPro;
    } else {
      url = LeooAppHostJunPro.leooCheckBillJunPro();
      other['billNo'] = token;
    }
    var res = await leooFromBaseJsonJunPro(other, url);
    if (res.result) {
      var entity = LeooDeductionEntity.fromJson(res.data);
      return LeooDataResultJunPro(entity, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooCreateRoomJunPro(String? name,
      String? type, String? timeLength, String? imgUrl, int? userId,
      [int multiRoom = 0]) async {
    Map<String, dynamic> other = {
      'name': name,
      'type': type,
      'timeLength': timeLength,
      'imgUrl': imgUrl,
      'createdUserId': userId,
      'multiRoom': multiRoom,
    };
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooRoomsJunPro());
    if (res.result) {
      var entity = LeooRoomEntity.fromJson(res.data);
      return LeooDataResultJunPro(entity, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooRoomsJunPro(int page, String type,
      [int? userId, int? size]) async {
    Map<String, dynamic> other = {
      'page': page,
      'createdUserId': userId,
      'size': size ?? LeooAppConfigJunPro.leooListSizeJunPro,
      'type': type,
    };
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooRoomsJunPro(),
        option: 'get');
    if (res.result) {
      var data = (res.data['data'] as List)
          .map((v) => LeooRoomEntity.fromJson(v))
          .toList();
      return LeooDataResultJunPro(data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooDeleteRoomJunPro(int? id) async {
    var res = await leooFromBaseJsonJunPro(
        null, LeooAppHostJunPro.leooRoomsJunPro() + '/$id',
        option: 'delete');
    if (res.result) {
      return LeooDataResultJunPro(res.data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooLikeRoomJunPro(
      int? roomId, int type) async {
    Map<String, dynamic> other = {
      'roomId': roomId,
      'type': type,
    };
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooLikeRoomJunPro());
    if (res.result) {
      return LeooDataResultJunPro(res.data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooTodayViewJunPro() async {
    var res = await leooFromBaseJsonJunPro(
        null, LeooAppHostJunPro.leooTodayViewJunPro(),
        option: 'get');
    if (res.result) {
      return LeooDataResultJunPro(res.data, true);
    }
    return res;
  }

  ///签到信息
  static Future<LeooDataResultJunPro> leooSignInfoJunPro() async {
    var res = await leooFromBaseJsonJunPro(
        null, LeooAppHostJunPro.leooGetSignInfoJunPro(),
        option: 'get');
    if (res.result) {
      var entity = LeooSignEntity.fromJson(res.data);
      return LeooDataResultJunPro(entity, true);
    }
    return res;
  }

  ///签到
  static Future<LeooDataResultJunPro> leooSignRewardJunPro() async {
    var res = await leooFromBaseJsonJunPro(
        null, LeooAppHostJunPro.leooSignRewardJunPro());
    if (res.result) {
      var entity = LeooTokenEntity.fromJson(res.data);
      return LeooDataResultJunPro(entity, true);
    }
    return res;
  }

  ///排行榜
  static Future<LeooDataResultJunPro> leooTopListJunPro(
      int type, int days) async {
    Map<String, dynamic> other = {'days': days};
    var res = await leooFromBaseJsonJunPro(
        other,
        type == 1
            ? LeooAppHostJunPro.leooTopRichJunPro()
            : type == 2
                ? LeooAppHostJunPro.leooTopGifterJunPro()
                : LeooAppHostJunPro.leooTopCharmJunPro(),
        option: 'get');
    if (res.result) {
      var data =
          (res.data as List).map((v) => LeooTopEntity.fromJson(v)).toList();
      return LeooDataResultJunPro(data, true);
    }
    return res;
  }

  ///用户-zhubo列表
  static Future<LeooDataResultJunPro> leooUserAnchorListJunPro(
      int page, int orderType, int? languageId) async {
    Map<String, dynamic> other = {
      'page': page,
      'orderType': orderType,
      'languageId': languageId,
      'userType': LeooMainDaoJunPro.leooUserTypeJunPro == 0 ? 1 : 0
    };
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooUserAnchorListJunPro());
    if (res.result) {
      var data = (res.data['data'] as List)
          .map((v) => LeooUserListEntity.fromJson(v))
          .toList();
      return LeooDataResultJunPro(data, true);
    }
    return res;
  }

  //推荐列表
  static Future<LeooDataResultJunPro> leooListRecommendJunPro() async {
    var res = await leooFromBaseJsonJunPro(
        null, LeooAppHostJunPro.leooListRecommendAnchorJunPro(),
        option: 'get');
    if (res.result) {
      var data = (res.data as List)
          .map((v) => LeooUserListEntity.fromJson(v))
          .toList();
      return LeooDataResultJunPro(data, true);
    }
    return res;
  }

  static List<LeooLanguageEntity> leooLanguageListJunPro = [];

  ///语言列表
  static Future<LeooDataResultJunPro> leooGetLanguageListJunPro() async {
    if (leooLanguageListJunPro.isNotEmpty) {
      return LeooDataResultJunPro(leooLanguageListJunPro, true);
    }
    var res = await leooFromBaseJsonJunPro(
        null, LeooAppHostJunPro.leooLanguageListJunPro(),
        option: 'get');
    if (res.result) {
      leooLanguageListJunPro = (res.data as List)
          .map((v) => LeooLanguageEntity.fromJson(v))
          .toList();
      return LeooDataResultJunPro(leooLanguageListJunPro, true);
    }
    return res;
  }

  static List<LeooLanguageEntity> leooTagListJunPro = [];

  ///tag列表
  static Future<LeooDataResultJunPro> leooGetTagListJunPro() async {
    if (leooTagListJunPro.isNotEmpty) {
      return LeooDataResultJunPro(leooTagListJunPro, true);
    }
    var res = await leooFromBaseJsonJunPro(
        null, LeooAppHostJunPro.leooTagListJunPro(),
        option: 'get');
    if (res.result) {
      leooTagListJunPro = (res.data as List)
          .map((v) => LeooLanguageEntity.fromJson(v))
          .toList();
      return LeooDataResultJunPro(leooTagListJunPro, true);
    }
    return res;
  }

  ///列表
  static Future<LeooDataResultJunPro> leooVideoListJunPro(
      int type, int page) async {
    Map<String, dynamic> other = {
      'page': page,
      'packageName': LeooNetConfigJunPro.leooPkgNameJunPro,
    };
    var res = await leooFromBaseJsonJunPro(
        other,
        type == 1
            ? LeooAppHostJunPro.leooListVideoJunPro()
            : type == 2
                ? LeooAppHostJunPro.leooListFollowVideoJunPro()
                : type == 3
                    ? LeooAppHostJunPro.leooListMyVideoJunPro()
                    : LeooAppHostJunPro.leooListLikeVideoJunPro());
    if (res.result) {
      var data = (res.data['data'] as List)
          .map((v) => LeooVideoListEntity.fromJson(v))
          .toList();
      return LeooDataResultJunPro(data, true);
    }
    return res;
  }

  ///列表
  static Future<LeooDataResultJunPro> leooListVideoByUserIdJunPro(
      int? userId) async {
    Map<String, dynamic> other = {'userId': userId};
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooListVideoByUserIdJunPro());
    if (res.result) {
      var data = (res.data['data'] as List)
          .map((v) => LeooVideoListEntity.fromJson(v))
          .toList();
      return LeooDataResultJunPro(data, true);
    }
    return res;
  }

  ///data
  static Future<LeooDataResultJunPro> leooStatisticsJunPro(int type) async {
    Map<String, dynamic> other = {'type': type};
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooStatisticsJunPro());
    if (res.result) {
      var entity = LeooDataEntity.fromJson(res.data);
      return LeooDataResultJunPro(entity, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooListCommisionJunPro(
      int page, String? month) async {
    Map<String, dynamic> other = {'page': page, 'month': month};
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooListCommisionJunPro());
    if (res.result) {
      var data = (res.data['data'] as List)
          .map((v) => LeooDetailEntity.fromJson(v))
          .toList();
      return LeooDataResultJunPro(data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooListMethodJunPro() async {
    var res = await leooFromBaseJsonJunPro(
        null, LeooAppHostJunPro.leooListMethodJunPro(),
        option: 'get');
    if (res.result) {
      var data = (res.data as List)
          .map((v) => LeooLanguageEntity.fromJson(v))
          .toList();
      return LeooDataResultJunPro(data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooWithdrawRequestJunPro(
      int? withdrawPayeeMethodId,
      String? payeeName,
      String? payeeAccount,
      double? withdrawAmount) async {
    Map<String, dynamic> other = {
      'withdrawPayeeMethodId': withdrawPayeeMethodId,
      'payeeName': payeeName,
      'payeeAccount': payeeAccount,
      'withdrawAmount': withdrawAmount
    };
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooWithdrawRequestJunPro());
    if (res.result) {
      return LeooDataResultJunPro(res.data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooVideoPublishJunPro(
      String? videoUrl, String? videoCoverUrl, int? feeGold) async {
    Map<String, dynamic> other = {
      'videoUrl': videoUrl,
      'videoCoverUrl': videoCoverUrl,
      'feeType': feeGold == 0 ? 0 : 1,
      'feeGold': feeGold,
    };
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooVideoPublishJunPro());
    if (res.result) {
      return LeooDataResultJunPro(res.data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooVideoDeleteJunPro(
      int? videoId) async {
    Map<String, dynamic> other = {'videoId': videoId};
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooVideoDeleteJunPro(),
        option: 'delete');
    if (res.result) {
      return LeooDataResultJunPro(res.data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooVideoDetailJunPro(
      int? withdrawPayeeMethodId,
      String? payeeName,
      String? payeeAccount,
      double? withdrawAmount) async {
    Map<String, dynamic> other = {
      'withdrawPayeeMethodId': withdrawPayeeMethodId,
      'payeeName': payeeName,
      'payeeAccount': payeeAccount,
      'withdrawAmount': withdrawAmount
    };
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooVideoDetailJunPro());
    if (res.result) {
      return LeooDataResultJunPro(res.data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooVideoLikeJunPro(int? videoId) async {
    Map<String, dynamic> other = {'videoId': videoId};
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooVideoLikeJunPro(),
        query: true);
    if (res.result) {
      return LeooDataResultJunPro(res.data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooVideoUnLikeJunPro(
      int? videoId) async {
    Map<String, dynamic> other = {'videoId': videoId};
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooVideoUnLikeJunPro(),
        query: true);
    if (res.result) {
      return LeooDataResultJunPro(res.data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooVideoUnlockJunPro(
      int? videoId) async {
    Map<String, dynamic> other = {'videoId': videoId};
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooVideoUnlockJunPro(),
        query: true);
    if (res.result) {
      return LeooDataResultJunPro(res.data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooGetMyAssetJunPro() async {
    var res = await leooFromBaseJsonJunPro(
        null, LeooAppHostJunPro.leooGetMyAssetJunPro(),
        option: 'get');
    if (res.result) {
      var entity = LeooMyassetEntity.fromJson(res.data);
      return LeooDataResultJunPro(entity, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooReportFirstFrameJunPro(
      int? matchingId, int? talkingId) async {
    Map<String, dynamic> other = {
      'matchingId': matchingId,
      'talkingId': talkingId
    };
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooReportFirstFrameJunPro());
    if (res.result) {
      return LeooDataResultJunPro(res.data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooMatchingJunPro() async {
    var res = await leooFromBaseJsonJunPro(
        null, LeooAppHostJunPro.leooMatchingJunPro());
    if (res.result) {
      var entity = LeooMatEntity.fromJson(res.data);
      return LeooDataResultJunPro(entity, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooFreeVideoJunPro(int? userId) async {
    Map<String, dynamic> other = {'userId': userId ?? 0};
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooFreeVideoJunPro(),
        option: 'get');
    if (res.result) {
      if (res.data != null) {
        var entity = LeooVideoListEntity.fromJson(res.data);
        return LeooDataResultJunPro(entity, true);
      } else {
        return LeooDataResultJunPro(null, false);
      }
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooOperateJunPro(
      int? matchingId, int operType) async {
    Map<String, dynamic> other = {
      'matchingId': matchingId,
      'operType': operType
    };
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooOperateJunPro());
    if (res.result) {
      var entity = LeooTokenEntity.fromJson(res.data);
      return LeooDataResultJunPro(entity, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooInitCallJunPro(int? targetUserId,
      [int check = 1]) async {
    Map<String, dynamic> other = {
      'targetUserId': targetUserId,
      'anchorCallUserBalanceCheck': check
    };
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooInitCallJunPro());
    if (res.result) {
      var entity = LeooMatEntity.fromJson(res.data);
      return LeooDataResultJunPro(entity, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooReviewScoreJunPro(
      int? targetUserId, int? talkingId, double? score) async {
    Map<String, dynamic> other = {
      'targetUserId': targetUserId,
      'talkingId': talkingId,
      'score': score
    };
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooReviewScoreJunPro());
    if (res.result) {
      return LeooDataResultJunPro(res.data, true);
    }
    return res;
  }

  static Future<LeooDataResultJunPro> leooTalkingInfoJunPro(
      int? talkingId) async {
    Map<String, dynamic> other = {'talkingId': talkingId};
    var res = await leooFromBaseJsonJunPro(
        other, LeooAppHostJunPro.leooTalkingInfoJunPro());
    if (res.result) {
      var entity = LeooVideoEndEntity.fromJson(res.data);
      return LeooDataResultJunPro(entity.totalTalkingTimeLength ?? 0, true);
    }
    return res;
  }
}
