import 'dart:async';
import 'dart:io';

import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leoonetconfigjunpro.dart';
import 'package:sqflite/sqflite.dart';

///数据库管理
class LeooSqlManagerJunPro {
  static const leooVERSIONJunPro = 1;

  static String leooNameDbJunPro =
      'flutter_${LeooNetConfigJunPro.leooPkgNameJunPro}.db';

  static Database? leooDatabaseJunPro;

  ///初始化
  static leooInitJunPro() async {
    // open the database
    var databasesPath = await getDatabasesPath();
//    var userRes = await UserDao.getUserInfoLocal();
    String dbName = leooNameDbJunPro;
//    if(userRes != null && userRes.result) {
//      UserEntity user = userRes.data;
//      if(user != null && user.login != null) {
//        dbName = user.login + "_" + _NAME;
//      }
//    }
    String path = databasesPath + dbName;
    if (Platform.isIOS) path = databasesPath + '/' + dbName;
    leooDatabaseJunPro = await openDatabase(path, version: leooVERSIONJunPro,
        onCreate: (Database db, int version) async {
      // When creating the db, create the table
      //await db.execute("CREATE TABLE Test (id INTEGER PRIMARY KEY, name TEXT, value INTEGER, num REAL)");
    }, onUpgrade: (Database db, int oldVersion, int newVersion) async {
      if (newVersion == 2) {
        await db.execute('alter table UserInfo add have integer');
      }
    });
  }

  ///表是否存在
  static leooIsTableExitsJunPro(String tableName) async {
    await leooGetCurrentDatabaseJunPro();
    var res = await leooDatabaseJunPro!.rawQuery(
        "select * from Sqlite_master where type = 'table' and name = '$tableName'");
    return res.isNotEmpty;
  }

  ///获取当前数据库对象
  static Future<Database> leooGetCurrentDatabaseJunPro() async {
    if (leooDatabaseJunPro == null) await leooInitJunPro();
    return leooDatabaseJunPro!;
  }

  ///关闭
  static leooCloseJunPro() {
    leooDatabaseJunPro?.close();
    leooDatabaseJunPro = null;
  }
}
