import 'dart:async';

///数据库表
import 'package:leoo_junpro/leooflagjunpro/leoodbjunpro/leoosqlmanagerjunpro.dart';
import 'package:meta/meta.dart';
import 'package:sqflite/sqflite.dart';

///基类
abstract class LeooBaseDbProviderJunPro {
  bool isTableExits = false;

  tableSqlString();

  tableName();

  tableBaseString(String name, String columnId) {
    return '''
        create table $name (
        $columnId integer primary key autoincrement,
      ''';
  }

  Future<Database> getDataBase() async {
    return await open();
  }

  @mustCallSuper
  prepare(name, String createSql) async {
    isTableExits = await LeooSqlManagerJunPro.leooIsTableExitsJunPro(name);
    if (!isTableExits) {
      Database db = await LeooSqlManagerJunPro.leooGetCurrentDatabaseJunPro();
      return await db.execute(createSql);
    }
  }

  @mustCallSuper
  open() async {
    if (!isTableExits) await prepare(tableName(), tableSqlString());
    return await LeooSqlManagerJunPro.leooGetCurrentDatabaseJunPro();
  }
}
