import 'dart:convert';

import 'package:collection/collection.dart';
import 'package:leoo_junpro/generated/json/base/json_field.dart';
import 'package:leoo_junpro/generated/json/leoouserentity.g.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoolanguageentity.dart';

@JsonSerializable()
class LeooUserEntity {
  factory LeooUserEntity.fromJson(Map<String, dynamic> json) =>
      $LeooUserEntityFromJson(json);

  Map<String, dynamic> toJson() => $LeooUserEntityToJson(this);

  LeooUserEntity(
      {this.id,
      this.email,
      this.nickname,
      this.age,
      this.gender,
      this.country,
      this.header,
      this.albums,
      this.lifePictures,
      this.description,
      this.following,
      this.followTime,
      this.chatStatus,
      this.weight,
      this.weightUnit,
      this.height,
      this.heightUnit,
      this.lifeStyle,
      this.experience,
      this.cupSize,
      this.languageIds,
      this.tagIds,
      this.contact,
      this.userType,
      this.brokerType,
      this.brokerCode,
      this.reviewScore,
      this.brokerRate,
      this.anchorRate,
      this.talkingGoldPerMin,
      this.anchorCheckStatus,
      this.token,
      this.amount,
      this.commissionAmount,
      this.freeNumber,
      this.followingNumber,
      this.followerNumber,
      this.likesNumber,
      this.have,
      this.inviteCode});

  int? id;
  String? email;
  String? nickname;
  int? age;
  int? gender;
  String? country;
  String? header;
  List<String>? albums;
  List<String>? lifePictures;
  String? description;
  int? following;
  int? followTime;
  int? chatStatus;
  String? birthday;
  int? weight;
  int? weightUnit;
  int? height;
  int? heightUnit;
  int? lifeStyle;
  int? experience;
  int? cupSize;
  List<int>? languageIds;
  List<int>? tagIds;
  LeooContacts? contact;

  //用户类型：0普通用户、1自有主播、2三方主播
  int? userType;

  //主播审核状态 0未申请、1申请驳回、2申请中、3申请成功
  int? anchorCheckStatus;

  //经纪人类型(0不是经纪人；1经纪人
  int? brokerType;
  String? brokerCode;
  double? reviewScore;
  double? brokerRate;
  double? anchorRate;
  int? talkingGoldPerMin;
  String? token;
  int? amount;
  double? commissionAmount;
  int? freeNumber;
  int? followingNumber;
  int? followerNumber;
  int? likesNumber;
  int? have;
  String? inviteCode;

  //sh
  String? musicType;

  String getNameAge() {
    if (age != null) {
      return (nickname ?? '') + ',$age';
    } else {
      return nickname ?? '';
    }
  }

  String getLanguageStr(List<LeooLanguageEntity> languageList) {
    String str = '';
    languageIds?.forEach((id) {
      LeooLanguageEntity? item =
          languageList.firstWhereOrNull((element) => id == element.id);
      if (item != null) {
        if (str == '') {
          str = item.enName ?? '';
        } else {
          str = str + ';' + (item.enName ?? '');
        }
      }
    });
    return str;
  }
}

@JsonSerializable()
class LeooContacts {
  int? contactType;
  String? contactContent;

  LeooContacts();

  factory LeooContacts.fromJson(Map<String, dynamic> json) =>
      $LeooContactsFromJson(json);

  Map<String, dynamic> toJson() => $LeooContactsToJson(this);

  @override
  String toString() {
    return jsonEncode(this);
  }
}
