import 'package:dio/dio.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leoonetconfigjunpro.dart';

///Log 拦截器
class LeooLogsInterceptorsJunPro extends InterceptorsWrapper {
  @override
  onRequest(RequestOptions options, RequestInterceptorHandler handler) async {
    LeooNetConfigJunPro.leooPrintLogJunPro('请求url: ${options.path}');
    LeooNetConfigJunPro.leooPrintLogJunPro(
        '请求头: ' + options.headers.toString());
    if (options.data != null) {
      LeooNetConfigJunPro.leooPrintLogJunPro(
          '请求参数: ' + options.data.toString());
    }
    if (options.queryParameters.isNotEmpty) {
      LeooNetConfigJunPro.leooPrintLogJunPro(
          '请求参数: ' + options.queryParameters.toString());
    }
    return super.onRequest(options, handler);
  }

  @override
  onResponse(Response response, ResponseInterceptorHandler handler) async {
    LeooNetConfigJunPro.leooPrintLogJunPro('返回参数: ' + response.toString());
    return super.onResponse(response, handler);
  }

  @override
  onError(DioError err, ErrorInterceptorHandler handler) async {
    LeooNetConfigJunPro.leooPrintLogJunPro('请求异常: ' + err.toString());
    LeooNetConfigJunPro.leooPrintLogJunPro(
        '请求异常信息: ' + (err.response ?? '').toString());
    return super.onError(err, handler);
  }
}
