import 'dart:convert';

import 'package:dio/dio.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leoonetconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoonetjunpro/leoocodejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoonetjunpro/leooresultdatajunpro.dart';

///Response拦截器
class LeooResponseInterceptorsJunPro extends InterceptorsWrapper {
  @override
  onResponse(Response response, ResponseInterceptorHandler handler) async {
    try {
      if (response.data is String && response.data[0] == '{') {
        try {
          response.data = jsonDecode(response.data);
        } catch (err) {
          LeooNetConfigJunPro.leooPrintLogJunPro(err);
        }
      }
      if (response.statusCode == 200 || response.statusCode == 201) {
        response.data = LeooResultDataJunPro(
            response.data, true, LeooCodeJunPro.leooSuccessJunPro,
            headers: response.headers);
      }
    } catch (e) {
      LeooNetConfigJunPro.leooPrintLogJunPro(
          e.toString() + response.requestOptions.path);
      response.data = LeooResultDataJunPro(
          response.data, false, response.statusCode,
          headers: response.headers);
    }
    return super.onResponse(response, handler);
  }
}
