import 'package:flutter/material.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leooappconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:sp_util/sp_util.dart';

class LeooThemeProviderJunPro extends ChangeNotifier {
  void setLocale(int locale) {
    SpUtil.putInt(LeooAppConfigJunPro.leooLocaleJunPro, locale);
    notifyListeners();
  }

  int getLocale() {
    return SpUtil.getInt(LeooAppConfigJunPro.leooLocaleJunPro)!;
  }

  ThemeData getTheme() {
    return ThemeData.dark().copyWith(
      primaryColor: LeooColorsJunPro.leooAppJunPro,
      dialogBackgroundColor: LeooColorsJunPro.leooPopBgJunPro,
      backgroundColor: LeooColorsJunPro.leooBgJunPro,
      scaffoldBackgroundColor: LeooColorsJunPro.leooBgJunPro,
      bottomAppBarColor: LeooColorsJunPro.leooBgJunPro,
      highlightColor: Colors.white.withOpacity(.2),
      splashColor: Colors.white.withOpacity(.2),
      textSelectionTheme: TextSelectionThemeData(
        cursorColor: LeooColorsJunPro.leooAppJunPro,
        selectionColor: LeooColorsJunPro.leooAppJunPro,
        selectionHandleColor: LeooColorsJunPro.leooAppJunPro,
      ),
    );
  }
}
