import 'dart:async';
import 'dart:core';

import 'package:collection/collection.dart';
import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:flutter_spinkit/flutter_spinkit.dart';
import 'package:im_flutter_sdk/im_flutter_sdk.dart';
import 'package:image_picker/image_picker.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leooappconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leoonetconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoomaindaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoorechargeentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoosignentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooeventjunpro/leooindexjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooeventjunpro/leoomaineventjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooproviderjunpro/leoouserproviderjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoomediautilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoorechargeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoobuttonwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leootextwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoowidgetjunpro/leoolivetextwidgetjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoomainjunpro/leoomainjunpro.dart';

//单例的公共类-弹窗
class LeooDialogUtilsJunPro {
  factory LeooDialogUtilsJunPro() => _getInstance();

  static LeooDialogUtilsJunPro get instance => _getInstance();
  static LeooDialogUtilsJunPro? _instance;

  LeooDialogUtilsJunPro._internal();

  static LeooDialogUtilsJunPro _getInstance() {
    _instance ??= LeooDialogUtilsJunPro._internal();
    return _instance!;
  }

  Future showLoadingDialog(BuildContext context) {
    FocusScope.of(context).unfocus();
    return LeooNavigatorUtilsJunPro.leooShowBaseDialogJunPro(context,
        name: 'showLoadingDialog', dismiss: LeooNetConfigJunPro.leooDeBugJunPro,
        builder: (BuildContext showContext) {
      return WillPopScope(
        onWillPop: () => Future.value(false),
        child: Center(
          child: Container(
            width: 120.w,
            height: 120.w,
            decoration: BoxDecoration(
              color: LeooColorsJunPro.leooPopBgJunPro,
              borderRadius: BorderRadius.all(Radius.circular(10)),
            ),
            child: SpinKitFadingCircle(
              color: LeooColorsJunPro.leooAppJunPro,
              size: 30.w,
            ),
          ),
        ),
      );
    });
  }

  Future showCustomDialog(BuildContext context,
      {String? title,
      String? content,
      String? left,
      String? right,
      bool showLeft = true,
      bool dismiss = true}) {
    FocusScope.of(context).unfocus();
    return LeooNavigatorUtilsJunPro.leooShowBaseDialogJunPro(
      context,
      dismiss: dismiss,
      name: 'showCustomDialog',
      builder: (BuildContext showContext) {
        return Center(
          child: Container(
            width: 1.sw - 30.w,
            decoration: BoxDecoration(
              color: LeooColorsJunPro.leooPopBgJunPro,
              borderRadius: BorderRadius.all(Radius.circular(30)),
            ),
            padding: EdgeInsets.fromLTRB(20.w, 20.w, 20.w, 20.w),
            child: Column(
              mainAxisSize: MainAxisSize.min,
              children: <Widget>[
                if (title?.isEmpty == false)
                  Text(
                    title ?? '',
                    style: LeooTextJunPro.leooGetTextStyleJunPro(
                        24, FontWeight.bold),
                    textAlign: TextAlign.center,
                  ),
                SizedBox(height: 10.w),
                Text(
                  content ?? '',
                  style: LeooTextJunPro.leooGetTextStyleJunPro(
                      20, FontWeight.bold),
                  textAlign: TextAlign.center,
                ),
                SizedBox(height: 30.w),
                showLeft
                    ? Row(
                        children: <Widget>[
                          Expanded(
                            child: LeooButtonWidgetJunPro(
                              left ?? S.of(context).appCancel,
                              LeooTextJunPro.leooGetTextStyleAppJunPro(
                                  20, FontWeight.bold),
                              shape: RoundedRectangleBorder(
                                borderRadius:
                                    const BorderRadius.all(Radius.circular(20)),
                                side: BorderSide(
                                  color: LeooColorsJunPro.leooAppJunPro,
                                  width: 2.w,
                                ),
                              ),
                              onPressed:
                                  LeooNavigatorUtilsJunPro.leooDebounceJunPro(
                                      () {
                                Navigator.pop(context);
                              }),
                            ),
                          ),
                          SizedBox(width: 15.w),
                          Expanded(
                            child: LeooButtonWidgetJunPro(
                              right ?? S.of(context).appDone,
                              LeooTextJunPro.leooGetTextStyleJunPro(
                                  20, FontWeight.bold),
                              color: LeooColorsJunPro.leooAppJunPro,
                              colorRight: LeooColorsJunPro.leooApp2JunPro,
                              shape: const RoundedRectangleBorder(
                                borderRadius:
                                    BorderRadius.all(Radius.circular(20)),
                              ),
                              onPressed:
                                  LeooNavigatorUtilsJunPro.leooDebounceJunPro(
                                      () {
                                Navigator.pop(context, true);
                              }),
                            ),
                          ),
                        ],
                      )
                    : LeooButtonWidgetJunPro(
                        right ?? S.of(context).appDone,
                        LeooTextJunPro.leooGetTextStyleJunPro(
                            20, FontWeight.bold),
                        color: LeooColorsJunPro.leooAppJunPro,
                        colorRight: LeooColorsJunPro.leooApp2JunPro,
                        shape: const RoundedRectangleBorder(
                          borderRadius: BorderRadius.all(Radius.circular(10)),
                        ),
                        onPressed:
                            LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                          Navigator.pop(context, true);
                        }),
                      ),
              ],
            ),
          ),
        );
      },
    );
  }

  Future showImageCustomDialog(BuildContext context, Widget image,
      {String? content,
      String? left,
      String? right,
      bool showLeft = true,
      bool dismiss = true}) {
    FocusScope.of(context).unfocus();
    return LeooNavigatorUtilsJunPro.leooShowBaseDialogJunPro(
      context,
      dismiss: dismiss,
      name: 'showImageCustomDialog',
      builder: (BuildContext showContext) {
        return Center(
          child: Container(
            width: 1.sw - 30.w,
            decoration: BoxDecoration(
              color: LeooColorsJunPro.leooPopBgJunPro,
              borderRadius: BorderRadius.all(Radius.circular(30)),
            ),
            padding: EdgeInsets.all(20.w),
            child: Column(
              mainAxisSize: MainAxisSize.min,
              children: <Widget>[
                SizedBox(height: 10.w),
                image,
                SizedBox(height: 10.w),
                Text(
                  content ?? '',
                  style: LeooTextJunPro.leooGetTextStyleJunPro(
                      16, FontWeight.bold),
                  textAlign: TextAlign.center,
                ),
                SizedBox(height: 20.w),
                showLeft
                    ? Row(
                        children: <Widget>[
                          Expanded(
                            child: LeooButtonWidgetJunPro(
                              left ?? S.of(context).appCancel,
                              LeooTextJunPro.leooGetTextStyleAppJunPro(
                                  20, FontWeight.bold),
                              shape: RoundedRectangleBorder(
                                borderRadius:
                                    const BorderRadius.all(Radius.circular(20)),
                                side: BorderSide(
                                  color: LeooColorsJunPro.leooAppJunPro,
                                  width: 2.w,
                                ),
                              ),
                              onPressed:
                                  LeooNavigatorUtilsJunPro.leooDebounceJunPro(
                                      () {
                                Navigator.pop(context);
                              }),
                            ),
                          ),
                          SizedBox(width: 15.w),
                          Expanded(
                            child: LeooButtonWidgetJunPro(
                              right ?? S.of(context).appSure,
                              LeooTextJunPro.leooGetTextStyleJunPro(
                                  20, FontWeight.bold),
                              color: LeooColorsJunPro.leooAppJunPro,
                              colorRight: LeooColorsJunPro.leooApp2JunPro,
                              shape: const RoundedRectangleBorder(
                                borderRadius:
                                    BorderRadius.all(Radius.circular(20)),
                              ),
                              onPressed:
                                  LeooNavigatorUtilsJunPro.leooDebounceJunPro(
                                      () {
                                Navigator.pop(context, true);
                              }),
                            ),
                          ),
                        ],
                      )
                    : LeooButtonWidgetJunPro(
                        right ?? S.of(context).appSure,
                        LeooTextJunPro.leooGetTextStyleJunPro(
                            20, FontWeight.bold),
                        color: LeooColorsJunPro.leooAppJunPro,
                        colorRight: LeooColorsJunPro.leooApp2JunPro,
                        shape: const RoundedRectangleBorder(
                          borderRadius: BorderRadius.all(Radius.circular(20)),
                        ),
                        onPressed:
                            LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                          Navigator.pop(context, true);
                        }),
                      ),
              ],
            ),
          ),
        );
      },
    );
  }

  ///列表item dialog
  static Future leooShowCommitOptionDialogJunPro(
      BuildContext context, List<String> commitMaps, String title, String item,
      {String name = 'LeooShowCommitOptionDialogJunPro', String? okTip}) {
    FocusScope.of(context).unfocus();
    return LeooNavigatorUtilsJunPro.leooShowBaseDialogJunPro(context,
        dismiss: true, name: name, builder: (BuildContext showContext) {
      return StatefulBuilder(builder: (showContext, showState) {
        return Center(
          child: Container(
            width: 1.sw - 30.w,
            decoration: BoxDecoration(
                color: LeooColorsJunPro.leooPopBgJunPro,
                borderRadius: BorderRadius.circular(30)),
            child: Column(
              mainAxisSize: MainAxisSize.min,
              children: [
                SizedBox(height: 10.w),
                Row(
                  children: [
                    SizedBox(width: 60.w),
                    Expanded(
                      child: Text(
                        title,
                        style: LeooTextJunPro.leooGetTextStyleJunPro(
                            20, FontWeight.bold),
                        textAlign: TextAlign.center,
                      ),
                    ),
                    IconButton(
                      padding: const EdgeInsets.all(0),
                      icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                          LeooIconsJunPro.leooPopCloseJunPro,
                          width: 30.w,
                          height: 30.w),
                      iconSize: 30.w,
                      onPressed:
                          LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                        Navigator.pop(context);
                      }),
                    ),
                    SizedBox(width: 10.w),
                  ],
                ),
                SizedBox(
                  height: .5.sh,
                  child: ListView.builder(
                    physics: const BouncingScrollPhysics(),
                    itemCount: commitMaps.length,
                    shrinkWrap: true,
                    itemBuilder: (BuildContext itemContext, int index) {
                      return LeooButtonWidgetJunPro(
                        commitMaps[index],
                        LeooTextJunPro.leooGetTextStyleJunPro(
                            16, FontWeight.bold),
                        mainAxisAlignment: MainAxisAlignment.spaceBetween,
                        iconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                            item == commitMaps[index]
                                ? LeooIconsJunPro.leooPopSelectOkJunPro
                                : LeooIconsJunPro.leooPopSelectJunPro,
                            width: 24.w,
                            height: 24.w),
                        padding: EdgeInsets.all(20.w),
                        right: true,
                        textExpanded: true,
                        onPressed:
                            LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                          item = commitMaps[index];
                          showState(() {});
                        }),
                      );
                    },
                  ),
                ),
                Padding(
                  padding: EdgeInsets.fromLTRB(20.w, 15.w, 20.w, 20.w),
                  child: LeooButtonWidgetJunPro(
                    okTip ?? S.of(context).appSubmit,
                    LeooTextJunPro.leooGetTextStyleJunPro(20, FontWeight.bold),
                    color: LeooColorsJunPro.leooAppJunPro,
                    colorRight: LeooColorsJunPro.leooApp2JunPro,
                    shape: const RoundedRectangleBorder(
                      borderRadius: BorderRadius.all(Radius.circular(20)),
                    ),
                    onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                      Navigator.pop(context, item);
                    }),
                  ),
                ),
              ],
            ),
          ),
        );
      });
    });
  }

  //获取麦克风和相机-通话中使用
  void showPermissionDialog(BuildContext context, back) async {
    LeooMediaUtilsJunPro.instance.requestPermissions(context).then((value) {
      back.call(value);
    });
  }

  void showPermissionDialogIndex(BuildContext context, back, int index) async {
    LeooMediaUtilsJunPro.instance
        .requestPermissions(context, chat: false, index: index)
        .then((value) {
      back.call(true);
    });
  }

  void showImageView(BuildContext context, callback,
      {bool multi = false}) async {
    showItemBottomList(
            context,
            [
              S.of(context).informationCamera,
              S.of(context).informationPhoto,
            ],
            name: 'showImageView')
        .then((value) async {
      if (value != null) {
        if (await LeooMediaUtilsJunPro.instance
                .grantedPermissions(context, chat: false, index: value) ==
            true) {
          showImagePicker(context, value, callback, multi: multi);
        } else {
          showPermissionDialogIndex(context, (value2) {
            if (value2) {
              showImagePicker(context, value, callback, multi: multi);
            }
          }, value);
        }
      }
    });
  }

  void showImagePicker(BuildContext context, int index, callback,
      {bool multi = false}) async {
    if (index == 0) {
      XFile? image = await ImagePicker()
          .pickImage(source: ImageSource.camera)
          .catchError((err) {
        LeooCommonUtilsJunPro.leooShowCustomToastJunPro(err.message);
      });
      if (image != null) {
        if (image.path.contains(' ')) {
          LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
              S.of(context).perPicErrorFormat);
          return;
        }
        callback?.call([image.path]);
      }
    } else {
      if (multi) {
        List<XFile>? image =
            await ImagePicker().pickMultiImage().catchError((err) {
          LeooCommonUtilsJunPro.leooShowCustomToastJunPro(err.message);
        });
        if (image?.isEmpty == false) {
          if (image!
                  .firstWhereOrNull((element) => element.path.contains(' ')) !=
              null) {
            LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
                S.of(context).perPicError);
            return;
          }
          callback?.call(image.map((value) => value.path).toList());
        }
      } else {
        XFile? image = await ImagePicker()
            .pickImage(source: ImageSource.gallery)
            .catchError((err) {
          LeooCommonUtilsJunPro.leooShowCustomToastJunPro(err.message);
        });
        if (image != null) {
          if (image.path.contains(' ')) {
            LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
                S.of(context).perPicError);
            return;
          }
          callback?.call([image.path]);
        }
      }
    }
  }

  void showPickedView(BuildContext context) {
    FocusScope.of(context).unfocus();
    LeooNavigatorUtilsJunPro.leooShowBaseDialogJunPro(context,
        name: 'showPickedView', builder: (BuildContext showContext) {
      return SizedBox(width: 1.sw, height: 1.sh);
    });
  }

  Future showItemBottomList(BuildContext context, List<String> itemList,
      {List<String>? iconList, String? headImage, String? name}) {
    FocusScope.of(context).unfocus();
    return showModalBottomSheet(
      context: context,
      backgroundColor: Colors.transparent,
      routeSettings: RouteSettings(name: name ?? 'showItemBottomList'),
      builder: (BuildContext showContext) {
        return SafeArea(
          maintainBottomViewPadding: true,
          child: Padding(
            padding: EdgeInsets.all(15.w),
            child: Column(
              mainAxisSize: MainAxisSize.min,
              children: <Widget>[
                ListView.separated(
                  shrinkWrap: true,
                  physics: const BouncingScrollPhysics(),
                  itemCount: itemList.length,
                  separatorBuilder: (BuildContext context, int index) {
                    return SizedBox(height: 5.w);
                  },
                  itemBuilder: (BuildContext itemContext, int index) {
                    return LeooButtonWidgetJunPro(
                      itemList[index],
                      LeooTextJunPro.leooGetTextStyleJunPro(20),
                      padding: EdgeInsets.only(top: 18.w, bottom: 18.w),
                      shape: RoundedRectangleBorder(
                          borderRadius: BorderRadius.circular(15)),
                      color: LeooColorsJunPro.leooPopBgJunPro,
                      iconData: (iconList?.length ?? 0) > index
                          ? LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                              iconList![index],
                              width: 22.w,
                              height: 22.w,
                            )
                          : null,
                      iconPadding: (iconList?.length ?? 0) > index ? 5.w : 0,
                      onPressed:
                          LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                        Navigator.pop(context, index);
                      }),
                    );
                  },
                ),
                SizedBox(height: 10.w),
                LeooButtonWidgetJunPro(
                  S.of(context).appCancel,
                  LeooTextJunPro.leooGetTextStyleHintJunPro(20),
                  padding: EdgeInsets.only(top: 18.w, bottom: 18.w),
                  shape: RoundedRectangleBorder(
                      borderRadius: BorderRadius.circular(15)),
                  color: LeooColorsJunPro.leooPopBgJunPro,
                  onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                    Navigator.pop(context);
                  }),
                ),
              ],
            ),
          ),
        );
      },
    );
  }

  void showReportBlack(BuildContext context, int? userId,
      {String? nickname,
      int? age,
      int? gender,
      String? country,
      String? header,
      String? description,
      String? title,
      List<String>? listStr,
      follow}) {
    showItemBottomList(
            context,
            follow == null
                ? [
                    S.of(context).black,
                    title ?? S.of(context).infoReport,
                  ]
                : [
                    S.of(context).followUser,
                    S.of(context).black,
                    title ?? S.of(context).infoReport,
                  ],
            iconList: follow == null
                ? [
                    LeooIconsJunPro.leooPopBlockJunPro,
                    LeooIconsJunPro.leooPopReportJunPro,
                  ]
                : [
                    LeooIconsJunPro.leooPopFollowJunPro,
                    LeooIconsJunPro.leooPopBlockJunPro,
                    LeooIconsJunPro.leooPopReportJunPro,
                  ],
            headImage: header,
            name: 'showReportBlack')
        .then((value) {
      if (follow != null && value == 0) {
        follow?.call();
      } else if (follow == null && value == 0 || follow != null && value == 1) {
        showCustomDialog(context, content: S.of(context).blackTip)
            .then((value) {
          if (value == true) {
            showLoadingDialog(context);
            LeooMainDaoJunPro.leooAddBlacklistJunPro(userId,
                    nickname: nickname,
                    age: age,
                    gender: gender,
                    country: country,
                    header: header,
                    description: description)
                .then((res) {
              Navigator.pop(context);
              if (res.result) {
                LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
                    S.of(context).appComplete(S.of(context).black));
                try {
                  EMClient.getInstance.chatManager
                      .deleteConversation(userId.toString());
                  EMClient.getInstance.contactManager
                      .addUserToBlockList(userId.toString());
                } catch (e) {
                  LeooNetConfigJunPro.leooPrintLogJunPro(e);
                }
                eventBus.fire(LeooListEventJunPro());
                eventBus.fire(LeooVideoInfoUnLikeEventJunPro());
                eventBus.fire(LeooMsgListEventJunPro());
                LeooNavigatorUtilsJunPro.leooPopUntilJunPro(
                    context,
                    LeooAppConfigJunPro.leooMainNameJunPro ??
                        LeooMainJunPro.leooNameJunPro);
              } else {
                LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
              }
            });
          }
        });
      } else if (follow == null && value == 1 || follow != null && value == 2) {
        showReportDialog(context, userId, title: title, listStr: listStr);
      }
    });
  }

  Future showReportDialog(BuildContext context, int? userId,
      {String? title, List<String>? listStr}) {
    List<String> list = listStr ??
        [
          S.of(context).infoReport1,
          S.of(context).infoReport2,
          S.of(context).infoReport3,
          S.of(context).infoReport4,
          S.of(context).infoReport5,
        ];
    return leooShowCommitOptionDialogJunPro(
            context, list, title ?? S.of(context).infoReport, '',
            name: 'showReportDialog', okTip: S.of(context).appSubmit)
        .then((value) {
      if (value != null) {
        showLoadingDialog(context);
        LeooMainDaoJunPro.leooReportJunPro(userId, value).then((res) {
          Navigator.pop(context);
          if (res.result) {
            LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
                S.of(context).appComplete(title ?? S.of(context).infoReport));
          } else {
            LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
          }
        });
      }
      return value;
    });
  }

  Future showNewDialog(BuildContext context, LeooRechargeEntity? rechargeBean) {
    return LeooNavigatorUtilsJunPro.leooShowBaseDialogJunPro(context,
        name: 'showNewDialog', builder: (BuildContext showContext) {
      return Center(
        child: Column(
          mainAxisSize: MainAxisSize.min,
          mainAxisAlignment: MainAxisAlignment.center,
          children: [
            Container(
              width: 1.sw - 30.w,
              height: 350.w,
              decoration: BoxDecoration(
                gradient: LinearGradient(
                  begin: Alignment.topCenter,
                  end: Alignment.bottomCenter,
                  colors: [
                    LeooColorsJunPro.leooApp3JunPro,
                    LeooColorsJunPro.leooAppJunPro,
                  ],
                ),
                borderRadius: BorderRadius.circular(30),
              ),
              child: Stack(
                alignment: Alignment.center,
                children: [
                  Padding(
                    padding: EdgeInsets.only(top: 40.w, bottom: 70.w),
                    child: LeooCommonUtilsJunPro.leooLottieJunPro(
                      LeooIconsJunPro.leooNewUserPopJunPro,
                      width: 1.sw,
                      height: 260.w,
                    ),
                  ),
                  Column(
                    children: <Widget>[
                      SizedBox(height: 20.w),
                      Text(
                          rechargeBean?.description ??
                              S.of(context).newDiscount,
                          style: LeooTextJunPro.leooGetTextStyleJunPro(
                              30, FontWeight.bold)),
                      Text(S.of(context).newX(rechargeBean?.gold ?? 0),
                          style: LeooTextJunPro.leooGetTextStyleJunPro(
                              30, FontWeight.bold)),
                      Expanded(child: Container()),
                      Container(
                        decoration: const ShapeDecoration(
                            shape: StadiumBorder(), color: Colors.white),
                        padding: EdgeInsets.fromLTRB(10.w, 3.5.w, 10.w, 3.5.w),
                        child: Text(S.of(context).newOff(25),
                            style: LeooTextJunPro.leooGetTextStyleAppJunPro(
                                14, FontWeight.w900)),
                      ),
                      InkWell(
                        child: Container(
                          margin: EdgeInsets.fromLTRB(20.w, 5.w, 20.w, 20.w),
                          padding: EdgeInsets.only(top: 10.5.w, bottom: 10.5.w),
                          decoration: const BoxDecoration(
                            borderRadius: BorderRadius.all(Radius.circular(20)),
                            color: LeooColorsJunPro.leooTextYellowJunPro,
                          ),
                          child: Row(
                            mainAxisAlignment: MainAxisAlignment.center,
                            children: [
                              Text(
                                S.of(context).newCoins3,
                                style:
                                    LeooTextJunPro.leooGetTextStyleBlackJunPro(
                                            20, FontWeight.bold)
                                        .copyWith(
                                            decoration:
                                                TextDecoration.lineThrough),
                              ),
                              SizedBox(width: 10.w),
                              Text(
                                S
                                    .of(context)
                                    .newCoins(rechargeBean?.price ?? 0),
                                style:
                                    LeooTextJunPro.leooGetTextStyleBlackJunPro(
                                        24, FontWeight.bold),
                              ),
                            ],
                          ),
                        ),
                        onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                          Navigator.pop(context);
                          LeooRechargeUtilsJunPro.instance.connectionInPay(
                              rechargeBean?.code, rechargeBean?.price,
                              inType: '新人充值');
                        }),
                      ),
                    ],
                  ),
                ],
              ),
            ),
            SizedBox(height: 5.w),
            LeooButtonWidgetJunPro(
              S.of(context).rechargeStoreNo,
              LeooTextJunPro.leooGetTextStyleJunPro(24, FontWeight.bold),
              mainAxisSize: MainAxisSize.min,
              onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                Navigator.pop(context);
              }),
            ),
          ],
        ),
      );
    });
  }

  int rewardGold = 0;
  bool checkSign = false;

  Future? showSignInfoDialog(
      BuildContext context, LeooSignEntity signEntity, userProvider,
      {bool checkShow = false}) {
    FocusScope.of(context).unfocus();
    dynamic showDailyState;
    checkSign = false;
    List<LeooSignBean>? list = signEntity.signData;
    if (list != null && list.length > 1) {
      list.sort((a, b) => (a.day ?? 0).compareTo(b.day ?? 0));
      LeooSignBean? bean =
          list.firstWhereOrNull((element) => element.state == false);
      checkSign = signEntity.curSignDay == bean?.day && bean?.state == false;
      if (checkSign) {
        rewardGold = bean?.rewardGold ?? 0;
      } else {
        rewardGold = 0;
        if (checkShow) {
          return Future.value();
        }
      }
    } else {
      LeooCommonUtilsJunPro.leooShowCustomToastJunPro(S.of(context).dailyError);
      return Future.value();
    }
    GlobalKey<LeooLiveTextWidgetState> timeKey = GlobalKey();
    DateTime dateTimeNow = signEntity.sysTime != null
        ? DateTime.fromMillisecondsSinceEpoch(signEntity.sysTime!)
        : DateTime.now();
    DateTime dateTime =
        DateTime(dateTimeNow.year, dateTimeNow.month, dateTimeNow.day);
    int _countdownNum = 24 * 60 * 60 * 1000 -
        (dateTimeNow.millisecondsSinceEpoch - dateTime.millisecondsSinceEpoch);
    Timer _countdownTimer = Timer.periodic(const Duration(seconds: 1), (timer) {
      try {
        _countdownNum -= 1000;
        timeKey.currentState?.onSetState(
          S.of(context).dailyTime(LeooCodeUtilsJunPro.leooGetTimeStrJunPro(
                DateTime.fromMillisecondsSinceEpoch(_countdownNum, isUtc: true),
              )),
        );
        if (_countdownNum < 1000) {
          _countdownNum = 24 * 60 * 60 * 1000;
          if (list.last.state == true) {
            for (var element in list) {
              element.state = false;
            }
            signEntity.curSignDay = 1;
          } else {
            signEntity.curSignDay = (signEntity.curSignDay ?? 0) + 1;
          }
          LeooSignBean? bean =
              list.firstWhereOrNull((element) => element.state == false);
          checkSign =
              signEntity.curSignDay == bean?.day && bean?.state == false;
          if (showDailyState != null) {
            showDailyState(() {});
          }
        }
      } catch (e) {
        LeooNetConfigJunPro.leooPrintLogJunPro(e);
      }
    });
    return LeooNavigatorUtilsJunPro.leooShowBaseDialogJunPro(context,
        name: 'showSignInfoDialog', builder: (BuildContext showContext) {
      return StatefulBuilder(builder: (showContext, showState) {
        showDailyState = showState;
        return Center(
          child: Container(
            width: 1.sw - 30.w,
            decoration: BoxDecoration(
                color: LeooColorsJunPro.leooPopBgJunPro,
                borderRadius: BorderRadius.circular(30)),
            child: Column(
              mainAxisSize: MainAxisSize.min,
              children: <Widget>[
                Container(
                  width: 1.sw - 30.w,
                  height: 70.w,
                  decoration: BoxDecoration(
                    gradient: LinearGradient(
                      colors: [
                        LeooColorsJunPro.leooAppJunPro,
                        LeooColorsJunPro.leooApp2JunPro,
                      ],
                    ),
                    borderRadius: BorderRadius.only(
                        topLeft: Radius.circular(30),
                        topRight: Radius.circular(30)),
                  ),
                  child: Row(
                    children: [
                      Expanded(
                        child: LeooTextWidgetJunPro(
                          S.of(context).daily,
                          LeooTextJunPro.leooGetTextStyleJunPro(
                              20, FontWeight.bold),
                          iconData:
                              LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                            LeooIconsJunPro.leooDailyLogoJunPro,
                            width: 40.w,
                            height: 40.w,
                          ),
                          iconPadding: 5.w,
                          margin: EdgeInsets.only(left: 20.w),
                        ),
                      ),
                      IconButton(
                        padding: const EdgeInsets.all(0),
                        icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                            LeooIconsJunPro.leooPopClose2JunPro,
                            width: 40.w,
                            height: 40.w),
                        iconSize: 40.w,
                        onPressed:
                            LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                          Navigator.pop(context);
                        }),
                      ),
                      SizedBox(width: 16.w),
                    ],
                  ),
                ),
                Container(
                  margin: EdgeInsets.all(15.w),
                  height: 205.w,
                  child: Row(
                    children: [
                      Expanded(
                        child: MediaQuery.removePadding(
                          removeTop: true,
                          context: context,
                          child: GridView.builder(
                              shrinkWrap: true,
                              physics: const NeverScrollableScrollPhysics(),
                              itemCount: list.length - 1,
                              gridDelegate:
                                  SliverGridDelegateWithFixedCrossAxisCount(
                                      crossAxisCount: 3,
                                      childAspectRatio: .75,
                                      mainAxisSpacing: 5.w,
                                      crossAxisSpacing: 5.w),
                              itemBuilder:
                                  (BuildContext itemContext, int index) {
                                LeooSignBean item = list[index];
                                return getSignChildWidget(
                                    context,
                                    item,
                                    index,
                                    item.day == signEntity.curSignDay,
                                    userProvider);
                              }),
                        ),
                      ),
                      Container(
                        width: 75.w,
                        height: 205.w,
                        margin: EdgeInsets.only(left: 5.w),
                        child: Stack(
                          fit: StackFit.expand,
                          children: [
                            Container(
                              decoration: BoxDecoration(
                                border: Border.all(
                                  color: Colors.white.withOpacity(.4),
                                  width: 1.w,
                                  style: list.last.state == true ||
                                          list.last.day == signEntity.curSignDay
                                      ? BorderStyle.none
                                      : BorderStyle.solid,
                                ),
                                borderRadius: BorderRadius.circular(10),
                                gradient: list.last.state == true ||
                                        list.last.day == signEntity.curSignDay
                                    ? LinearGradient(
                                        begin: Alignment.topCenter,
                                        end: Alignment.bottomCenter,
                                        colors: [
                                          LeooColorsJunPro.leooAppJunPro,
                                          LeooColorsJunPro.leooApp2JunPro,
                                        ],
                                      )
                                    : LinearGradient(
                                        begin: Alignment.topCenter,
                                        end: Alignment.bottomCenter,
                                        colors: [
                                          Colors.white.withOpacity(.1),
                                          Colors.white.withOpacity(.1),
                                        ],
                                      ),
                              ),
                            ),
                            Column(
                              mainAxisAlignment: MainAxisAlignment.spaceEvenly,
                              children: [
                                Text(S.of(context).dailyDay(list.length),
                                    style:
                                        LeooTextJunPro.leooGetTextStyleJunPro(
                                            14, FontWeight.bold)),
                                LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                                  LeooIconsJunPro.leooDailySurpriseJunPro,
                                  width: 50.w,
                                  height: 50.w,
                                ),
                                Text(S.of(context).dailySurprise,
                                    style:
                                        LeooTextJunPro.leooGetTextStyleJunPro(
                                            16, FontWeight.bold)),
                              ],
                            ),
                            if (list.last.state == true)
                              Container(
                                decoration: BoxDecoration(
                                  color: Colors.black.withOpacity(.4),
                                  borderRadius: BorderRadius.circular(10),
                                ),
                                alignment: Alignment.center,
                                child: LeooCommonUtilsJunPro
                                    .leooGetLoadWidgetJunPro(
                                        LeooIconsJunPro.leooDailyCheckedJunPro,
                                        width: 50.w,
                                        height: 50.w),
                              ),
                          ],
                        ),
                      ),
                    ],
                  ),
                ),
                Text(S.of(context).dailyTip,
                    style: LeooTextJunPro.leooGetTextStyleHintJunPro(
                        14, FontWeight.bold),
                    textAlign: TextAlign.center),
                SizedBox(height: 10.w),
                Padding(
                  padding: EdgeInsets.only(left: 20.w, right: 20.w),
                  child: checkSign
                      ? LeooButtonWidgetJunPro(
                          S.of(context).dailyCheck,
                          LeooTextJunPro.leooGetTextStyleJunPro(
                              20, FontWeight.bold),
                          color: LeooColorsJunPro.leooAppJunPro,
                          colorRight: LeooColorsJunPro.leooApp2JunPro,
                          shape: RoundedRectangleBorder(
                              borderRadius: BorderRadius.circular(20)),
                          onPressed:
                              LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                            Navigator.pop(context, true);
                          }),
                        )
                      : Container(
                          width: 1.sw - 30.w,
                          decoration: BoxDecoration(
                            borderRadius: BorderRadius.circular(20),
                            color: LeooColorsJunPro.leooAppJunPro,
                          ),
                          padding: EdgeInsets.only(top: 13.w, bottom: 13.w),
                          alignment: Alignment.center,
                          child: LeooLiveTextWidgetJunPro(
                            timeKey,
                            LeooTextJunPro.leooGetTextStyleHintJunPro(
                                    20, FontWeight.bold)
                                .copyWith(color: Colors.white.withOpacity(.8)),
                            S.of(context).dailyTime(
                                    LeooCodeUtilsJunPro.leooGetTimeStrJunPro(
                                  DateTime.fromMillisecondsSinceEpoch(
                                      _countdownNum,
                                      isUtc: true),
                                )),
                          ),
                        ),
                ),
                SizedBox(height: 24.w),
              ],
            ),
          ),
        );
      });
    }).then((value) {
      _countdownTimer.cancel();
      showDailyState = null;
      return value;
    });
  }

  Widget getSignChildWidget(BuildContext context, LeooSignBean item, int index,
      bool day, LeooUserProviderJunPro userProvider) {
    return Stack(
      fit: StackFit.expand,
      children: [
        Container(
          decoration: BoxDecoration(
            border: Border.all(
                color: Colors.white.withOpacity(.4),
                width: 1.w,
                style: item.state == true || day
                    ? BorderStyle.none
                    : BorderStyle.solid),
            borderRadius: BorderRadius.circular(10),
            gradient: item.state == true || day
                ? LinearGradient(
                    begin: Alignment.topCenter,
                    end: Alignment.bottomCenter,
                    colors: [
                      LeooColorsJunPro.leooAppJunPro,
                      LeooColorsJunPro.leooApp2JunPro,
                    ],
                  )
                : LinearGradient(
                    begin: Alignment.topCenter,
                    end: Alignment.bottomCenter,
                    colors: [
                      Colors.white.withOpacity(.1),
                      Colors.white.withOpacity(.1),
                    ],
                  ),
          ),
        ),
        Column(
          mainAxisAlignment: MainAxisAlignment.center,
          children: [
            Text(S.of(context).dailyDay(index + 1),
                style:
                    LeooTextJunPro.leooGetTextStyleJunPro(14, FontWeight.bold),
                textAlign: TextAlign.center),
            SizedBox(height: 3.w),
            LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
              index == 4
                  ? LeooIconsJunPro.leooDailySurpriseJunPro
                  : LeooIconsJunPro.leooCheckCoinsJunPro,
              width: 40.w,
              height: 40.w,
            ),
            SizedBox(height: 1.w),
            Text(
                index == 4 ? S.of(context).dailySurprise : '${item.rewardGold}',
                style:
                    LeooTextJunPro.leooGetTextStyleJunPro(16, FontWeight.bold),
                textAlign: TextAlign.center)
          ],
        ),
        if (item.state == true)
          Container(
            decoration: BoxDecoration(
              borderRadius: BorderRadius.circular(10),
              color: Colors.black.withOpacity(.4),
            ),
            alignment: Alignment.center,
            child: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                LeooIconsJunPro.leooDailyCheckedJunPro,
                width: 40.w,
                height: 40.w),
          ),
      ],
    );
  }

  Future signReward(BuildContext context, LeooUserProviderJunPro userProvider) {
    LeooDialogUtilsJunPro.instance.showLoadingDialog(context);
    return LeooMainDaoJunPro.leooSignRewardJunPro().then((res) {
      Navigator.pop(context);
      if (res.result) {
        int price = rewardGold;
        int money = userProvider.userEntity.amount ?? 0;
        userProvider.setMoney(price + money);
        checkSign = false;
        return showSignSuccessDialog(
            context, S.of(context).dailyCoins(rewardGold));
      } else {
        LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
        return false;
      }
    });
  }

  Future showSignSuccessDialog(BuildContext context, String? title,
      {String? content}) {
    FocusScope.of(context).unfocus();
    return LeooNavigatorUtilsJunPro.leooShowBaseDialogJunPro(context,
        name: 'showSignSuccessDialog', builder: (BuildContext showContext) {
      return Center(
        child: Column(
          mainAxisSize: MainAxisSize.min,
          children: [
            Stack(
              alignment: Alignment.bottomCenter,
              children: <Widget>[
                LeooCommonUtilsJunPro.leooLottieJunPro(
                  LeooIconsJunPro.leooGetDiaJunPro,
                  width: 300.w,
                  height: 300.w,
                ),
                Positioned(
                  bottom: 50.w,
                  child: Text(title ?? '',
                      style: LeooTextJunPro.leooGetTextStyleJunPro(
                          24, FontWeight.bold)),
                ),
              ],
            ),
            LeooButtonWidgetJunPro(
              S.of(context).appOk,
              LeooTextJunPro.leooGetTextStyleJunPro(20, FontWeight.bold),
              color: LeooColorsJunPro.leooAppJunPro,
              colorRight: LeooColorsJunPro.leooApp2JunPro,
              shape: const RoundedRectangleBorder(
                borderRadius: BorderRadius.all(Radius.circular(20)),
              ),
              mainAxisSize: MainAxisSize.min,
              padding: EdgeInsets.fromLTRB(60.w, 14.w, 60.w, 14.w),
              onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                Navigator.pop(context);
              }),
            ),
          ],
        ),
      );
    });
  }
}
