import 'dart:async';

import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leooappconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leoonetconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoowidgetjunpro/leoocircleroutejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoowidgetjunpro/leootransparentroutejunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leooinfojunpro/leooviewimagejunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoomainjunpro/leoomainjunpro.dart';
import 'package:leoo_junpro/leoorouterjunpro.dart';

///导航类
class LeooNavigatorUtilsJunPro {
  static Map leooRouteMapJunPro = {};

  //自定义
  static var leooInfoPageJunPro;

  ///公共打开方式
  static Future leooNavigatorPushJunPro(
      BuildContext context, Widget widget, String name,
      {bool add = false,
      bool replace = false,
      bool fullscreenDialog = false,
      bool match = false,
      Offset? center}) {
    FocusScope.of(context).unfocus();
    var route = match
        ? LeooCirclePageRouteJunPro(
            (context) => widget,
            fullscreenDialog: fullscreenDialog,
            settings: RouteSettings(name: name),
            center: center,
          )
        : CupertinoPageRoute(
            fullscreenDialog: fullscreenDialog,
            settings: RouteSettings(name: name),
            builder: (context) => widget);
    if (add) {
      if (leooRouteMapJunPro[name]?.isActive == true) {
        Navigator.removeRoute(context, leooRouteMapJunPro[name]);
      }
      leooRouteMapJunPro[name] = route;
    }
    return replace
        ? Navigator.pushReplacement(context, route)
        : Navigator.push(context, route);
  }

  static leooPopUntilJunPro(BuildContext context, String name) {
    FocusScope.of(context).unfocus();
    Navigator.popUntil(context, ModalRoute.withName(name));
  }

  ///Page页面的容器，做一次通用自定义
  static Widget leooPageContainerJunPro(BuildContext context, widget) {
    return MediaQuery(
        data: MediaQuery.of(context).copyWith(textScaleFactor: 1.0),
        child: widget);
  }

  ///主页
  static Future leooGoHomeJunPro(BuildContext context, {int position = 0}) {
    FocusScope.of(context).unfocus();
    LeooMainJunPro.leooCurIndexJunPro = position;
    return Navigator.pushNamedAndRemoveUntil(
        context,
        LeooAppConfigJunPro.leooMainNameJunPro ?? LeooMainJunPro.leooNameJunPro,
        (Route router) => false);
  }

  ///登录页面
  static void leooGoSplashJunPro(BuildContext context) {
    if (!LeooAppConfigJunPro.leooSplashOpenJunPro) {
      FocusScope.of(context).unfocus();
      Navigator.pushNamedAndRemoveUntil(context,
          LeooAppConfigJunPro.leooSplashNameJunPro, (Route router) => false);
    }
  }

  static void leooGoSplash2JunPro() {
    if (!LeooAppConfigJunPro.leooSplashOpenJunPro) {
      FocusScope.of(LeooRouterJunPro.leooContextJunPro).unfocus();
      Navigator.pushNamedAndRemoveUntil(LeooRouterJunPro.leooContextJunPro,
          LeooAppConfigJunPro.leooSplashNameJunPro, (Route router) => false);
    }
  }

  ///图片预览
  static Future leooGotoPhotoViewJunPro(BuildContext context,
      {bool single = true,
      String? localPath,
      String? imageUri,
      bool imUri = true,
      List<String>? pics,
      int? currentIndex,
      String? hero,
      Map<String, String>? headers}) {
    FocusScope.of(context).unfocus();
    return Navigator.push(
      context,
      LeooTransparentPageRouteJunPro(
        (context) => LeooViewImageJunPro(
            single: single,
            localPath: localPath,
            imageUri: imageUri,
            imUri: imUri,
            pics: pics,
            currentIndex: currentIndex,
            hero: hero,
            headers: headers),
        settings: const RouteSettings(name: 'LeooGotoPhotoViewJunPro'),
      ),
    );
  }

  // ///弹出 dialog
  static Future<T?> leooShowBaseDialogJunPro<T>(BuildContext context,
      {bool dismiss = false,
      WidgetBuilder? builder,
      Color color = Colors.black54,
      String? name}) {
    FocusScope.of(context).unfocus();
    return showDialog<T>(
        context: context,
        barrierColor: color,
        routeSettings: RouteSettings(name: name ?? 'LeooShowBaseDialogJunPro'),
        builder: (context) {
          return GestureDetector(
            behavior: HitTestBehavior.opaque,
            onTap: () {
              if (dismiss) {
                Navigator.pop(context);
              }
            },
            child: Scaffold(
              resizeToAvoidBottomInset: false,
              backgroundColor: Colors.transparent,
              body: MediaQuery(
                ///不受系统字体缩放影响
                data: MediaQuery.of(context).copyWith(textScaleFactor: 1.0),
                child: builder!(context),
              ),
            ),
          );
        });
  }

  static int leooClicksJunPro = 0;
  static int leooJumpTimeJunPro = 0;

  ///防止多次点击
  static VoidCallback leooDebounceJunPro(Function fn, [int t = 400]) {
    return () {
      if (leooJumpTimeJunPro >= (DateTime.now().millisecondsSinceEpoch - t) &&
          leooClicksJunPro <= 10) {
        leooClicksJunPro++;
        leooJumpTimeJunPro = DateTime.now().millisecondsSinceEpoch;
        LeooNetConfigJunPro.leooPrintLogJunPro('屏蔽快速点击');
      } else {
        leooJumpTimeJunPro = DateTime.now().millisecondsSinceEpoch;
        leooClicksJunPro = 0;
        LeooNetConfigJunPro.leooPrintLogJunPro('clicks');
        fn();
      }
    };
  }
}
