import 'dart:async';
import 'dart:convert';
import 'dart:core';
import 'dart:io';
import 'dart:math';

import 'package:connectivity/connectivity.dart';
import 'package:crypto/crypto.dart';
import 'package:firebase_analytics/firebase_analytics.dart';
import 'package:firebase_crashlytics/firebase_crashlytics.dart';
import 'package:firebase_messaging/firebase_messaging.dart';
import 'package:flutter/material.dart';
import 'package:flutter_local_notifications/flutter_local_notifications.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:im_flutter_sdk/im_flutter_sdk.dart';
import 'package:in_app_purchase/in_app_purchase.dart';
import 'package:in_app_purchase_android/billing_client_wrappers.dart';
import 'package:in_app_purchase_android/in_app_purchase_android.dart';
import 'package:in_app_purchase_storekit/in_app_purchase_storekit.dart';
import 'package:in_app_purchase_storekit/store_kit_wrappers.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leooappconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leoonetconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoomaindaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoogiftentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoorechargeentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoouserentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooeventjunpro/leooindexjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooeventjunpro/leoorechargeeventjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoonetjunpro/leooapphostjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooproviderjunpro/leoouserproviderjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoodialogutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoobuttonwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leooslidescalewidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leootextwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoowidgetjunpro/leoovisiblewidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoozoominwidgetjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoomejunpro/leoorechargenewjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoosetjunpro/leoocustomerjunpro.dart';
import 'package:leoo_junpro/leoorouterjunpro.dart';
import 'package:sp_util/sp_util.dart';

///单例的公共类-系统配置，充值，礼物
class LeooRechargeUtilsJunPro {
  factory LeooRechargeUtilsJunPro() => _getInstance();

  static LeooRechargeUtilsJunPro get instance => _getInstance();
  static LeooRechargeUtilsJunPro? _instance;

  LeooRechargeUtilsJunPro._internal();

  static LeooRechargeUtilsJunPro _getInstance() {
    _instance ??= LeooRechargeUtilsJunPro._internal();
    return _instance!;
  }

  final AndroidNotificationChannel channel = const AndroidNotificationChannel(
    'default_channel',
    'Default',
    description: 'Default notification channel',
    importance: Importance.high,
  );
  final FlutterLocalNotificationsPlugin flutterLocalNotificationsPlugin =
      FlutterLocalNotificationsPlugin();
  final NotificationDetails platformChannelSpecifics =
      const NotificationDetails(
          android: AndroidNotificationDetails('default_channel', 'Default',
              channelDescription: 'Default notification channel',
              icon: 'ic_launcher',
              importance: Importance.max,
              priority: Priority.high),
          iOS: IOSNotificationDetails(
              presentAlert: true, presentBadge: true, presentSound: true));

  Future initFirebase() async {
    try {
      await FirebaseCrashlytics.instance.setCrashlyticsCollectionEnabled(true);
      FirebaseMessaging.instance
          .getInitialMessage()
          .then((RemoteMessage? message) {
        if (message != null) {
          LeooNetConfigJunPro.leooPrintLogJunPro(
              'FirebaseMessaging RemoteMessage: ${message.messageId}');
        }
      });
      FirebaseMessaging.onMessage.listen((RemoteMessage message) {
        RemoteNotification? notification = message.notification;
        AndroidNotification? android = message.notification?.android;
        if (notification != null && android != null) {
          flutterLocalNotificationsPlugin.show(notification.hashCode,
              notification.title, notification.body, platformChannelSpecifics);
        }
      });
      FirebaseMessaging.onMessageOpenedApp.listen((RemoteMessage message) {
        LeooNetConfigJunPro.leooPrintLogJunPro(
            'A new onMessageOpenedApp event was published!');
      });
      FirebaseMessaging.instance.getToken().then((token) {
        LeooNetConfigJunPro.leooPrintLogJunPro(
            'FirebaseMessaging getToken: $token');
        // if (token?.isEmpty == false) {
        //   MainDao.setFirebaseToken(token);
        // }
      });
      FirebaseMessaging.instance.subscribeToTopic('ALL');
    } catch (e) {
      LeooNetConfigJunPro.leooPrintLogJunPro(e);
    }
  }

  void dispose() {
    timer?.cancel();
  }

  bool showBottomSheet = false;
  bool showLoading = false;
  bool showInPay = false;

  ///支付
  List<LeooRechargeEntity> rechargePay = [];
  List products = [];

  String? payInType; //内购列表还是弹窗

  String? rechargeError;
  String? meUser;

  InAppPurchase connection = InAppPurchase.instance;
  StreamSubscription<List<PurchaseDetails>>? subscription;

  Timer? timer;
  bool restored = false;
  int maxIndex = 5;

  void initInAppPurchase() {
    try {
      Stream purchaseUpdated = connection.purchaseStream;
      subscription?.cancel();
      subscription = purchaseUpdated.listen((purchaseDetailsList) {
        listenToPurchaseUpdated(purchaseDetailsList);
      }, onDone: () {
        subscription?.cancel();
        LeooNetConfigJunPro.leooPrintLogJunPro('subscription: cancel');
      }, onError: (error) {
        LeooNetConfigJunPro.leooPrintLogJunPro('purchaseUpdated: $error');
      }) as StreamSubscription<List<PurchaseDetails>>;
      queryPastPurchases(first: true);
    } catch (e) {
      LeooNetConfigJunPro.leooPrintLogJunPro(e);
    }
  }

  void listenToPurchaseUpdated(List<PurchaseDetails?> purchaseDetailsList,
      {bool rest = false}) async {
    LeooNetConfigJunPro.leooPrintLogJunPro(
        'listenToPurchaseUpdated: ${purchaseDetailsList.length}');
    if (purchaseDetailsList.isNotEmpty) {
      purchaseDetailsList = purchaseDetailsList.reversed.toList();
      Map payPurchase = {};
      for (PurchaseDetails? purchaseDetail in purchaseDetailsList) {
        if (purchaseDetail!.status == PurchaseStatus.purchased ||
            purchaseDetail.status == PurchaseStatus.restored) {
          String md5Str = md5
              .convert(const Utf8Encoder().convert(
                  purchaseDetail.verificationData.serverVerificationData))
              .toString();
          LeooNetConfigJunPro.leooPrintLogJunPro(
              'purchaseUpdated md5Str: $md5Str');
          if (payPurchase[purchaseDetail.productID] != md5Str) {
            payPurchase[purchaseDetail.productID] = md5Str;
            await purchaseUpdated(purchaseDetail);
          } else if (payPurchase[purchaseDetail.productID] == md5Str) {
            completePurchaseInPay(purchaseDetail);
          }
        } else {
          await purchaseUpdated(purchaseDetail);
        }
      }
    } else if (restored) {
      if (showLoading) {
        showLoading = false;
        Navigator.pop(LeooRouterJunPro.leooContextJunPro);
      }
      SpUtil.putString(LeooAppConfigJunPro.leooInTokenJunPro, '');
      SpUtil.putString(LeooAppConfigJunPro.leooInCodeJunPro, '');
      restored = false;
    }
  }

  Future purchaseUpdated(PurchaseDetails purchaseDetail,
      {bool rest = false}) async {
    if (purchaseDetail.status == PurchaseStatus.pending) {
      FirebaseAnalytics.instance.logEvent(name: '${payInType ?? ''}内购支付中');
      LeooNetConfigJunPro.leooPrintLogJunPro('PurchaseStatus.pending');
    } else if (purchaseDetail.status == PurchaseStatus.canceled) {
      if (showLoading) {
        showLoading = false;
        Navigator.pop(LeooRouterJunPro.leooContextJunPro);
      }
      LeooNetConfigJunPro.leooPrintLogJunPro('PurchaseStatus.canceled');
      FirebaseAnalytics.instance.logEvent(
          name:
              '${payInType ?? ''}取消支付, details: ${purchaseDetail.error!.code}');
      LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
          S.of(LeooRouterJunPro.leooContextJunPro).appCancel);
      completePurchaseInPay(purchaseDetail);
    } else if (purchaseDetail.status == PurchaseStatus.error) {
      if (showLoading) {
        showLoading = false;
        Navigator.pop(LeooRouterJunPro.leooContextJunPro);
      }
      LeooNetConfigJunPro.leooPrintLogJunPro(
          'PurchaseStatus.error:${purchaseDetail.error!.code}');
      if (purchaseDetail.error?.message == 'BillingResponse.itemAlreadyOwned') {
        queryPastPurchases();
      } else {
        FirebaseAnalytics.instance.logEvent(
            name:
                '${payInType ?? ''}内购返回支付失败, details: ${purchaseDetail.error!.code}');
        LeooDialogUtilsJunPro.instance
            .showCustomDialog(LeooRouterJunPro.leooContextJunPro,
                content: S.of(LeooRouterJunPro.leooContextJunPro).inAppError,
                dismiss: false)
            .then((value) {
          if (value == true) {
            LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
                LeooRouterJunPro.leooContextJunPro,
                const LeooCustomerJunPro(),
                'LeooCustomerJunPro');
          }
        });
        completePurchaseInPay(purchaseDetail);
      }
    } else if (purchaseDetail.status == PurchaseStatus.purchased ||
        purchaseDetail.status == PurchaseStatus.restored) {
      LeooNetConfigJunPro.leooPrintLogJunPro(
          'PurchaseStatus.purchased: ${purchaseDetail.status}');
      if (purchaseDetail.status == PurchaseStatus.restored) {
        restored = false;
      }
      FirebaseAnalytics.instance.logEvent(name: '${payInType ?? ''}内购支付成功');
      SpUtil.putString(
          LeooAppConfigJunPro.leooInCodeJunPro, purchaseDetail.productID);
      if (Platform.isIOS) {
        SpUtil.putString(LeooAppConfigJunPro.leooInTokenJunPro,
            purchaseDetail.verificationData.serverVerificationData);
        await checkInPayPurchase(
            purchaseDetail.verificationData.serverVerificationData,
            purchaseDetail.productID,
            first: purchaseDetail.status != PurchaseStatus.restored,
            purchaseDetail: purchaseDetail,
            index: purchaseDetail.status == PurchaseStatus.restored
                ? maxIndex
                : 1);
      } else {
        SpUtil.putString(
            LeooAppConfigJunPro.leooInTokenJunPro,
            (purchaseDetail as GooglePlayPurchaseDetails)
                .billingClientPurchase
                .purchaseToken);
        await checkInPayPurchase(
            purchaseDetail.billingClientPurchase.purchaseToken,
            purchaseDetail.productID,
            first: purchaseDetail.status != PurchaseStatus.restored,
            purchaseDetail: purchaseDetail,
            index: purchaseDetail.status == PurchaseStatus.restored
                ? maxIndex
                : 1);
      }
    } else {
      if (showLoading) {
        showLoading = false;
        Navigator.pop(LeooRouterJunPro.leooContextJunPro);
      }
      if (showBottomSheet) {
        showBottomSheet = false;
        Navigator.pop(LeooRouterJunPro.leooContextJunPro);
      }
    }
  }

  void getRechargeList(callback, changed,
      {bool pop = true, bool cache = true}) {
    FocusScope.of(LeooRouterJunPro.leooContextJunPro).unfocus();
    if (cache && rechargePay.isNotEmpty) {
      callback?.call();
      changed?.call(LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro);
      return;
    }
    clearRechargeList();
    showLoading = false;
    changed?.call(LeooCommonUtilsJunPro.leooPageStatusLoadingJunPro);
    rechargeInList(callback, changed, pop: pop);
  }

  void clearRechargeList() {
    rechargePay.clear();
    products.clear();
    if (showBottomSheet) {
      showBottomSheet = false;
      Navigator.pop(LeooRouterJunPro.leooContextJunPro);
    }
  }

  void rechargeInList(callback, changed, {bool pop = false}) {
    LeooMainDaoJunPro.leooListConfigJunPro().then((res) {
      if (res.result) {
        rechargePay = res.data;
        rechargePay
            .sort((a, b) => (a.serialNum ?? 0).compareTo(b.serialNum ?? 0));
        if (rechargePay.isNotEmpty) {
          callback?.call();
          changed?.call(LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro);
          return;
        }
      }
      callback?.call();
      changed?.call(rechargePay.isNotEmpty
          ? LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro
          : LeooCommonUtilsJunPro.leooPageStatusEmptyJunPro);
    });
  }

  void showRechargeLoading() {
    showLoading = true;
    LeooDialogUtilsJunPro.instance
        .showLoadingDialog(LeooRouterJunPro.leooContextJunPro);
  }

  List<PurchaseDetails?> verifiedPurchases = [];

  Future queryPastPurchases({bool refresh = false, bool first = false}) async {
    if (await connection.isAvailable()) {
      if (Platform.isAndroid || refresh) {
        if (restored) {
          FirebaseAnalytics.instance
              .logEvent(name: '${payInType ?? ''}恢复购买为空再次检查、清空本地缓存');
          SpUtil.putString(LeooAppConfigJunPro.leooInTokenJunPro, '');
          SpUtil.putString(LeooAppConfigJunPro.leooInCodeJunPro, '');
          restored = false;
        } else {
          restored = true;
          await connection.restorePurchases();
        }
      } else if (!first) {
        InAppPurchaseStoreKitPlatformAddition iosAddition = connection
            .getPlatformAddition<InAppPurchaseStoreKitPlatformAddition>();
        PurchaseVerificationData? verificationData =
            await iosAddition.refreshPurchaseVerificationData();
        if (verificationData != null) {
          SpUtil.putString(LeooAppConfigJunPro.leooInTokenJunPro,
              verificationData.serverVerificationData);
          await checkInPayPurchase(verificationData.serverVerificationData, '');
        } else {
          FirebaseAnalytics.instance
              .logEvent(name: '${payInType ?? ''}刷新票据为空清空本地缓存');
          SpUtil.putString(LeooAppConfigJunPro.leooInTokenJunPro, '');
          SpUtil.putString(LeooAppConfigJunPro.leooInCodeJunPro, '');
        }
      }
    }
  }

  Widget getGridChildWidget(LeooRechargeEntity item,
      {bool top = false, String? eventName, back}) {
    return InkWell(
      child: Stack(
        alignment: Alignment.bottomCenter,
        children: [
          Positioned(
            left: 0,
            right: 0,
            child: Container(
              height: 30.w,
              decoration: BoxDecoration(
                color: LeooColorsJunPro.leooAppJunPro,
                borderRadius: BorderRadius.only(
                  bottomLeft: Radius.circular(20),
                  bottomRight: Radius.circular(20),
                ),
              ),
            ),
          ),
          Container(
            decoration: BoxDecoration(
              border: Border.all(
                color: LeooColorsJunPro.leooAppJunPro,
                width: 1.w,
              ),
              borderRadius: BorderRadius.circular(20),
            ),
            padding: EdgeInsets.only(
              left: 10.w,
              top: 10.w,
              right: 10.w,
            ),
            child: Column(
              children: <Widget>[
                Text(
                  item.description ?? '',
                  style: item.highlight == 1
                      ? LeooTextJunPro.leooGetTextStyleAppJunPro(
                          12, FontWeight.bold)
                      : LeooTextJunPro.leooGetTextStyleHintJunPro(
                          12, FontWeight.bold),
                  maxLines: 1,
                  overflow: TextOverflow.ellipsis,
                ),
                SizedBox(height: 10.w),
                LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                  LeooIconsJunPro.leooMainCoinsJunPro,
                  width: 32.w,
                  height: 32.w,
                ),
                Expanded(
                  flex: 2,
                  child: Center(
                    child: Text(
                      '${item.gold}',
                      style: LeooTextJunPro.leooGetTextStyleJunPro(
                          20, FontWeight.bold),
                      textAlign: TextAlign.center,
                      maxLines: 1,
                      overflow: TextOverflow.ellipsis,
                    ),
                  ),
                ),
                Container(
                  width: 120.w,
                  height: 30.w,
                  alignment: Alignment.center,
                  child: Text(
                    '\$${item.price}',
                    style: LeooTextJunPro.leooGetTextStyleJunPro(
                        14, FontWeight.bold),
                    textAlign: TextAlign.center,
                    maxLines: 1,
                    overflow: TextOverflow.ellipsis,
                  ),
                ),
              ],
            ),
          ),
        ],
      ),
      onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() async {
        if (eventName?.isEmpty == false) {
          FirebaseAnalytics.instance.logEvent(name: '$eventName点击进入充值发起充值');
        }
        connectionInPay(item.code, item.price, inType: '弹窗');
      }),
    );
  }

  Future completePurchaseInPay(PurchaseDetails? purchaseDetail) async {
    try {
      if (Platform.isAndroid) {
        InAppPurchaseAndroidPlatformAddition androidAddition = InAppPurchase
            .instance
            .getPlatformAddition<InAppPurchaseAndroidPlatformAddition>();
        BillingResultWrapper billingResult =
            await androidAddition.consumePurchase(purchaseDetail!);
        LeooNetConfigJunPro.leooPrintLogJunPro(
            'completePurchase: ${billingResult.responseCode}');
      } else if (purchaseDetail?.pendingCompletePurchase == true) {
        await connection.completePurchase(purchaseDetail!);
        LeooNetConfigJunPro.leooPrintLogJunPro(
            'completePurchase: checkInPayPurchase');
      } else {
        paymentQueueWrapper(payId: purchaseDetail?.productID, delayed: false);
      }
    } catch (e) {
      LeooNetConfigJunPro.leooPrintLogJunPro(e);
    }
  }

  Future paymentQueueWrapper(
      {String? payId, bool delayed = true, bool finish = true}) async {
    if (Platform.isIOS) {
      var transactions = await SKPaymentQueueWrapper().transactions();
      transactions = transactions.skipWhile((value) {
        return payId?.isEmpty == false &&
            payId != value.payment.productIdentifier;
      }).toList();
      LeooNetConfigJunPro.leooPrintLogJunPro(
          'paymentQueueWrapper: ${transactions.length}');
      if (transactions.isEmpty == false) {
        if (finish) {
          LeooNetConfigJunPro.leooPrintLogJunPro(
              'paymentQueueWrapper finishTransaction: ${transactions.length}');
          for (SKPaymentTransactionWrapper wrapper in transactions) {
            await SKPaymentQueueWrapper().finishTransaction(wrapper);
          }
        }
        if (delayed) {
          await Future.delayed(const Duration(seconds: 5), () async {
            await paymentQueueWrapper(finish: finish);
          });
        }
      }
    }
  }

  Future showRechargeDialog(BuildContext context, String content,
      {bool back = false, bool dismiss = true, bool call = false}) {
    if (LeooAppHostJunPro.leooModeJunPro) {
      LeooCommonUtilsJunPro.leooShowCustomToastJunPro(content);
      if (back) {
        Navigator.pop(context);
      }
      return goRechargePage(context, call);
    } else {
      return LeooDialogUtilsJunPro.instance
          .showCustomDialog(context,
              content: content, right: S.of(context).recharge, dismiss: dismiss)
          .then((value) {
        if (value == true) {
          if (back) {
            Navigator.pop(context);
          }
          return goRechargePage(context, call);
        }
        return value;
      });
    }
  }

  Future goRechargePage(BuildContext context, [bool call = false]) {
    return LeooNavigatorUtilsJunPro.leooShowBaseDialogJunPro(
      context,
      name: 'goRechargePage',
      builder: (BuildContext showContext) {
        return LeooRechargeNewJunPro(call: call);
      },
    );
  }

  List<LeooGiftEntity>? gifts;
  int currentUserIndex = -1;

  Future showGiftButton(context, LeooUserProviderJunPro userProvider,
      {List<LeooUserEntity?>? users, LeooUserEntity? user, back}) async {
    FocusScope.of(context).unfocus();
    if (gifts == null || gifts?.isEmpty != false) {
      back?.call(true);
      LeooDialogUtilsJunPro.instance.showLoadingDialog(context);
      var res = await LeooMainDaoJunPro.leooGiftListJunPro();
      back?.call(false);
      Navigator.pop(context);
      if (res.result) {
        gifts = res.data;
      } else {
        Navigator.pop(context);
        LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
      }
    }
    if (gifts != null) {
      currentUserIndex = -1;
      GlobalKey<LeooVisibleWidgetState> visibleKey = GlobalKey();
      if (users != null) {
        if (user == null) {
          currentUserIndex = 0;
        } else {
          currentUserIndex = users.indexOf(user);
        }
      }
      int current = -1;
      return showModalBottomSheet(
          context: context,
          backgroundColor: LeooColorsJunPro.leooBgJunPro.withOpacity(.8),
          routeSettings: const RouteSettings(name: 'showGiftButton'),
          builder: (BuildContext showContext) {
            return StatefulBuilder(builder: (showContext, setBottomSheetState) {
              return SafeArea(
                maintainBottomViewPadding: true,
                child: Stack(
                  children: [
                    Column(
                      mainAxisSize: MainAxisSize.min,
                      children: <Widget>[
                        SizedBox(
                          height: 250.w,
                          child: PageView.builder(
                            physics: const BouncingScrollPhysics(),
                            itemCount: (gifts!.length / 8).ceil(),
                            itemBuilder: (BuildContext context, int index) {
                              int end = (index + 1) * 8;
                              if (end > gifts!.length) {
                                end = gifts!.length;
                              }
                              List list = gifts!.sublist(index * 8, end);
                              return GridView.builder(
                                  shrinkWrap: true,
                                  physics: const BouncingScrollPhysics(),
                                  itemCount: list.length,
                                  padding: EdgeInsets.only(
                                      left: 15.w, top: 15.w, right: 15.w),
                                  gridDelegate:
                                      SliverGridDelegateWithFixedCrossAxisCount(
                                          crossAxisCount: 4,
                                          childAspectRatio: .75,
                                          mainAxisSpacing: 15.w,
                                          crossAxisSpacing: 15.w),
                                  itemBuilder:
                                      (BuildContext itemContext, int index) {
                                    return getGiftChildWidget(
                                        itemContext,
                                        userProvider,
                                        list[index],
                                        current == index, () {
                                      current = index;
                                      setBottomSheetState(() {});
                                    });
                                  });
                            },
                          ),
                        ),
                        Padding(
                          padding: EdgeInsets.only(
                              left: 15.w, bottom: 15.w, right: 15.w),
                          child: Row(
                            mainAxisAlignment: MainAxisAlignment.spaceBetween,
                            children: <Widget>[
                              LeooTextWidgetJunPro(
                                '${userProvider.userEntity.amount ?? 0}',
                                LeooTextJunPro.leooGetTextStyleJunPro(
                                    16, FontWeight.bold),
                                iconData: LeooCommonUtilsJunPro
                                    .leooGetLoadWidgetJunPro(
                                  LeooIconsJunPro.leooMainCoinsJunPro,
                                  width: 20.w,
                                  height: 20.w,
                                ),
                                iconPadding: 2.5.w,
                                mainAxisSize: MainAxisSize.min,
                                decoration: ShapeDecoration(
                                    shape: StadiumBorder(
                                  side: BorderSide(
                                    color: LeooColorsJunPro.leooCoinsLineJunPro,
                                    width: 1.w,
                                  ),
                                )),
                                padding: EdgeInsets.all(10.w),
                              ),
                              Row(
                                children: [
                                  if (users != null && currentUserIndex != -1)
                                    LeooButtonWidgetJunPro(
                                      users[currentUserIndex]?.nickname ?? '',
                                      LeooTextJunPro.leooGetTextStyleJunPro(
                                          20, FontWeight.bold),
                                      color: LeooColorsJunPro.leooBtnBg2JunPro,
                                      shape: const RoundedRectangleBorder(
                                        borderRadius: BorderRadius.only(
                                          topLeft: Radius.circular(30),
                                          bottomLeft: Radius.circular(30),
                                        ),
                                      ),
                                      textWidth: 80.w,
                                      textAlign: TextAlign.center,
                                      padding: EdgeInsets.all(8.w),
                                      onPressed: LeooNavigatorUtilsJunPro
                                          .leooDebounceJunPro(() {
                                        if (users.length > 1) {
                                          visibleKey.currentState
                                              ?.onSetState(true);
                                        }
                                      }),
                                    ),
                                  LeooButtonWidgetJunPro(
                                    S.of(context).appSend.toUpperCase(),
                                    LeooTextJunPro.leooGetTextStyleJunPro(
                                        20, FontWeight.bold),
                                    color: LeooColorsJunPro.leooAppJunPro,
                                    colorRight: LeooColorsJunPro.leooApp2JunPro,
                                    shape: users != null
                                        ? const RoundedRectangleBorder(
                                            borderRadius: BorderRadius.only(
                                              topRight: Radius.circular(30),
                                              bottomRight: Radius.circular(30),
                                            ),
                                          )
                                        : const StadiumBorder(),
                                    padding: users != null
                                        ? EdgeInsets.fromLTRB(
                                            12.w, 8.w, 12.w, 8.w)
                                        : EdgeInsets.fromLTRB(
                                            24.w, 8.w, 24.w, 8.w),
                                    onPressed: current == -1
                                        ? null
                                        : LeooNavigatorUtilsJunPro
                                            .leooDebounceJunPro(() {
                                            Navigator.pop(
                                                context, gifts![current]);
                                          }),
                                  ),
                                ],
                              ),
                            ],
                          ),
                        ),
                      ],
                    ),
                    LeooVisibleWidgetJunPro(
                      visibleKey,
                      false,
                      Positioned(
                        bottom: 60.w,
                        right: 80.w,
                        child: LeooSlideScaleWidgetJunPro(
                          ClipRRect(
                            borderRadius: BorderRadius.circular(4),
                            child: Container(
                              width: 120.w,
                              constraints: BoxConstraints(
                                maxHeight: 140.w,
                              ),
                              color: LeooColorsJunPro.leooBtnBg2JunPro,
                              child: ListView.separated(
                                shrinkWrap: true,
                                physics: const BouncingScrollPhysics(),
                                itemCount: users?.length ?? 0,
                                separatorBuilder:
                                    (BuildContext context, int index) {
                                  return Divider(
                                    height: 0,
                                    color: LeooColorsJunPro.leooLineJunPro,
                                    indent: 8.w,
                                    endIndent: 8.w,
                                  );
                                },
                                itemBuilder:
                                    (BuildContext itemContext, int index) {
                                  LeooUserEntity item = users![index]!;
                                  return InkWell(
                                    child: Padding(
                                      padding: EdgeInsets.all(10.w),
                                      child: Text(
                                        item.nickname ?? '',
                                        style: LeooTextJunPro
                                            .leooGetTextStyleJunPro(
                                                14, FontWeight.bold),
                                        textAlign: TextAlign.center,
                                      ),
                                    ),
                                    onTap: LeooNavigatorUtilsJunPro
                                        .leooDebounceJunPro(() {
                                      visibleKey.currentState
                                          ?.onSetState(false);
                                      currentUserIndex = index;
                                      setBottomSheetState(() {});
                                    }),
                                  );
                                },
                              ),
                            ),
                          ),
                          left: 1,
                        ),
                      ),
                    ),
                  ],
                ),
              );
            });
          });
    } else {
      return null;
    }
  }

  Widget getGiftChildWidget(
      BuildContext context,
      LeooUserProviderJunPro userProvider,
      LeooGiftEntity item,
      bool check,
      Function giftClick) {
    return InkWell(
      splashColor: Colors.transparent,
      highlightColor: Colors.transparent,
      child: Container(
        decoration: BoxDecoration(
          border: Border.all(
              color: check
                  ? LeooColorsJunPro.leooAppJunPro
                  : Colors.white.withOpacity(.2),
              width: 2.w),
          borderRadius: BorderRadius.circular(10),
        ),
        padding: EdgeInsets.fromLTRB(5.w, 5.w, 5.w, 10.w),
        child: Column(
          mainAxisAlignment: MainAxisAlignment.spaceEvenly,
          children: <Widget>[
            LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
              item.imgUrl,
              width: 60.w,
              height: 60.w,
              color: false,
            ),
            LeooTextWidgetJunPro(
              item.price.replaceAll('.0', ''),
              LeooTextJunPro.leooGetTextStyleJunPro(14, FontWeight.bold),
              iconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                LeooIconsJunPro.leooMainCoinsJunPro,
                width: 15.w,
                height: 15.w,
              ),
              iconPadding: 2.w,
              mainAxisSize: MainAxisSize.min,
              maxWidth: 36.w,
            ),
          ],
        ),
      ),
      onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
        int money = userProvider.userEntity.amount ?? 0;
        if (money == 0 || money < double.parse(item.price)) {
          showRechargeDialog(context, S.of(context).diamondGiftTip, back: true);
        } else {
          giftClick();
        }
      }),
    );
  }

  Future showGiftView(BuildContext context, LeooGiftEntity gift) async {
    return LeooNavigatorUtilsJunPro.leooShowBaseDialogJunPro(context,
        name: 'showGiftView', builder: (BuildContext showContext) {
      return Center(
        child: LeooZoomInWidgetJunPro(
          Column(
            mainAxisSize: MainAxisSize.min,
            children: [
              LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                gift.imgUrl,
                width: 200.w,
                height: 200.w,
                color: false,
              ),
              Padding(
                  padding: EdgeInsets.only(top: 15.w, bottom: 30.w),
                  child: Text(gift.name,
                      style: LeooTextJunPro.leooGetTextStyleJunPro(
                          24, FontWeight.bold)))
            ],
          ),
          back: () {
            Navigator.pop(context);
          },
        ),
      );
    });
  }

  Future<EMMessage?> willSendGift(BuildContext context,
      LeooUserProviderJunPro userProvider, LeooGiftEntity gift, int? userId,
      {pop, bool send = false}) async {
    LeooDialogUtilsJunPro.instance.showLoadingDialog(context);
    return LeooMainDaoJunPro.leooDeductionGiftJunPro(int.parse(gift.id), userId)
        .then((res) {
      Navigator.pop(context);
      if (res.result) {
        if (res.data.enough == 0) {
          showRechargeDialog(context, S.of(context).diamondSendTip);
        } else {
          userProvider.setMoney(res.data.amount);
          showGiftView(context, gift).then((value) {
            pop?.call();
          });
          EMMessage sendMessage = EMMessage.createCustomSendMessage(
              username: userId.toString(),
              event: LeooAppConfigJunPro.leooGiftEventJunPro,
              params: gift.toJson().cast<String, String>());
          sendMessage.attributes = {
            'em_apns_ext': {
              'em_push_name': userProvider.userEntity.nickname,
              'em_push_content': '[${gift.name}]'
            }
          };
          if (send) {
            EMClient.getInstance.chatManager.sendMessage(sendMessage);
          }
          return sendMessage;
        }
      } else {
        Navigator.pop(context);
        showRechargeDialog(context, S.of(context).diamondGiftTip);
      }
      return null;
    });
  }

  int getRoomSize(int size) {
    Random random = Random();
    if (size == 0) {
      return random.nextInt(3001) + 2000;
    } else {
      int next = random.nextInt(21) - 20 + size;
      if (next < 2000 && next < random.nextInt(1001) + 1000) {
        return random.nextInt(21) + size;
      } else if (next > 10000 && next > random.nextInt(10001) + 10000) {
        return size - random.nextInt(21);
      } else {
        return next;
      }
    }
  }

  int getRoomJunProSize(int? size, {bool first = false}) {
    Random random = Random();
    if (size == 0 || first) {
      return size! + random.nextInt(100) + 101;
    } else {
      int next = random.nextInt(31) - 10 + size!;
      if (next < 200 && next < random.nextInt(101) + 100) {
        return random.nextInt(21) + size;
      } else if (next > 2000 && next > random.nextInt(1001) + 1000) {
        return size - random.nextInt(21);
      } else {
        return next;
      }
    }
  }

  Future connectionInPay(String? payId, double? price, {String? inType}) async {
    if (await checkInPay(first: false) == false && !showLoading) {
      if (inType != null) {
        payInType = inType;
        FirebaseAnalytics.instance.logEvent(name: '$payInType发起内购支付');
      } else {
        payInType = null;
      }
      showRechargeLoading();
      final bool isAvailable = await connection.isAvailable();
      if (isAvailable) {
        Set<String> _kProductIds = {payId!};
        ProductDetailsResponse productDetailResponse =
            await connection.queryProductDetails(_kProductIds);
        if (productDetailResponse.error == null) {
          List<ProductDetails> products = productDetailResponse.productDetails;
          if (products.isNotEmpty) {
            bool buy = false;
            try {
              FirebaseAnalytics.instance
                  .logEvent(name: '用户进入内购列表点击${'$price'.replaceAll('.', '_')}');
              PurchaseParam purchaseParam =
                  PurchaseParam(productDetails: products[0]);
              buy = await connection.buyConsumable(
                  purchaseParam: purchaseParam,
                  autoConsume: !Platform.isAndroid);
              LeooNetConfigJunPro.leooPrintLogJunPro('buyConsumable: $buy');
              if (buy) {
                FirebaseAnalytics.instance
                    .logEvent(name: '${payInType ?? ''}成功调起内购支付');
                return true;
              }
            } catch (e) {
              FirebaseAnalytics.instance.logEvent(
                  name: '${payInType ?? ''}内购支付调取失败, buyConsumable');
              LeooNetConfigJunPro.leooPrintLogJunPro(e);
              if (showLoading) {
                showLoading = false;
                Navigator.pop(LeooRouterJunPro.leooContextJunPro);
              }
              showInPay = true;
              LeooDialogUtilsJunPro.instance
                  .showCustomDialog(LeooRouterJunPro.leooContextJunPro,
                      content: S.of(LeooRouterJunPro.leooContextJunPro).inAppNo,
                      dismiss: false)
                  .then((value) async {
                showInPay = false;
                if (value == true) {
                  showRechargeLoading();
                  queryPastPurchases(refresh: true);
                }
              });
              return false;
            }
            FirebaseAnalytics.instance
                .logEvent(name: '${payInType ?? ''}内购支付统一下单失败');
            if (showLoading) {
              showLoading = false;
              Navigator.pop(LeooRouterJunPro.leooContextJunPro);
            }
            LeooCommonUtilsJunPro.leooShowErrorToastJunPro();
            return false;
          }
        }
      }
      FirebaseAnalytics.instance.logEvent(name: '${payInType ?? ''}内购支付不存在');
      if (showLoading) {
        showLoading = false;
        Navigator.pop(LeooRouterJunPro.leooContextJunPro);
      }
      LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
          S.of(LeooRouterJunPro.leooContextJunPro).inAppPaymentNo);
      return false;
    } else {
      return false;
    }
  }

  Future checkInPayPurchase(String? token, String? productID,
      {bool first = false,
      PurchaseDetails? purchaseDetail,
      int index = 1,
      int indexNum = 1,
      int indexNumNext = 1}) async {
    if (LeooAppConfigJunPro.leooTokenJunPro.isEmpty == false) {
      FirebaseAnalytics.instance
          .logEvent(name: '${payInType ?? ''}支付成功调起服务器接口$index');
      await LeooMainDaoJunPro.leooCheckBillJunPro(token, productId: productID)
          .then((res) async {
        timer?.cancel();
        if (res.result) {
          FirebaseAnalytics.instance
              .logEvent(name: '${payInType ?? ''}调起服务器成功$index');
          bool show = false;
          if (showLoading) {
            showLoading = false;
            Navigator.pop(LeooRouterJunPro.leooContextJunPro);
            show = true;
          }
          clearRechargeList();
          eventBus.fire(LeooRechargeEventJunPro(res.data.amount));
          if (show) {
            LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
                S.of(LeooRouterJunPro.leooContextJunPro).inAppOk);
          }
          FirebaseAnalytics.instance.logEvent(name: '${payInType ?? ''}成功加币');
          SpUtil.putString(LeooAppConfigJunPro.leooInTokenJunPro, '');
          SpUtil.putString(LeooAppConfigJunPro.leooInCodeJunPro, '');
          if (purchaseDetail != null) {
            completePurchaseInPay(purchaseDetail);
          } else if (Platform.isAndroid) {
            queryPastPurchases();
          } else {
            paymentQueueWrapper(payId: productID, delayed: false);
          }
        } else {
          int errorData = 0;
          try {
            errorData = res.data?.data;
          } catch (e) {
            LeooNetConfigJunPro.leooPrintLogJunPro(e);
          }
          if (errorData != 0) {
            if (errorData != 4) {
              LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
            }
            if (showLoading) {
              showLoading = false;
              Navigator.pop(LeooRouterJunPro.leooContextJunPro);
            }
            if (errorData == 1) {
              showInPayDialog(token, productID,
                  showLeft: !first,
                  restored: purchaseDetail?.status == PurchaseStatus.restored);
            } else {
              FirebaseAnalytics.instance
                  .logEvent(name: '${payInType ?? ''}订单错误状态：$errorData');
              SpUtil.putString(LeooAppConfigJunPro.leooInTokenJunPro, '');
              SpUtil.putString(LeooAppConfigJunPro.leooInCodeJunPro, '');
            }
            return;
          }
          FirebaseAnalytics.instance
              .logEvent(name: '${payInType ?? ''}调起服务器失败$index');
          try {
            rechargeError = res.data?.message;
          } catch (e) {
            LeooNetConfigJunPro.leooPrintLogJunPro(e);
          }
          var connectivityResult = await (Connectivity().checkConnectivity());
          if (connectivityResult == ConnectivityResult.none) {
            FirebaseAnalytics.instance
                .logEvent(name: '${payInType ?? ''}重试$index次由于网络终止');
          } else {
            FirebaseAnalytics.instance
                .logEvent(name: '${payInType ?? ''}重试$index次');
          }
          LeooNetConfigJunPro.leooPrintLogJunPro(
              '支付失败重试: $index, 时间: ${index > 2 ? indexNum + indexNumNext : indexNumNext}');
          if (connectivityResult == ConnectivityResult.none ||
              index >= maxIndex) {
            LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
            if (showLoading) {
              showLoading = false;
              Navigator.pop(LeooRouterJunPro.leooContextJunPro);
            }
            showInPayDialog(token, productID,
                showLeft: !first,
                restored: purchaseDetail?.status == PurchaseStatus.restored);
          } else {
            timer = Timer(
                Duration(
                    seconds: index > 2
                        ? indexNum + indexNumNext
                        : indexNumNext), () async {
              checkInPayPurchase(token, productID,
                  first: first,
                  purchaseDetail: purchaseDetail,
                  index: index + 1,
                  indexNum: indexNumNext,
                  indexNumNext:
                      index > 2 ? indexNum + indexNumNext : indexNumNext);
            });
          }
        }
      });
    } else {
      FirebaseAnalytics.instance
          .logEvent(name: '${payInType ?? ''}支付成功token空无法调起服务器接口');
    }
  }

  Future checkInPay({bool first = true}) async {
    String? token = SpUtil.getString(LeooAppConfigJunPro.leooInTokenJunPro);
    if (token?.isEmpty == false) {
      String? productID =
          SpUtil.getString(LeooAppConfigJunPro.leooInCodeJunPro);
      if (first) {
        startInPayPurchase(token, productID, first: first);
      } else {
        showInPayDialog(token, productID, showLeft: first);
      }
      return true;
    }
    return false;
  }

  void showInPayDialog(String? token, String? productID,
      {bool showLeft = true, bool restored = false}) {
    if (showInPay || restored) {
      return;
    }
    showInPay = true;
    FocusScope.of(LeooRouterJunPro.leooContextJunPro).unfocus();
    LeooNavigatorUtilsJunPro.leooShowBaseDialogJunPro(
        LeooRouterJunPro.leooContextJunPro,
        name: 'showInPayDialog', builder: (BuildContext showContext) {
      return WillPopScope(
          onWillPop: () => Future.value(false),
          child: Center(
            child: Container(
              width: 1.sw - 100.w,
              decoration: BoxDecoration(
                color: LeooColorsJunPro.leooPopBgJunPro,
                borderRadius: BorderRadius.all(
                  Radius.circular(28),
                ),
              ),
              padding: EdgeInsets.fromLTRB(20.w, 10.w, 20.w, 30.w),
              child: Column(
                mainAxisSize: MainAxisSize.min,
                children: <Widget>[
                  Padding(
                      padding: EdgeInsets.fromLTRB(20.w, 10.w, 20.w, 20.w),
                      child: Text(
                          S
                              .of(LeooRouterJunPro.leooContextJunPro)
                              .inAppPopTitle,
                          style: LeooTextJunPro.leooGetTextStyleAppJunPro(
                              22, FontWeight.bold),
                          textAlign: TextAlign.center)),
                  LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                    LeooIconsJunPro.leooMainCoinsJunPro,
                    width: 32.w,
                    height: 32.w,
                  ),
                  Padding(
                      padding: EdgeInsets.all(20.w),
                      child: Text(
                          S
                              .of(LeooRouterJunPro.leooContextJunPro)
                              .inAppPopContent,
                          style: LeooTextJunPro.leooGetTextStyleJunPro(14),
                          textAlign: TextAlign.center)),
                  showLeft
                      ? Row(
                          mainAxisAlignment: MainAxisAlignment.spaceEvenly,
                          children: <Widget>[
                            Expanded(
                              child: LeooButtonWidgetJunPro(
                                S
                                    .of(LeooRouterJunPro.leooContextJunPro)
                                    .appCancel,
                                LeooTextJunPro.leooGetTextStyleJunPro(
                                    16, FontWeight.bold),
                                textAlign: TextAlign.center,
                                color: LeooColorsJunPro.leooBtnBgJunPro,
                                shape: RoundedRectangleBorder(
                                  borderRadius: BorderRadius.circular(20),
                                ),
                                padding:
                                    EdgeInsets.only(top: 10.w, bottom: 10.w),
                                mainAxisSize: MainAxisSize.min,
                                onPressed:
                                    LeooNavigatorUtilsJunPro.leooDebounceJunPro(
                                        () async {
                                  Navigator.pop(showContext);
                                  FirebaseAnalytics.instance
                                      .logEvent(name: '${payInType ?? ''}取消重试');
                                }),
                              ),
                            ),
                            SizedBox(width: 18.w),
                            Expanded(
                              child: LeooButtonWidgetJunPro(
                                S
                                    .of(LeooRouterJunPro.leooContextJunPro)
                                    .appContinue,
                                LeooTextJunPro.leooGetTextStyleJunPro(
                                    16, FontWeight.bold),
                                textAlign: TextAlign.center,
                                color: LeooColorsJunPro.leooAppJunPro,
                                colorRight: LeooColorsJunPro.leooApp2JunPro,
                                shape: RoundedRectangleBorder(
                                  borderRadius: BorderRadius.circular(20),
                                ),
                                padding:
                                    EdgeInsets.only(top: 10.w, bottom: 10.w),
                                mainAxisSize: MainAxisSize.min,
                                onPressed:
                                    LeooNavigatorUtilsJunPro.leooDebounceJunPro(
                                        () {
                                  Navigator.pop(showContext);
                                  FirebaseAnalytics.instance
                                      .logEvent(name: '${payInType ?? ''}手动重试');
                                  showRechargeLoading();
                                  queryPastPurchases(refresh: true);
                                }),
                              ),
                            ),
                          ],
                        )
                      : LeooButtonWidgetJunPro(
                          S.of(LeooRouterJunPro.leooContextJunPro).appContinue,
                          LeooTextJunPro.leooGetTextStyleJunPro(
                              16, FontWeight.bold),
                          textAlign: TextAlign.center,
                          color: LeooColorsJunPro.leooAppJunPro,
                          colorRight: LeooColorsJunPro.leooApp2JunPro,
                          shape: RoundedRectangleBorder(
                            borderRadius: BorderRadius.circular(20),
                          ),
                          padding: EdgeInsets.only(top: 10.w, bottom: 10.w),
                          mainAxisSize: MainAxisSize.max,
                          onPressed:
                              LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                            Navigator.pop(showContext);
                            FirebaseAnalytics.instance
                                .logEvent(name: '${payInType ?? ''}手动重试');
                            showRechargeLoading();
                            queryPastPurchases(refresh: true);
                          }),
                        ),
                ],
              ),
            ),
          ));
    }).then((value) {
      showInPay = false;
    });
  }

  void startInPayPurchase(String? token, String? productID,
      {bool first = false,
      int index = 1,
      int indexNum = 1,
      int indexNumNext = 1}) async {
    if (!showLoading) {
      if (!first) {
        showRechargeLoading();
        checkInPayPurchase(token, productID,
            first: first,
            index: index,
            indexNum: indexNum,
            indexNumNext: indexNumNext);
      } else {
        checkInPayPurchase(token, productID,
            first: first,
            index: index,
            indexNum: indexNum,
            indexNumNext: indexNumNext);
      }
    }
  }
}
