import 'dart:ui';

import 'package:country_pickers/country.dart';
import 'package:firebase_analytics/firebase_analytics.dart';
import 'package:flutter/material.dart';
import 'package:flutter_picker/flutter_picker.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoodaoresultjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoomaindaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leootalkentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoouserentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoovideolistentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocountryutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoodialogutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoorechargeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoovideoutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leootextwidgetjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leooinfojunpro/leooinfojunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoolistjunpro/leoovideolistjunpro.dart';

///通用逻辑-基本方法管理-通用控件方法
class LeooWidgetUtilsJunPro {
  ///导航栏
  static Widget leooGetAppBarWidgetJunPro(BuildContext context, String title,
      {Widget? leftChild,
      Widget? rightChild,
      String? popIcon,
      Decoration? decoration,
      double? right,
      bool back = true,
      bool top = false,
      Color? color,
      Function? pop}) {
    return Container(
      color: decoration == null ? (color ?? Colors.transparent) : null,
      decoration: decoration,
      padding: EdgeInsets.only(top: top ? ScreenUtil().statusBarHeight : 0),
      child: Stack(
        alignment: Alignment.center,
        children: <Widget>[
          Container(
            width: 1.sw,
            height: 56.w,
            alignment: Alignment.center,
            margin: EdgeInsets.only(left: 40.w, right: 40.w),
            child: Text(title,
                style:
                    LeooTextJunPro.leooGetTextStyleJunPro(20, FontWeight.bold),
                textAlign: TextAlign.center,
                maxLines: 1,
                overflow: TextOverflow.ellipsis),
          ),
          if (back && leftChild == null)
            Positioned(
              left: 4.w,
              child: IconButton(
                iconSize: 40.w,
                padding: const EdgeInsets.all(0),
                icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                    popIcon ?? LeooIconsJunPro.leooTopBackJunPro,
                    width: 40.w,
                    height: 40.w),
                onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                  if (pop == null) {
                    Navigator.pop(context);
                  } else {
                    pop();
                  }
                }),
              ),
            ),
          if (leftChild != null)
            Positioned(
              left: 4.w,
              child: leftChild,
            ),
          if (rightChild != null)
            Positioned(
              right: right ?? 4.w,
              child: rightChild,
            ),
        ],
      ),
    );
  }

  static Widget leooGetCountryItemJunPro(Country country) {
    return Row(children: <Widget>[
      LeooCountryPickerUtilsJunPro.getDefaultFlagImage(country),
      SizedBox(width: 8.w),
      Text('+${country.phoneCode}',
          style: LeooTextJunPro.leooGetTextStyleJunPro(16)),
      SizedBox(width: 8.w),
      Flexible(
          child: Text(country.name,
              style: LeooTextJunPro.leooGetTextStyleJunPro(16)))
    ]);
  }

  static Widget leooGetOnlineTipJunPro(context, int? online,
      {int size = 14, BoxBorder? border}) {
    Color color;
    switch (online) {
      case 1:
        color = LeooColorsJunPro.leooBusyJunPro;
        break;
      case 2:
        color = LeooColorsJunPro.leooOnlineJunPro;
        break;
      default:
        color = LeooColorsJunPro.leooOfflineJunPro;
        break;
    }
    return Container(
      width: size.w,
      height: size.w,
      decoration: BoxDecoration(
        shape: BoxShape.circle,
        color: color,
        border: border ??
            Border.all(
              color: LeooColorsJunPro.leooBgJunPro,
              width: 2.w,
            ),
      ),
    );
  }

  static Widget leooGetOnlineTextJunPro(context, int? online,
      [bool host = false]) {
    String text;
    Color color;
    if (host) {
      switch (online) {
        case 1:
          text = S.of(context).online;
          color = LeooColorsJunPro.leooOnlineJunPro;
          break;
        case 2:
          text = S.of(context).busy;
          color = LeooColorsJunPro.leooBusyJunPro;
          break;
        default:
          text = S.of(context).offline;
          color = LeooColorsJunPro.leooOfflineJunPro;
          break;
      }
    } else {
      switch (online) {
        case 1:
          text = S.of(context).busy;
          color = LeooColorsJunPro.leooBusyJunPro;
          break;
        case 2:
          text = S.of(context).online;
          color = LeooColorsJunPro.leooOnlineJunPro;
          break;
        default:
          text = S.of(context).offline;
          color = LeooColorsJunPro.leooOfflineJunPro;
          break;
      }
    }
    return Container(
      padding: EdgeInsets.fromLTRB(10.w, 4.w, 10.w, 2.5.w),
      decoration: ShapeDecoration(color: color, shape: const StadiumBorder()),
      child: Text(text,
          style: LeooTextJunPro.leooGetTextStyleJunPro(14, FontWeight.bold)),
    );
  }

  //通话最终状态类型：1、Missed call 未接来电 2、Call ended 通话结束 3、Reject the call 拒绝来电
  // 4、No answer。 无应答 5、Call rejected。 来电被拒 6、Calling。 通话中;
  static String leooGetCallStatusTextJunPro(context, int? status) {
    switch (status) {
      case 2:
        return S.of(context).callStatus2;
      case 3:
        return S.of(context).callStatus3;
      case 4:
        return S.of(context).callStatus4;
      case 5:
        return S.of(context).callStatus5;
      case 6:
        return S.of(context).callStatus6;
      default:
        return S.of(context).callStatus1;
    }
  }

  static Widget leooGetCallStatusIconJunPro(int? status) {
    String icon;
    switch (status) {
      case 2:
      case 6:
        icon = LeooIconsJunPro.leooCallEndJunPro;
        break;
      case 3:
      case 5:
        icon = LeooIconsJunPro.leooCallRejectedJunPro;
        break;
      default:
        icon = LeooIconsJunPro.leooCallMissedJunPro;
        break;
    }
    return LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
      icon,
      width: 20.w,
      height: 20.w,
    );
  }

  static Widget leooAllBgWidgetJunPro(Widget child, {Color? color}) {
    return Container(
      decoration: BoxDecoration(
        gradient: LinearGradient(
          begin: Alignment.topCenter,
          end: Alignment.bottomCenter,
          colors: [
            color ?? LeooColorsJunPro.leooTextJunPro,
            color ?? Colors.black,
          ],
        ),
      ),
      child: child,
    );
  }

  static Future leooShowCareDialogJunPro(
      BuildContext context, int? following, int? userId, back,
      {String? log,
      String? nickname,
      int? age,
      int? gender,
      String? country,
      String? header,
      String? description}) {
    if (following == 1) {
      return LeooDialogUtilsJunPro.instance
          .showCustomDialog(context, content: S.of(context).followTip)
          .then((value) {
        if (value == true) {
          leooHostCareJunPro(context, following, userId, back,
              log: log,
              nickname: nickname,
              age: age,
              gender: gender,
              country: country,
              header: header,
              description: description);
        }
        return value;
      });
    } else {
      leooHostCareJunPro(context, following, userId, back,
          log: log,
          nickname: nickname,
          age: age,
          gender: gender,
          country: country,
          header: header,
          description: description);
      return Future.value();
    }
  }

  static void leooHostCareJunPro(
      BuildContext context, int? following, int? userId, back,
      {String? log,
      String? nickname,
      int? age,
      int? gender,
      String? country,
      String? header,
      String? description}) {
    LeooDialogUtilsJunPro.instance.showLoadingDialog(context);
    Future<LeooDataResultJunPro> res;
    if (following == 1) {
      FirebaseAnalytics.instance.logEvent(name: '${log ?? ''}点击取消关注');
      res = LeooMainDaoJunPro.leooCancelFollowingJunPro(userId);
    } else {
      FirebaseAnalytics.instance.logEvent(name: '${log ?? ''}点击关注');
      res = LeooMainDaoJunPro.leooFollowingJunPro(userId,
          nickname: nickname,
          age: age,
          gender: gender,
          country: country,
          header: header,
          description: description);
    }
    res.then((res) {
      Navigator.pop(context);
      if (res.result) {
        if (following == 1) {
          back(0);
          LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
              S.of(context).appComplete(S.of(context).appCancel));
        } else {
          back(1);
          LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
              S.of(context).appComplete(S.of(context).followUser));
        }
      } else {
        LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
      }
    });
  }

  static Widget leooGetFollowListChildWidgetJunPro(
      context, LeooUserEntity item, String hero) {
    return InkWell(
      child: Padding(
        padding: EdgeInsets.all(15.w),
        child: Row(
          children: <Widget>[
            Stack(
              alignment: Alignment.topRight,
              children: [
                Hero(
                  tag: hero,
                  transitionOnUserGestures: true,
                  child: ClipOval(
                    child: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                      item.header,
                      width: 50.w,
                      height: 50.w,
                      load: LeooIconsJunPro.leooLoadHeadJunPro,
                    ),
                  ),
                ),
                LeooWidgetUtilsJunPro.leooGetOnlineTipJunPro(
                    context, item.chatStatus),
              ],
            ),
            SizedBox(width: 10.w),
            Expanded(
              child: Column(
                crossAxisAlignment: CrossAxisAlignment.start,
                children: [
                  Text(item.nickname ?? '',
                      style: LeooTextJunPro.leooGetTextStyleJunPro(
                          20, FontWeight.bold),
                      maxLines: 1,
                      overflow: TextOverflow.ellipsis),
                  SizedBox(height: 5.w),
                  Text(item.description ?? '',
                      style: LeooTextJunPro.leooGetTextStyleHintJunPro(16),
                      maxLines: 1,
                      overflow: TextOverflow.ellipsis),
                ],
              ),
            ),
            SizedBox(width: 10.w),
            IconButton(
              padding: const EdgeInsets.all(0),
              icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                LeooIconsJunPro.leooListVideoJunPro,
                width: 50.w,
                height: 50.w,
              ),
              onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                LeooVideoUtilsJunPro.instance
                    .requestVideoPermission(context, item.id, infoEntity: item);
              }),
            ),
          ],
        ),
      ),
      onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
        LeooNavigatorUtilsJunPro.leooInfoPageJunPro?.call(context, item.id,
                following: item.following, infoEntity: item) ??
            LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
                context, LeooInfoJunPro(item.id, item, hero), 'LeooInfoJunPro',
                add: true);
      }),
    );
  }

  static Widget leooGetListTalkChildWidgetJunPro(
      context, LeooTalkEntity item, String hero) {
    return InkWell(
      child: Padding(
        padding: EdgeInsets.all(15.w),
        child: Row(
          children: <Widget>[
            if (item.matchingId == null)
              leooGetCallStatusIconJunPro(item.talkStatus),
            if (item.matchingId == null) SizedBox(width: 10.w),
            Stack(
              alignment: Alignment.topRight,
              children: [
                Hero(
                  tag: hero,
                  transitionOnUserGestures: true,
                  child: ClipOval(
                    child: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                      item.header,
                      width: 50.w,
                      height: 50.w,
                      load: LeooIconsJunPro.leooLoadHeadJunPro,
                    ),
                  ),
                ),
                LeooWidgetUtilsJunPro.leooGetOnlineTipJunPro(
                    context, item.onlineStatus),
              ],
            ),
            SizedBox(width: 10.w),
            Expanded(
              child: Column(
                crossAxisAlignment: CrossAxisAlignment.start,
                children: [
                  Text(item.nickname ?? '',
                      style: LeooTextJunPro.leooGetTextStyleJunPro(
                          20, FontWeight.bold),
                      maxLines: 1,
                      overflow: TextOverflow.ellipsis),
                  SizedBox(height: 5.w),
                  Text(
                      item.matchingId == null
                          ? item.talkStatus != 2 && item.talkStatus != 6
                              ? leooGetCallStatusTextJunPro(
                                  context, item.talkStatus)
                              : S.of(context).callDuration(
                                  LeooCodeUtilsJunPro.leooGetTimeStrJunPro(
                                      DateTime.fromMillisecondsSinceEpoch(
                                          (item.talkingTimeLength ?? 0) * 1000,
                                          isUtc: true)))
                          : LeooCodeUtilsJunPro.leooGetNewsTimeStrJunPro(
                              context,
                              DateTime.fromMillisecondsSinceEpoch(
                                  item.matchedTime ?? 0)),
                      style: item.matchingId != null ||
                              item.talkStatus == 2 ||
                              item.talkStatus == 6
                          ? LeooTextJunPro.leooGetTextStyleOnlineJunPro(16)
                          : item.talkStatus == 3 || item.talkStatus == 5
                              ? LeooTextJunPro.leooGetTextStyleHintJunPro(16)
                              : LeooTextJunPro.leooGetTextStyleAppJunPro(16),
                      maxLines: 1,
                      overflow: TextOverflow.ellipsis),
                ],
              ),
            ),
            SizedBox(width: 10.w),
            IconButton(
              padding: const EdgeInsets.all(0),
              icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                LeooIconsJunPro.leooListVideoJunPro,
                width: 50.w,
                height: 50.w,
              ),
              onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                LeooUserEntity infoEntity = LeooUserEntity(
                  id: item.userId,
                  nickname: item.nickname,
                  header: item.header,
                );
                LeooVideoUtilsJunPro.instance.requestVideoPermission(
                    context, item.userId,
                    infoEntity: infoEntity);
              }),
            ),
          ],
        ),
      ),
      onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
        LeooUserEntity infoEntity = LeooUserEntity(
          id: item.userId,
          nickname: item.nickname,
          header: item.header,
        );
        LeooNavigatorUtilsJunPro.leooInfoPageJunPro
                ?.call(context, item.userId, infoEntity: infoEntity) ??
            LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(context,
                LeooInfoJunPro(item.userId, infoEntity, hero), 'LeooInfoJunPro',
                add: true);
      }),
    );
  }

  static Widget leooGetCountryWidgetJunPro(context, String? country,
      {bool name = false, bool bg = false, bool item = true}) {
    return Row(
      mainAxisSize: MainAxisSize.min,
      children: [
        LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
          LeooCountryPickerUtilsJunPro.getFlagImageAssetPath(name
              ? LeooCountryPickerUtilsJunPro.getCountryByName(country)?.isoCode
              : country),
          width: 18.w,
          fit: BoxFit.fitHeight,
          imageStartUrl: LeooCountryPickerUtilsJunPro.getFlagImageAssetPath(name
              ? LeooCountryPickerUtilsJunPro.getCountryByName(country)?.isoCode
              : country),
          package: 'country_pickers',
        ),
        SizedBox(width: 4.5.w),
        Container(
          constraints: BoxConstraints(maxWidth: item ? 1.sw / 5 : 1.sw / 2),
          child: Text(
              (name
                      ? country
                      : LeooCountryPickerUtilsJunPro.getCountryByIsoCode(
                              country)
                          ?.name) ??
                  '',
              style: LeooTextJunPro.leooGetTextStyleJunPro(14, FontWeight.bold),
              maxLines: 1,
              overflow: TextOverflow.ellipsis),
        ),
      ],
    );
  }

  static Widget leooGetVideoListChildWidgetJunPro(
      BuildContext context,
      int type,
      int page,
      LeooVideoListEntity item,
      int index,
      List<LeooVideoListEntity> allList) {
    return InkWell(
      child: Stack(
        alignment: Alignment.center,
        children: <Widget>[
          ClipRRect(
            borderRadius: BorderRadius.circular(20),
            child: Stack(
              children: [
                LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                  item.videoCoverUrl,
                  width: .5.sw,
                  height: .5.sh,
                ),
                if (item.feeType == 1 && item.unlockStatus == 0)
                  BackdropFilter(
                    filter: ImageFilter.blur(sigmaX: 6, sigmaY: 6),
                    child: Container(
                      color: Colors.white.withOpacity(.1),
                    ),
                  ),
              ],
            ),
          ),
          if (type != 3 || item.checkStatus == 1)
            Positioned(
              left: 0,
              right: 0,
              bottom: 0,
              child: Container(
                padding: EdgeInsets.all(10.w),
                decoration: BoxDecoration(
                  gradient: LinearGradient(
                    begin: Alignment.topCenter,
                    end: Alignment.bottomCenter,
                    colors: [
                      LeooColorsJunPro.leooBgJunPro.withOpacity(0),
                      LeooColorsJunPro.leooBgJunPro.withOpacity(.7),
                    ],
                  ),
                ),
                child: Column(
                  crossAxisAlignment: CrossAxisAlignment.start,
                  children: [
                    Text(item.nickname ?? '',
                        style: LeooTextJunPro.leooGetTextStyleJunPro(
                            20, FontWeight.bold)),
                    LeooTextWidgetJunPro(
                      '+${item.likeCount}',
                      LeooTextJunPro.leooGetTextStyleJunPro(
                          16, FontWeight.bold),
                      iconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                        LeooIconsJunPro.leooVideoListFireJunPro,
                        width: 15.w,
                        height: 15.w,
                      ),
                      iconPadding: 2.5.w,
                      mainAxisSize: MainAxisSize.min,
                      maxWidth: .3.sw,
                    ),
                  ],
                ),
              ),
            ),
          type != 3 || item.checkStatus == 1
              ? LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                  item.feeType == 0 || item.unlockStatus == 1 || type == 3
                      ? LeooIconsJunPro.leooVideoPlayJunPro
                      : LeooIconsJunPro.leooVideoLockJunPro,
                  width: 50.w,
                  height: 50.w,
                )
              : Text(
                  item.checkStatus == 2
                      ? S.of(context).videoAudit
                      : S.of(context).videoUnder,
                  style: LeooTextJunPro.leooGetTextStyleAppJunPro(
                      16, FontWeight.bold),
                ),
        ],
      ),
      onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
        LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
            context,
            LeooVideoListJunPro(type, page, index, allList),
            'LeooVideoListJunPro',
            add: true);
      }),
    );
  }

  static Widget leooGetMainCoinsWidgetJunPro(BuildContext context, int? amount,
      [bool check = true]) {
    return InkWell(
      child: Container(
        decoration: ShapeDecoration(
          shape: StadiumBorder(
            side: BorderSide(
              color: LeooColorsJunPro.leooCoinsLineJunPro,
              width: 1.w,
            ),
          ),
        ),
        padding: EdgeInsets.fromLTRB(8.w, 5.w, 10.w, 5.w),
        child: Row(
          children: [
            LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
              LeooIconsJunPro.leooMainCoinsJunPro,
              width: 20.w,
              height: 20.w,
            ),
            SizedBox(width: 5.w),
            Text(
              '${amount ?? 0}',
              style: LeooTextJunPro.leooGetTextStyleJunPro(16, FontWeight.bold),
            ),
          ],
        ),
      ),
      onTap: check
          ? LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
              LeooRechargeUtilsJunPro.instance.goRechargePage(context);
            })
          : null,
    );
  }

  static void leooShowPickerWidgetJunPro(
      BuildContext context,
      PickerAdapter adapter,
      List<int> selected,
      String title,
      PickerConfirmCallback back) {
    FocusScope.of(context).unfocus();
    Future.delayed(const Duration(milliseconds: 100), () {
      Picker(
          adapter: adapter,
          looping: true,
          changeToFirst: true,
          selecteds: selected,
          title: Text(
            title,
            style: LeooTextJunPro.leooGetTextStyleJunPro(20, FontWeight.bold),
          ),
          textStyle: LeooTextJunPro.leooGetTextStyleJunPro(18),
          cancelTextStyle:
              LeooTextJunPro.leooGetTextStyleJunPro(16, FontWeight.bold),
          confirmTextStyle:
              LeooTextJunPro.leooGetTextStyleJunPro(16, FontWeight.bold),
          selectedTextStyle:
              LeooTextJunPro.leooGetTextStyleJunPro(20, FontWeight.bold),
          backgroundColor: LeooColorsJunPro.leooPopBgJunPro,
          containerColor: LeooColorsJunPro.leooPopBgJunPro,
          headerColor: LeooColorsJunPro.leooPopBgJunPro,
          itemExtent: 50.w,
          height: 200.w,
          onConfirm: (Picker picker, List<int> value) {
            back.call(picker, value);
          }).showModal(context);
    });
  }
}
