import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';

///返回菜单-刷新控制
class LeooAppBarWidgetJunPro extends StatefulWidget {
  final String title;
  final Color? color;
  final bool top;
  final Widget? rightChild;
  final Widget? rightChild2;

  const LeooAppBarWidgetJunPro(this.title,
      {Key? key,
      this.color,
      this.top = true,
      this.rightChild,
      this.rightChild2})
      : super(key: key);

  @override
  LeooAppBarWidgetState createState() => LeooAppBarWidgetState();
}

class LeooAppBarWidgetState extends State<LeooAppBarWidgetJunPro>
    with SingleTickerProviderStateMixin {
  bool show = true;
  Color? color;
  Widget? rightChild;
  Widget? rightChild2;

  @override
  void initState() {
    super.initState();
    color = widget.color;
    rightChild = widget.rightChild;
    rightChild2 = widget.rightChild2;
  }

  @override
  void didUpdateWidget(covariant LeooAppBarWidgetJunPro oldWidget) {
    super.didUpdateWidget(oldWidget);
    if (rightChild != widget.rightChild) {
      rightChild = widget.rightChild;
    }
  }

  void onSetState(Color? color, Widget rightChild, Widget rightChild2) {
    this.color = color;
    this.rightChild = rightChild;
    this.rightChild2 = rightChild2;
    show = color == null;
    LeooCodeUtilsJunPro.onSetState(this);
  }

  @override
  Widget build(BuildContext context) {
    return Container(
      color: color ?? LeooColorsJunPro.leooAppJunPro,
      padding:
          EdgeInsets.only(top: widget.top ? ScreenUtil().statusBarHeight : 0),
      child: Stack(
        alignment: Alignment.center,
        children: <Widget>[
          Container(
            width: 1.sw,
            height: 56.w,
            alignment: Alignment.center,
            margin: EdgeInsets.only(left: 40.w, right: 40.w),
            child: Text(show ? widget.title : '',
                style:
                    LeooTextJunPro.leooGetTextStyleJunPro(24, FontWeight.bold),
                textAlign: TextAlign.center,
                maxLines: 1,
                overflow: TextOverflow.ellipsis),
          ),
          Positioned(
            left: 4.w,
            child: IconButton(
              iconSize: 40.w,
              padding: const EdgeInsets.all(0),
              icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                  LeooIconsJunPro.leooTopBackJunPro,
                  width: 40.w,
                  height: 40.w),
              onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                Navigator.pop(context);
              }),
            ),
          ),
          Positioned(
            right: 4.w,
            child: Row(
              children: [rightChild2 ?? Container(), rightChild ?? Container()],
            ),
          ),
        ],
      ),
    );
  }
}
