import 'package:flutter/material.dart';

///底部/顶部出现-控制显示还是隐藏
class LeooBottomSlideWidgetJunPro extends StatefulWidget {
  final Widget child;
  final int duration;
  final bool top;

  const LeooBottomSlideWidgetJunPro(
      {Key? key, required this.child, this.duration = 200, this.top = false})
      : super(key: key);

  @override
  _TightBottomSlideWidgetState createState() => _TightBottomSlideWidgetState();
}

class _TightBottomSlideWidgetState extends State<LeooBottomSlideWidgetJunPro>
    with SingleTickerProviderStateMixin {
  AnimationController? _controller;
  late Animation _animation;

  @override
  void initState() {
    _controller = AnimationController(
        vsync: this, duration: Duration(milliseconds: widget.duration));
    _animation = Tween(
            begin: Offset(.0, widget.top ? -1.0 : 1.0),
            end: const Offset(.0, .0))
        .animate(_controller!);
    super.initState();
  }

  @override
  void dispose() {
    _controller?.dispose();
    super.dispose();
  }

  void show() {
    _controller?.forward();
  }

  void hide() {
    _controller?.reverse();
  }

  @override
  Widget build(BuildContext context) {
    return SlideTransition(
        position: _animation as Animation<Offset>, child: widget.child);
  }
}
