import 'package:flutter/material.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leoonetconfigjunpro.dart';

///底部弹出到中间，控制时间和顺序
class LeooBottomCenterWidgetJunPro extends StatefulWidget {
  final Widget child;
  final int? index;
  final int duration;
  final double yOffset;

  const LeooBottomCenterWidgetJunPro(this.child,
      {Key? key, this.yOffset = 1.0, this.duration = 600, this.index})
      : super(key: key);

  @override
  _LeooBottomCenterWidgetState createState() => _LeooBottomCenterWidgetState();
}

class _LeooBottomCenterWidgetState extends State<LeooBottomCenterWidgetJunPro>
    with SingleTickerProviderStateMixin {
  AnimationController? _controller;
  late Animation _animation;

  @override
  void initState() {
    _controller = AnimationController(
        vsync: this, duration: Duration(milliseconds: widget.duration));
    _animation =
        Tween(begin: Offset(.0, widget.yOffset), end: const Offset(.0, .0))
            .animate(_controller!);
    Future.delayed(Duration(milliseconds: 200 * widget.index!), () {
      try {
        _controller?.forward();
      } catch (e) {
        LeooNetConfigJunPro.leooPrintLogJunPro(e);
      }
    });
    super.initState();
  }

  @override
  void dispose() {
    _controller?.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return SlideTransition(
        position: _animation as Animation<Offset>, child: widget.child);
  }
}
