import 'package:flutter/material.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leoonetconfigjunpro.dart';

///底部弹出到顶部，控制时间和顺序
class LeooBottomTopWidgetJunPro extends StatefulWidget {
  final Widget child;
  final int index;
  final int duration;
  final bool last;

  const LeooBottomTopWidgetJunPro(this.child, this.index,
      {Key? key, this.duration = 600, this.last = false})
      : super(key: key);

  @override
  _LeooBottomTopWidgetState createState() => _LeooBottomTopWidgetState();
}

class _LeooBottomTopWidgetState extends State<LeooBottomTopWidgetJunPro>
    with SingleTickerProviderStateMixin {
  AnimationController? _controller;
  late Animation _animation;

  @override
  void initState() {
    _controller = AnimationController(
        vsync: this, duration: Duration(milliseconds: widget.duration));
    _animation = Tween(
            begin: Offset(.0, widget.last ? 4.0 : 2.0),
            end: const Offset(.0, .0))
        .animate(_controller!);
    Future.delayed(Duration(milliseconds: 200 * widget.index), () {
      try {
        _controller?.forward();
      } catch (e) {
        LeooNetConfigJunPro.leooPrintLogJunPro(e);
      }
    });
    super.initState();
  }

  @override
  void dispose() {
    _controller?.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return SlideTransition(
        position: _animation as Animation<Offset>, child: widget.child);
  }
}
