import 'package:flutter/material.dart';

///横向滚动 停在中间
class LeooLeftCenterWidgetJunPro extends StatefulWidget {
  final Widget child;
  final bool left;

  const LeooLeftCenterWidgetJunPro(
      {Key? key, required this.child, this.left = true})
      : super(key: key);

  @override
  _TightLeftCenterWidgetState createState() => _TightLeftCenterWidgetState();
}

class _TightLeftCenterWidgetState extends State<LeooLeftCenterWidgetJunPro>
    with SingleTickerProviderStateMixin {
  AnimationController? _controller;
  late Animation _animation;

  @override
  void initState() {
    _controller =
        AnimationController(vsync: this, duration: const Duration(seconds: 1));
    _animation = Tween(
            begin: widget.left ? const Offset(-1.5, .0) : const Offset(1.5, .0),
            end: widget.left ? const Offset(-.4, .0) : const Offset(.4, .0))
        .animate(
            CurvedAnimation(parent: _controller!, curve: Curves.easeOutBack));
    Future.delayed(const Duration(milliseconds: 500), () {
      _controller!.forward();
    });
    super.initState();
  }

  @override
  void dispose() {
    _controller?.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return SlideTransition(
        position: _animation as Animation<Offset>, child: widget.child);
  }
}
