import 'package:flutter/material.dart';

///数字递增变化
class LeooNumberRunWidgetJunPro extends StatefulWidget {
  final TextStyle style;
  final int number;

  const LeooNumberRunWidgetJunPro(this.style, this.number, {Key? key})
      : super(key: key);

  @override
  _LeooNumberRunWidgetState createState() => _LeooNumberRunWidgetState();
}

class _LeooNumberRunWidgetState extends State<LeooNumberRunWidgetJunPro>
    with SingleTickerProviderStateMixin {
  AnimationController? _controller;
  late Animation _animation;
  int? number;

  @override
  void initState() {
    number = widget.number;
    _controller = AnimationController(
        vsync: this, duration: const Duration(milliseconds: 1000));
    _animation =
        IntTween(begin: number! - 100, end: number).animate(_controller!);
    super.initState();
  }

  @override
  void didUpdateWidget(LeooNumberRunWidgetJunPro oldWidget) {
    super.didUpdateWidget(oldWidget);
    if (number != widget.number) {
      _controller!.reset();
      _animation =
          IntTween(begin: number, end: widget.number).animate(_controller!);
      number = widget.number;
    }
  }

  @override
  void dispose() {
    _controller?.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    _controller!.forward();
    return AnimatedBuilder(
        animation: _animation,
        builder: (BuildContext context, Widget? child) {
          return Text('${_animation.value}', style: widget.style);
        });
  }
}
