import 'package:flutter/material.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leoonetconfigjunpro.dart';

///旋转
class LeooSpinWidgetJunPro extends StatefulWidget {
  final Widget? child;
  final int seconds;
  final int delayed;

  const LeooSpinWidgetJunPro(
      {Key? key, this.child, this.seconds = 5, this.delayed = 500})
      : super(key: key);

  @override
  _LeooSpinWidgetState createState() => _LeooSpinWidgetState();
}

class _LeooSpinWidgetState extends State<LeooSpinWidgetJunPro>
    with SingleTickerProviderStateMixin {
  AnimationController? _controller;
  late Animation _animationRota;

  @override
  void initState() {
    _controller = AnimationController(
        vsync: this, duration: Duration(seconds: widget.seconds));
    _animationRota = Tween(begin: .0, end: 1.0)
        .animate(CurvedAnimation(parent: _controller!, curve: Curves.linear));
    Future.delayed(Duration(milliseconds: widget.delayed), () {
      try {
        _controller?.repeat();
      } catch (e) {
        LeooNetConfigJunPro.leooPrintLogJunPro(e);
      }
    });
    super.initState();
  }

  @override
  void dispose() {
    _controller?.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return RotationTransition(
        turns: _animationRota as Animation<double>, child: widget.child);
  }
}
