import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:step_progress_indicator/step_progress_indicator.dart';

//倒计时
class LeooSwitcherProgressWidgetJunPro extends StatefulWidget {
  final int allRate;
  final Widget child;
  final double? size;
  final bool decoration;
  final bool match;

  const LeooSwitcherProgressWidgetJunPro(this.allRate, this.child,
      {Key? key, this.size, this.decoration = true, this.match = false})
      : super(key: key);

  @override
  State<StatefulWidget> createState() => LeooSwitcherProgressWidgetState();
}

class LeooSwitcherProgressWidgetState
    extends State<LeooSwitcherProgressWidgetJunPro>
    with SingleTickerProviderStateMixin {
  late AnimationController _controller;
  late Animation<double> _animation;

  @override
  void initState() {
    super.initState();
    _controller = AnimationController(
        vsync: this,
        duration: Duration(
          seconds: widget.allRate,
        ));
    _animation = Tween<double>(
      begin: 0,
      end: 10000,
    ).animate(CurvedAnimation(parent: _controller, curve: Curves.linear))
      ..addListener(() {
        LeooCodeUtilsJunPro.onSetState(this);
      });
    _controller.forward();
  }

  @override
  void dispose() {
    _controller.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return CircularStepProgressIndicator(
        totalSteps: 10000,
        currentStep: _animation.value.toInt(),
        selectedColor: Colors.transparent,
        unselectedColor: widget.match
            ? LeooColorsJunPro.leooAppJunPro
            : LeooColorsJunPro.leooApp3JunPro,
        stepSize: 3.w,
        selectedStepSize: 3.w,
        padding: 0,
        width: widget.size ?? 50.w,
        height: widget.size ?? 50.w,
        child: Container(
            margin: EdgeInsets.all(4.w),
            decoration: widget.decoration
                ? BoxDecoration(
                    color: Colors.black.withOpacity(.5), shape: BoxShape.circle)
                : null,
            child: widget.child));
  }
}
