import 'package:dots_indicator/dots_indicator.dart';
import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';

// 封装的DotsIndicator Widget 局部刷新
class LeooDotsIndicatorWidgetJunPro extends StatefulWidget {
  final int dotsCount;
  final double position;
  final double dotsSize;

  const LeooDotsIndicatorWidgetJunPro(
      this.dotsCount, this.position, this.dotsSize,
      {Key? key})
      : super(key: key);

  @override
  State<StatefulWidget> createState() => LeooDotsIndicatorWidgetState();
}

class LeooDotsIndicatorWidgetState
    extends State<LeooDotsIndicatorWidgetJunPro> {
  late int dotsCount;
  late double position;
  late double dotsSize;

  @override
  void initState() {
    super.initState();
    dotsCount = widget.dotsCount;
    position = widget.position;
    dotsSize = widget.dotsSize;
  }

  void onSetState({int? dotsCount, double? position, double? dotsSize}) {
    if (dotsCount != null) this.dotsCount = dotsCount;
    if (position != null) this.position = position;
    if (dotsSize != null) this.dotsSize = dotsSize;
    LeooCodeUtilsJunPro.onSetState(this);
  }

  @override
  Widget build(BuildContext context) {
    return DotsIndicator(
        dotsCount: dotsCount,
        position: position,
        decorator: DotsDecorator(
            size: Size(dotsSize, 6.w),
            activeSize: Size(dotsSize, 6.w),
            spacing: EdgeInsets.all(5.w),
            shape: const StadiumBorder(),
            activeShape: const StadiumBorder(),
            color: Colors.black.withOpacity(.2),
            activeColor: Colors.white));
  }
}
