import 'package:flutter/material.dart';

///小到大，最后消失
class LeooZoomInWidgetJunPro extends StatefulWidget {
  final Widget child;
  final Function? back;

  const LeooZoomInWidgetJunPro(this.child, {Key? key, this.back})
      : super(key: key);

  @override
  _LeooZoomInWidgetState createState() => _LeooZoomInWidgetState();
}

class _LeooZoomInWidgetState extends State<LeooZoomInWidgetJunPro>
    with TickerProviderStateMixin {
  AnimationController? _controller;
  late Animation<double> _animation;
  late AnimationController _controllerFade;
  late Animation<double> _animationFade;
  bool fade = false;

  @override
  void initState() {
    _controller =
        AnimationController(vsync: this, duration: const Duration(seconds: 3));
    _animation = Tween(begin: .0, end: 1.0).animate(
        CurvedAnimation(parent: _controller!, curve: Curves.easeOutBack))
      ..addListener(() {
        if (_controller!.value > .5 && !fade) {
          fade = true;
          _controllerFade.forward();
        }
      });
    _controllerFade =
        AnimationController(vsync: this, duration: const Duration(seconds: 1));
    _animationFade = Tween(begin: 1.0, end: .0).animate(
        CurvedAnimation(parent: _controllerFade, curve: Curves.linear));
    _controllerFade.addStatusListener((status) {
      if (status == AnimationStatus.completed) {
        widget.back?.call();
      }
    });
    _controller!.forward();
    super.initState();
  }

  @override
  void dispose() {
    _controller?.dispose();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return ScaleTransition(
        scale: _animation,
        child: FadeTransition(opacity: _animationFade, child: widget.child));
  }
}
