import 'dart:core';

import 'package:flutter/material.dart';
import 'package:flutter_keyboard_visibility/flutter_keyboard_visibility.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:im_flutter_sdk/im_flutter_sdk.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leooappconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leoonetconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoomaindaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodbjunpro/leooproviderjunpro/leootranslatordbproviderjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoogiftentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoouserentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leoonetjunpro/leooapphostjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooproviderjunpro/leoouserproviderjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoodialogutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leooimutils.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoorechargeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoovideoutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoowidgetjunpro/leookeyboardheightwidgetjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoocalljunpro/leooitemjunpro/leoobottominputbarjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoocalljunpro/leooitemjunpro/leooconversationitemjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leooinfojunpro/leooinfojunpro.dart';
import 'package:provider/provider.dart';
import 'package:pull_to_refresh/pull_to_refresh.dart';

///聊天
class LeooChatJunPro extends StatefulWidget {
  static bool leooOpenJunPro = false;
  final int? userId;
  final LeooUserEntity? infoEntity;
  final bool getNet;
  final EMConversation? conversation;
  final String hero;

  const LeooChatJunPro(this.userId, this.infoEntity, this.hero,
      {Key? key, this.getNet = true, this.conversation})
      : super(key: key);

  @override
  _LeooChatState createState() => _LeooChatState();
}

class _LeooChatState extends State<LeooChatJunPro>
    with
        LeooConversationItemDelegateJunPro,
        LeooBottomInputBarDelegateJunPro,
        OnImPluginDelegate {
  final RefreshController _refreshController = RefreshController();
  final ScrollController _scrollController = ScrollController();
  int pageSize = LeooAppConfigJunPro.leooListSizeJunPro;
  List<EMMessage> allList = [];
  late LeooTranslatorDbProviderJunPro translatorDbProvider;
  Map<String?, String?> translatorMap = {}; //翻译数组
  int status = LeooCommonUtilsJunPro.leooPageStatusLoadingJunPro;
  TextEditingController controller = TextEditingController();
  FocusNode focusNode = FocusNode();
  GlobalKey<LeooBottomInputBarState> inputKey = GlobalKey();
  LeooUserEntity? infoEntity;
  bool showOnline = false;
  bool sending = false;
  late LeooUserProviderJunPro userProvider;
  EMConversation? conversation;
  String? accessToken;

  @override
  void initState() {
    super.initState();
    LeooChatJunPro.leooOpenJunPro = true;
    LeooImUtilsJunPro.instance.imPluginDelegateList.add(this);
    _scrollController.addListener(() {
      focusNode.unfocus();
    });
    infoEntity = widget.infoEntity;
    if (infoEntity != null) {
      status = LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro;
    }
    if (widget.getNet) {
      hostInfo();
    }
    showOnline = !widget.getNet;
    getTransList();
  }

  void getTransList({bool update = false}) async {
    translatorDbProvider = LeooTranslatorDbProviderJunPro();
    translatorMap =
        await translatorDbProvider.getTranslatorDataList(widget.userId);
    addIMHandler();
  }

  @override
  void dispose() {
    LeooChatJunPro.leooOpenJunPro = false;
    LeooImUtilsJunPro.instance.imPluginDelegateList.remove(this);
    conversation?.markAllMessagesAsRead();
    super.dispose();
  }

  void hostInfo() {
    LeooMainDaoJunPro.leooDetailJunPro(widget.userId).then((res) async {
      if (res.result) {
        showOnline = true;
        infoEntity = res.data;
        status = LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro;
        LeooCodeUtilsJunPro.onSetState(this);
      } else {
        status = LeooCommonUtilsJunPro.leooPageStatusErrorJunPro;
        LeooCodeUtilsJunPro.onSetState(this);
        LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
      }
    });
  }

  void addIMHandler() async {
    if (conversation == null) {
      if (widget.conversation == null) {
        conversation = await EMClient.getInstance.chatManager
            .getConversation(widget.userId.toString());
      } else {
        conversation = widget.conversation;
      }
      conversation!.markAllMessagesAsRead();
    }
    allList.clear();
    accessToken = await EMClient.getInstance.getAccessToken();
    onGetHistoryMessages();
  }

  void onGetHistoryMessages() async {
    List<EMMessage>? messages = await conversation!.loadMessages(
        startMsgId: allList.isNotEmpty ? allList.last.msgId : '',
        loadCount: LeooAppConfigJunPro.leooListSizeJunPro);
    if (messages?.isEmpty == false) {
      messages = messages!.reversed.toList();
      allList.addAll(messages);
      translatorMessages(messages);
    } else if (allList.isEmpty) {
      refreshUI(allList);
    }
    refreshUI(messages);
  }

  void refreshUI(List? messages) {
    LeooCodeUtilsJunPro.onSetState(this);
    if (messages != null) {
      if (messages.isEmpty) {
        _refreshController.loadNoData();
      } else {
        _refreshController.loadComplete();
      }
    }
  }

  void translatorMessages(List<EMMessage> messages) async {
    for (var message in messages) {
      if (message.direction == MessageDirection.RECEIVE &&
          message.body is EMTextMessageBody &&
          translatorMap[message.msgId] == null) {
        await translatorMessage(
            message.msgId, (message.body as EMTextMessageBody).content,
            refresh: true);
      }
    }
  }

  Future<String?> translatorMessage(String messageId, String text,
      {bool refresh = false, bool send = false}) async {
    var translatedText =
        await LeooCodeUtilsJunPro.leooTranslatorMessageTextJunPro(text,
            send: send);
    if (translatedText != null) {
      translatorMap[messageId] = translatedText;
    } else {
      translatorMap[messageId] = text;
    }
    try {
      translatorDbProvider.insert(
          messageId, widget.userId, text, translatedText);
    } catch (e) {
      LeooNetConfigJunPro.leooPrintLogJunPro(e);
    }
    if (refresh) {
      LeooCodeUtilsJunPro.onSetState(this);
    }
    return translatedText;
  }

  @override
  Widget build(BuildContext context) {
    return KeyboardVisibilityBuilder(builder: (context, isKeyboardVisible) {
      Future(() {
        inputKey.currentState?.onSetState(isKeyboardVisible);
      });
      return Consumer<LeooUserProviderJunPro>(
          builder: (_, LeooUserProviderJunPro userProvider, __) {
        this.userProvider = userProvider;
        return GestureDetector(
          behavior: HitTestBehavior.opaque,
          onTap: () {
            focusNode.unfocus();
          },
          child: Scaffold(
            resizeToAvoidBottomInset: false,
            body: SafeArea(
              bottom: !isKeyboardVisible,
              maintainBottomViewPadding: true,
              child: Column(
                children: [
                  Row(
                    children: <Widget>[
                      SizedBox(width: 4.w),
                      IconButton(
                        iconSize: 40.w,
                        padding: const EdgeInsets.all(0),
                        icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                            LeooIconsJunPro.leooTopBackJunPro,
                            width: 40.w,
                            height: 40.w),
                        onPressed:
                            LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                          Navigator.pop(context);
                        }),
                      ),
                      Expanded(
                        child: InkWell(
                          onTap:
                              LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                            LeooNavigatorUtilsJunPro.leooInfoPageJunPro?.call(
                                    context, widget.userId,
                                    following: infoEntity?.following,
                                    infoEntity: infoEntity) ??
                                LeooNavigatorUtilsJunPro
                                    .leooNavigatorPushJunPro(
                                        context,
                                        LeooInfoJunPro(
                                          widget.userId,
                                          infoEntity,
                                          widget.hero,
                                          getNet: !showOnline,
                                        ),
                                        'LeooInfoJunPro',
                                        add: true);
                          }),
                          child: Row(
                            mainAxisAlignment: MainAxisAlignment.center,
                            children: [
                              ClipOval(
                                child: LeooCommonUtilsJunPro
                                    .leooGetLoadWidgetJunPro(
                                  LeooAppConfigJunPro.leooCustomerIdJunPro ==
                                          infoEntity?.id
                                      ? LeooIconsJunPro.leooAppLogoJunPro
                                      : infoEntity?.header,
                                  width: 30.w,
                                  height: 30.w,
                                  load: LeooIconsJunPro.leooLoadHeadJunPro,
                                ),
                              ),
                              Padding(
                                padding: EdgeInsets.all(5.w),
                                child: Text(
                                    LeooAppConfigJunPro.leooCustomerIdJunPro ==
                                            infoEntity?.id
                                        ? S.of(context).mineCustomer
                                        : infoEntity?.getNameAge() ?? '',
                                    style:
                                        LeooTextJunPro.leooGetTextStyleJunPro(
                                            20, FontWeight.bold),
                                    maxLines: 1,
                                    overflow: TextOverflow.ellipsis),
                              ),
                            ],
                          ),
                        ),
                      ),
                      LeooAppConfigJunPro.leooCustomerIdJunPro == infoEntity?.id
                          ? SizedBox(width: 44.w)
                          : IconButton(
                              iconSize: 40.w,
                              padding: const EdgeInsets.all(0),
                              icon:
                                  LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                                      LeooIconsJunPro.leooInfoMoreJunPro,
                                      width: 40.w,
                                      height: 40.w),
                              onPressed:
                                  LeooNavigatorUtilsJunPro.leooDebounceJunPro(
                                      () {
                                LeooDialogUtilsJunPro.instance.showReportBlack(
                                    context, widget.userId,
                                    nickname: infoEntity?.nickname,
                                    age: infoEntity?.age,
                                    gender: infoEntity?.gender,
                                    country: infoEntity?.country,
                                    header: infoEntity?.header,
                                    description: infoEntity?.description);
                              }),
                            ),
                      SizedBox(width: 4.w),
                    ],
                  ),
                  Expanded(
                    child: status !=
                            LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro
                        ? LeooCommonUtilsJunPro.leooCheckPageStatusJunPro(
                            context,
                            status,
                            onTap: () {
                              status = LeooCommonUtilsJunPro
                                  .leooPageStatusLoadingJunPro;
                              LeooCodeUtilsJunPro.onSetState(this);
                              hostInfo();
                            },
                          )
                        : Stack(
                            fit: StackFit.expand,
                            children: [
                              if (LeooAppConfigJunPro.leooCustomerIdJunPro !=
                                      infoEntity?.id &&
                                  allList.isEmpty)
                                Positioned.fill(
                                  left: 40.w,
                                  right: 40.w,
                                  top: 50.w,
                                  child: Column(
                                    children: [
                                      Container(
                                        width: 120.w,
                                        height: 120.w,
                                        decoration: ShapeDecoration(
                                          shape: CircleBorder(
                                            side: BorderSide(
                                              color: LeooColorsJunPro
                                                  .leooAppJunPro,
                                              width: 4.w,
                                            ),
                                          ),
                                        ),
                                        child: ClipOval(
                                          child: LeooCommonUtilsJunPro
                                              .leooGetLoadWidgetJunPro(
                                            LeooAppConfigJunPro
                                                        .leooCustomerIdJunPro ==
                                                    infoEntity?.id
                                                ? LeooIconsJunPro
                                                    .leooAppLogoJunPro
                                                : infoEntity?.header,
                                            width: 120.w,
                                            height: 120.w,
                                            load: LeooIconsJunPro
                                                .leooLoadHeadJunPro,
                                          ),
                                        ),
                                      ),
                                      SizedBox(height: 10.w),
                                      Text(
                                          LeooAppConfigJunPro
                                                      .leooCustomerIdJunPro ==
                                                  infoEntity?.id
                                              ? S.of(context).mineCustomer
                                              : infoEntity?.getNameAge() ?? '',
                                          style: LeooTextJunPro
                                              .leooGetTextStyleJunPro(
                                                  24, FontWeight.bold),
                                          maxLines: 1,
                                          overflow: TextOverflow.ellipsis),
                                      SizedBox(height: 50.w),
                                      Text(
                                        S.of(context).chatStartTip,
                                        style: LeooTextJunPro
                                            .leooGetTextStyleJunPro(
                                                24, FontWeight.bold),
                                      ),
                                      SizedBox(height: 5.w),
                                      Text(
                                        infoEntity?.description ?? '',
                                        style: LeooTextJunPro
                                            .leooGetTextStyleHintJunPro(16),
                                      ),
                                    ],
                                  ),
                                ),
                              SmartRefresher(
                                controller: _refreshController,
                                scrollController: _scrollController,
                                primary: false,
                                header: const ClassicHeader(),
                                footer: const ClassicFooter(),
                                enablePullDown: false,
                                enablePullUp: allList.length >=
                                    LeooAppConfigJunPro.leooListSizeJunPro,
                                onLoading: () {
                                  onGetHistoryMessages();
                                },
                                child: ListView.builder(
                                  physics: const BouncingScrollPhysics(),
                                  reverse: true,
                                  itemCount: allList.length,
                                  itemBuilder: (BuildContext itemContext,
                                      int itemIndex) {
                                    EMMessage item = allList[itemIndex];
                                    return LeooConversationItemJunPro(
                                        this,
                                        item,
                                        LeooCodeUtilsJunPro
                                            .leooNeedShowTimeListJunPro(
                                                itemIndex, allList),
                                        translatorMap[item.msgId],
                                        widget.userId.toString(),
                                        accessToken);
                                  },
                                ),
                              ),
                            ],
                          ),
                  ),
                  LeooBottomInputBarJunPro(
                    this,
                    controller,
                    userProvider.userEntity.userType == 1 ||
                            (userProvider.userEntity.freeNumber ?? 0) != 0 ||
                            !LeooAppHostJunPro.leooModeJunPro ||
                            LeooAppConfigJunPro.leooCustomerIdJunPro ==
                                infoEntity?.id
                        ? S.of(context).chatInputFree
                        : S.of(context).chatInput(
                            LeooAppConfigJunPro.leooMessageCostJunPro),
                    LeooAppConfigJunPro.leooCustomerIdJunPro !=
                            infoEntity?.id &&
                        userProvider.userEntity.userType == 0,
                    LeooAppConfigJunPro.leooCustomerIdJunPro != infoEntity?.id,
                    true,
                    focusNode: focusNode,
                    key: inputKey,
                    bottom: false,
                  ),
                  const LeooKeyBoardHeightWidgetJunPro(),
                ],
              ),
            ),
          ),
        );
      });
    });
  }

  void _insertOrReplaceMessage(EMMessage message, [bool tran = false]) {
    int index = -1;
    for (int i = 0; i < allList.length; i++) {
      EMMessage msg = allList[i];
      if (msg.msgId == message.msgId) {
        index = i;
        break;
      }
    }
    //如果数据源中相同 id 消息，那么更新对应消息，否则插入消息
    if (index >= 0) {
      allList[index] = message;
    } else {
      allList.insert(0, message);
    }
    if (tran &&
        message.direction == MessageDirection.RECEIVE &&
        message.body is EMTextMessageBody) {
      translatorMessage(
          message.msgId, (message.body as EMTextMessageBody).content,
          refresh: true);
    }
    LeooCodeUtilsJunPro.onSetState(this);
  }

  @override
  void didTapButton(int type) {
    if (type == 1) {
      LeooRechargeUtilsJunPro.instance
          .showGiftButton(context, userProvider)
          .then((value) {
        if (value != null) {
          willSendGift(value);
        }
      });
    } else if (type == 2) {
      LeooDialogUtilsJunPro.instance.showImageView(context, (path) {
        willSendImage(path[0]);
      });
    } else if (type == 3) {
      LeooVideoUtilsJunPro.instance.requestVideoPermission(
          context, widget.userId,
          infoEntity: infoEntity);
    }
  }

  @override
  void inputStatusDidChange(bool hasFocus) {}

  @override
  void willInputSendText(String text) {
    willSendText(text);
  }

  @override
  void didTapMessageItem(EMMessage message) {
    if (message.body is EMImageMessageBody) {
      EMImageMessageBody msg = message.body as EMImageMessageBody;
      String tag = '${message.msgId}imageMessageItem';
      LeooNavigatorUtilsJunPro.leooGotoPhotoViewJunPro(
        context,
        localPath: msg.localPath,
        imageUri: msg.remotePath,
        hero: tag,
        headers: {
          'Authorization': 'Bearer $accessToken',
          'share-secret': msg.secret ?? ''
        },
      );
    } else if (message.body is EMCustomMessageBody) {
      EMCustomMessageBody body = message.body as EMCustomMessageBody;
      if (body.event == LeooAppConfigJunPro.leooImageEventJunPro) {
        String tag = '${message.msgId}imageMessageItem';
        LeooNavigatorUtilsJunPro.leooGotoPhotoViewJunPro(
          context,
          imageUri: body.params?['image'],
          hero: tag,
        );
      }
    }
  }

  @override
  void didTapLongMessageItem(EMMessage message) {
    if (message.body is EMTextMessageBody) {
      LeooCommonUtilsJunPro.leooCopyJunPro(
          context, (message.body as EMTextMessageBody).content);
    }
  }

  void willSendText(String text) async {
    if (sending) {
      return;
    }
    sending = true;
    controller.text = '';
    if (userProvider.userEntity.userType == 0) {
      LeooMainDaoJunPro.leooDeductionMessageJunPro(widget.userId)
          .then((res) async {
        if (res.result) {
          if (res.data.enough == 0) {
            LeooRechargeUtilsJunPro.instance
                .showRechargeDialog(context, S.of(context).diamondSendTip);
            sending = false;
          } else {
            userProvider.setMoney(res.data.amount, res.data.freeNumber);
            EMMessage sendMessage = EMMessage.createTxtSendMessage(
                username: widget.userId.toString(), content: text);
            sendMessage.attributes = {
              'em_apns_ext': {
                'em_push_name': userProvider.userEntity.nickname,
                'em_push_content': text
              }
            };
            _insertOrReplaceMessage(sendMessage);
            sending = false;
          }
        } else {
          LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
          sending = false;
        }
      });
    } else {
      EMMessage sendMessage = EMMessage.createTxtSendMessage(
          username: widget.userId.toString(), content: text);
      sendMessage.attributes = {
        'em_apns_ext': {
          'em_push_name': userProvider.userEntity.nickname,
          'em_push_content': text
        }
      };
      _insertOrReplaceMessage(sendMessage);
      sending = false;
    }
  }

  void willSendImage(String? image) async {
    if (userProvider.userEntity.userType == 0) {
      LeooDialogUtilsJunPro.instance.showLoadingDialog(context);
      LeooMainDaoJunPro.leooDeductionMessageJunPro(widget.userId)
          .then((res) async {
        Navigator.pop(context);
        if (res.result) {
          if (res.data.enough == 0) {
            LeooRechargeUtilsJunPro.instance
                .showRechargeDialog(context, S.of(context).diamondSendTip);
            sending = false;
          } else {
            userProvider.setMoney(res.data.amount, res.data.freeNumber);
            image = await LeooMainDaoJunPro.leooCompressImageJunPro(image!);
            EMMessage sendMessage = EMMessage.createImageSendMessage(
                username: widget.userId.toString(),
                filePath: image!,
                sendOriginalImage: true);
            sendMessage.attributes = {
              'em_apns_ext': {
                'em_push_name': userProvider.userEntity.nickname,
                'em_push_content': '[${S.of(context).messageImage}]'
              }
            };
            _insertOrReplaceMessage(sendMessage);
            sending = false;
          }
        } else {
          LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
        }
      });
    } else {
      image = await LeooMainDaoJunPro.leooCompressImageJunPro(image!);
      EMMessage sendMessage = EMMessage.createImageSendMessage(
          username: widget.userId.toString(),
          filePath: image,
          sendOriginalImage: true);
      sendMessage.attributes = {
        'em_apns_ext': {
          'em_push_name': userProvider.userEntity.nickname,
          'em_push_content': '[${S.of(context).messageImage}]'
        }
      };
      _insertOrReplaceMessage(sendMessage);
    }
  }

  void willSendGift(LeooGiftEntity gift) async {
    EMMessage? sendMessage = await LeooRechargeUtilsJunPro.instance
        .willSendGift(context, userProvider, gift, widget.userId);
    if (sendMessage != null) {
      _insertOrReplaceMessage(sendMessage);
    }
    sending = false;
  }

  @override
  void onMessageReceived(List<EMMessage> messages) {
    for (var msg in messages) {
      if (msg.from == widget.userId.toString()) {
        if (msg.body is EMTextMessageBody ||
            msg.body is EMImageMessageBody ||
            msg.body is EMCustomMessageBody) {
          _insertOrReplaceMessage(msg, true);
        }
      }
    }
  }

  @override
  void onConnectionStatusChange(bool connected) {}
}
