import 'dart:async';
import 'dart:math';

import 'package:firebase_analytics/firebase_analytics.dart';
import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:im_flutter_sdk/im_flutter_sdk.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leooappconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leoonetconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoomaindaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoogiftentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoohostinfoentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leootokenentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooeventjunpro/leooindexjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooeventjunpro/leoorechargeeventjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooproviderjunpro/leoouserproviderjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostringjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoodialogutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoomediautilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoorechargeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoowidgetutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoospinwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leooswitcherprogresswidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leootextwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoowidgetjunpro/leookeyboardheightwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoowidgetjunpro/leoolivetextwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoowidgetjunpro/leooswitchertextwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoowidgetjunpro/leoovisiblewidgetjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoocalljunpro/leoovideocallhostwidgetjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoocalljunpro/leoovideocalljunpro.dart';
import 'package:leoo_junpro/leoorouterjunpro.dart';
import 'package:provider/provider.dart';

///通话页面-用户与zb
class LeooVideoCallHostJunPro extends StatefulWidget {
  final int? userId;
  final LeooHostInfoEntity infoEntity;

  const LeooVideoCallHostJunPro(this.userId, this.infoEntity, {Key? key})
      : super(key: key);

  @override
  _LeooVideoCallState createState() => _LeooVideoCallState();
}

class _LeooVideoCallState extends State<LeooVideoCallHostJunPro>
    with LeooVideoCallHostDelegateJunPro, WidgetsBindingObserver, RouteAware {
  late LeooHostInfoEntity infoEntity; //zb信息
  late LeooUserProviderJunPro userProvider;

  ///通话前计时器
  Timer? beforeTimer;
  int beforeRate = 0;
  bool showPopView = false; //显示弹窗
  bool showRecharge = false; //显示充值弹窗

  //-1-未点击拨号(获取到数据显示待接听或拨号界面) 0-链接中 1-正在通话 2-已挂断 3-没钱已挂断
  int callStatus = -1;

  //网络质量检测
  bool showNetText = false; //显示网络质量不好的提示
  String? netText; //显示网络质量不好的提示
  ///聊天
  GlobalKey<LeooTextWidgetState> timeKey = GlobalKey();
  GlobalKey<LeooSwitcherTextWidgetState> timeKeyDown = GlobalKey();
  GlobalKey<LeooSwitcherProgressWidgetState> progressKey = GlobalKey();
  bool showVideoView = true; //显示界面其他按钮
  //通话交互
  GlobalKey<LeooVideoCallHostWidgetState> videoCallKey = GlobalKey();
  GlobalKey<LeooVisibleWidgetState> visibleKey = GlobalKey();
  late bool checkGiftButton = false;

  late String callTip;

  //即将关闭页面、在好多秒的时候==0不关闭
  int willPop = 0;
  late StreamSubscription subscriptionRecharge;

  @override
  void didChangeAppLifecycleState(AppLifecycleState state) {
    super.didChangeAppLifecycleState(state);
    if (state == AppLifecycleState.resumed) {
      if (callStatus == 1) {
        videoCallKey.currentState?.rtcEngine?.enableLocalVideo(true);
      }
    }
  }

  @override
  void didChangeDependencies() {
    super.didChangeDependencies();
    LeooRouterJunPro.leooRouteObserverJunPro
        .subscribe(this, ModalRoute.of(context) as PageRoute<dynamic>);
  }

  @override
  void didPopNext() {
    super.didPopNext();
    LeooCommonUtilsJunPro.leooCheckIsCurrentJunPro(context, () {
      if (callStatus == 1) {
        videoCallKey.currentState?.rtcEngine?.enableLocalVideo(true);
      }
    });
  }

  @override
  void initState() {
    super.initState();
    WidgetsBinding.instance!.addObserver(this);
    infoEntity = widget.infoEntity;
    hostInfo();
    subscriptionRecharge =
        eventBus.on<LeooRechargeEventJunPro>().listen((event) {
      willPop = 0;
    });
  }

  @override
  void dispose() {
    LeooMediaUtilsJunPro.instance.stopPlayAudio();
    subscriptionRecharge.cancel();
    beforeTimer?.cancel();
    WidgetsBinding.instance!.removeObserver(this);
    LeooRouterJunPro.leooRouteObserverJunPro.unsubscribe(this);
    super.dispose();
  }

  void hostInfo() async {
    LeooCodeUtilsJunPro.onSetState(this);
    startTimer();
    checkHostInfo();
    Future.delayed(const Duration(seconds: 2), () {
      visibleKey.currentState?.onSetState(true);
    });
  }

  void checkHostInfo() async {
    Future.delayed(const Duration(milliseconds: 500), () {
      LeooCommonUtilsJunPro.leooCheckIsCurrentJunPro(context, () {
        LeooMediaUtilsJunPro.instance.startPlayAudio(true);
      });
    });
  }

  @override
  Widget build(BuildContext context) {
    return Consumer<LeooUserProviderJunPro>(
      builder: (_, LeooUserProviderJunPro userProvider, __) {
        this.userProvider = userProvider;
        return WillPopScope(
          onWillPop: () {
            setHangUp();
            return Future.value(false);
          },
          child: Scaffold(
            resizeToAvoidBottomInset: false,
            body: Column(
              children: [
                Expanded(
                  child: Stack(
                    children: <Widget>[
                      LeooVideoCallHostWidgetJunPro(
                          videoCallKey,
                          LeooNetConfigJunPro.leooAgoraAppKeyJunPro,
                          widget.userId,
                          infoEntity.id,
                          userProvider.userEntity.nickname ?? '',
                          userProvider.userEntity.header ?? '',
                          userProvider.userEntity.id ?? 0,
                          true,
                          delegate: this,
                          closeWidget:
                              LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                            LeooIconsJunPro.leooVideoCloseTipJunPro,
                            width: 120.w,
                            height: 180.w,
                          ),
                          bottomBarHeight: ScreenUtil().bottomBarHeight),
                      if ((callStatus == 1 || callStatus == 3) &&
                          videoCallKey.currentState?.userUid != null)
                        InkWell(
                          onTap:
                              LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                            showVideoView =
                                videoCallKey.currentState?.setShowVideoView() ??
                                    true;
                            LeooCodeUtilsJunPro.onSetState(this);
                          }),
                          child: Container(),
                        ),
                      if (showVideoView == true &&
                          callStatus == 1 &&
                          videoCallKey.currentState?.showTime == true &&
                          videoCallKey.currentState?.closeCamera != true)
                        Positioned(
                          bottom: 85.w + ScreenUtil().bottomBarHeight,
                          right: 55,
                          child: IconButton(
                            padding: const EdgeInsets.all(0),
                            onPressed:
                                LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                              videoCallKey.currentState?.switchCamera();
                            }, 1000),
                            icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                              LeooIconsJunPro.leooVideoSwitchJunPro,
                              width: 40.w,
                              height: 40.w,
                            ),
                            iconSize: 40.w,
                          ),
                        ),
                      if (showVideoView == true &&
                          (callStatus == 1 || callStatus == 3) &&
                          videoCallKey.currentState?.showTime == true)
                        Positioned(
                          top: ScreenUtil().statusBarHeight + 20.w,
                          left: 20.w,
                          right: 20.w,
                          child: Row(
                            crossAxisAlignment: CrossAxisAlignment.start,
                            children: [
                              Expanded(
                                child: Column(
                                  crossAxisAlignment: CrossAxisAlignment.start,
                                  children: <Widget>[
                                    Row(
                                      children: [
                                        Container(
                                          decoration: ShapeDecoration(
                                            shape: CircleBorder(
                                              side: BorderSide(
                                                color: LeooColorsJunPro
                                                    .leooAppJunPro,
                                                width: 2.w,
                                              ),
                                            ),
                                          ),
                                          width: 50.w,
                                          height: 50.w,
                                          child: ClipOval(
                                            child: LeooCommonUtilsJunPro
                                                .leooGetLoadWidgetJunPro(
                                              infoEntity.avatar,
                                              width: 50.w,
                                              height: 50.w,
                                              load: LeooIconsJunPro
                                                  .leooLoadHeadJunPro,
                                            ),
                                          ),
                                        ),
                                        SizedBox(width: 10.w),
                                        Expanded(
                                          child: Column(
                                            crossAxisAlignment:
                                                CrossAxisAlignment.start,
                                            children: [
                                              LeooTextWidgetJunPro(
                                                infoEntity.getNameAge(),
                                                LeooTextJunPro
                                                    .leooGetTextStyleJunPro(
                                                        20, FontWeight.bold),
                                                iconData: (infoEntity.gender ??
                                                            0) ==
                                                        0
                                                    ? null
                                                    : LeooCommonUtilsJunPro
                                                        .leooGetLoadWidgetJunPro(
                                                        infoEntity.gender == 1
                                                            ? LeooIconsJunPro
                                                                .leooInfoMaleJunPro
                                                            : LeooIconsJunPro
                                                                .leooInfoFemaleJunPro,
                                                        width: 18.w,
                                                        height: 18.w,
                                                      ),
                                                iconPadding: 2.5.w,
                                                right: true,
                                                mainAxisSize: MainAxisSize.min,
                                                maxWidth:
                                                    ScreenUtil().screenWidth /
                                                        3,
                                              ),
                                              SizedBox(height: 5.w),
                                              LeooLiveTextWidgetJunPro(
                                                timeKey,
                                                LeooTextJunPro
                                                    .leooGetTextStyleJunPro(
                                                        14, FontWeight.bold),
                                                LeooCodeUtilsJunPro
                                                    .leooGetTimeStrJunPro(
                                                  DateTime.fromMillisecondsSinceEpoch(
                                                      (videoCallKey.currentState
                                                                  ?.currentRate ??
                                                              0) *
                                                          1000,
                                                      isUtc: true),
                                                ),
                                              ),
                                            ],
                                          ),
                                        ),
                                      ],
                                    ),
                                    SizedBox(height: 10.w),
                                    if (showNetText)
                                      Padding(
                                        padding: EdgeInsets.all(8.w),
                                        child: Text(netText ?? '',
                                            style: LeooTextJunPro
                                                .leooGetTextStyleJunPro(
                                                    16, FontWeight.bold)),
                                      ),
                                  ],
                                ),
                              ),
                              IconButton(
                                padding: const EdgeInsets.all(0),
                                icon: LeooCommonUtilsJunPro
                                    .leooGetLoadWidgetJunPro(
                                  LeooIconsJunPro.leooVideoHangJunPro,
                                  width: 40.w,
                                  height: 40.w,
                                ),
                                iconSize: 40.w,
                                onPressed:
                                    LeooNavigatorUtilsJunPro.leooDebounceJunPro(
                                        () {
                                  setHangUp();
                                }),
                              ),
                            ],
                          ),
                        ),
                      if (callStatus == 1 &&
                          videoCallKey.currentState?.currentDown != 0)
                        Positioned(
                          top: ScreenUtil().statusBarHeight + 70.w,
                          right: 20.w,
                          child: Container(
                            decoration: BoxDecoration(
                                color: Colors.black.withOpacity(.5),
                                shape: BoxShape.circle),
                            padding: EdgeInsets.all(3.w),
                            child: LeooSwitcherProgressWidgetJunPro(
                              LeooAppConfigJunPro.leooCallTimeJunPro,
                              LeooSwitcherTextWidgetJunPro(
                                  timeKeyDown,
                                  LeooTextJunPro.leooGetTextStyleAppJunPro(
                                      22, FontWeight.bold),
                                  LeooTextJunPro.leooGetTextStyleAppJunPro(
                                      24, FontWeight.bold),
                                  LeooAppConfigJunPro.leooCallTimeJunPro),
                              decoration: false,
                              size: 56.w,
                              key: progressKey,
                            ),
                          ),
                        ),
                      if (showVideoView == true &&
                          (callStatus == 1 || callStatus == 3) &&
                          videoCallKey.currentState?.showTime == true)
                        Positioned(
                          bottom: ScreenUtil().bottomBarHeight + 20.w,
                          left: 0,
                          right: 0,
                          child: Column(
                            crossAxisAlignment: CrossAxisAlignment.start,
                            children: [
                              Row(
                                mainAxisAlignment:
                                    MainAxisAlignment.spaceEvenly,
                                children: [
                                  IconButton(
                                    padding: const EdgeInsets.all(0),
                                    icon: LeooCommonUtilsJunPro
                                        .leooGetLoadWidgetJunPro(
                                      videoCallKey.currentState
                                                  ?.closeMicrophone !=
                                              true
                                          ? LeooIconsJunPro.leooVideoMicJunPro
                                          : LeooIconsJunPro
                                              .leooVideoMicNoJunPro,
                                      width: 50.w,
                                      height: 50.w,
                                    ),
                                    iconSize: 50.w,
                                    onPressed: LeooNavigatorUtilsJunPro
                                        .leooDebounceJunPro(() async {
                                      await videoCallKey.currentState
                                          ?.setCloseMicrophone();
                                      LeooCodeUtilsJunPro.onSetState(this);
                                    }, 1000),
                                  ),
                                  IconButton(
                                    padding: const EdgeInsets.all(0),
                                    icon: LeooCommonUtilsJunPro
                                        .leooGetLoadWidgetJunPro(
                                      videoCallKey.currentState?.closeCamera !=
                                              true
                                          ? LeooIconsJunPro
                                              .leooVideoCameraJunPro
                                          : LeooIconsJunPro
                                              .leooVideoCameraNoJunPro,
                                      width: 50.w,
                                      height: 50.w,
                                    ),
                                    iconSize: 50.w,
                                    onPressed: LeooNavigatorUtilsJunPro
                                        .leooDebounceJunPro(() async {
                                      await videoCallKey.currentState
                                          ?.setCloseCamera();
                                      LeooCodeUtilsJunPro.onSetState(this);
                                    }),
                                  ),
                                  if (userProvider.userEntity.userType == 0)
                                    IconButton(
                                      padding: const EdgeInsets.all(0),
                                      icon: LeooCommonUtilsJunPro
                                          .leooLottieJunPro(
                                        LeooIconsJunPro.leooGiftJunPro,
                                        width: 50.w,
                                        height: 50.w,
                                      ),
                                      iconSize: 50.w,
                                      onPressed: LeooNavigatorUtilsJunPro
                                          .leooDebounceJunPro(() {
                                        showGiftButton();
                                      }),
                                    ),
                                  if (userProvider.userEntity.userType == 0)
                                    IconButton(
                                      padding: const EdgeInsets.all(0),
                                      icon: LeooCommonUtilsJunPro
                                          .leooGetLoadWidgetJunPro(
                                        LeooIconsJunPro.leooVideoCoinsJunPro,
                                        width: 50.w,
                                        height: 50.w,
                                      ),
                                      iconSize: 50.w,
                                      onPressed: LeooNavigatorUtilsJunPro
                                          .leooDebounceJunPro(() {
                                        showRecharge = true;
                                        LeooRechargeUtilsJunPro.instance
                                            .goRechargePage(context, true)
                                            .then((value) {
                                          showRecharge = false;
                                          if (value == null &&
                                              callStatus == 2) {
                                            setHangUp(close: true);
                                          }
                                        });
                                      }),
                                    ),
                                ],
                              ),
                              const LeooKeyBoardHeightWidgetJunPro(
                                  bottom: false)
                            ],
                          ),
                        ),
                      if (callStatus < 1 || callStatus == 2) callWidget(),
                      if (callStatus == 3)
                        Center(
                          child: InkWell(
                            onTap:
                                LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                              showRecharge = true;
                              LeooRechargeUtilsJunPro.instance
                                  .goRechargePage(context, true)
                                  .then((value) {
                                showRecharge = false;
                                if (value != null) {
                                  callStatus = -1;
                                  videoCallKey.currentState
                                      ?.setCallStatus(callStatus);
                                  videoCallKey.currentState?.callBefore();
                                  hostInfo();
                                }
                              });
                            }),
                            child: Column(
                              mainAxisSize: MainAxisSize.min,
                              children: [
                                Text(
                                  S.of(context).videoContinueTip,
                                  style: LeooTextJunPro.leooGetTextStyleJunPro(
                                      24, FontWeight.bold),
                                  textAlign: TextAlign.center,
                                ),
                                SizedBox(height: 18.w),
                                Container(
                                  decoration: ShapeDecoration(
                                    color: LeooColorsJunPro.leooAppJunPro,
                                    shape: RoundedRectangleBorder(
                                      borderRadius: BorderRadius.circular(20),
                                    ),
                                  ),
                                  padding:
                                      EdgeInsets.only(top: 14.w, bottom: 15.w),
                                  width: 1.sw - 120.w,
                                  child: Column(
                                    mainAxisSize: MainAxisSize.min,
                                    children: [
                                      Text(
                                        S.of(context).videoContinue,
                                        style: LeooTextJunPro
                                            .leooGetTextStyleJunPro(
                                                18, FontWeight.bold),
                                      ),
                                      LeooTextWidgetJunPro(
                                        S.of(context).randomPopMin(
                                            LeooAppConfigJunPro
                                                .leooTalkingCostJunPro),
                                        LeooTextJunPro.leooGetTextStyleJunPro(
                                            14, FontWeight.bold),
                                        iconData: LeooCommonUtilsJunPro
                                            .leooGetLoadWidgetJunPro(
                                          LeooIconsJunPro.leooMainCoinsJunPro,
                                          width: 16.w,
                                          height: 16.w,
                                        ),
                                        iconPadding: 2.5.w,
                                        mainAxisSize: MainAxisSize.min,
                                      ),
                                    ],
                                  ),
                                ),
                              ],
                            ),
                          ),
                        ),
                    ],
                  ),
                ),
              ],
            ),
          ),
        );
      },
    );
  }

  Widget callWidget() {
    return Stack(
      alignment: Alignment.center,
      fit: StackFit.expand,
      children: [
        LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
          infoEntity.avatar,
          width: 1.sw,
          height: 1.sh,
          load: LeooIconsJunPro.leooLoadHeadJunPro,
        ),
        Positioned(
          top: ScreenUtil().statusBarHeight + 20.w,
          right: 20.w,
          child: IconButton(
            iconSize: 50.w,
            padding: const EdgeInsets.all(0),
            icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                LeooIconsJunPro.leooPopClose2JunPro,
                width: 50.w,
                height: 50.w),
            onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
              setHangUp();
            }),
          ),
        ),
        Column(
          mainAxisAlignment: MainAxisAlignment.center,
          mainAxisSize: MainAxisSize.min,
          children: [
            Stack(
              alignment: Alignment.center,
              children: [
                LeooSpinWidgetJunPro(
                  seconds: 15,
                  child: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                    LeooIconsJunPro.leooVideoCallBgJunPro,
                    width: 150.w,
                    height: 150.w,
                  ),
                ),
                Container(
                  decoration: ShapeDecoration(
                    shape: CircleBorder(
                      side: BorderSide(
                        color: LeooColorsJunPro.leooAppJunPro,
                        width: 4.w,
                      ),
                    ),
                  ),
                  width: 120.w,
                  height: 120.w,
                  child: ClipOval(
                    child: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                      infoEntity.avatar,
                      width: 120.w,
                      height: 120.w,
                      load: LeooIconsJunPro.leooLoadHeadJunPro,
                    ),
                  ),
                ),
              ],
            ),
            SizedBox(height: 10.w),
            LeooTextWidgetJunPro(
              infoEntity.getNameAge(),
              LeooTextJunPro.leooGetTextStyleJunPro(24, FontWeight.bold),
              iconData: (infoEntity.gender ?? 0) == 0
                  ? null
                  : LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                      infoEntity.gender == 1
                          ? LeooIconsJunPro.leooInfoMaleJunPro
                          : LeooIconsJunPro.leooInfoFemaleJunPro,
                      width: 18.w,
                      height: 18.w,
                    ),
              iconPadding: 2.5.w,
              right: true,
              mainAxisSize: MainAxisSize.min,
              maxWidth: .5.sw,
            ),
            SizedBox(height: 5.w),
            if (infoEntity.regionCode?.isEmpty == false)
              LeooWidgetUtilsJunPro.leooGetCountryWidgetJunPro(
                  context, infoEntity.regionCode,
                  item: false),
            SizedBox(height: 5.w),
            SizedBox(height: 80.w),
            callStatusWidget(),
            SizedBox(height: 10.w),
            SizedBox(
              width: 1.sw - 100.w,
              height: 100.w,
              child: Text(
                callTip,
                style:
                    LeooTextJunPro.leooGetTextStyleJunPro(16, FontWeight.bold),
                textAlign: TextAlign.center,
              ),
            ),
          ],
        ),
      ],
    );
  }

  Widget callStatusWidget() {
    if (videoCallKey.currentState?.partyLeft == true) {
      return Text(S.of(context).videoErrorTo2,
          style: LeooTextJunPro.leooGetTextStyleJunPro(30, FontWeight.bold),
          textAlign: TextAlign.center);
    }
    switch (callStatus) {
      case 2:
        return Text(S.of(context).videoError4,
            style: LeooTextJunPro.leooGetTextStyleJunPro(30, FontWeight.bold),
            textAlign: TextAlign.center);
      case -1:
        return Text(S.of(context).videoWaiting,
            style: LeooTextJunPro.leooGetTextStyleJunPro(30, FontWeight.bold),
            textAlign: TextAlign.center);
      case 0:
        String text;
        if (videoCallKey.currentState?.isConnect == true) {
          text = S.of(context).videoConnection;
        } else {
          text = S.of(context).videoWaiting;
        }
        return Text(text,
            style: LeooTextJunPro.leooGetTextStyleJunPro(30, FontWeight.bold),
            textAlign: TextAlign.center);
      default:
        return Text(S.of(context).videoConnection,
            style: LeooTextJunPro.leooGetTextStyleJunPro(30, FontWeight.bold),
            textAlign: TextAlign.center);
    }
  }

  void normalPop({bool delayed = false}) {
    callStatus = 2;
    if (showRecharge) {
      return;
    }
    LeooMediaUtilsJunPro.instance.stopPlayAudio();
    if (delayed) {
      Future.delayed(const Duration(seconds: 2), () {
        beforeTimer?.cancel();
        if (!LeooVideoCallJunPro.leooOpenJunPro) {
          return;
        }
        LeooVideoCallJunPro.leooOpenJunPro = false;
        if (showPopView) {
          showPopView = false;
          Navigator.pop(context);
        }
        Navigator.pop(context);
      });
    } else {
      beforeTimer?.cancel();
      if (!LeooVideoCallJunPro.leooOpenJunPro) {
        return;
      }
      LeooVideoCallJunPro.leooOpenJunPro = false;
      if (showPopView) {
        showPopView = false;
        Navigator.pop(context);
      }
      Navigator.pop(context);
    }
  }

  void setHangUp({bool net = false, bool close = false}) {
    if (callStatus == 0) {
      return;
    }
    if (callStatus == 1) {
      if (showPopView) {
        return;
      }
      showPopView = true;
      LeooDialogUtilsJunPro.instance
          .showCustomDialog(context,
              content: S.of(context).videoHang, right: S.of(context).appYes)
          .then((value) {
        showPopView = false;
        if (value == true) {
          leaveChannel();
        }
      });
    } else if (!close) {
      if (showPopView) {
        return;
      }
      showPopView = true;
      LeooDialogUtilsJunPro.instance
          .showCustomDialog(context,
              content: S.of(context).videoHang, right: S.of(context).appYes)
          .then((value) {
        showPopView = false;
        if (value == true) {
          setHangUp(net: net, close: true);
        }
      });
    } else {
      if (callStatus <= 0) {
        callReport(1);
      }
      videoCallKey.currentState?.willSendVideo(1);
      normalPop();
    }
  }

  //主动判断
  void showEndView([bool keep = false]) {
    leaveChannel(keep);
    if (keep) {
      callStatus = 3;
      videoCallKey.currentState?.setCallStatus(callStatus);
      LeooCodeUtilsJunPro.onSetState(this);
    } else if (callStatus != 3) {
      Future.delayed(const Duration(milliseconds: 500), () {
        normalPop();
      });
    }
  }

  //被动判断
  void leaveChannel([bool keep = false]) {
    videoCallKey.currentState?.leaveChannel(keep);
  }

  void startTimer() {
    if (beforeTimer?.isActive == true) {
      beforeTimer?.cancel();
    }
    beforeRate = 0;
    List list = [
      LeooStringJunPro.leooStrPartyTip1JunPro,
      LeooStringJunPro.leooStrPartyTip2JunPro,
      LeooStringJunPro.leooStrPartyTip3JunPro,
      LeooStringJunPro.leooStrPartyTip4JunPro,
    ];
    Random rand = Random();
    callTip = list[rand.nextInt(4)];
    beforeTimer = Timer.periodic(const Duration(seconds: 1), (timer) {
      beforeRate++;
      // AppConfig.printLog('beforeRate:$beforeRate');
      if (beforeRate % 2 == 0) {
        callTip = list[rand.nextInt(4)];
      }
      if (beforeRate >= LeooAppConfigJunPro.leooInCallTimeJunPro) {
        videoCallKey.currentState?.offline = true;
        callStatus = 2;
        setHangUp(close: true);
      }
      LeooCodeUtilsJunPro.onSetState(this);
    });
  }

  //0-超时未接听、1-主动挂断、2-对方挂断
  void callReport(int type) {
    LeooMainDaoJunPro.leooCallReportJunPro(
        videoCallKey.currentState?.callId, type);
  }

  @override
  void onAnalyticsEvent(String name) {
    FirebaseAnalytics.instance.logEvent(name: name);
  }

  @override
  void onCallStatus(int callStatus) {
    if (callStatus == 1) {
      beforeTimer?.cancel();
      LeooMediaUtilsJunPro.instance.stopPlayAudio();
    }
    this.callStatus = callStatus;
    LeooCodeUtilsJunPro.onSetState(this);
  }

  @override
  void onCalling([int? amount]) {
    LeooMainDaoJunPro.leooDeductionVideoJunPro(
            videoCallKey.currentState?.callId,
            userId: widget.userId)
        .then((res) {
      if (res.result) {
        if (res.data.enough == 0) {
          onRemoteUserLeft(2);
        } else {
          int money = res.data.amount ?? 0;
          int size = money ~/ LeooAppConfigJunPro.leooTalkingCostJunPro;
          if (size == 0) {
            videoCallKey.currentState?.isSoonMoney = true;
            if (videoCallKey.currentState?.currentDown == 0) {
              var time = (size + 1) * 60 -
                  (videoCallKey.currentState?.currentRate ?? 0) % 60;
              if (time < 30) {
                Future.delayed(Duration(seconds: time), () {
                  videoCallKey.currentState?.currentDown = 60;
                });
              } else {
                videoCallKey.currentState?.currentDown = time;
              }
            }
            willPop = 55;
          } else {
            videoCallKey.currentState?.isSoonMoney = false;
            videoCallKey.currentState?.currentDown = 0;
          }
          userProvider.setMoney(res.data.amount);
        }
      } else {
        leaveChannel();
        LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
      }
    });
  }

  @override
  void onCurrentRate(int rate, {bool down = false}) {
    if (down) {
      timeKeyDown.currentState?.onSetState(rate);
      if (rate == 0) {
        LeooCodeUtilsJunPro.onSetState(this);
      }
    } else {
      if (willPop != 0 && rate % 60 == willPop) {
        onRemoteUserLeft(2);
      }
      timeKey.currentState?.onSetState(
        LeooCodeUtilsJunPro.leooGetTimeStrJunPro(
          DateTime.fromMillisecondsSinceEpoch(rate * 1000, isUtc: true),
        ),
      );
    }
  }

  @override
  void onNormalPop({bool hangup = true, bool? delayed = false}) {
    if (hangup) {
      normalPop(delayed: delayed!);
    } else {
      setHangUp();
    }
  }

  @override
  void onShowLocalVideo(bool local) {
    if (callStatus == -1) {
      if (local) {
        LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
            S.of(context).videoErrorTo10);
        onRemoteUserLeft(4, toast: false);
      } else {
        LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
            S.of(context).videoErrorOut6);
        onRemoteUserLeft(4, toast: false);
      }
    }
  }

  Future onShowCoinsWidget(String content) {
    if (showPopView) {
      showPopView = false;
      Navigator.pop(context);
    }
    showRecharge = true;
    return LeooRechargeUtilsJunPro.instance
        .showRechargeDialog(context, content, dismiss: false, call: true)
        .then((value) {
      if (value != false) {
        showRecharge = false;
        if (value == null) {
          normalPop();
        } else if (value != null && callStatus == 2) {
          callStatus = -1;
          videoCallKey.currentState?.setCallStatus(callStatus);
          videoCallKey.currentState?.callBefore();
          hostInfo();
          return null;
        }
      }
      return value;
    });
  }

  @override
  void onShowNetText(bool? me) {
    if (me == null) {
      showNetText = false;
      LeooCodeUtilsJunPro.onSetState(this);
    } else if (!showNetText) {
      showNetText = true;
      if (me) {
        netText = S.of(context).videoNetMe;
      } else {
        netText = S.of(context).videoNetOther;
      }
      LeooCodeUtilsJunPro.onSetState(this);
    }
  }

  @override
  void onShowToast(int type) {
    switch (type) {
      case -1:
        LeooCommonUtilsJunPro.leooShowErrorToastJunPro();
        break;
      case 0:
        LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
            S.of(LeooRouterJunPro.leooContextJunPro).videoNetEr);
        break;
      case 1:
        LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
            S.of(LeooRouterJunPro.leooContextJunPro).videoErrorTo5);
        break;
      case 2:
        LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
            S.of(LeooRouterJunPro.leooContextJunPro).videoErrorTo6);
        break;
      case 3:
        LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
            S.of(LeooRouterJunPro.leooContextJunPro).videoErrorOut7);
        break;
      case 5:
        LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
            S.of(LeooRouterJunPro.leooContextJunPro).videoErrorTo1);
        break;
      case 6:
        LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
            S.of(LeooRouterJunPro.leooContextJunPro).videoErrorTo11);
        break;
      default:
        break;
    }
  }

  @override
  void onRemoteUserLeft(int dropped, {bool toast = true}) {
    if (callStatus == 1) {
      callStatus = 2;
      videoCallKey.currentState?.setCallStatus(callStatus);
      if (dropped != 1) {
        //0-自己挂断//1-对方正常挂断//2-没钱最后一分钟挂断//3-通话过程中对方异常//4-声网回调异常//5-后台挂断
        if (dropped == 2 && videoCallKey.currentState?.currentRate != 0) {
          if (toast) {
            LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
                S.of(context).videoErrorTo8);
          }
        } else {
          if (dropped == 3 || dropped == 4) {
            if (toast) {
              LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
                  S.of(context).videoErrorOut5);
            }
          } else {
            if (dropped == 5 && toast) {
              LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
                  S.of(context).videoErrorTo8);
            }
          }
        }
      } else {
        //通话过程对方挂断
        if (toast) {
          LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
              S.of(context).videoErrorOut0);
        }
      }
      LeooMainDaoJunPro.leooCallEndJunPro(videoCallKey.currentState?.callId,
          dropped, videoCallKey.currentState?.currentRate);
      showEndView(userProvider.userEntity.userType == 0 &&
          videoCallKey.currentState?.currentDown != 0 &&
          dropped == 2);
    } else if (callStatus <= 2) {
      if (toast) {
        LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
            S.of(context).videoErrorTo1);
      }
      normalPop();
    }
  }

  @override
  void onVideoSetState(callStatus) {
    this.callStatus = callStatus;
    LeooCodeUtilsJunPro.onSetState(this);
  }

  void showGiftButton() {
    LeooRechargeUtilsJunPro.instance.showGiftButton(context, userProvider,
        back: (value) {
      if (value == true) {
        showPopView = true;
      } else {
        showPopView = false;
      }
    }).then((value) {
      if (value != null) {
        willSendGift(value);
      }
    });
  }

  void willSendGift(LeooGiftEntity gift) async {
    showPopView = true;
    EMMessage? sendMessage = await LeooRechargeUtilsJunPro.instance
        .willSendGift(context, userProvider, gift, widget.userId, pop: () {
      showPopView = false;
    });
    if (sendMessage == null) {
      showPopView = false;
    }
  }

  @override
  Future<LeooTokenEntity?> callBefore({int? userId, String? channelName}) {
    int money = userProvider.userEntity.amount ?? 0;
    if (money <= LeooAppConfigJunPro.leooTalkingCostJunPro) {
      onShowCoinsWidget(S.of(context).diamondVideoTip).then((value) {
        if (value != null && callStatus != 2) {
          videoCallKey.currentState?.callBefore();
        }
      });
      return Future.value();
    } else {
      return LeooMainDaoJunPro.leooRtcTokenJunPro(
              userId ?? userProvider.userEntity.id, userId == null ? 1 : 2,
              channelName: channelName)
          .then((res) async {
        if (res.result) {
          return res.data;
        }
        LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
        normalPop();
        return null;
      });
    }
  }
}
