import 'dart:async';
import 'dart:math';

import 'package:firebase_analytics/firebase_analytics.dart';
import 'package:flutter/material.dart';
import 'package:flutter_keyboard_visibility/flutter_keyboard_visibility.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:im_flutter_sdk/im_flutter_sdk.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leooappconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leoonetconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoodaoresultjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoomaindaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodbjunpro/leooproviderjunpro/leootranslatordbproviderjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoogiftentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoortmentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leootokenentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoouserentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooeventjunpro/leooindexjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooeventjunpro/leoorechargeeventjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooproviderjunpro/leoouserproviderjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostringjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoodialogutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leooimutils.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoomediautilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoorechargeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoovideoutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoowidgetutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoobubblejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leooslidescalewidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoospinwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leooswitcherprogresswidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leootextwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoowidgetjunpro/leookeyboardheightwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoowidgetjunpro/leoolivetextwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoowidgetjunpro/leooswitchertextwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoowidgetjunpro/leoovisiblewidgetjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoocalljunpro/leooitemjunpro/leoobottominputbarjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoocalljunpro/leooitemjunpro/leooconversationtextitemjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoocalljunpro/leoovideocallwidgetjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoocalljunpro/leoovideoendjunpro.dart';
import 'package:leoo_junpro/leoorouterjunpro.dart';
import 'package:provider/provider.dart';
import 'package:video_player/video_player.dart';

///通话页面-用户与zb
class LeooVideoCallJunPro extends StatefulWidget {
  static bool leooOpenJunPro = false;
  static bool leooOpenCloseJunPro = false;
  final int? userId;
  final bool call;
  final int? matchingId;
  final int? callId;
  final String? channelId;
  final LeooUserEntity? infoEntity;

  const LeooVideoCallJunPro(this.userId, this.call,
      {Key? key, this.matchingId, this.callId, this.channelId, this.infoEntity})
      : super(key: key);

  @override
  _LeooVideoCallState createState() => _LeooVideoCallState();
}

class _LeooVideoCallState extends State<LeooVideoCallJunPro>
    with
        LeooVideoCallDelegateJunPro,
        WidgetsBindingObserver,
        RouteAware,
        LeooBottomInputBarDelegateJunPro,
        OnImPluginDelegate {
  int status = LeooCommonUtilsJunPro.leooPageStatusLoadingJunPro;
  LeooUserEntity? infoEntity; //zb信息
  late LeooUserProviderJunPro userProvider;

  ///通话前计时器
  Timer? beforeTimer;
  int beforeRate = 0;
  bool showPopView = false; //显示弹窗
  bool showRecharge = false; //显示充值弹窗

  //-1-未点击拨号(获取到数据显示待接听或拨号界面) 0-链接中 1-正在通话 2-已挂断 3-没钱已挂断
  int callStatus = -1;
  late bool call; //主动拨打还是被动
  bool userCheck = false; //是否点击拨号
  //网络质量检测
  bool showNetText = false; //显示网络质量不好的提示
  String? netText; //显示网络质量不好的提示
  ///聊天
  GlobalKey<LeooLiveTextWidgetState> timeKey = GlobalKey();
  GlobalKey<LeooSwitcherTextWidgetState> timeKeyDown = GlobalKey();
  GlobalKey<LeooSwitcherProgressWidgetState> progressKey = GlobalKey();
  bool showVideoView = true; //显示界面其他按钮
  //通话交互
  GlobalKey<LeooVideoCallWidgetState> videoCallKey = GlobalKey();
  GlobalKey<LeooVisibleWidgetState> visibleKey = GlobalKey();
  late bool checkGiftButton = false;
  bool keyboardAware = false;

  LeooTranslatorDbProviderJunPro? translatorDbProvider;
  Map<String?, String?> translatorMap = {}; //翻译数组
  List<EMMessage> allList = [];
  final ScrollController _scrollController = ScrollController();
  TextEditingController controller = TextEditingController();
  FocusNode focusNode = FocusNode();
  GlobalKey<LeooBottomInputBarState> inputKey = GlobalKey();
  bool openChat = false;

  late String callTip;
  VideoPlayerController? _controller;
  bool match = false;
  int? matchingId;

  bool showOtherDownText = false; //显示对方余额不足
  late StreamSubscription subscriptionRecharge;

  @override
  void didChangeAppLifecycleState(AppLifecycleState state) {
    super.didChangeAppLifecycleState(state);
    if (state == AppLifecycleState.resumed) {
      if (callStatus == 1) {
        videoCallKey.currentState?.rtcEngine?.enableLocalVideo(true);
      }
    }
  }

  @override
  void didChangeDependencies() {
    super.didChangeDependencies();
    LeooRouterJunPro.leooRouteObserverJunPro
        .subscribe(this, ModalRoute.of(context) as PageRoute<dynamic>);
  }

  @override
  void didPopNext() {
    super.didPopNext();
    LeooCommonUtilsJunPro.leooCheckIsCurrentJunPro(context, () {
      if (callStatus == 1) {
        videoCallKey.currentState?.rtcEngine?.enableLocalVideo(true);
      }
    });
  }

  @override
  void initState() {
    super.initState();
    LeooImUtilsJunPro.instance.imPluginDelegateList.add(this);
    WidgetsBinding.instance!.addObserver(this);
    call = widget.call;
    matchingId = widget.matchingId;
    match = matchingId != null;
    infoEntity = widget.infoEntity;
    hostInfo();
    _scrollController.addListener(() {
      focusNode.unfocus();
      if (openChat) {
        openChat = false;
        LeooCodeUtilsJunPro.onSetState(this);
      }
    });
    var keyboardVisibilityController = KeyboardVisibilityController();
    keyboardVisibilityController.onChange.listen((bool visible) {
      if (!visible && checkGiftButton) {
        checkGiftButton = false;
        showGiftButton();
      }
    });
    subscriptionRecharge =
        eventBus.on<LeooRechargeEventJunPro>().listen((event) {
      if (videoCallKey.currentState?.currentDown != 0) {
        onCalling(event.amount);
        if (videoCallKey.currentState?.isSoonMoney == false) {
          videoCallKey.currentState?.willSendVideo(10002);
        }
      }
    });
  }

  @override
  void dispose() {
    LeooImUtilsJunPro.instance.imPluginDelegateList.remove(this);
    LeooMediaUtilsJunPro.instance.stopPlayAudio();
    beforeTimer?.cancel();
    _controller?.dispose();
    WidgetsBinding.instance!.removeObserver(this);
    LeooRouterJunPro.leooRouteObserverJunPro.unsubscribe(this);
    subscriptionRecharge.cancel();
    super.dispose();
  }

  void hostInfo() async {
    if (infoEntity == null || infoEntity?.talkingGoldPerMin == null) {
      LeooDataResultJunPro res =
          await LeooMainDaoJunPro.leooDetailJunPro(widget.userId);
      if (res.result) {
        infoEntity = res.data;
      } else {
        status = LeooCommonUtilsJunPro.leooPageStatusErrorJunPro;
        LeooCodeUtilsJunPro.onSetState(this);
        LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
        return;
      }
    }
    status = LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro;
    LeooCodeUtilsJunPro.onSetState(this);
    startTimer();
    checkHostInfo();
    Future.delayed(const Duration(seconds: 2), () {
      visibleKey.currentState?.onSetState(true);
    });
    checkVideoUrl();
  }

  void onSetState() {
    LeooCodeUtilsJunPro.onSetState(this);
  }

  void checkVideoUrl() async {
    LeooMainDaoJunPro.leooFreeVideoJunPro(widget.userId).then((res) async {
      if (res.result) {
        String? videoUrl = res.data.videoUrl;
        if (videoUrl?.isEmpty == false) {
          _controller = VideoPlayerController.network(videoUrl!);
          _controller!.setVolume(.0);
          _controller!.setLooping(true);
          _controller!.initialize().then((value) {
            LeooCodeUtilsJunPro.onSetState(this);
            _controller?.play();
          });
        }
      }
    });
  }

  void checkHostInfo() async {
    Future.delayed(const Duration(milliseconds: 1000), () {
      LeooCommonUtilsJunPro.leooCheckIsCurrentJunPro(context, () {
        LeooMediaUtilsJunPro.instance.startPlayAudio(call);
        if (!call) {
          LeooMediaUtilsJunPro.instance.startVibration();
        }
      });
    });
  }

  @override
  Widget build(BuildContext context) {
    return KeyboardVisibilityBuilder(builder: (context, isKeyboardVisible) {
      keyboardAware = isKeyboardVisible;
      if (callStatus == 1 || callStatus == 3) {
        if (isKeyboardVisible) {
          Future(() {
            setBottomHeightLone();
          });
        } else {
          setBottomHeightLone();
        }
      }
      return Consumer<LeooUserProviderJunPro>(
        builder: (_, LeooUserProviderJunPro userProvider, __) {
          this.userProvider = userProvider;
          return WillPopScope(
            onWillPop: () {
              if (openChat) {
                openChat = false;
                LeooCodeUtilsJunPro.onSetState(this);
              } else {
                setHangUp(send: !call);
              }
              return Future.value(false);
            },
            child: GestureDetector(
              behavior: HitTestBehavior.opaque,
              onTap: () {
                focusNode.unfocus();
                if (openChat) {
                  openChat = false;
                  LeooCodeUtilsJunPro.onSetState(this);
                }
              },
              child: Scaffold(
                resizeToAvoidBottomInset: false,
                body: status !=
                        LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro
                    ? Stack(
                        children: [
                          LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                            infoEntity?.header,
                            width: 1.sw,
                            height: 1.sh,
                            load: LeooIconsJunPro.leooLoadHeadJunPro,
                          ),
                          LeooCommonUtilsJunPro.leooCheckPageStatusJunPro(
                              context, status, onTap: () {
                            status = LeooCommonUtilsJunPro
                                .leooPageStatusLoadingJunPro;
                            LeooCodeUtilsJunPro.onSetState(this);
                            hostInfo();
                          }),
                        ],
                      )
                    : Column(
                        children: [
                          Expanded(
                            child: Stack(
                              children: <Widget>[
                                LeooVideoCallWidgetJunPro(
                                    videoCallKey,
                                    LeooNetConfigJunPro.leooAgoraAppKeyJunPro,
                                    LeooVideoUtilsJunPro.instance.rtmClient!,
                                    matchingId,
                                    widget.callId,
                                    widget.channelId,
                                    widget.userId,
                                    userProvider.userEntity.nickname ?? '',
                                    userProvider.userEntity.header ?? '',
                                    userProvider.userEntity.id ?? 0,
                                    userProvider.userEntity.userType ?? 0,
                                    call,
                                    true,
                                    delegate: this,
                                    closeWidget: LeooCommonUtilsJunPro
                                        .leooGetLoadWidgetJunPro(
                                      LeooIconsJunPro.leooVideoCloseTipJunPro,
                                      width: 120.w,
                                      height: 180.w,
                                    ),
                                    bottomBarHeight:
                                        ScreenUtil().bottomBarHeight),
                                if ((callStatus == 1 || callStatus == 3) &&
                                    videoCallKey.currentState?.userUid != null)
                                  InkWell(
                                    onTap: LeooNavigatorUtilsJunPro
                                        .leooDebounceJunPro(() {
                                      if (openChat) {
                                        openChat = false;
                                        LeooCodeUtilsJunPro.onSetState(this);
                                      } else {
                                        showVideoView = videoCallKey
                                                .currentState
                                                ?.setShowVideoView() ??
                                            true;
                                        LeooCodeUtilsJunPro.onSetState(this);
                                      }
                                    }),
                                    child: Container(),
                                  ),
                                if (showVideoView == true &&
                                    callStatus == 1 &&
                                    videoCallKey.currentState?.showTime ==
                                        true &&
                                    videoCallKey.currentState?.closeCamera !=
                                        true)
                                  Positioned(
                                    bottom: 90.w +
                                        ScreenUtil().bottomBarHeight +
                                        (isKeyboardVisible
                                            ? MediaQuery.of(context)
                                                    .viewInsets
                                                    .bottom -
                                                ScreenUtil().bottomBarHeight
                                            : 0),
                                    right: 55,
                                    child: IconButton(
                                      padding: const EdgeInsets.all(0),
                                      onPressed: LeooNavigatorUtilsJunPro
                                          .leooDebounceJunPro(() {
                                        videoCallKey.currentState
                                            ?.switchCamera();
                                      }, 1000),
                                      icon: LeooCommonUtilsJunPro
                                          .leooGetLoadWidgetJunPro(
                                        LeooIconsJunPro.leooVideoSwitchJunPro,
                                        width: 40.w,
                                        height: 40.w,
                                      ),
                                      iconSize: 40.w,
                                    ),
                                  ),
                                if (showVideoView == true &&
                                    (callStatus == 1 || callStatus == 3) &&
                                    videoCallKey.currentState?.showTime == true)
                                  Positioned(
                                    top: ScreenUtil().statusBarHeight + 20.w,
                                    left: 20.w,
                                    right: 20.w,
                                    child: Row(
                                      crossAxisAlignment:
                                          CrossAxisAlignment.start,
                                      children: [
                                        Expanded(
                                          child: Column(
                                            crossAxisAlignment:
                                                CrossAxisAlignment.start,
                                            children: <Widget>[
                                              Row(
                                                children: [
                                                  Container(
                                                    decoration: ShapeDecoration(
                                                      shape: CircleBorder(
                                                        side: BorderSide(
                                                          color: LeooColorsJunPro
                                                              .leooAppJunPro,
                                                          width: 2.w,
                                                        ),
                                                      ),
                                                    ),
                                                    width: 50.w,
                                                    height: 50.w,
                                                    child: ClipOval(
                                                      child: LeooCommonUtilsJunPro
                                                          .leooGetLoadWidgetJunPro(
                                                        infoEntity?.header,
                                                        width: 50.w,
                                                        height: 50.w,
                                                        load: LeooIconsJunPro
                                                            .leooLoadHeadJunPro,
                                                      ),
                                                    ),
                                                  ),
                                                  SizedBox(width: 10.w),
                                                  Expanded(
                                                    child: Column(
                                                      crossAxisAlignment:
                                                          CrossAxisAlignment
                                                              .start,
                                                      children: [
                                                        LeooTextWidgetJunPro(
                                                          infoEntity
                                                                  ?.getNameAge() ??
                                                              '',
                                                          LeooTextJunPro
                                                              .leooGetTextStyleJunPro(
                                                                  20,
                                                                  FontWeight
                                                                      .bold),
                                                          iconData: (infoEntity
                                                                          ?.gender ??
                                                                      0) ==
                                                                  0
                                                              ? null
                                                              : LeooCommonUtilsJunPro
                                                                  .leooGetLoadWidgetJunPro(
                                                                  infoEntity?.gender ==
                                                                          1
                                                                      ? LeooIconsJunPro
                                                                          .leooInfoMaleJunPro
                                                                      : LeooIconsJunPro
                                                                          .leooInfoFemaleJunPro,
                                                                  width: 18.w,
                                                                  height: 18.w,
                                                                ),
                                                          iconPadding: 2.5.w,
                                                          right: true,
                                                          mainAxisSize:
                                                              MainAxisSize.min,
                                                          maxWidth: ScreenUtil()
                                                                  .screenWidth /
                                                              3,
                                                        ),
                                                        SizedBox(height: 5.w),
                                                        LeooLiveTextWidgetJunPro(
                                                          timeKey,
                                                          LeooTextJunPro
                                                              .leooGetTextStyleJunPro(
                                                                  14,
                                                                  FontWeight
                                                                      .bold),
                                                          LeooCodeUtilsJunPro
                                                              .leooGetTimeStrJunPro(
                                                            DateTime.fromMillisecondsSinceEpoch(
                                                                (matchingId !=
                                                                            null
                                                                        ? LeooAppConfigJunPro
                                                                            .leooMatchCallTimeJunPro
                                                                        : (videoCallKey.currentState?.currentRate ??
                                                                            0)) *
                                                                    1000,
                                                                isUtc: true),
                                                          ),
                                                        ),
                                                      ],
                                                    ),
                                                  ),
                                                ],
                                              ),
                                              SizedBox(height: 10.w),
                                              if (showNetText)
                                                Padding(
                                                  padding: EdgeInsets.all(8.w),
                                                  child: Text(netText ?? '',
                                                      style: LeooTextJunPro
                                                          .leooGetTextStyleJunPro(
                                                              16,
                                                              FontWeight.bold)),
                                                ),
                                              if (showOtherDownText)
                                                Padding(
                                                  padding: EdgeInsets.all(8.w),
                                                  child: Text(
                                                      S
                                                          .of(context)
                                                          .videoOtherDown,
                                                      style: LeooTextJunPro
                                                          .leooGetTextStyleJunPro(
                                                              16,
                                                              FontWeight.bold)),
                                                ),
                                            ],
                                          ),
                                        ),
                                        IconButton(
                                          padding: const EdgeInsets.all(0),
                                          icon: LeooCommonUtilsJunPro
                                              .leooGetLoadWidgetJunPro(
                                            LeooIconsJunPro.leooVideoHangJunPro,
                                            width: 40.w,
                                            height: 40.w,
                                          ),
                                          iconSize: 40.w,
                                          onPressed: LeooNavigatorUtilsJunPro
                                              .leooDebounceJunPro(() {
                                            setHangUp(send: !call);
                                          }),
                                        ),
                                      ],
                                    ),
                                  ),
                                if (callStatus == 1 &&
                                    videoCallKey.currentState?.currentDown != 0)
                                  Positioned(
                                    top: ScreenUtil().statusBarHeight + 70.w,
                                    right: 20.w,
                                    child: Container(
                                      decoration: BoxDecoration(
                                          color: Colors.black.withOpacity(.5),
                                          shape: BoxShape.circle),
                                      padding: EdgeInsets.all(3.w),
                                      child: LeooSwitcherProgressWidgetJunPro(
                                        matchingId != null
                                            ? LeooAppConfigJunPro
                                                .leooMatchCallTimeJunPro
                                            : LeooAppConfigJunPro
                                                .leooCallTimeJunPro,
                                        LeooSwitcherTextWidgetJunPro(
                                            timeKeyDown,
                                            LeooTextJunPro
                                                .leooGetTextStyleAppJunPro(
                                                    22, FontWeight.bold),
                                            LeooTextJunPro
                                                .leooGetTextStyleAppJunPro(
                                                    24, FontWeight.bold),
                                            matchingId != null
                                                ? LeooAppConfigJunPro
                                                    .leooMatchCallTimeJunPro
                                                : LeooAppConfigJunPro
                                                    .leooCallTimeJunPro),
                                        decoration: false,
                                        size: 56.w,
                                        key: progressKey,
                                      ),
                                    ),
                                  ),
                                if (showVideoView == true &&
                                    (callStatus == 1 || callStatus == 3) &&
                                    videoCallKey.currentState?.showTime == true)
                                  Positioned(
                                    bottom: isKeyboardVisible
                                        ? 0
                                        : ScreenUtil().bottomBarHeight + 20.w,
                                    left: 0,
                                    right: 0,
                                    child: Column(
                                      crossAxisAlignment:
                                          CrossAxisAlignment.start,
                                      children: [
                                        SizedBox(
                                          height: 250.w,
                                          child: ListView.separated(
                                            physics:
                                                const BouncingScrollPhysics(),
                                            reverse: true,
                                            shrinkWrap: true,
                                            itemCount: allList.length,
                                            controller: _scrollController,
                                            separatorBuilder:
                                                (BuildContext context,
                                                    int index) {
                                              return SizedBox(height: 10.w);
                                            },
                                            itemBuilder:
                                                (BuildContext itemContext,
                                                    int itemIndex) {
                                              EMMessage item =
                                                  allList[itemIndex];
                                              return LeooConversationTextItemJunPro(
                                                  item,
                                                  translatorMap[item.msgId],
                                                  userProvider
                                                      .userEntity.nickname,
                                                  infoEntity?.nickname,
                                                  item.from !=
                                                      widget.userId.toString());
                                            },
                                          ),
                                        ),
                                        SizedBox(height: 20.w),
                                        openChat
                                            ? LeooBottomInputBarJunPro(
                                                this,
                                                controller,
                                                S.of(context).chatInputFree,
                                                false,
                                                false,
                                                false,
                                                focusNode: focusNode,
                                                autoFocus: true,
                                                key: inputKey,
                                              )
                                            : Row(
                                                mainAxisAlignment:
                                                    MainAxisAlignment
                                                        .spaceEvenly,
                                                children: [
                                                  IconButton(
                                                    padding:
                                                        const EdgeInsets.all(0),
                                                    icon: LeooCommonUtilsJunPro
                                                        .leooGetLoadWidgetJunPro(
                                                      videoCallKey.currentState?.closeMicrophone !=
                                                              true
                                                          ? LeooIconsJunPro
                                                              .leooVideoMicJunPro
                                                          : LeooIconsJunPro
                                                              .leooVideoMicNoJunPro,
                                                      width: 50.w,
                                                      height: 50.w,
                                                    ),
                                                    iconSize: 50.w,
                                                    onPressed:
                                                        LeooNavigatorUtilsJunPro
                                                            .leooDebounceJunPro(
                                                                () async {
                                                      await videoCallKey
                                                          .currentState
                                                          ?.setCloseMicrophone();
                                                      LeooCodeUtilsJunPro
                                                          .onSetState(this);
                                                    }, 1000),
                                                  ),
                                                  IconButton(
                                                    padding:
                                                        const EdgeInsets.all(0),
                                                    icon: LeooCommonUtilsJunPro
                                                        .leooGetLoadWidgetJunPro(
                                                      videoCallKey.currentState?.closeCamera !=
                                                              true
                                                          ? LeooIconsJunPro
                                                              .leooVideoCameraJunPro
                                                          : LeooIconsJunPro
                                                              .leooVideoCameraNoJunPro,
                                                      width: 50.w,
                                                      height: 50.w,
                                                    ),
                                                    iconSize: 50.w,
                                                    onPressed:
                                                        LeooNavigatorUtilsJunPro
                                                            .leooDebounceJunPro(
                                                                () async {
                                                      await videoCallKey
                                                          .currentState
                                                          ?.setCloseCamera();
                                                      LeooCodeUtilsJunPro
                                                          .onSetState(this);
                                                    }),
                                                  ),
                                                  IconButton(
                                                    padding:
                                                        const EdgeInsets.all(0),
                                                    icon: LeooCommonUtilsJunPro
                                                        .leooGetLoadWidgetJunPro(
                                                      LeooIconsJunPro
                                                          .leooVideoMessageJunPro,
                                                      width: 50.w,
                                                      height: 50.w,
                                                    ),
                                                    iconSize: 50.w,
                                                    onPressed:
                                                        LeooNavigatorUtilsJunPro
                                                            .leooDebounceJunPro(
                                                                () {
                                                      openChat = true;
                                                      LeooCodeUtilsJunPro
                                                          .onSetState(this);
                                                      focusNode.requestFocus();
                                                    }),
                                                  ),
                                                  if (userProvider.userEntity
                                                          .userType ==
                                                      0)
                                                    IconButton(
                                                      padding:
                                                          const EdgeInsets.all(
                                                              0),
                                                      icon:
                                                          LeooCommonUtilsJunPro
                                                              .leooLottieJunPro(
                                                        LeooIconsJunPro
                                                            .leooGiftJunPro,
                                                        width: 50.w,
                                                        height: 50.w,
                                                      ),
                                                      iconSize: 50.w,
                                                      onPressed:
                                                          LeooNavigatorUtilsJunPro
                                                              .leooDebounceJunPro(
                                                                  () {
                                                        showGiftButton();
                                                      }),
                                                    ),
                                                  if (userProvider.userEntity
                                                          .userType ==
                                                      0)
                                                    IconButton(
                                                      padding:
                                                          const EdgeInsets.all(
                                                              0),
                                                      icon: LeooCommonUtilsJunPro
                                                          .leooGetLoadWidgetJunPro(
                                                        LeooIconsJunPro
                                                            .leooVideoCoinsJunPro,
                                                        width: 50.w,
                                                        height: 50.w,
                                                      ),
                                                      iconSize: 50.w,
                                                      onPressed:
                                                          LeooNavigatorUtilsJunPro
                                                              .leooDebounceJunPro(
                                                                  () {
                                                        showRecharge = true;
                                                        LeooRechargeUtilsJunPro
                                                            .instance
                                                            .goRechargePage(
                                                                context, true)
                                                            .then((value) {
                                                          showRecharge = false;
                                                          if (value == null &&
                                                              callStatus == 2) {
                                                            setHangUp(
                                                                send: true,
                                                                close: true);
                                                          }
                                                        });
                                                      }),
                                                    ),
                                                ],
                                              ),
                                        const LeooKeyBoardHeightWidgetJunPro(
                                            bottom: false)
                                      ],
                                    ),
                                  ),
                                if (callStatus < 1 || callStatus == 2)
                                  callWidget(),
                                if (callStatus == 3)
                                  Center(
                                    child: InkWell(
                                      onTap: LeooNavigatorUtilsJunPro
                                          .leooDebounceJunPro(() {
                                        showRecharge = true;
                                        LeooRechargeUtilsJunPro.instance
                                            .goRechargePage(context, true)
                                            .then((value) {
                                          showRecharge = false;
                                          if (value != null) {
                                            callStatus = -1;
                                            call = true;
                                            videoCallKey.currentState
                                                ?.setCallStatus(callStatus);
                                            videoCallKey.currentState
                                                ?.callBefore();
                                            hostInfo();
                                          }
                                        });
                                      }),
                                      child: Column(
                                        mainAxisSize: MainAxisSize.min,
                                        children: [
                                          Container(
                                            decoration: ShapeDecoration(
                                              color: LeooColorsJunPro
                                                  .leooAppJunPro,
                                              shape: RoundedRectangleBorder(
                                                borderRadius:
                                                    BorderRadius.circular(20),
                                              ),
                                            ),
                                            padding: EdgeInsets.only(
                                                top: 14.w, bottom: 15.w),
                                            width: 1.sw - 120.w,
                                            child: Column(
                                              mainAxisSize: MainAxisSize.min,
                                              children: [
                                                Text(
                                                  S.of(context).videoContinue,
                                                  style: LeooTextJunPro
                                                      .leooGetTextStyleJunPro(
                                                          20, FontWeight.bold),
                                                ),
                                                LeooTextWidgetJunPro(
                                                  S.of(context).randomPopMin(
                                                      infoEntity
                                                              ?.talkingGoldPerMin ??
                                                          0),
                                                  LeooTextJunPro
                                                      .leooGetTextStyleJunPro(
                                                          16, FontWeight.bold),
                                                  iconData: LeooCommonUtilsJunPro
                                                      .leooGetLoadWidgetJunPro(
                                                    LeooIconsJunPro
                                                        .leooMainCoinsJunPro,
                                                    width: 20.w,
                                                    height: 20.w,
                                                  ),
                                                  iconPadding: 2.5.w,
                                                  mainAxisSize:
                                                      MainAxisSize.min,
                                                ),
                                              ],
                                            ),
                                          ),
                                          SizedBox(height: 20.w),
                                          Text(
                                            S.of(context).videoContinueTip,
                                            style: LeooTextJunPro
                                                .leooGetTextStyleJunPro(
                                                    20, FontWeight.bold),
                                            textAlign: TextAlign.center,
                                          ),
                                        ],
                                      ),
                                    ),
                                  ),
                              ],
                            ),
                          ),
                        ],
                      ),
              ),
            ),
          );
        },
      );
    });
  }

  Widget callWidget() {
    return Stack(
      alignment: Alignment.center,
      fit: StackFit.expand,
      children: [
        SizedBox(
          width: 1.sw,
          height: 1.sh,
          child: _controller?.value.isInitialized == true
              ? Transform.scale(
                  scale: _controller!.value.aspectRatio > 1
                      ? 1
                      : (_controller!.value.aspectRatio <
                              MediaQuery.of(context).size.aspectRatio
                          ? MediaQuery.of(context).size.aspectRatio /
                              _controller!.value.aspectRatio
                          : _controller!.value.aspectRatio /
                              MediaQuery.of(context).size.aspectRatio),
                  child: Center(
                    child: AspectRatio(
                      aspectRatio: _controller!.value.aspectRatio,
                      child: VideoPlayer(_controller!),
                    ),
                  ),
                )
              : LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                  infoEntity?.header,
                  load: LeooIconsJunPro.leooLoadHeadJunPro,
                ),
        ),
        if (call)
          Positioned(
            top: ScreenUtil().statusBarHeight + 20.w,
            right: 20.w,
            child: IconButton(
              iconSize: 50.w,
              padding: const EdgeInsets.all(0),
              icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                  LeooIconsJunPro.leooPopClose2JunPro,
                  width: 50.w,
                  height: 50.w),
              onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                setHangUp(send: !call);
              }),
            ),
          ),
        call
            ? Column(
                mainAxisAlignment: MainAxisAlignment.center,
                mainAxisSize: MainAxisSize.min,
                children: [
                  Stack(
                    alignment: Alignment.center,
                    children: [
                      LeooSpinWidgetJunPro(
                        seconds: 15,
                        child: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                          LeooIconsJunPro.leooVideoCallBgJunPro,
                          width: 150.w,
                          height: 150.w,
                        ),
                      ),
                      Container(
                        decoration: ShapeDecoration(
                          shape: CircleBorder(
                            side: BorderSide(
                              color: LeooColorsJunPro.leooAppJunPro,
                              width: 4.w,
                            ),
                          ),
                        ),
                        width: 120.w,
                        height: 120.w,
                        child: ClipOval(
                          child: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                            infoEntity?.header,
                            width: 120.w,
                            height: 120.w,
                            load: LeooIconsJunPro.leooLoadHeadJunPro,
                          ),
                        ),
                      ),
                    ],
                  ),
                  SizedBox(height: 10.w),
                  LeooTextWidgetJunPro(
                    infoEntity?.getNameAge() ?? '',
                    LeooTextJunPro.leooGetTextStyleJunPro(24, FontWeight.bold),
                    iconData: (infoEntity?.gender ?? 0) == 0
                        ? null
                        : LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                            infoEntity?.gender == 1
                                ? LeooIconsJunPro.leooInfoMaleJunPro
                                : LeooIconsJunPro.leooInfoFemaleJunPro,
                            width: 18.w,
                            height: 18.w,
                          ),
                    iconPadding: 2.5.w,
                    right: true,
                    mainAxisSize: MainAxisSize.min,
                    maxWidth: .5.sw,
                  ),
                  SizedBox(height: 5.w),
                  if (infoEntity?.country?.isEmpty == false)
                    LeooWidgetUtilsJunPro.leooGetCountryWidgetJunPro(
                        context, infoEntity?.country,
                        item: false),
                  SizedBox(height: 5.w),
                  if (!match && userProvider.userEntity.userType == 0)
                    LeooTextWidgetJunPro(
                      S
                          .of(context)
                          .randomPopMin(infoEntity?.talkingGoldPerMin ?? 0),
                      LeooTextJunPro.leooGetTextStyleJunPro(
                          16, FontWeight.bold),
                      iconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                        LeooIconsJunPro.leooMainCoinsJunPro,
                        width: 16.w,
                        height: 16.w,
                      ),
                      padding: EdgeInsets.fromLTRB(10.w, 5.w, 10.w, 5.w),
                      decoration: ShapeDecoration(
                        shape: const StadiumBorder(),
                        color: Colors.white.withOpacity(.1),
                      ),
                      iconPadding: 2.5.w,
                      mainAxisSize: MainAxisSize.min,
                    ),
                  SizedBox(height: 80.w),
                  callStatusWidget(),
                  SizedBox(height: 10.w),
                  SizedBox(
                    width: 1.sw - 100.w,
                    height: 100.w,
                    child: Text(
                      callTip,
                      style: LeooTextJunPro.leooGetTextStyleJunPro(
                          16, FontWeight.bold),
                      textAlign: TextAlign.center,
                    ),
                  ),
                ],
              )
            : Column(
                mainAxisAlignment: MainAxisAlignment.center,
                children: [
                  SizedBox(height: ScreenUtil().statusBarHeight + 30.w),
                  Row(
                    children: [
                      SizedBox(width: 20.w),
                      Container(
                        decoration: ShapeDecoration(
                          shape: CircleBorder(
                            side: BorderSide(
                              color: LeooColorsJunPro.leooAppJunPro,
                              width: 2.w,
                            ),
                          ),
                        ),
                        width: 60.w,
                        height: 60.w,
                        child: ClipOval(
                          child: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                            infoEntity?.header,
                            width: 60.w,
                            height: 60.w,
                            load: LeooIconsJunPro.leooLoadHeadJunPro,
                          ),
                        ),
                      ),
                      SizedBox(width: 10.w),
                      Expanded(
                        child: Column(
                          crossAxisAlignment: CrossAxisAlignment.start,
                          children: [
                            LeooTextWidgetJunPro(
                              infoEntity?.getNameAge() ?? '',
                              LeooTextJunPro.leooGetTextStyleJunPro(
                                  20, FontWeight.bold),
                              iconData: (infoEntity?.gender ?? 0) == 0
                                  ? null
                                  : LeooCommonUtilsJunPro
                                      .leooGetLoadWidgetJunPro(
                                      infoEntity?.gender == 1
                                          ? LeooIconsJunPro.leooInfoMaleJunPro
                                          : LeooIconsJunPro
                                              .leooInfoFemaleJunPro,
                                      width: 18.w,
                                      height: 18.w,
                                    ),
                              iconPadding: 2.5.w,
                              right: true,
                              mainAxisSize: MainAxisSize.min,
                              maxWidth: .5.sw,
                            ),
                            if (infoEntity?.country?.isEmpty == false)
                              SizedBox(height: 2.w),
                            if (infoEntity?.country?.isEmpty == false)
                              LeooWidgetUtilsJunPro.leooGetCountryWidgetJunPro(
                                  context, infoEntity?.country,
                                  item: false),
                          ],
                        ),
                      ),
                      SizedBox(width: 20.w),
                    ],
                  ),
                  Expanded(child: Container()),
                  callStatusWidget(),
                  SizedBox(height: 10.w),
                  SizedBox(
                    width: 1.sw - 100.w,
                    height: 100.w,
                    child: Text(
                      callTip,
                      style: LeooTextJunPro.leooGetTextStyleJunPro(
                          16, FontWeight.bold),
                      textAlign: TextAlign.center,
                    ),
                  ),
                  SizedBox(
                      height: 120.w,
                      child: !call && callStatus == -1 && !userCheck
                          ? Row(
                              mainAxisAlignment: MainAxisAlignment.spaceEvenly,
                              children: [
                                SizedBox(
                                  width: 80.w,
                                  height: 80.w,
                                  child: IconButton(
                                    padding: const EdgeInsets.all(0),
                                    icon: LeooCommonUtilsJunPro
                                        .leooGetLoadWidgetJunPro(
                                            LeooIconsJunPro
                                                .leooVideoCloseJunPro,
                                            width: 70.w,
                                            height: 70.w),
                                    iconSize: 70.w,
                                    onPressed: LeooNavigatorUtilsJunPro
                                        .leooDebounceJunPro(() {
                                      setHangUp(send: !call);
                                    }),
                                  ),
                                ),
                                Stack(
                                  clipBehavior: Clip.none,
                                  children: [
                                    IconButton(
                                      padding: const EdgeInsets.all(0),
                                      icon: LeooCommonUtilsJunPro
                                          .leooLottieJunPro(
                                              LeooIconsJunPro.leooAnswerJunPro,
                                              width: 80.w,
                                              height: 80.w),
                                      iconSize: 80.w,
                                      onPressed: LeooNavigatorUtilsJunPro
                                          .leooDebounceJunPro(() {
                                        if (videoCallKey.currentState?.isInit ==
                                            true) {
                                          int money =
                                              userProvider.userEntity.amount ??
                                                  0;
                                          int size = money ~/
                                              (infoEntity?.talkingGoldPerMin ??
                                                  1);
                                          if (userProvider
                                                      .userEntity.userType ==
                                                  0 &&
                                              size == 0) {
                                            onShowCoinsWidget(S
                                                    .of(context)
                                                    .diamondVideoTip)
                                                .then((value) {
                                              if (value != null &&
                                                  callStatus != 2) {
                                                userCheck = true;
                                                LeooCodeUtilsJunPro.onSetState(
                                                    this);
                                                videoCallKey.currentState
                                                    ?.userInHouseCheck();
                                              }
                                            });
                                          } else {
                                            userCheck = true;
                                            LeooCodeUtilsJunPro.onSetState(
                                                this);
                                            videoCallKey.currentState
                                                ?.userInHouseCheck();
                                          }
                                        }
                                      }),
                                    ),
                                    LeooVisibleWidgetJunPro(
                                      visibleKey,
                                      false,
                                      Positioned(
                                        top: -60.w,
                                        left: -60.w,
                                        right: -60.w,
                                        child: LeooSlideScaleWidgetJunPro(
                                          LeooBubbleJunPro(
                                            Row(
                                              children: [
                                                Stack(
                                                  children: [
                                                    ClipOval(
                                                      child: LeooCommonUtilsJunPro
                                                          .leooGetLoadWidgetJunPro(
                                                        infoEntity?.header,
                                                        width: 40,
                                                        height: 40,
                                                        load: LeooIconsJunPro
                                                            .leooLoadHeadJunPro,
                                                      ),
                                                    ),
                                                    Positioned(
                                                        right: 0.w,
                                                        top: 0.w,
                                                        child: LeooWidgetUtilsJunPro
                                                            .leooGetOnlineTipJunPro(
                                                                context,
                                                                infoEntity
                                                                    ?.chatStatus,
                                                                size: 12)),
                                                  ],
                                                ),
                                                SizedBox(width: 10.w),
                                                Expanded(
                                                  child: Text(
                                                      S
                                                          .of(context)
                                                          .videoCallTip,
                                                      style: LeooTextJunPro
                                                          .leooGetTextStyleJunPro(
                                                              16,
                                                              FontWeight.bold)),
                                                ),
                                              ],
                                            ),
                                            direction: BubbleDirection.bottom,
                                            borderRadius:
                                                const Radius.circular(30),
                                            padding: EdgeInsets.all(8.w),
                                            margin:
                                                EdgeInsets.only(bottom: 8.w),
                                            decoration: ShapeDecoration(
                                              shape: StadiumBorder(),
                                              color: LeooColorsJunPro
                                                  .leooPopBgJunPro,
                                            ),
                                          ),
                                          left: 1,
                                        ),
                                      ),
                                    ),
                                  ],
                                ),
                              ],
                            )
                          : Container()),
                  SizedBox(height: 30.w),
                ],
              ),
      ],
    );
  }

  Widget callStatusWidget() {
    if (videoCallKey.currentState?.partyLeft == true) {
      return Text(S.of(context).videoErrorTo2,
          style: LeooTextJunPro.leooGetTextStyleJunPro(30, FontWeight.bold),
          textAlign: TextAlign.center);
    }
    switch (callStatus) {
      case 2:
        return Text(S.of(context).videoError4,
            style: LeooTextJunPro.leooGetTextStyleJunPro(30, FontWeight.bold),
            textAlign: TextAlign.center);
      case -1:
        return Text(S.of(context).videoWaiting,
            style: LeooTextJunPro.leooGetTextStyleJunPro(30, FontWeight.bold),
            textAlign: TextAlign.center);
      case 0:
        String text;
        if (videoCallKey.currentState?.isConnect == true) {
          text = S.of(context).videoConnection;
        } else {
          text = S.of(context).videoWaiting;
        }
        return Text(text,
            style: LeooTextJunPro.leooGetTextStyleJunPro(30, FontWeight.bold),
            textAlign: TextAlign.center);
      default:
        return Text(S.of(context).videoConnection,
            style: LeooTextJunPro.leooGetTextStyleJunPro(30, FontWeight.bold),
            textAlign: TextAlign.center);
    }
  }

  void willSendText(String text, {bool call = true}) async {
    //被动操作不需要发送消息
    if (!call) {
      return;
    }
    try {
      EMMessage sendMessage = EMMessage.createTxtSendMessage(
          username: widget.userId.toString(), content: text);
      sendMessage.attributes = {
        'customEvent': LeooAppConfigJunPro.leooCallEventJunPro,
        'status': status,
        'em_apns_ext': {
          'em_push_name': userProvider.userEntity.nickname,
          'em_push_content': text
        }
      };
      EMClient.getInstance.chatManager.sendMessage(sendMessage);
    } catch (e) {
      LeooNetConfigJunPro.leooPrintLogJunPro(e);
    }
  }

  void normalPop({bool delayed = false, bool popEnd = false}) {
    callStatus = 2;
    if (showRecharge) {
      return;
    }
    LeooMediaUtilsJunPro.instance.stopPlayAudio();
    if (delayed) {
      Future.delayed(const Duration(seconds: 2), () {
        beforeTimer?.cancel();
        if (!LeooVideoCallJunPro.leooOpenJunPro) {
          return;
        }
        LeooVideoCallJunPro.leooOpenJunPro = false;
        if (showPopView) {
          showPopView = false;
          Navigator.pop(context);
        }
        Navigator.pop(context);
        if (popEnd) {
          LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
            context,
            LeooVideoEndJunPro(infoEntity, videoCallKey.currentState?.callId,
                userProvider.userEntity.userType == 0),
            'LeooVideoEndJunPro',
            fullscreenDialog: true,
          );
        }
      });
    } else {
      beforeTimer?.cancel();
      if (!LeooVideoCallJunPro.leooOpenJunPro) {
        return;
      }
      LeooVideoCallJunPro.leooOpenJunPro = false;
      if (showPopView) {
        showPopView = false;
        Navigator.pop(context);
      }
      Navigator.pop(context);
      if (popEnd) {
        LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
          context,
          LeooVideoEndJunPro(infoEntity, videoCallKey.currentState?.callId,
              userProvider.userEntity.userType == 0),
          'LeooVideoEndJunPro',
          fullscreenDialog: true,
        );
      }
    }
  }

  void setHangUp({bool net = false, bool send = false, bool close = false}) {
    if (callStatus == 0) {
      return;
    }
    if (callStatus == 1) {
      if (showPopView) {
        return;
      }
      showPopView = true;
      LeooDialogUtilsJunPro.instance
          .showCustomDialog(context,
              content: S.of(context).videoHang, right: S.of(context).appYes)
          .then((value) {
        showPopView = false;
        if (value == true) {
          leaveChannel();
        }
      });
    } else if (!close) {
      if (showPopView) {
        return;
      }
      showPopView = true;
      LeooDialogUtilsJunPro.instance
          .showCustomDialog(context,
              content: S.of(context).videoHang, right: S.of(context).appYes)
          .then((value) {
        showPopView = false;
        if (value == true) {
          setHangUp(net: net, send: send, close: true);
        }
      });
    } else {
      if (callStatus <= 0 || send) {
        callReport(call ? 1 : 2);
      }
      if (net) {
        if (!call) {
          willSendText(S.of(context).videoError4, call: callStatus != -1);
          videoCallKey.currentState?.willSendVideo(1);
        }
      } else if (callStatus <= 0 || send) {
        if (call) {
          willSendText(S.of(context).videoError0,
              call: call || callStatus > -1);
        } else {
          willSendText(S.of(context).videoError1, call: callStatus != -1);
        }
        videoCallKey.currentState?.willSendVideo(1);
      }
      normalPop();
    }
  }

  //主动判断
  void showEndView([bool keep = false, bool popEnd = true]) {
    leaveChannel(keep);
    if (keep) {
      callStatus = 3;
      videoCallKey.currentState?.setCallStatus(callStatus);
      LeooCodeUtilsJunPro.onSetState(this);
    } else if (callStatus != 3) {
      Future.delayed(const Duration(milliseconds: 500), () {
        normalPop(popEnd: popEnd);
      });
    }
  }

  //被动判断
  void leaveChannel([bool keep = false]) {
    videoCallKey.currentState?.leaveChannel(keep);
  }

  void startTimer() {
    if (beforeTimer?.isActive == true) {
      beforeTimer?.cancel();
    }
    beforeRate = 0;
    List list = [
      LeooStringJunPro.leooStrPartyTip1JunPro,
      LeooStringJunPro.leooStrPartyTip2JunPro,
      LeooStringJunPro.leooStrPartyTip3JunPro,
      LeooStringJunPro.leooStrPartyTip4JunPro,
    ];
    Random rand = Random();
    callTip = list[rand.nextInt(4)];
    beforeTimer = Timer.periodic(const Duration(seconds: 1), (timer) {
      beforeRate++;
      // AppConfig.printLog('beforeRate:$beforeRate');
      if (beforeRate % 2 == 0) {
        callTip = list[rand.nextInt(4)];
      }
      if (beforeRate >= LeooAppConfigJunPro.leooInCallTimeJunPro) {
        timer.cancel();
        videoCallKey.currentState?.offline = true;
        if (callStatus <= 0) {
          videoCallKey.currentState?.willSendVideo(1);
          if (call) {
            callReport(0);
          }
        }
        normalPop();
      }
      LeooCodeUtilsJunPro.onSetState(this);
    });
  }

  //0-超时未接听、1-主动挂断、2-对方挂断
  void callReport(int type) {
    LeooMainDaoJunPro.leooCallReportJunPro(
        videoCallKey.currentState?.callId, type);
  }

  @override
  void onAnalyticsEvent(String name) {
    FirebaseAnalytics.instance.logEvent(name: name);
  }

  @override
  void onCallStatus(int callStatus) {
    if (callStatus == 1) {
      beforeTimer?.cancel();
      LeooMediaUtilsJunPro.instance.stopPlayAudio();
      if (matchingId != null && userProvider.userEntity.userType == 0) {
        EMMessage sendMessage = EMMessage.createTxtSendMessage(
            username: '',
            content: S.of(context).videoMatchTimeTip(
                infoEntity?.talkingGoldPerMin ?? 0,
                LeooAppConfigJunPro.leooMatchCallTimeJunPro));
        sendMessage.status = MessageStatus.SUCCESS;
        _insertOrReplaceMessage(sendMessage);
      }
    }
    this.callStatus = callStatus;
    LeooCodeUtilsJunPro.onSetState(this);
  }

  @override
  void onCalling([int? amount]) {
    if (matchingId != null && videoCallKey.currentState?.currentDown == 0) {
      videoCallKey.currentState?.currentDown =
          LeooAppConfigJunPro.leooMatchCallTimeJunPro;
    }
    if (userProvider.userEntity.userType != 0) {
      return;
    }
    if (matchingId == null) {
      int money = amount ?? userProvider.userEntity.amount ?? 0;
      int size = money ~/ (infoEntity?.talkingGoldPerMin ?? 1);
      LeooNetConfigJunPro.leooPrintLogJunPro('onCalling size: $size');
      if (size == 0) {
        if (videoCallKey.currentState?.isSoonMoney == false) {
          videoCallKey.currentState?.isSoonMoney = true;
          var time = (size + 1) * 60 -
              (videoCallKey.currentState?.currentRate ?? 0) % 60;
          if (time < 30) {
            Future.delayed(Duration(seconds: time), () {
              videoCallKey.currentState?.currentDown = 60;
            });
          } else {
            videoCallKey.currentState?.currentDown = time;
          }
          videoCallKey.currentState?.willSendVideo(10001);
        }
      } else {
        videoCallKey.currentState?.isSoonMoney = false;
        match = false;
        videoCallKey.currentState?.currentDown = 0;
      }
    } else if (videoCallKey.currentState?.currentDown == 0) {
      videoCallKey.currentState?.currentDown =
          LeooAppConfigJunPro.leooMatchCallTimeJunPro -
              (videoCallKey.currentState?.currentRate ?? 0) % 60;
    }
    if (amount != null) {
      userProvider.setMoney(amount);
    }
  }

  @override
  void onVideoState(type) {
    if (type == 10001 && !showOtherDownText) {
      showOtherDownText = true;
      LeooCodeUtilsJunPro.onSetState(this);
    } else if (type == 10002 && showOtherDownText) {
      showOtherDownText = false;
      LeooCodeUtilsJunPro.onSetState(this);
    }
  }

  @override
  void onCurrentRate(int rate, {bool down = false}) {
    if (down) {
      timeKeyDown.currentState?.onSetState(rate);
      if (rate == 0) {
        LeooCodeUtilsJunPro.onSetState(this);
      }
    } else {
      if (matchingId != null &&
          LeooAppConfigJunPro.leooMatchCallTimeJunPro != rate) {
        timeKey.currentState?.onSetState(
          LeooCodeUtilsJunPro.leooGetTimeStrJunPro(
            DateTime.fromMillisecondsSinceEpoch(
                (LeooAppConfigJunPro.leooMatchCallTimeJunPro - rate) * 1000,
                isUtc: true),
          ),
        );
      } else {
        if (matchingId != null) {
          matchingId = null;
          videoCallKey.currentState?.matchId = null;
          videoCallKey.currentState?.currentRate = 0;
          videoCallKey.currentState?.currentDown = 0;
          rate = 0;
          onCalling();
          if (allList.isNotEmpty) {
            allList.removeAt(0);
          }
        }
        timeKey.currentState?.onSetState(
          LeooCodeUtilsJunPro.leooGetTimeStrJunPro(
            DateTime.fromMillisecondsSinceEpoch(rate * 1000, isUtc: true),
          ),
        );
      }
    }
  }

  @override
  void onNormalPop({bool hangup = true, bool? delayed = false}) {
    if (hangup) {
      normalPop(delayed: delayed!);
    } else {
      setHangUp();
    }
  }

  @override
  void onShowLocalVideo(bool local) {
    if (callStatus == -1) {
      if (local) {
        LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
            S.of(context).videoErrorTo10);
        onRemoteUserLeft(4, toast: false);
      } else {
        LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
            S.of(context).videoErrorOut6);
        onRemoteUserLeft(4, toast: false);
      }
    }
  }

  Future onShowCoinsWidget(String content, [bool send = true]) {
    if (showPopView) {
      showPopView = false;
      Navigator.pop(context);
    }
    showRecharge = true;
    return LeooRechargeUtilsJunPro.instance
        .showRechargeDialog(context, content, dismiss: false, call: true)
        .then((value) {
      if (value != false) {
        showRecharge = false;
        if (value == null) {
          if (send) {
            callStatus = 2;
            setHangUp(send: true, close: true);
          } else {
            normalPop();
          }
        } else if (value != null && callStatus == 2) {
          callStatus = -1;
          call = true;
          videoCallKey.currentState?.setCallStatus(callStatus);
          videoCallKey.currentState?.callBefore();
          hostInfo();
          return null;
        }
      }
      return value;
    });
  }

  @override
  void onShowNetText(bool? me) {
    if (me == null) {
      showNetText = false;
      LeooCodeUtilsJunPro.onSetState(this);
    } else if (!showNetText) {
      showNetText = true;
      if (me) {
        netText = S.of(context).videoNetMe;
      } else {
        netText = S.of(context).videoNetOther;
      }
      LeooCodeUtilsJunPro.onSetState(this);
    }
  }

  @override
  void onShowToast(int type) {
    switch (type) {
      case -1:
        LeooCommonUtilsJunPro.leooShowErrorToastJunPro();
        break;
      case 0:
        LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
            S.of(LeooRouterJunPro.leooContextJunPro).videoNetEr);
        break;
      case 1:
        LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
            S.of(LeooRouterJunPro.leooContextJunPro).videoErrorTo5);
        break;
      case 2:
        LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
            S.of(LeooRouterJunPro.leooContextJunPro).videoErrorTo6);
        break;
      case 3:
        LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
            S.of(LeooRouterJunPro.leooContextJunPro).videoErrorOut7);
        break;
      case 5:
        LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
            S.of(LeooRouterJunPro.leooContextJunPro).videoErrorTo1);
        break;
      case 6:
        LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
            S.of(LeooRouterJunPro.leooContextJunPro).videoErrorTo11);
        break;
      default:
        break;
    }
  }

  @override
  bool onWillCheckSendVideo() {
    if (!LeooVideoUtilsJunPro.instance.rtmLogin) {
      LeooNetConfigJunPro.leooPrintLogJunPro(
          'rtmLogin: ${LeooVideoUtilsJunPro.instance.rtmLogin}, rtmLoginOut: ${LeooVideoUtilsJunPro.instance.rtmLoginOut}');
      LeooCommonUtilsJunPro.leooShowCustomToastJunPro(S.of(context).chatImNo);
      if (LeooVideoUtilsJunPro.instance.rtmLoginOut) {
        LeooVideoUtilsJunPro.instance.rtmLoginOut = false;
        LeooVideoUtilsJunPro.instance.rtmLogin = false;
        LeooVideoUtilsJunPro.instance.rtmClient = null;
        LeooVideoUtilsJunPro.instance.createRtmClient(context);
      }
      leaveChannel();
      return false;
    }
    return true;
  }

  @override
  void onRemoteUserLeft(int dropped, {bool toast = true}) {
    if (callStatus == 1) {
      callStatus = 2;
      videoCallKey.currentState?.setCallStatus(callStatus);
      if (dropped != 1) {
        //0-自己挂断//1-对方正常挂断//2-没钱最后一分钟挂断//3-通话过程中对方异常//4-声网回调异常//5-后台挂断
        call = true;
        if (dropped == 2 && videoCallKey.currentState?.currentRate != 0 ||
            dropped != 0 && match) {
          if (toast) {
            LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
                S.of(context).videoErrorTo8);
          }
          if (match) {
            willSendText(S.of(context).videoError5);
          } else {
            willSendText(S.of(context).videoError3);
          }
        } else {
          if (dropped == 3 || dropped == 4) {
            if (toast) {
              LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
                  S.of(context).videoErrorOut5);
            }
            willSendText(S.of(context).videoError4);
          } else {
            if (dropped == 5 && toast) {
              LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
                  S.of(context).videoErrorTo8);
            }
            willSendText(S.of(context).videoError3);
          }
        }
      } else {
        //通话过程对方挂断
        if (toast) {
          LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
              S.of(context).videoErrorOut0);
        }
      }
      if (dropped == 0 || dropped == 3 || dropped == 4) {
        LeooMainDaoJunPro.leooCallEndJunPro(videoCallKey.currentState?.callId,
            dropped, videoCallKey.currentState?.currentRate);
      }
      showEndView(
          userProvider.userEntity.userType == 0 &&
              videoCallKey.currentState?.currentDown != 0 &&
              dropped == 2,
          !match ||
              userProvider.userEntity.userType != 0 &&
                  (videoCallKey.currentState?.currentRate ?? 0) > 30);
    } else if (callStatus <= 2) {
      if (toast) {
        LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
            S.of(context).videoErrorTo1);
      }
      normalPop();
    }
  }

  @override
  void onFirstFrame() {
    LeooMainDaoJunPro.leooReportFirstFrameJunPro(
            matchingId, videoCallKey.currentState?.callId)
        .then((res) {
      if (res.result) {
        if (res.data == true) {
          LeooRtmEntity entity = LeooRtmEntity();
          entity.type = 3;
          videoCallKey.currentState?.onRtmMessageReceived(entity);
        }
      } else {
        LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
        int money = userProvider.userEntity.amount ?? 0;
        int size = money ~/ (infoEntity?.talkingGoldPerMin ?? 1);
        if (size == 0) {
          onShowCoinsWidget(S.of(context).diamondVideoTip).then((value) {
            if (value != null && callStatus != 2) {
              callStatus = 2;
              setHangUp(send: true, close: true);
            }
          });
        } else {
          callStatus = 2;
          setHangUp(send: true, close: true);
        }
      }
    });
  }

  void showGiftButton() {
    LeooRechargeUtilsJunPro.instance.showGiftButton(context, userProvider,
        back: (value) {
      if (value == true) {
        showPopView = true;
      } else {
        showPopView = false;
      }
    }).then((value) {
      if (value != null) {
        willSendGift(value);
      }
    });
  }

  void willSendGift(LeooGiftEntity gift) async {
    showPopView = true;
    EMMessage? sendMessage = await LeooRechargeUtilsJunPro.instance
        .willSendGift(context, userProvider, gift, widget.userId, pop: () {
      showPopView = false;
    });
    if (sendMessage == null) {
      showPopView = false;
    } else {
      _insertOrReplaceMessage(sendMessage);
    }
  }

  @override
  Future<LeooTokenEntity?> callBefore(
      {int? targetUserId, String? channelName}) {
    if (targetUserId != null && channelName == null) {
      return LeooMainDaoJunPro.leooInitCallJunPro(
              targetUserId, userProvider.userEntity.userType == 0 ? 1 : 0)
          .then((res) async {
        if (res.result) {
          if (res.data.result == true) {
            var token = await LeooMainDaoJunPro.leooRtcTokenJunPro(
                    userProvider.userEntity.id, 1,
                    channelName: res.data.channelName)
                .then((resToken) {
              if (resToken.result) {
                return resToken.data;
              }
              LeooCommonUtilsJunPro.leooShowErrorToastJunPro(resToken);
              normalPop();
              return null;
            });
            return token;
          } else if (res.data.errType == 1) {
            onShowCoinsWidget(S.of(context).diamondVideoTip, false)
                .then((value) {
              if (value != null && callStatus != 2) {
                videoCallKey.currentState?.callBefore();
              }
            });
            return null;
          } else {
            if (res.data.errType == 2) {
              LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
                  S.of(context).videoErrType2);
            } else if (res.data.errType == 3) {
              LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
                  S.of(context).videoErrType3);
            } else if (res.data.errType == 4) {
              LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
                  S.of(context).videoErrType4);
            } else {
              LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
            }
            normalPop();
            return null;
          }
        } else {
          LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
          normalPop();
          return null;
        }
      });
    } else if (channelName != null) {
      return LeooMainDaoJunPro.leooRtcTokenJunPro(userProvider.userEntity.id, 1,
              channelName: channelName)
          .then((res) {
        if (res.result) {
          return res.data;
        }
        LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
        normalPop();
        return null;
      });
    } else {
      LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
          S.of(context).videoErrorOut5);
      normalPop();
      return Future.value();
    }
  }

  @override
  void didTapButton(int type) {}

  @override
  void inputStatusDidChange(bool hasFocus) {
    setBottomHeightLone();
  }

  void setBottomHeightLone() {
    videoCallKey.currentState?.setBottomHeight(keyboardAware
        ? MediaQuery.of(context).viewInsets.bottom -
            ScreenUtil().bottomBarHeight
        : 0);
  }

  @override
  void willInputSendText(String text) {
    willSendTextInput(text);
  }

  Future<String?> translatorMessage(String messageId, String text,
      {bool refresh = false, bool send = false}) async {
    var translatedText =
        await LeooCodeUtilsJunPro.leooTranslatorMessageTextJunPro(text,
            send: send);
    if (translatedText != null) {
      translatorMap[messageId] = translatedText;
    } else {
      translatorMap[messageId] = text;
    }
    try {
      translatorDbProvider ??= LeooTranslatorDbProviderJunPro();
      translatorDbProvider!
          .insert(messageId, widget.userId, text, translatedText);
    } catch (e) {
      LeooNetConfigJunPro.leooPrintLogJunPro(e);
    }
    if (refresh) {
      LeooCodeUtilsJunPro.onSetState(this);
    }
    return translatedText;
  }

  void translatorMessages(List<EMMessage> messages) async {
    for (var message in messages) {
      if (message.direction == MessageDirection.RECEIVE &&
          message.body is EMTextMessageBody &&
          translatorMap[message.msgId] == null) {
        await translatorMessage(
            message.msgId, (message.body as EMTextMessageBody).content,
            refresh: true);
      }
    }
  }

  void willSendTextInput(String text) async {
    controller.text = '';
    EMMessage sendMessage = EMMessage.createTxtSendMessage(
        username: widget.userId.toString(), content: text);
    sendMessage.attributes = {
      'em_apns_ext': {
        'em_push_name': userProvider.userEntity.nickname,
        'em_push_content': text
      }
    };
    _insertOrReplaceMessage(sendMessage);
  }

  void _insertOrReplaceMessage(EMMessage message, [bool tran = false]) {
    int index = -1;
    for (int i = 0; i < allList.length; i++) {
      EMMessage msg = allList[i];
      if (msg.msgId == message.msgId) {
        index = i;
        break;
      }
    }
    //如果数据源中相同 id 消息，那么更新对应消息，否则插入消息
    if (index >= 0) {
      allList[index] = message;
    } else {
      allList.insert(0, message);
    }
    if (tran &&
        message.direction == MessageDirection.RECEIVE &&
        message.body is EMTextMessageBody) {
      translatorMessage(
          message.msgId, (message.body as EMTextMessageBody).content,
          refresh: true);
    }
    LeooCodeUtilsJunPro.onSetState(this);
  }

  @override
  void onMessageReceived(List<EMMessage> messages) {
    for (var msg in messages) {
      if (msg.from == widget.userId.toString()) {
        if (msg.body is EMTextMessageBody ||
            msg.body is EMImageMessageBody ||
            msg.body is EMCustomMessageBody) {
          _insertOrReplaceMessage(msg, true);
        }
      }
    }
  }

  @override
  void onConnectionStatusChange(bool connected) {}
}
