import 'dart:core';

import 'package:flutter/material.dart';
import 'package:flutter_rating_bar/flutter_rating_bar.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoomaindaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoouserentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoouserlistentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoodialogutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoowidgetutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoobuttonwidgetjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leooinfojunpro/leooinfojunpro.dart';

///通话结束
class LeooVideoEndJunPro extends StatefulWidget {
  static bool leooOpenJunPro = false;
  final LeooUserEntity? infoEntity;
  final int? talkingId;
  final bool recommended;

  const LeooVideoEndJunPro(this.infoEntity, this.talkingId, this.recommended,
      {Key? key})
      : super(key: key);

  @override
  _LeooVideoEndState createState() => _LeooVideoEndState();
}

class _LeooVideoEndState extends State<LeooVideoEndJunPro> {
  List<LeooUserListEntity> allList = [];
  double userRating = 5;
  int talkingTime = 0;

  @override
  void initState() {
    super.initState();
    LeooVideoEndJunPro.leooOpenJunPro = true;
    getTalkingTime();
    if (widget.recommended) {
      getList();
    }
  }

  void getList() {
    LeooMainDaoJunPro.leooListRecommendJunPro().then((res) async {
      if (res.result) {
        allList = res.data;
        LeooCodeUtilsJunPro.onSetState(this);
      }
    });
  }

  void getTalkingTime() {
    LeooMainDaoJunPro.leooTalkingInfoJunPro(widget.talkingId).then((res) async {
      if (res.result) {
        talkingTime = res.data;
        LeooCodeUtilsJunPro.onSetState(this);
      }
    });
  }

  @override
  void dispose() {
    LeooVideoEndJunPro.leooOpenJunPro = false;
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      resizeToAvoidBottomInset: false,
      body: SafeArea(
        maintainBottomViewPadding: true,
        child: Column(
          mainAxisSize: MainAxisSize.min,
          children: [
            LeooWidgetUtilsJunPro.leooGetAppBarWidgetJunPro(
                context, S.of(context).videoAssess,
                popIcon: LeooIconsJunPro.leooPopCloseJunPro),
            SizedBox(height: 30.w),
            Container(
              decoration: ShapeDecoration(
                shape: CircleBorder(
                  side: BorderSide(
                    color: LeooColorsJunPro.leooAppJunPro,
                    width: 2.w,
                  ),
                ),
              ),
              width: 80.w,
              height: 80.w,
              child: ClipOval(
                child: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                  widget.infoEntity?.header,
                  width: 80.w,
                  height: 80.w,
                  load: LeooIconsJunPro.leooLoadHeadJunPro,
                ),
              ),
            ),
            SizedBox(height: 10.w),
            Text(
              widget.infoEntity?.getNameAge() ?? '',
              style: LeooTextJunPro.leooGetTextStyleJunPro(20, FontWeight.bold),
            ),
            SizedBox(height: 5.w),
            Text(
              talkingTime == 0
                  ? '--:--:--'
                  : LeooCodeUtilsJunPro.leooGetTimeStrJunPro(
                      DateTime.fromMillisecondsSinceEpoch(talkingTime * 1000,
                          isUtc: true),
                    ),
              style: LeooTextJunPro.leooGetTextStyleJunPro(16, FontWeight.bold),
            ),
            SizedBox(height: 50.w),
            Text(
              S.of(context).videoHow,
              style: LeooTextJunPro.leooGetTextStyleJunPro(20, FontWeight.bold),
            ),
            SizedBox(height: 20.w),
            RatingBar(
              initialRating: userRating,
              allowHalfRating: true,
              itemSize: 40.w,
              ratingWidget: RatingWidget(
                full: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                    LeooIconsJunPro.leooInfoStarFullJunPro),
                half: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                    LeooIconsJunPro.leooInfoStarHalfJunPro),
                empty: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                    LeooIconsJunPro.leooInfoStarEmptyJunPro),
              ),
              itemPadding: EdgeInsets.symmetric(horizontal: 10.w),
              onRatingUpdate: (rating) {
                userRating = rating;
              },
            ),
            SizedBox(height: 40.w),
            Padding(
              padding: EdgeInsets.only(
                left: 35.w,
                right: 35.w,
              ),
              child: LeooButtonWidgetJunPro(
                S.of(context).appSubmit,
                LeooTextJunPro.leooGetTextStyleJunPro(20, FontWeight.bold),
                color: LeooColorsJunPro.leooAppJunPro,
                colorRight: LeooColorsJunPro.leooApp2JunPro,
                shape: const RoundedRectangleBorder(
                  borderRadius: BorderRadius.all(Radius.circular(20)),
                ),
                onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                  LeooDialogUtilsJunPro.instance.showLoadingDialog(context);
                  LeooMainDaoJunPro.leooReviewScoreJunPro(
                          widget.infoEntity?.id, widget.talkingId, userRating)
                      .then((res) async {
                    Navigator.pop(context);
                    if (res.result) {
                      Navigator.pop(context);
                      LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
                          S.of(context).appComplete(S.of(context).videoAssess));
                    } else {
                      LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
                    }
                  });
                }),
              ),
            ),
            Expanded(
              child: Center(
                child: allList.isNotEmpty
                    ? Column(
                        mainAxisSize: MainAxisSize.min,
                        children: [
                          Padding(
                            padding: EdgeInsets.all(15.w),
                            child: Text(
                              S.of(context).matchGuess,
                              style: LeooTextJunPro.leooGetTextStyleJunPro(
                                  16, FontWeight.bold),
                            ),
                          ),
                          SizedBox(
                            height: 50.w,
                            child: ListView.separated(
                                physics: const BouncingScrollPhysics(),
                                scrollDirection: Axis.horizontal,
                                itemCount: allList.length,
                                separatorBuilder:
                                    (BuildContext context, int index) {
                                  return SizedBox(width: 10.w);
                                },
                                padding:
                                    EdgeInsets.only(left: 20.w, right: 20.w),
                                itemBuilder:
                                    (BuildContext itemContext, int index) {
                                  LeooUserListEntity item = allList[index];
                                  return InkWell(
                                    child: Stack(
                                      alignment: Alignment.topRight,
                                      children: [
                                        ClipOval(
                                          child: LeooCommonUtilsJunPro
                                              .leooGetLoadWidgetJunPro(
                                            item.header,
                                            width: 50.w,
                                            height: 50.w,
                                            load: LeooIconsJunPro
                                                .leooLoadHeadJunPro,
                                          ),
                                        ),
                                        LeooWidgetUtilsJunPro
                                            .leooGetOnlineTipJunPro(context,
                                                item.onlineStatus ?? 2),
                                      ],
                                    ),
                                    onTap: LeooNavigatorUtilsJunPro
                                        .leooDebounceJunPro(() {
                                      Navigator.pop(context);
                                      LeooUserEntity infoEntity =
                                          LeooUserEntity(
                                        id: item.userId,
                                        nickname: item.nickname,
                                        header: item.header,
                                      );
                                      LeooNavigatorUtilsJunPro
                                              .leooInfoPageJunPro
                                              ?.call(context, item.userId,
                                                  following:
                                                      infoEntity.following,
                                                  infoEntity: infoEntity) ??
                                          LeooNavigatorUtilsJunPro
                                              .leooNavigatorPushJunPro(
                                                  context,
                                                  LeooInfoJunPro(
                                                      item.userId,
                                                      infoEntity,
                                                      'matchWait${item.userId}'),
                                                  'LeooInfoJunPro',
                                                  add: true);
                                    }),
                                  );
                                }),
                          ),
                        ],
                      )
                    : Container(),
              ),
            ),
          ],
        ),
      ),
    );
  }
}
