import 'dart:typed_data';

import 'package:flutter/material.dart';
import 'package:flutter_picker/Picker.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leooappconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leoonetconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoomaindaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooeventjunpro/leooindexjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooeventjunpro/leoomaineventjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoodialogutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoowidgetutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoobuttonwidgetjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoocamerajunpro/leooplayjunpro.dart';
import 'package:video_compress/video_compress.dart';

///拍摄页面-上传
class LeooUploadJunPro extends StatefulWidget {
  final String videoFileUrl;

  const LeooUploadJunPro(this.videoFileUrl, {Key? key}) : super(key: key);

  @override
  _LeooUploadState createState() => _LeooUploadState();
}

class _LeooUploadState extends State<LeooUploadJunPro> {
  int videoPrice = 0;
  Uint8List? videoImage;
  List<String> priceList = [];

  @override
  void initState() {
    super.initState();
    getByteThumbnail();
  }

  void getByteThumbnail() async {
    try {
      videoImage = await VideoCompress.getByteThumbnail(widget.videoFileUrl);
      LeooCodeUtilsJunPro.onSetState(this);
    } catch (e) {
      LeooNetConfigJunPro.leooPrintLogJunPro(e);
    }
  }

  @override
  Widget build(BuildContext context) {
    if (priceList.isEmpty) {
      priceList = LeooAppConfigJunPro.leooListVideoFeeJunPro.map((e) {
        if (e == 0) {
          return S.of(context).uploadFree;
        }
        return '$e';
      }).toList();
    }
    return Scaffold(
      resizeToAvoidBottomInset: false,
      body: SafeArea(
        maintainBottomViewPadding: true,
        child: Column(
          children: <Widget>[
            LeooWidgetUtilsJunPro.leooGetAppBarWidgetJunPro(
                context, S.of(context).upload),
            Expanded(
              child: Padding(
                padding: EdgeInsets.all(15.w),
                child: Column(
                  crossAxisAlignment: CrossAxisAlignment.start,
                  children: [
                    InkWell(
                      onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                        LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
                            context,
                            LeooPlayJunPro(widget.videoFileUrl),
                            'LeooPlayJunPro');
                      }),
                      child: Stack(
                        alignment: Alignment.center,
                        children: [
                          SizedBox(width: 1.sw, height: 1.sw),
                          if (videoImage != null)
                            ClipRRect(
                              borderRadius: BorderRadius.circular(20),
                              child: Image.memory(
                                videoImage!,
                                width: .5.sw,
                                height: 1.sw,
                                fit: BoxFit.cover,
                              ),
                            ),
                          if (videoImage != null)
                            LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                              LeooIconsJunPro.leooVideoPlayJunPro,
                              width: 100.w,
                              height: 100.w,
                            ),
                        ],
                      ),
                    ),
                    SizedBox(height: 20.w),
                    InkWell(
                      child: Container(
                        decoration: BoxDecoration(
                          borderRadius: BorderRadius.circular(20),
                          color: Colors.white.withOpacity(.1),
                        ),
                        padding: EdgeInsets.fromLTRB(15.w, 18.w, 15.w, 18.w),
                        child: Row(
                          children: [
                            Expanded(
                              child: Text(
                                S.of(context).uploadPrice,
                                style:
                                    LeooTextJunPro.leooGetTextStyleHintJunPro(
                                        16, FontWeight.bold),
                              ),
                            ),
                            Text(
                              videoPrice == 0
                                  ? S.of(context).uploadFree
                                  : '$videoPrice',
                              style: LeooTextJunPro.leooGetTextStyleJunPro(
                                  20, FontWeight.bold),
                            ),
                          ],
                        ),
                      ),
                      onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                        LeooWidgetUtilsJunPro.leooShowPickerWidgetJunPro(
                          context,
                          PickerDataAdapter<String>(pickerdata: priceList),
                          priceList.contains(videoPrice.toString())
                              ? [priceList.indexOf(videoPrice.toString())]
                              : [0],
                          S.of(context).uploadPrice,
                          (Picker picker, List value) {
                            String selected = picker.getSelectedValues()[0];
                            if (selected == S.of(context).uploadFree) {
                              videoPrice = 0;
                            } else {
                              videoPrice =
                                  int.parse(picker.getSelectedValues()[0]);
                            }
                            LeooCodeUtilsJunPro.onSetState(this);
                          },
                        );
                      }),
                    ),
                    SizedBox(height: 50.w),
                    Padding(
                      padding: EdgeInsets.only(left: 20.w, right: 20.w),
                      child: LeooButtonWidgetJunPro(
                        S.of(context).appPost,
                        LeooTextJunPro.leooGetTextStyleJunPro(
                            20, FontWeight.bold),
                        color: LeooColorsJunPro.leooAppJunPro,
                        colorRight: LeooColorsJunPro.leooApp2JunPro,
                        shape: const RoundedRectangleBorder(
                          borderRadius: BorderRadius.all(Radius.circular(20)),
                        ),
                        onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(
                            () async {
                          LeooDialogUtilsJunPro.instance
                              .showLoadingDialog(context);
                          MediaInfo info = await VideoCompress.getMediaInfo(
                              widget.videoFileUrl);
                          if ((info.duration ?? 0) >
                              (LeooAppConfigJunPro.leooVideoMaxTimeJunPro + 1) *
                                  1000) {
                            Navigator.pop(context);
                            LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
                                S.of(context).videoMaxTip);
                          } else {
                            LeooMainDaoJunPro.leooUploadVideoJunPro(
                                    widget.videoFileUrl)
                                .then((res) {
                              if (res.result) {
                                LeooMainDaoJunPro.leooVideoPublishJunPro(
                                        res.data.videoPath,
                                        res.data.coverPath,
                                        videoPrice)
                                    .then((res) {
                                  if (res.result) {
                                    Navigator.pop(context);
                                    LeooCommonUtilsJunPro
                                        .leooShowCustomToastJunPro(S
                                            .of(context)
                                            .appComplete(S.of(context).upload));
                                    eventBus.fire(LeooVideoListMyEventJunPro());
                                    Navigator.pop(context);
                                  } else {
                                    Navigator.pop(context);
                                    LeooCommonUtilsJunPro
                                        .leooShowErrorToastJunPro(res);
                                  }
                                });
                              } else {
                                Navigator.pop(context);
                                LeooCommonUtilsJunPro.leooShowErrorToastJunPro(
                                    res);
                              }
                            });
                          }
                        }),
                      ),
                    ),
                  ],
                ),
              ),
            ),
          ],
        ),
      ),
    );
  }
}
