import 'dart:convert';

import 'package:crypto/crypto.dart';
import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoomaindaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooproviderjunpro/leoouserproviderjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoodialogutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoowidgetutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoobuttonwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leooedittextwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoowidgetjunpro/leookeyboardheightwidgetjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoofirstjunpro/leooaboutjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoofirstjunpro/leoologinjunpro.dart';
import 'package:provider/provider.dart';

class LeooSignUpJunPro extends StatefulWidget {
  const LeooSignUpJunPro({Key? key}) : super(key: key);

  @override
  _LeooSignUpState createState() => _LeooSignUpState();
}

class _LeooSignUpState extends State<LeooSignUpJunPro> {
  FocusNode focusNode = FocusNode();
  FocusNode focusNode1 = FocusNode();
  String? email;
  String? password;

  @override
  Widget build(BuildContext context) {
    return Consumer<LeooUserProviderJunPro>(
      builder: (_, LeooUserProviderJunPro userProvider, __) {
        return GestureDetector(
          behavior: HitTestBehavior.opaque,
          onTap: () {
            focusNode.unfocus();
            focusNode1.unfocus();
          },
          child: Scaffold(
            resizeToAvoidBottomInset: false,
            body: SafeArea(
              maintainBottomViewPadding: true,
              child: Column(
                children: [
                  LeooWidgetUtilsJunPro.leooGetAppBarWidgetJunPro(
                    context,
                    '',
                    rightChild: InkWell(
                      child: Padding(
                        padding: EdgeInsets.all(6.w),
                        child: Text(S.of(context).login,
                            style: LeooTextJunPro.leooGetTextStyleAppJunPro(
                                20, FontWeight.bold)),
                      ),
                      onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                        LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
                            context,
                            const LeooLoginJunPro(),
                            'LeooLoginJunPro');
                      }),
                    ),
                  ),
                  Expanded(
                    child: SingleChildScrollView(
                      physics: const BouncingScrollPhysics(),
                      child: Padding(
                        padding:
                            EdgeInsets.only(left: 35.w, top: 40.w, right: 35.w),
                        child: Column(
                          crossAxisAlignment: CrossAxisAlignment.start,
                          children: [
                            Text(S.of(context).loginSignUp,
                                style: LeooTextJunPro.leooGetTextStyleJunPro(
                                    36, FontWeight.bold)),
                            SizedBox(height: 30.w),
                            Text(S.of(context).loginEmail,
                                style: LeooTextJunPro.leooGetTextStyleJunPro(
                                    20, FontWeight.bold)),
                            SizedBox(height: 10.w),
                            LeooEditTextWidgetJunPro(
                                keyboardType: ITextInputType.text,
                                maxLines: 1,
                                textStyle:
                                    LeooTextJunPro.leooGetTextStyleJunPro(
                                        18, FontWeight.bold),
                                inputText: email ?? '',
                                fieldCallBack: (content) {
                                  email = content;
                                },
                                focusNode: focusNode,
                                inputBorder: OutlineInputBorder(
                                    borderRadius: BorderRadius.circular(20),
                                    borderSide: BorderSide.none),
                                fillColor: Colors.white.withOpacity(.1),
                                hintText: S.of(context).loginEmailHint,
                                hintStyle:
                                    LeooTextJunPro.leooGetTextStyleHintJunPro(
                                        18, FontWeight.bold),
                                inputMaxLength: 100),
                            SizedBox(height: 16.w),
                            Text(S.of(context).loginPassword,
                                style: LeooTextJunPro.leooGetTextStyleJunPro(
                                    20, FontWeight.bold)),
                            SizedBox(height: 10.w),
                            LeooEditTextWidgetJunPro(
                                keyboardType: ITextInputType.password,
                                maxLines: 1,
                                textStyle:
                                    LeooTextJunPro.leooGetTextStyleJunPro(
                                        18, FontWeight.bold),
                                inputText: password ?? '',
                                fieldCallBack: (content) {
                                  password = content;
                                },
                                focusNode: focusNode1,
                                inputBorder: OutlineInputBorder(
                                    borderRadius: BorderRadius.circular(20),
                                    borderSide: BorderSide.none),
                                fillColor: Colors.white.withOpacity(.1),
                                hintText: S.of(context).loginPasswordHint,
                                hintStyle:
                                    LeooTextJunPro.leooGetTextStyleHintJunPro(
                                        18, FontWeight.bold),
                                suffixStrShow: LeooIconsJunPro.leooSeeJunPro,
                                suffixStrHide: LeooIconsJunPro.leooSeeNoJunPro,
                                inputMaxLength: 100),
                            SizedBox(height: 34.w),
                            LeooButtonWidgetJunPro(
                              S.of(context).appNext,
                              LeooTextJunPro.leooGetTextStyleJunPro(
                                  20, FontWeight.bold),
                              color: LeooColorsJunPro.leooAppJunPro,
                              colorRight: LeooColorsJunPro.leooApp2JunPro,
                              shape: const RoundedRectangleBorder(
                                borderRadius:
                                    BorderRadius.all(Radius.circular(20)),
                              ),
                              onPressed:
                                  LeooNavigatorUtilsJunPro.leooDebounceJunPro(
                                      () {
                                if (email?.isEmpty != false) {
                                  LeooCommonUtilsJunPro
                                      .leooShowCustomToastJunPro(
                                          S.of(context).loginEmailHint, true);
                                } else if (password?.isEmpty != false) {
                                  LeooCommonUtilsJunPro
                                      .leooShowCustomToastJunPro(
                                          S.of(context).loginPasswordHint,
                                          true);
                                } else if (!RegExp(
                                        '^[a-zA-Z0-9_.-]+@[a-zA-Z0-9-]+(.[a-zA-Z0-9-]+)*.[a-zA-Z0-9]{2,6}\$')
                                    .hasMatch(email!)) {
                                  LeooCommonUtilsJunPro
                                      .leooShowCustomToastJunPro(
                                          S.of(context).loginEmailTip, true);
                                } else {
                                  LeooDialogUtilsJunPro.instance
                                      .showLoadingDialog(context);
                                  String md5Str = md5
                                      .convert(const Utf8Encoder()
                                          .convert(password!))
                                      .toString();
                                  LeooMainDaoJunPro.leooRegistUserByEmailJunPro(
                                          userProvider, email, md5Str)
                                      .then((res) {
                                    Navigator.pop(context);
                                    if (res.result) {
                                      LeooNavigatorUtilsJunPro
                                          .leooNavigatorPushJunPro(
                                              context,
                                              const LeooAboutJunPro(),
                                              'LeooAboutJunPro');
                                    } else {
                                      LeooCommonUtilsJunPro
                                          .leooShowErrorToastJunPro(res);
                                    }
                                  });
                                }
                              }),
                            ),
                          ],
                        ),
                      ),
                    ),
                  ),
                  const LeooKeyBoardHeightWidgetJunPro(),
                ],
              ),
            ),
          ),
        );
      },
    );
  }
}
