import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoomaindaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoouserentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooproviderjunpro/leoouserproviderjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoodialogutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoowidgetutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoobuttonwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leooedittextwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoowidgetjunpro/leookeyboardheightwidgetjunpro.dart';
import 'package:provider/provider.dart';

//三方和游客填写资料
class LeooSkipJunPro extends StatefulWidget {
  const LeooSkipJunPro({Key? key}) : super(key: key);

  @override
  _LeooSkipState createState() => _LeooSkipState();
}

class _LeooSkipState extends State<LeooSkipJunPro> {
  FocusNode focusNode = FocusNode();
  late LeooUserEntity userEntity;
  bool first = true;

  List<String> ageList = [];
  int pageIndex = 0;
  PageController pageController =
      PageController(viewportFraction: 0.2, initialPage: 0);

  @override
  void initState() {
    super.initState();
    for (int i = 18; i <= 80; i++) {
      ageList.add('$i');
    }
    pageController.addListener(() {
      if (pageController.page! % 1 == 0) {
        pageIndex = pageController.page!.toInt();
        userEntity.age = 18 + pageIndex;
        LeooCodeUtilsJunPro.onSetState(this);
      }
    });
  }

  @override
  Widget build(BuildContext context) {
    return Consumer<LeooUserProviderJunPro>(
        builder: (_, LeooUserProviderJunPro userProvider, __) {
      if (first) {
        first = false;
        userEntity = userProvider.userEntity;
      }
      return WillPopScope(
        onWillPop: () {
          LeooNavigatorUtilsJunPro.leooGoHomeJunPro(context);
          return Future.value(false);
        },
        child: GestureDetector(
          behavior: HitTestBehavior.opaque,
          onTap: () {
            focusNode.unfocus();
          },
          child: Scaffold(
            resizeToAvoidBottomInset: false,
            body: SafeArea(
              maintainBottomViewPadding: true,
              child: Column(
                children: [
                  LeooWidgetUtilsJunPro.leooGetAppBarWidgetJunPro(
                      context, S.of(context).skip.toUpperCase(),
                      rightChild: InkWell(
                        child: Padding(
                          padding: EdgeInsets.all(6.w),
                          child: Text(S.of(context).appSkip.toUpperCase(),
                              style: LeooTextJunPro.leooGetTextStyleAppJunPro(
                                  16, FontWeight.bold)),
                        ),
                        onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                          LeooNavigatorUtilsJunPro.leooGoHomeJunPro(context);
                        }),
                      ),
                      back: false),
                  Expanded(
                    child: SingleChildScrollView(
                      physics: const BouncingScrollPhysics(),
                      child: Padding(
                        padding: EdgeInsets.all(25.w),
                        child: Column(
                          children: [
                            SizedBox(height: 25.w),
                            Text(S.of(context).aboutGender,
                                style: LeooTextJunPro.leooGetTextStyleJunPro(
                                    20, FontWeight.bold)),
                            SizedBox(height: 20.w),
                            Row(
                              mainAxisAlignment: MainAxisAlignment.spaceAround,
                              children: [
                                Column(
                                  children: [
                                    IconButton(
                                      iconSize: 80.w,
                                      padding: const EdgeInsets.all(0),
                                      icon: LeooCommonUtilsJunPro
                                          .leooGetLoadWidgetJunPro(
                                              userEntity.gender == 1
                                                  ? LeooIconsJunPro
                                                      .leooSkipMaleJunPro
                                                  : LeooIconsJunPro
                                                      .leooSkipMaleNoJunPro,
                                              width: 90.w,
                                              height: 90.w),
                                      onPressed: LeooNavigatorUtilsJunPro
                                          .leooDebounceJunPro(() {
                                        userEntity.gender = 1;
                                        LeooCodeUtilsJunPro.onSetState(this);
                                      }),
                                    ),
                                    SizedBox(height: 10.w),
                                    Text(
                                      S.of(context).aboutMale,
                                      style: userEntity.gender == 1
                                          ? LeooTextJunPro
                                              .leooGetTextStyleAppJunPro(
                                                  16, FontWeight.bold)
                                          : LeooTextJunPro
                                              .leooGetTextStyleHint2JunPro(
                                                  16, FontWeight.bold),
                                    ),
                                  ],
                                ),
                                Column(
                                  children: [
                                    IconButton(
                                      iconSize: 80.w,
                                      padding: const EdgeInsets.all(0),
                                      icon: LeooCommonUtilsJunPro
                                          .leooGetLoadWidgetJunPro(
                                              userEntity.gender == 2
                                                  ? LeooIconsJunPro
                                                      .leooSkipFemaleJunPro
                                                  : LeooIconsJunPro
                                                      .leooSkipFemaleNoJunPro,
                                              width: 90.w,
                                              height: 90.w),
                                      onPressed: LeooNavigatorUtilsJunPro
                                          .leooDebounceJunPro(() {
                                        userEntity.gender = 2;
                                        LeooCodeUtilsJunPro.onSetState(this);
                                      }),
                                    ),
                                    SizedBox(height: 10.w),
                                    Text(
                                      S.of(context).aboutFemale,
                                      style: userEntity.gender == 2
                                          ? LeooTextJunPro
                                              .leooGetTextStyleAppJunPro(
                                                  16, FontWeight.bold)
                                          : LeooTextJunPro
                                              .leooGetTextStyleHint2JunPro(
                                                  16, FontWeight.bold),
                                    ),
                                  ],
                                ),
                              ],
                            ),
                            SizedBox(height: 50.w),
                            Text(S.of(context).aboutAge,
                                style: LeooTextJunPro.leooGetTextStyleJunPro(
                                    20, FontWeight.bold)),
                            SizedBox(height: 20.w),
                            Stack(
                              alignment: Alignment.center,
                              children: [
                                Container(
                                  width: 50.w,
                                  height: 50.w,
                                  decoration: ShapeDecoration(
                                    color: LeooColorsJunPro.leooAppJunPro,
                                    shape: CircleBorder(),
                                  ),
                                ),
                                SizedBox(
                                  width: 1.sw,
                                  height: 50.w,
                                  child: PageView.builder(
                                    itemCount: ageList.length,
                                    controller: pageController,
                                    scrollDirection: Axis.horizontal,
                                    physics: const BouncingScrollPhysics(),
                                    itemBuilder:
                                        (BuildContext itemContext, int index) {
                                      return InkWell(
                                        child: Container(
                                          alignment: Alignment.center,
                                          width: 50.w,
                                          height: 50.w,
                                          child: Text(
                                            ageList[index],
                                            style: index == pageIndex
                                                ? LeooTextJunPro
                                                    .leooGetTextStyleJunPro(
                                                        24, FontWeight.bold)
                                                : LeooTextJunPro
                                                    .leooGetTextStyleHintJunPro(
                                                        24, FontWeight.bold),
                                          ),
                                        ),
                                        onTap: LeooNavigatorUtilsJunPro
                                            .leooDebounceJunPro(() {
                                          pageController.animateToPage(index,
                                              duration: const Duration(
                                                  milliseconds: 400),
                                              curve: Curves.easeInOut);
                                        }),
                                      );
                                    },
                                  ),
                                ),
                              ],
                            ),
                            SizedBox(height: 50.w),
                            Text(S.of(context).aboutName,
                                style: LeooTextJunPro.leooGetTextStyleJunPro(
                                    18, FontWeight.bold)),
                            SizedBox(height: 20.w),
                            LeooEditTextWidgetJunPro(
                                keyboardType: ITextInputType.text,
                                maxLines: 1,
                                textStyle:
                                    LeooTextJunPro.leooGetTextStyleJunPro(
                                        18, FontWeight.bold),
                                textAlign: TextAlign.center,
                                inputText: userEntity.nickname ?? '',
                                fieldCallBack: (content) {
                                  userEntity.nickname = content;
                                },
                                focusNode: focusNode,
                                inputBorder: OutlineInputBorder(
                                    borderRadius: BorderRadius.circular(20),
                                    borderSide: BorderSide.none),
                                fillColor: Colors.white.withOpacity(.1),
                                hintText: S.of(context).aboutNameHint,
                                hintStyle:
                                    LeooTextJunPro.leooGetTextStyleHintJunPro(
                                        18, FontWeight.bold),
                                inputMaxLength: 100),
                            SizedBox(height: 80.w),
                            Padding(
                              padding: EdgeInsets.only(left: 10.w, right: 10.w),
                              child: LeooButtonWidgetJunPro(
                                S.of(context).appDone,
                                LeooTextJunPro.leooGetTextStyleJunPro(
                                    20, FontWeight.bold),
                                color: LeooColorsJunPro.leooAppJunPro,
                                colorRight: LeooColorsJunPro.leooApp2JunPro,
                                shape: const RoundedRectangleBorder(
                                  borderRadius:
                                      BorderRadius.all(Radius.circular(20)),
                                ),
                                onPressed:
                                    LeooNavigatorUtilsJunPro.leooDebounceJunPro(
                                        () {
                                  if ((userEntity.gender ?? 0) == 0) {
                                    LeooCommonUtilsJunPro
                                        .leooShowCustomToastJunPro(
                                            S.of(context).aboutGenderTip, true);
                                  } else if (userEntity.nickname?.isEmpty !=
                                      false) {
                                    LeooCommonUtilsJunPro
                                        .leooShowCustomToastJunPro(
                                            S.of(context).aboutNameHint, true);
                                  } else {
                                    LeooDialogUtilsJunPro.instance
                                        .showLoadingDialog(context);
                                    LeooMainDaoJunPro.leooUpdateJunPro(
                                            userEntity, userProvider)
                                        .then((res) {
                                      Navigator.pop(context);
                                      if (res.result) {
                                        LeooCommonUtilsJunPro
                                            .leooShowCustomToastJunPro(S
                                                .of(context)
                                                .appComplete(
                                                    S.of(context).appSubmit));
                                        LeooNavigatorUtilsJunPro
                                            .leooGoHomeJunPro(context);
                                      } else {
                                        LeooCommonUtilsJunPro
                                            .leooShowErrorToastJunPro(res);
                                      }
                                    });
                                  }
                                }),
                              ),
                            ),
                          ],
                        ),
                      ),
                    ),
                  ),
                  const LeooKeyBoardHeightWidgetJunPro(),
                ],
              ),
            ),
          ),
        ),
      );
    });
  }
}
