import 'package:carousel_slider/carousel_slider.dart';
import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leooappconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoohostdaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoohostinfoentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooproviderjunpro/leoouserproviderjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocountryutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoodialogutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoovideoutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoowidgetutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoobubblejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leooslidescalewidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leootextwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoowidgetjunpro/leoodotswidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoowidgetjunpro/leooopacitywidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoowidgetjunpro/leoovisiblewidgetjunpro.dart';
import 'package:provider/provider.dart';

///zb详细页-host
class LeooHostInfoJunPro extends StatefulWidget {
  final int? userId;
  final LeooHostInfoEntity infoEntity;
  final String hero;

  const LeooHostInfoJunPro(this.userId, this.infoEntity, this.hero, {Key? key})
      : super(key: key);

  @override
  _LeooInfoState createState() => _LeooInfoState();
}

class _LeooInfoState extends State<LeooHostInfoJunPro> {
  late LeooUserProviderJunPro userProvider;
  late LeooHostInfoEntity infoEntity;
  List<String> imageList = [];

  double dotsSize = 40.w;
  GlobalKey<LeooDotsIndicatorWidgetState> dotsKey = GlobalKey();
  GlobalKey<LeooVisibleWidgetState> visibleKey = GlobalKey();
  GlobalKey<LeooOpacityWidgetState> opacityKey = GlobalKey();
  bool opacityBar = false;

  @override
  void initState() {
    super.initState();
    infoEntity = widget.infoEntity;
    hostInfo();
  }

  void hostInfo() {
    LeooHostDaoJunPro.leooHostInfoJunPro(widget.userId).then((res) async {
      if (res.result) {
        infoEntity = res.data;
        imageList.clear();
        infoEntity.extraInfoList?.forEach((element) {
          if (element.type == 2) {
            imageList.add(element.url!);
          }
        });
        LeooCodeUtilsJunPro.onSetState(this);
      }
    });
  }

  @override
  Widget build(BuildContext context) {
    return Consumer<LeooUserProviderJunPro>(
        builder: (_, LeooUserProviderJunPro userProvider, __) {
      this.userProvider = userProvider;
      return Scaffold(
        resizeToAvoidBottomInset: false,
        body: Stack(
          children: <Widget>[
            SizedBox(
              width: 1.sw,
              height: 1.sh,
              child: NotificationListener(
                onNotification: (ScrollNotification notification) {
                  if (notification.metrics.axis == Axis.vertical) {
                    double height = 1.sw;
                    if (notification.metrics.pixels > height) {
                      if (opacityBar &&
                          notification.metrics.pixels > height + 20.w) {
                        opacityBar = false;
                        opacityKey.currentState!.onSetState(1.0);
                      } else if (notification.metrics.pixels <= height + 20.w) {
                        opacityBar = true;
                        opacityKey.currentState!.onSetState(
                            (notification.metrics.pixels - height) / 20.w);
                      }
                    } else if (opacityBar) {
                      opacityBar = false;
                      opacityKey.currentState!.onSetState(.0);
                    }
                  }
                  return true;
                },
                child: SingleChildScrollView(
                  physics: const BouncingScrollPhysics(),
                  child: Column(
                    crossAxisAlignment: CrossAxisAlignment.start,
                    children: <Widget>[
                      Stack(
                        alignment: Alignment.bottomCenter,
                        children: <Widget>[
                          SizedBox(
                            width: 1.sw,
                            height: 1.sw * 5 / 4,
                            child: imageList.isEmpty == false
                                ? CarouselSlider(
                                    items: imageList.asMap().keys.map((index) {
                                      return getPicChildWidget(
                                          imageList[index], index);
                                    }).toList(),
                                    options: CarouselOptions(
                                      autoPlay: true,
                                      viewportFraction: 1.0,
                                      aspectRatio: MediaQuery.of(context)
                                          .size
                                          .aspectRatio,
                                      onPageChanged: (index, reason) {
                                        if (!mounted) {
                                          return;
                                        }
                                        dotsKey.currentState?.onSetState(
                                            position: index.toDouble());
                                      },
                                    ),
                                  )
                                : getPicChildWidget(infoEntity.avatar, 0),
                          ),
                          if (imageList.isEmpty == false)
                            Positioned(
                              left: 0,
                              right: 0,
                              bottom: 10.w,
                              child: LeooDotsIndicatorWidgetJunPro(
                                  imageList.length, 0, dotsSize,
                                  key: dotsKey),
                            ),
                          Positioned(
                              left: 15.w,
                              bottom: 10.w,
                              child:
                                  LeooWidgetUtilsJunPro.leooGetOnlineTextJunPro(
                                      context, infoEntity.chatStatus)),
                        ],
                      ),
                      Padding(
                        padding: EdgeInsets.fromLTRB(15.w, 20.w, 15.w,
                            ScreenUtil().bottomBarHeight + 80.w),
                        child: Column(
                          crossAxisAlignment: CrossAxisAlignment.start,
                          children: [
                            Row(
                              children: [
                                Text(
                                  infoEntity.getNameAge(),
                                  style: LeooTextJunPro.leooGetTextStyleJunPro(
                                      20, FontWeight.bold),
                                ),
                                if (infoEntity.regionCode?.isEmpty == false)
                                  SizedBox(width: 5.w),
                                if (infoEntity.regionCode?.isEmpty == false)
                                  LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                                    LeooCountryPickerUtilsJunPro
                                        .getFlagImageAssetPath(
                                            infoEntity.regionCode),
                                    width: 18.w,
                                    fit: BoxFit.fitHeight,
                                    imageStartUrl: LeooCountryPickerUtilsJunPro
                                        .getFlagImageAssetPath(
                                            infoEntity.regionCode),
                                    package: 'country_pickers',
                                  ),
                                SizedBox(width: 5.w),
                                if ((infoEntity.gender ?? 0) != 0)
                                  LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                                    infoEntity.gender == 1
                                        ? LeooIconsJunPro.leooInfoMaleJunPro
                                        : LeooIconsJunPro.leooInfoFemaleJunPro,
                                    width: 18.w,
                                    height: 18.w,
                                  ),
                              ],
                            ),
                            SizedBox(height: 5.w),
                            if (infoEntity.remark?.isEmpty == false)
                              SizedBox(height: 5.w),
                            if (infoEntity.remark?.isEmpty == false)
                              Text(
                                infoEntity.remark ?? '',
                                style:
                                    LeooTextJunPro.leooGetTextStyleHintJunPro(
                                        16),
                              ),
                            SizedBox(height: 20.w),
                            Text(S.of(context).infoBasic,
                                style: LeooTextJunPro.leooGetTextStyleJunPro(
                                    16, FontWeight.bold)),
                            SizedBox(height: 10.w),
                            Padding(
                              padding: EdgeInsets.only(top: 15.w, bottom: 15.w),
                              child: Row(
                                mainAxisAlignment:
                                    MainAxisAlignment.spaceBetween,
                                children: [
                                  Text(S.of(context).infoId,
                                      style: LeooTextJunPro
                                          .leooGetTextStyleHintJunPro(16)),
                                  Text('${infoEntity.uid ?? 0}',
                                      style:
                                          LeooTextJunPro.leooGetTextStyleJunPro(
                                              16)),
                                ],
                              ),
                            ),
                            Divider(
                              height: 1.w,
                              color: Colors.white.withOpacity(.1),
                            ),
                            if (infoEntity.lookFor?.isEmpty == false)
                              Padding(
                                padding:
                                    EdgeInsets.only(top: 15.w, bottom: 15.w),
                                child: Row(
                                  mainAxisAlignment:
                                      MainAxisAlignment.spaceBetween,
                                  children: [
                                    Text(S.of(context).infoLookFor,
                                        style: LeooTextJunPro
                                            .leooGetTextStyleHintJunPro(16)),
                                    Text(infoEntity.lookFor ?? '',
                                        style: LeooTextJunPro
                                            .leooGetTextStyleJunPro(16)),
                                  ],
                                ),
                              ),
                            if (infoEntity.lookFor?.isEmpty == false)
                              Divider(
                                height: 1.w,
                                color: Colors.white.withOpacity(.1),
                              ),
                            if (infoEntity.likeType?.isEmpty == false)
                              Padding(
                                padding:
                                    EdgeInsets.only(top: 15.w, bottom: 15.w),
                                child: Row(
                                  mainAxisAlignment:
                                      MainAxisAlignment.spaceBetween,
                                  children: [
                                    Text(S.of(context).infoLikeType,
                                        style: LeooTextJunPro
                                            .leooGetTextStyleHintJunPro(16)),
                                    Text(infoEntity.likeType ?? '',
                                        style: LeooTextJunPro
                                            .leooGetTextStyleJunPro(16)),
                                  ],
                                ),
                              ),
                            if (infoEntity.likeType?.isEmpty == false)
                              Divider(
                                height: 1.w,
                                color: Colors.white.withOpacity(.1),
                              ),
                            if (infoEntity.tag?.isEmpty == false)
                              Padding(
                                padding:
                                    EdgeInsets.only(top: 20.w, bottom: 10.w),
                                child: Text(S.of(context).infoTag,
                                    style:
                                        LeooTextJunPro.leooGetTextStyleJunPro(
                                            16, FontWeight.bold)),
                              ),
                            if (infoEntity.tag?.isEmpty == false)
                              Wrap(
                                spacing: 10.w,
                                runSpacing: 10.w,
                                children: infoEntity.tag!.split(' ').map(
                                  (item) {
                                    if (item.isEmpty) {
                                      return Container();
                                    }
                                    Color color = LeooColorsJunPro
                                        .leooGetRandomColorJunPro();
                                    return Container(
                                      padding: EdgeInsets.fromLTRB(
                                          10.w, 5.w, 10.w, 5.w),
                                      decoration: ShapeDecoration(
                                          color: color,
                                          shape: const StadiumBorder()),
                                      child: Text(item,
                                          style: LeooTextJunPro
                                              .leooGetTextStyleJunPro(
                                                  16, FontWeight.bold)),
                                    );
                                  },
                                ).toList(),
                              ),
                          ],
                        ),
                      ),
                    ],
                  ),
                ),
              ),
            ),
            Positioned(
              left: 0,
              right: 0,
              bottom: 0,
              child: Container(
                padding: EdgeInsets.fromLTRB(
                    15.w, 30.w, 15.w, ScreenUtil().bottomBarHeight + 15.w),
                decoration: BoxDecoration(
                  gradient: LinearGradient(
                    begin: Alignment.topCenter,
                    end: Alignment.bottomCenter,
                    colors: [
                      LeooColorsJunPro.leooBgJunPro.withOpacity(0),
                      LeooColorsJunPro.leooBgJunPro,
                    ],
                  ),
                ),
                child: Stack(
                  alignment: Alignment.topCenter,
                  clipBehavior: Clip.none,
                  children: [
                    InkWell(
                      onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                        LeooVideoUtilsJunPro.instance.requestVideoPermission(
                            context, widget.userId,
                            infoHostEntity: infoEntity);
                      }),
                      child: Container(
                        decoration: BoxDecoration(
                          borderRadius: BorderRadius.circular(20),
                          color: LeooColorsJunPro.leooAppJunPro,
                        ),
                        padding: EdgeInsets.fromLTRB(15.w, 0, 15.w, 0),
                        child: Row(
                          mainAxisAlignment: MainAxisAlignment.center,
                          children: [
                            LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                              LeooIconsJunPro.leooInfoVideoJunPro,
                              width: 28.w,
                              height: 24.w,
                            ),
                            SizedBox(width: 10.w, height: 50.w),
                            Column(
                              children: [
                                Text(
                                  S.of(context).infoVideoCall,
                                  style: LeooTextJunPro.leooGetTextStyleJunPro(
                                      20, FontWeight.bold),
                                ),
                                LeooTextWidgetJunPro(
                                  S.of(context).coinsMin(LeooAppConfigJunPro
                                      .leooTalkingCostJunPro),
                                  LeooTextJunPro.leooGetTextStyleJunPro(
                                      14, FontWeight.bold),
                                  iconData: LeooCommonUtilsJunPro
                                      .leooGetLoadWidgetJunPro(
                                    LeooIconsJunPro.leooMainCoinsJunPro,
                                    width: 15.w,
                                    height: 15.w,
                                  ),
                                  iconPadding: 2.5.w,
                                  mainAxisSize: MainAxisSize.min,
                                ),
                              ],
                            ),
                          ],
                        ),
                      ),
                    ),
                    LeooVisibleWidgetJunPro(
                      visibleKey,
                      false,
                      Positioned(
                        bottom: ScreenUtil().bottomBarHeight + 55.w,
                        left: 25.w,
                        right: 25.w,
                        child: LeooSlideScaleWidgetJunPro(
                          LeooBubbleJunPro(
                            SizedBox(
                              width: 1.sw - 35.w,
                              child: Row(
                                children: [
                                  Stack(
                                    children: [
                                      ClipOval(
                                        child: LeooCommonUtilsJunPro
                                            .leooGetLoadWidgetJunPro(
                                          infoEntity.avatar,
                                          width: 40.w,
                                          height: 40.w,
                                          load: LeooIconsJunPro
                                              .leooLoadHeadJunPro,
                                        ),
                                      ),
                                      Positioned(
                                          right: 0.w,
                                          top: 0.w,
                                          child: LeooWidgetUtilsJunPro
                                              .leooGetOnlineTipJunPro(context,
                                                  infoEntity.chatStatus,
                                                  size: 12)),
                                    ],
                                  ),
                                  SizedBox(width: 10.w),
                                  Expanded(
                                    child: Text(S.of(context).infoTip,
                                        style: LeooTextJunPro
                                            .leooGetTextStyleJunPro(
                                                16, FontWeight.bold)),
                                  ),
                                ],
                              ),
                            ),
                            direction: BubbleDirection.bottom,
                            borderRadius: const Radius.circular(30),
                            padding: EdgeInsets.all(8.w),
                            margin: EdgeInsets.only(bottom: 8.w),
                            center: 1.3,
                            decoration: ShapeDecoration(
                              shape: StadiumBorder(),
                              color: LeooColorsJunPro.leooPopBgJunPro,
                            ),
                          ),
                          left: 1,
                        ),
                      ),
                    ),
                  ],
                ),
              ),
            ),
            LeooOpacityWidgetJunPro(
              opacityKey,
              .0,
              Container(
                width: 1.sw,
                height: ScreenUtil().statusBarHeight + kToolbarHeight,
                color: LeooColorsJunPro.leooBgJunPro,
                alignment: Alignment.center,
                padding: EdgeInsets.only(top: ScreenUtil().statusBarHeight / 2),
                child: Text(
                  infoEntity.nickname ?? '',
                  style: LeooTextJunPro.leooGetTextStyleJunPro(
                      20, FontWeight.bold),
                ),
              ),
            ),
            Positioned(
              top: ScreenUtil().statusBarHeight + 4.w,
              left: 4.w,
              child: IconButton(
                iconSize: 40.w,
                padding: const EdgeInsets.all(0),
                icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                  LeooIconsJunPro.leooTopBackJunPro,
                  width: 40.w,
                  height: 40.w,
                ),
                onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                  Navigator.pop(context);
                }),
              ),
            ),
            Positioned(
              top: ScreenUtil().statusBarHeight + 4.w,
              right: 4.w,
              child: IconButton(
                iconSize: 40.w,
                padding: const EdgeInsets.all(0),
                icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                  LeooIconsJunPro.leooInfoMoreJunPro,
                  width: 40.w,
                  height: 40.w,
                ),
                onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                  LeooDialogUtilsJunPro.instance.showReportBlack(
                      context, widget.userId,
                      nickname: infoEntity.nickname,
                      age: infoEntity.age,
                      gender: infoEntity.gender,
                      country: infoEntity.regionCode,
                      header: infoEntity.avatar,
                      description: infoEntity.remark);
                }),
              ),
            ),
          ],
        ),
      );
    });
  }

  Widget getPicChildWidget(String? item, int index) {
    String hero = 'infoPicItem$index';
    return InkWell(
      child: Hero(
        tag: hero,
        transitionOnUserGestures: true,
        child: ClipRRect(
          borderRadius: BorderRadius.circular(5),
          child: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
            item,
            width: 1.sw,
            height: 1.sw * 5 / 4,
          ),
        ),
      ),
      onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
        LeooNavigatorUtilsJunPro.leooGotoPhotoViewJunPro(
          context,
          single: false,
          pics: imageList,
          currentIndex: index,
          hero: hero,
        );
      }),
    );
  }
}
