import 'dart:async';

import 'package:carousel_slider/carousel_slider.dart';
import 'package:collection/collection.dart';
import 'package:flutter/material.dart';
import 'package:flutter_html/shims/dart_ui_real.dart';
import 'package:flutter_rating_bar/flutter_rating_bar.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leooappconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoomaindaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoolanguageentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoouserentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoovideolistentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooeventjunpro/leooindexjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooeventjunpro/leoomaineventjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooproviderjunpro/leoouserproviderjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocountryutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoodialogutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoovideoutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoowidgetutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoobubblejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leooslidescalewidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leootextwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoowidgetjunpro/leoodotswidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoowidgetjunpro/leooopacitywidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoowidgetjunpro/leoovisiblewidgetjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoocalljunpro/leoochatjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leooinfojunpro/leoovideolistjunpro.dart';
import 'package:provider/provider.dart';

///zb详细页
class LeooInfoJunPro extends StatefulWidget {
  final int? userId;
  final LeooUserEntity? infoEntity;
  final bool getNet;
  final String hero;

  const LeooInfoJunPro(this.userId, this.infoEntity, this.hero,
      {Key? key, this.getNet = true})
      : super(key: key);

  @override
  _LeooInfoState createState() => _LeooInfoState();
}

class _LeooInfoState extends State<LeooInfoJunPro> with WidgetsBindingObserver {
  int status = LeooCommonUtilsJunPro.leooPageStatusLoadingJunPro;
  late LeooUserProviderJunPro userProvider;
  LeooUserEntity? infoEntity;
  bool showOnline = false;

  double dotsSize = 40.w;
  GlobalKey<LeooDotsIndicatorWidgetState> dotsKey = GlobalKey();
  GlobalKey<LeooVisibleWidgetState> visibleKey = GlobalKey();
  GlobalKey<LeooOpacityWidgetState> opacityKey = GlobalKey();
  bool opacityBar = false;

  List<LeooVideoListEntity> videoList = [];
  List<LeooLanguageEntity> languageList = [];
  List<LeooLanguageEntity> tagList = [];
  List<String> cupList = [];
  late StreamSubscription subscription;

  void getLanguageList() {
    LeooMainDaoJunPro.leooGetLanguageListJunPro().then((res) async {
      if (res.result) {
        languageList.addAll(res.data);
        getTagList();
      } else {
        LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
        status = LeooCommonUtilsJunPro.leooPageStatusErrorJunPro;
        LeooCodeUtilsJunPro.onSetState(this);
      }
    });
  }

  void getTagList() {
    LeooMainDaoJunPro.leooGetTagListJunPro().then((res) async {
      if (res.result) {
        tagList = res.data;
        cupList = [
          S.of(context).applyCup1,
          S.of(context).applyCup2,
          S.of(context).applyCup3,
          S.of(context).applyCup4,
          S.of(context).applyCup5
        ];
        if (infoEntity != null) {
          status = LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro;
        }
        if (widget.getNet) {
          hostInfo();
        }
        getVideoList();
        LeooCodeUtilsJunPro.onSetState(this);
      } else {
        LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
        status = LeooCommonUtilsJunPro.leooPageStatusErrorJunPro;
        LeooCodeUtilsJunPro.onSetState(this);
      }
    });
  }

  void hostInfo() {
    LeooMainDaoJunPro.leooDetailJunPro(widget.userId).then((res) async {
      if (res.result) {
        showOnline = true;
        infoEntity = res.data;
        int picSize = infoEntity!.albums?.length ?? 1;
        dotsSize =
            (1.sw - 200.w) / picSize > 40.w ? 40.w : (1.sw - 200.w) / picSize;
        status = LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro;
        dotsKey.currentState
            ?.onSetState(dotsCount: picSize, dotsSize: dotsSize);
        LeooCodeUtilsJunPro.onSetState(this);
        Future.delayed(const Duration(seconds: 2), () {
          visibleKey.currentState?.onSetState(true);
          Future.delayed(const Duration(seconds: 5), () {
            visibleKey.currentState?.onSetState(false);
          });
        });
      } else {
        status = LeooCommonUtilsJunPro.leooPageStatusErrorJunPro;
        LeooCodeUtilsJunPro.onSetState(this);
        LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
      }
    });
  }

  void getVideoList() {
    LeooMainDaoJunPro.leooListVideoByUserIdJunPro(widget.userId)
        .then((res) async {
      if (res.result) {
        videoList = res.data;
        LeooCodeUtilsJunPro.onSetState(this);
      }
    });
  }

  @override
  void didChangeAppLifecycleState(AppLifecycleState state) {
    super.didChangeAppLifecycleState(state);
    if (state == AppLifecycleState.resumed) {
      LeooCommonUtilsJunPro.leooCheckIsCurrentJunPro(context, () {
        hostInfo();
        getVideoList();
      });
    }
  }

  @override
  void initState() {
    super.initState();
    WidgetsBinding.instance!.addObserver(this);
    infoEntity = widget.infoEntity;
    int picSize = infoEntity!.albums?.length ?? 1;
    dotsSize =
        (1.sw - 200.w) / picSize > 40.w ? 40.w : (1.sw - 200.w) / picSize;
    getLanguageList();
    showOnline = !widget.getNet;
    subscription =
        eventBus.on<LeooVideoInfoUnlockEventJunPro>().listen((event) {
      videoList[event.position].unlockStatus = 1;
      LeooCodeUtilsJunPro.onSetState(this);
    });
  }

  @override
  void dispose() {
    WidgetsBinding.instance!.removeObserver(this);
    subscription.cancel();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return Consumer<LeooUserProviderJunPro>(
        builder: (_, LeooUserProviderJunPro userProvider, __) {
      this.userProvider = userProvider;
      return Scaffold(
        resizeToAvoidBottomInset: false,
        body: status != LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro
            ? LeooCommonUtilsJunPro.leooCheckPageStatusJunPro(context, status,
                onTap: () {
                status = LeooCommonUtilsJunPro.leooPageStatusLoadingJunPro;
                LeooCodeUtilsJunPro.onSetState(this);
                hostInfo();
                getVideoList();
              })
            : Stack(
                children: <Widget>[
                  SizedBox(
                    width: 1.sw,
                    height: 1.sh,
                    child: NotificationListener(
                      onNotification: (ScrollNotification notification) {
                        if (notification.metrics.axis == Axis.vertical) {
                          double height = 1.sw;
                          if (notification.metrics.pixels > height) {
                            if (opacityBar &&
                                notification.metrics.pixels > height + 20.w) {
                              opacityBar = false;
                              opacityKey.currentState!.onSetState(1.0);
                            } else if (notification.metrics.pixels <=
                                height + 20.w) {
                              opacityBar = true;
                              opacityKey.currentState!.onSetState(
                                  (notification.metrics.pixels - height) /
                                      20.w);
                            }
                          } else if (opacityBar) {
                            opacityBar = false;
                            opacityKey.currentState!.onSetState(.0);
                          }
                        }
                        return true;
                      },
                      child: SingleChildScrollView(
                        physics: const BouncingScrollPhysics(),
                        child: Column(
                          crossAxisAlignment: CrossAxisAlignment.start,
                          children: <Widget>[
                            Stack(
                              alignment: Alignment.bottomCenter,
                              children: <Widget>[
                                SizedBox(
                                  width: 1.sw,
                                  height: 1.sw * 5 / 4,
                                  child: infoEntity?.albums?.isEmpty == false
                                      ? CarouselSlider(
                                          items: infoEntity?.albums
                                              ?.asMap()
                                              .keys
                                              .map((index) {
                                            return getPicChildWidget(
                                                infoEntity?.albums?[index],
                                                index);
                                          }).toList(),
                                          options: CarouselOptions(
                                            autoPlay: true,
                                            viewportFraction: 1.0,
                                            aspectRatio: MediaQuery.of(context)
                                                .size
                                                .aspectRatio,
                                            onPageChanged: (index, reason) {
                                              if (!mounted) {
                                                return;
                                              }
                                              dotsKey.currentState?.onSetState(
                                                  position: index.toDouble());
                                            },
                                          ),
                                        )
                                      : getPicChildWidget(
                                          infoEntity?.header, 0),
                                ),
                                if (infoEntity?.albums?.isEmpty == false)
                                  Positioned(
                                    left: 0,
                                    right: 0,
                                    bottom: 10.w,
                                    child: LeooDotsIndicatorWidgetJunPro(
                                        infoEntity?.albums?.length ?? 1,
                                        0,
                                        dotsSize,
                                        key: dotsKey),
                                  ),
                                if (showOnline)
                                  Positioned(
                                      left: 15.w,
                                      bottom: 10.w,
                                      child: LeooWidgetUtilsJunPro
                                          .leooGetOnlineTextJunPro(
                                              context, infoEntity?.chatStatus)),
                                if (showOnline)
                                  Positioned(
                                    right: 15.w,
                                    bottom: 10.w,
                                    child: IconButton(
                                      padding: const EdgeInsets.all(0),
                                      icon: LeooCommonUtilsJunPro
                                          .leooGetLoadWidgetJunPro(
                                        infoEntity?.following == 1
                                            ? LeooIconsJunPro
                                                .leooInfoLikedJunPro
                                            : LeooIconsJunPro
                                                .leooInfoLikeJunPro,
                                        width: 50.w,
                                        height: 50.w,
                                      ),
                                      iconSize: 50.w,
                                      onPressed: infoEntity?.following == null
                                          ? null
                                          : LeooNavigatorUtilsJunPro
                                              .leooDebounceJunPro(() {
                                              LeooWidgetUtilsJunPro
                                                  .leooShowCareDialogJunPro(
                                                      context,
                                                      infoEntity?.following,
                                                      infoEntity?.id, (care) {
                                                infoEntity?.following = care;
                                                LeooCodeUtilsJunPro.onSetState(
                                                    this);
                                                eventBus.fire(
                                                    LeooVideoInfoFollowEventJunPro(
                                                        infoEntity?.id,
                                                        infoEntity?.following));
                                              },
                                                      log: '详细页',
                                                      nickname:
                                                          infoEntity?.nickname,
                                                      age: infoEntity?.age,
                                                      gender:
                                                          infoEntity?.gender,
                                                      country:
                                                          infoEntity?.country,
                                                      header:
                                                          infoEntity?.header,
                                                      description: infoEntity
                                                          ?.description);
                                            }),
                                    ),
                                  ),
                              ],
                            ),
                            Padding(
                              padding: EdgeInsets.fromLTRB(15.w, 20.w, 15.w,
                                  ScreenUtil().bottomBarHeight + 80.w),
                              child: Column(
                                crossAxisAlignment: CrossAxisAlignment.start,
                                children: [
                                  Row(
                                    children: [
                                      Text(
                                        infoEntity?.getNameAge() ?? '',
                                        style: LeooTextJunPro
                                            .leooGetTextStyleJunPro(
                                                20, FontWeight.bold),
                                      ),
                                      if (infoEntity?.country?.isEmpty == false)
                                        SizedBox(width: 5.w),
                                      if (infoEntity?.country?.isEmpty == false)
                                        LeooCommonUtilsJunPro
                                            .leooGetLoadWidgetJunPro(
                                          LeooCountryPickerUtilsJunPro
                                              .getFlagImageAssetPath(
                                                  infoEntity?.country),
                                          width: 18.w,
                                          fit: BoxFit.fitHeight,
                                          imageStartUrl:
                                              LeooCountryPickerUtilsJunPro
                                                  .getFlagImageAssetPath(
                                                      infoEntity?.country),
                                          package: 'country_pickers',
                                        ),
                                      SizedBox(width: 5.w),
                                      if ((infoEntity?.gender ?? 0) != 0)
                                        LeooCommonUtilsJunPro
                                            .leooGetLoadWidgetJunPro(
                                          infoEntity?.gender == 1
                                              ? LeooIconsJunPro
                                                  .leooInfoMaleJunPro
                                              : LeooIconsJunPro
                                                  .leooInfoFemaleJunPro,
                                          width: 18.w,
                                          height: 18.w,
                                        ),
                                    ],
                                  ),
                                  SizedBox(height: 5.w),
                                  if (infoEntity?.description?.isEmpty == false)
                                    SizedBox(height: 5.w),
                                  if (infoEntity?.description?.isEmpty == false)
                                    Text(
                                      infoEntity?.description ?? '',
                                      style:
                                          LeooTextJunPro.leooGetTextStyleJunPro(
                                              16),
                                    ),
                                  if (videoList.isNotEmpty)
                                    Padding(
                                      padding: EdgeInsets.only(
                                          top: 20.w, bottom: 10.w),
                                      child: Text(S.of(context).infoVideos,
                                          style: LeooTextJunPro
                                              .leooGetTextStyleHintJunPro(
                                                  16, FontWeight.bold)),
                                    ),
                                  if (videoList.isNotEmpty)
                                    SizedBox(
                                      height: 180.w,
                                      child: ListView.separated(
                                          physics:
                                              const BouncingScrollPhysics(),
                                          scrollDirection: Axis.horizontal,
                                          itemCount: videoList.length,
                                          separatorBuilder:
                                              (BuildContext context,
                                                  int index) {
                                            return SizedBox(width: 10.w);
                                          },
                                          itemBuilder:
                                              (BuildContext itemContext,
                                                  int index) {
                                            LeooVideoListEntity item =
                                                videoList[index];
                                            return getVideoChildWidget(
                                                index, item);
                                          }),
                                    ),
                                  SizedBox(height: 20.w),
                                  Text(S.of(context).infoBasic,
                                      style: LeooTextJunPro
                                          .leooGetTextStyleHintJunPro(
                                              16, FontWeight.bold)),
                                  SizedBox(height: 10.w),
                                  if (infoEntity?.userType == 1 &&
                                      infoEntity
                                              ?.getLanguageStr(languageList)
                                              .isEmpty ==
                                          false)
                                    Padding(
                                      padding: EdgeInsets.only(
                                          top: 15.w, bottom: 15.w),
                                      child: Row(
                                        mainAxisAlignment:
                                            MainAxisAlignment.spaceBetween,
                                        children: [
                                          Text(S.of(context).infoLanguage,
                                              style: LeooTextJunPro
                                                  .leooGetTextStyleHintJunPro(
                                                      16)),
                                          Text(
                                              infoEntity?.getLanguageStr(
                                                      languageList) ??
                                                  '',
                                              style: LeooTextJunPro
                                                  .leooGetTextStyleJunPro(16)),
                                        ],
                                      ),
                                    ),
                                  if (infoEntity?.userType == 1 &&
                                      infoEntity
                                              ?.getLanguageStr(languageList)
                                              .isEmpty ==
                                          false)
                                    Divider(
                                      height: 1.w,
                                      color: Colors.white.withOpacity(.1),
                                    ),
                                  Padding(
                                    padding: EdgeInsets.only(
                                        top: 15.w, bottom: 15.w),
                                    child: Row(
                                      mainAxisAlignment:
                                          MainAxisAlignment.spaceBetween,
                                      children: [
                                        Text(S.of(context).infoId,
                                            style: LeooTextJunPro
                                                .leooGetTextStyleHintJunPro(
                                                    16)),
                                        Text('${infoEntity?.id ?? 0}',
                                            style: LeooTextJunPro
                                                .leooGetTextStyleJunPro(16)),
                                      ],
                                    ),
                                  ),
                                  Divider(
                                    height: 1.w,
                                    color: Colors.white.withOpacity(.1),
                                  ),
                                  if (infoEntity?.userType == 1)
                                    Padding(
                                      padding: EdgeInsets.only(
                                          top: 15.w, bottom: 15.w),
                                      child: Row(
                                        mainAxisAlignment:
                                            MainAxisAlignment.spaceBetween,
                                        children: [
                                          Text(S.of(context).infoFollowers,
                                              style: LeooTextJunPro
                                                  .leooGetTextStyleHintJunPro(
                                                      16)),
                                          Text(
                                              '${infoEntity?.followerNumber ?? 0}',
                                              style: LeooTextJunPro
                                                  .leooGetTextStyleJunPro(16)),
                                        ],
                                      ),
                                    ),
                                  if (infoEntity?.userType == 1)
                                    Divider(
                                      height: 1.w,
                                      color: Colors.white.withOpacity(.1),
                                    ),
                                  if (infoEntity?.userType == 1)
                                    Padding(
                                      padding: EdgeInsets.only(
                                          top: 15.w, bottom: 15.w),
                                      child: Row(
                                        mainAxisAlignment:
                                            MainAxisAlignment.spaceBetween,
                                        children: [
                                          Text(S.of(context).infoHeight,
                                              style: LeooTextJunPro
                                                  .leooGetTextStyleHintJunPro(
                                                      16)),
                                          Text(
                                              '${infoEntity?.height ?? 0}${LeooAppConfigJunPro.leooHeightUnitListJunPro[(infoEntity?.heightUnit ?? 1) - 1]}',
                                              style: LeooTextJunPro
                                                  .leooGetTextStyleJunPro(16)),
                                        ],
                                      ),
                                    ),
                                  if (infoEntity?.userType == 1)
                                    Divider(
                                      height: 1.w,
                                      color: Colors.white.withOpacity(.1),
                                    ),
                                  if (infoEntity?.userType == 1)
                                    Padding(
                                      padding: EdgeInsets.only(
                                          top: 15.w, bottom: 15.w),
                                      child: Row(
                                        mainAxisAlignment:
                                            MainAxisAlignment.spaceBetween,
                                        children: [
                                          Text(S.of(context).infoWeight,
                                              style: LeooTextJunPro
                                                  .leooGetTextStyleHintJunPro(
                                                      16)),
                                          Text(
                                              '${infoEntity?.weight ?? 0}${LeooAppConfigJunPro.leooWeightUnitListJunPro[(infoEntity?.weightUnit ?? 1) - 1]}',
                                              style: LeooTextJunPro
                                                  .leooGetTextStyleJunPro(16)),
                                        ],
                                      ),
                                    ),
                                  if (infoEntity?.userType == 1)
                                    Divider(
                                      height: 1.w,
                                      color: Colors.white.withOpacity(.1),
                                    ),
                                  if (infoEntity?.userType == 1)
                                    Padding(
                                      padding: EdgeInsets.only(
                                          top: 15.w, bottom: 15.w),
                                      child: Row(
                                        mainAxisAlignment:
                                            MainAxisAlignment.spaceBetween,
                                        children: [
                                          Text(S.of(context).infoCup,
                                              style: LeooTextJunPro
                                                  .leooGetTextStyleHintJunPro(
                                                      16)),
                                          Text(
                                              cupList[infoEntity?.cupSize ?? 0],
                                              style: LeooTextJunPro
                                                  .leooGetTextStyleJunPro(16)),
                                        ],
                                      ),
                                    ),
                                  if (infoEntity?.userType == 1)
                                    Divider(
                                      height: 1.w,
                                      color: Colors.white.withOpacity(.1),
                                    ),
                                  if (infoEntity?.userType == 1)
                                    Padding(
                                      padding: EdgeInsets.only(
                                          top: 15.w, bottom: 15.w),
                                      child: Row(
                                        mainAxisAlignment:
                                            MainAxisAlignment.spaceBetween,
                                        children: [
                                          Text(S.of(context).infoScore,
                                              style: LeooTextJunPro
                                                  .leooGetTextStyleHintJunPro(
                                                      16)),
                                          RatingBar(
                                            initialRating:
                                                infoEntity?.reviewScore ?? 5,
                                            allowHalfRating: true,
                                            ignoreGestures: true,
                                            itemSize: 20.w,
                                            ratingWidget: RatingWidget(
                                              full: LeooCommonUtilsJunPro
                                                  .leooGetLoadWidgetJunPro(
                                                      LeooIconsJunPro
                                                          .leooInfoStarFullJunPro),
                                              half: LeooCommonUtilsJunPro
                                                  .leooGetLoadWidgetJunPro(
                                                      LeooIconsJunPro
                                                          .leooInfoStarHalfJunPro),
                                              empty: LeooCommonUtilsJunPro
                                                  .leooGetLoadWidgetJunPro(
                                                      LeooIconsJunPro
                                                          .leooInfoStarEmptyJunPro),
                                            ),
                                            itemPadding: EdgeInsets.symmetric(
                                                horizontal: 5.w),
                                            onRatingUpdate: (rating) {},
                                          ),
                                        ],
                                      ),
                                    ),
                                  if (infoEntity?.userType == 1)
                                    Divider(
                                      height: 1.w,
                                      color: Colors.white.withOpacity(.1),
                                    ),
                                  if (infoEntity?.userType == 1 &&
                                      infoEntity?.tagIds?.isEmpty == false)
                                    Padding(
                                      padding: EdgeInsets.only(
                                          top: 20.w, bottom: 10.w),
                                      child: Text(S.of(context).infoTag,
                                          style: LeooTextJunPro
                                              .leooGetTextStyleHintJunPro(
                                                  16, FontWeight.bold)),
                                    ),
                                  if (infoEntity?.userType == 1 &&
                                      infoEntity?.tagIds?.isEmpty == false)
                                    Wrap(
                                      spacing: 10.w,
                                      runSpacing: 10.w,
                                      children: infoEntity!.tagIds!.map(
                                        (item) {
                                          LeooLanguageEntity? tag = tagList
                                              .firstWhereOrNull((element) =>
                                                  element.id == item);
                                          if (tag != null) {
                                            Color color = LeooColorsJunPro
                                                .leooGetRandomColorJunPro();
                                            return Container(
                                              padding: EdgeInsets.fromLTRB(
                                                  10.w, 5.w, 10.w, 5.w),
                                              decoration: ShapeDecoration(
                                                  color: color,
                                                  shape: const StadiumBorder()),
                                              child: Text('#${tag.enName}',
                                                  style: LeooTextJunPro
                                                      .leooGetTextStyleJunPro(
                                                          16, FontWeight.bold)),
                                            );
                                          }
                                          return Container();
                                        },
                                      ).toList(),
                                    ),
                                ],
                              ),
                            ),
                          ],
                        ),
                      ),
                    ),
                  ),
                  Positioned(
                    left: 0,
                    right: 0,
                    bottom: 0,
                    child: Container(
                      padding: EdgeInsets.fromLTRB(15.w, 30.w, 15.w,
                          ScreenUtil().bottomBarHeight + 15.w),
                      decoration: BoxDecoration(
                        gradient: LinearGradient(
                          begin: Alignment.topCenter,
                          end: Alignment.bottomCenter,
                          colors: [
                            LeooColorsJunPro.leooBgJunPro.withOpacity(0),
                            LeooColorsJunPro.leooBgJunPro,
                          ],
                        ),
                      ),
                      child: Stack(
                        alignment: Alignment.topCenter,
                        clipBehavior: Clip.none,
                        children: [
                          Row(
                            children: <Widget>[
                              InkWell(
                                onTap:
                                    LeooNavigatorUtilsJunPro.leooDebounceJunPro(
                                        () {
                                  LeooNavigatorUtilsJunPro
                                      .leooNavigatorPushJunPro(
                                          context,
                                          LeooChatJunPro(widget.userId,
                                              infoEntity, widget.hero,
                                              getNet: !showOnline),
                                          'LeooChatJunPro',
                                          add: true);
                                }),
                                child: Container(
                                  decoration: BoxDecoration(
                                    borderRadius: BorderRadius.circular(20),
                                    color: LeooColorsJunPro.leooOnlineJunPro,
                                  ),
                                  padding: EdgeInsets.fromLTRB(
                                      15.w, 12.w, 15.w, 12.w),
                                  child: Row(
                                    mainAxisAlignment: MainAxisAlignment.center,
                                    children: [
                                      LeooCommonUtilsJunPro
                                          .leooGetLoadWidgetJunPro(
                                        LeooIconsJunPro.leooInfoMessageJunPro,
                                        width: 26.w,
                                        height: 26.w,
                                      ),
                                      SizedBox(width: 10.w),
                                      Text(
                                        S.of(context).infoHi,
                                        style: LeooTextJunPro
                                            .leooGetTextStyleJunPro(
                                                20, FontWeight.bold),
                                      ),
                                    ],
                                  ),
                                ),
                              ),
                              SizedBox(width: 10.w),
                              Expanded(
                                child: InkWell(
                                  onTap: LeooNavigatorUtilsJunPro
                                      .leooDebounceJunPro(() {
                                    LeooVideoUtilsJunPro.instance
                                        .requestVideoPermission(
                                            context, widget.userId,
                                            infoEntity: infoEntity);
                                  }),
                                  child: Container(
                                    decoration: BoxDecoration(
                                      borderRadius: BorderRadius.circular(20),
                                      color: LeooColorsJunPro.leooAppJunPro,
                                    ),
                                    padding:
                                        EdgeInsets.fromLTRB(15.w, 0, 15.w, 0),
                                    child: Row(
                                      mainAxisAlignment:
                                          MainAxisAlignment.center,
                                      children: [
                                        LeooCommonUtilsJunPro
                                            .leooGetLoadWidgetJunPro(
                                          LeooIconsJunPro.leooInfoVideoJunPro,
                                          width: 28.w,
                                          height: 24.w,
                                        ),
                                        SizedBox(width: 10.w, height: 50.w),
                                        Column(
                                          children: [
                                            Text(
                                              S.of(context).infoVideoCall,
                                              style: LeooTextJunPro
                                                  .leooGetTextStyleJunPro(
                                                      20, FontWeight.bold),
                                            ),
                                            if (infoEntity?.userType == 1)
                                              LeooTextWidgetJunPro(
                                                S.of(context).coinsMin(infoEntity
                                                        ?.talkingGoldPerMin ??
                                                    0),
                                                LeooTextJunPro
                                                    .leooGetTextStyleJunPro(
                                                        14, FontWeight.bold),
                                                iconData: LeooCommonUtilsJunPro
                                                    .leooGetLoadWidgetJunPro(
                                                  LeooIconsJunPro
                                                      .leooMainCoinsJunPro,
                                                  width: 15.w,
                                                  height: 15.w,
                                                ),
                                                iconPadding: 2.5.w,
                                                mainAxisSize: MainAxisSize.min,
                                              ),
                                          ],
                                        ),
                                      ],
                                    ),
                                  ),
                                ),
                              ),
                            ],
                          ),
                          LeooVisibleWidgetJunPro(
                            visibleKey,
                            false,
                            Positioned(
                              bottom: 55.w,
                              left: 25.w,
                              right: 25.w,
                              child: LeooSlideScaleWidgetJunPro(
                                LeooBubbleJunPro(
                                  SizedBox(
                                    width: 1.sw - 35.w,
                                    child: Row(
                                      children: [
                                        Stack(
                                          children: [
                                            ClipOval(
                                              child: LeooCommonUtilsJunPro
                                                  .leooGetLoadWidgetJunPro(
                                                infoEntity?.header,
                                                width: 40.w,
                                                height: 40.w,
                                                load: LeooIconsJunPro
                                                    .leooLoadHeadJunPro,
                                              ),
                                            ),
                                            Positioned(
                                                right: 0.w,
                                                top: 0.w,
                                                child: LeooWidgetUtilsJunPro
                                                    .leooGetOnlineTipJunPro(
                                                        context,
                                                        infoEntity?.chatStatus,
                                                        size: 12)),
                                          ],
                                        ),
                                        SizedBox(width: 10.w),
                                        Expanded(
                                          child: Text(S.of(context).infoTip,
                                              style: LeooTextJunPro
                                                  .leooGetTextStyleJunPro(
                                                      16, FontWeight.bold)),
                                        ),
                                      ],
                                    ),
                                  ),
                                  direction: BubbleDirection.bottom,
                                  borderRadius: const Radius.circular(30),
                                  padding: EdgeInsets.all(8.w),
                                  margin: EdgeInsets.only(bottom: 8.w),
                                  center: 1.3,
                                  decoration: ShapeDecoration(
                                    shape: StadiumBorder(),
                                    color: LeooColorsJunPro.leooPopBgJunPro,
                                  ),
                                ),
                                left: 1,
                              ),
                            ),
                          ),
                        ],
                      ),
                    ),
                  ),
                  LeooOpacityWidgetJunPro(
                    opacityKey,
                    .0,
                    Container(
                      width: 1.sw,
                      height: ScreenUtil().statusBarHeight + kToolbarHeight,
                      color: LeooColorsJunPro.leooBgJunPro,
                      alignment: Alignment.center,
                      padding: EdgeInsets.only(
                          top: ScreenUtil().statusBarHeight / 2),
                      child: Text(
                        infoEntity?.nickname ?? '',
                        style: LeooTextJunPro.leooGetTextStyleJunPro(
                            20, FontWeight.bold),
                      ),
                    ),
                  ),
                  Positioned(
                    top: ScreenUtil().statusBarHeight + 4.w,
                    left: 4.w,
                    child: IconButton(
                      iconSize: 40.w,
                      padding: const EdgeInsets.all(0),
                      icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                        LeooIconsJunPro.leooTopBackJunPro,
                        width: 40.w,
                        height: 40.w,
                      ),
                      onPressed:
                          LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                        Navigator.pop(context);
                      }),
                    ),
                  ),
                  Positioned(
                    top: ScreenUtil().statusBarHeight + 4.w,
                    right: 4.w,
                    child: IconButton(
                      iconSize: 40.w,
                      padding: const EdgeInsets.all(0),
                      icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                        LeooIconsJunPro.leooInfoMoreJunPro,
                        width: 40.w,
                        height: 40.w,
                      ),
                      onPressed:
                          LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                        LeooDialogUtilsJunPro.instance
                            .showReportBlack(context, widget.userId,
                                nickname: infoEntity?.nickname,
                                age: infoEntity?.age,
                                gender: infoEntity?.gender,
                                country: infoEntity?.country,
                                header: infoEntity?.header,
                                description: infoEntity?.description,
                                follow: infoEntity?.following != 1
                                    ? () {
                                        LeooWidgetUtilsJunPro
                                            .leooShowCareDialogJunPro(
                                                context,
                                                infoEntity?.following,
                                                infoEntity?.id, (care) {
                                          infoEntity?.following = care;
                                          LeooCodeUtilsJunPro.onSetState(this);
                                        },
                                                log: '详细页',
                                                nickname: infoEntity?.nickname,
                                                age: infoEntity?.age,
                                                gender: infoEntity?.gender,
                                                country: infoEntity?.country,
                                                header: infoEntity?.header,
                                                description:
                                                    infoEntity?.description);
                                      }
                                    : null);
                      }),
                    ),
                  ),
                ],
              ),
      );
    });
  }

  Widget getPicChildWidget(String? item, int index) {
    String hero = 'infoPicItem$index';
    return InkWell(
      child: Hero(
        tag: hero,
        transitionOnUserGestures: true,
        child: ClipRRect(
          borderRadius: BorderRadius.circular(5),
          child: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
            item,
            width: 1.sw,
            height: 1.sw * 5 / 4,
            load: LeooIconsJunPro.leooLoadHeadJunPro,
          ),
        ),
      ),
      onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
        LeooNavigatorUtilsJunPro.leooGotoPhotoViewJunPro(
          context,
          single: false,
          pics: infoEntity?.albums,
          currentIndex: index,
          hero: hero,
        );
      }),
    );
  }

  Widget getVideoChildWidget(int index, LeooVideoListEntity item) {
    return InkWell(
      onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
        LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
                context,
                LeooVideoListJunPro(index, infoEntity, videoList),
                'LeooVideoListJunPro',
                add: true)
            .then((value) {
          LeooCodeUtilsJunPro.onSetState(this);
        });
      }),
      child: ClipRRect(
        borderRadius: BorderRadius.circular(15),
        child: Stack(
          alignment: Alignment.center,
          children: [
            LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
              item.videoCoverUrl,
              width: 120.w,
              height: 180.w,
            ),
            if (item.feeType == 1 && item.unlockStatus == 0)
              BackdropFilter(
                filter: ImageFilter.blur(sigmaX: 6, sigmaY: 6),
                child: Container(
                  color: Colors.white.withOpacity(.1),
                ),
              ),
            LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                item.feeType == 1 && item.unlockStatus == 0
                    ? LeooIconsJunPro.leooVideoLockJunPro
                    : LeooIconsJunPro.leooVideoPlayJunPro,
                width: 50.w,
                height: 50.w)
          ],
        ),
      ),
    );
  }
}
