import 'dart:async';
import 'dart:ui';

import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoomaindaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoogiftentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoouserentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoovideolistentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooeventjunpro/leooindexjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooeventjunpro/leoomaineventjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooproviderjunpro/leoouserproviderjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoodialogutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoorechargeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoovideoutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoowidgetutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoobuttonwidgetjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoocalljunpro/leoochatjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leooinfojunpro/leooinfojunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leooinfojunpro/leoovideolistjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoolistjunpro/leoovideolistjunpro.dart'
    as list;
import 'package:provider/provider.dart';
import 'package:video_player/video_player.dart';

///播放视频的页面
class LeooVideoPlayJunPro extends StatefulWidget {
  static bool leooOpenJunPro = false;
  final int position;
  final LeooUserEntity? infoEntity;
  final LeooVideoListEntity videoInfo;
  final bool play;
  final bool mine;
  final bool list;

  const LeooVideoPlayJunPro(this.position, this.videoInfo,
      {Key? key,
      this.infoEntity,
      this.play = false,
      this.mine = false,
      this.list = true})
      : super(key: key);

  @override
  State<StatefulWidget> createState() => LeooVideoPlayState();
}

class LeooVideoPlayState extends State<LeooVideoPlayJunPro>
    with AutomaticKeepAliveClientMixin<LeooVideoPlayJunPro> {
  @override
  bool get wantKeepAlive => true;
  VideoPlayerController? _controller;
  bool play = false;
  late LeooUserProviderJunPro userProvider;
  late StreamSubscription subscription;
  LeooUserEntity? infoEntity;

  @override
  void initState() {
    super.initState();
    LeooVideoPlayJunPro.leooOpenJunPro = true;
    infoEntity = widget.infoEntity;
    if (!widget.mine && infoEntity == null) {
      hostInfo();
    }
    play = widget.play;
    if (widget.videoInfo.feeType != 1 || widget.videoInfo.unlockStatus != 0) {
      setVideoPlay(widget.videoInfo.videoUrl ?? '', play: play);
    }
    subscription = eventBus.on<LeooVideoPlayEventJunPro>().listen((event) {
      if (event.position == widget.position) {
        if (_controller != null) {
          if (_controller?.value.isInitialized == true) {
            checkPlay(false);
          } else {
            _controller!.initialize().then((value) {
              LeooCodeUtilsJunPro.onSetState(this);
            });
          }
        } else {
          setVideoPlay(widget.videoInfo.videoUrl ?? '', play: true);
        }
      } else {
        _controller?.pause();
        LeooCodeUtilsJunPro.onSetState(this);
      }
    });
  }

  void hostInfo() {
    LeooMainDaoJunPro.leooDetailJunPro(widget.videoInfo.userId)
        .then((res) async {
      if (res.result) {
        infoEntity = res.data;
        LeooCodeUtilsJunPro.onSetState(this);
      }
    });
  }

  @override
  void dispose() {
    LeooVideoPlayJunPro.leooOpenJunPro = false;
    _controller?.dispose();
    subscription.cancel();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    super.build(context);
    return Consumer<LeooUserProviderJunPro>(
        builder: (_, LeooUserProviderJunPro userProvider, __) {
      this.userProvider = userProvider;
      return Stack(
        fit: StackFit.expand,
        children: [
          GestureDetector(
            behavior: HitTestBehavior.opaque,
            onTap: () {
              if (_controller?.value.isInitialized == true) {
                if (_controller?.value.isPlaying != false) {
                  _controller?.pause();
                  LeooCodeUtilsJunPro.onSetState(this);
                } else {
                  checkPlay();
                }
              }
            },
            child: Stack(
              alignment: Alignment.center,
              children: <Widget>[
                LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                  widget.videoInfo.videoCoverUrl,
                  fit: (_controller?.value.aspectRatio ?? 0) > 1
                      ? BoxFit.fitWidth
                      : BoxFit.cover,
                  width: 1.sw,
                  height: 1.sh,
                ),
                if (widget.videoInfo.feeType == 1 &&
                    widget.videoInfo.unlockStatus == 0)
                  BackdropFilter(
                    filter: ImageFilter.blur(sigmaX: 6, sigmaY: 6),
                    child: Container(
                      color: Colors.white.withOpacity(.1),
                    ),
                  ),
                ClipRect(
                  child: _controller?.value.isInitialized == true
                      ? Transform.scale(
                          scale: _controller!.value.aspectRatio > 1
                              ? 1
                              : (_controller!.value.aspectRatio <
                                      MediaQuery.of(context).size.aspectRatio
                                  ? MediaQuery.of(context).size.aspectRatio /
                                      _controller!.value.aspectRatio
                                  : _controller!.value.aspectRatio /
                                      MediaQuery.of(context).size.aspectRatio),
                          child: Center(
                            child: AspectRatio(
                              aspectRatio: _controller!.value.aspectRatio,
                              child: VideoPlayer(_controller!),
                            ),
                          ),
                        )
                      : Container(
                          width: 80.w,
                          height: 80.w,
                          padding: EdgeInsets.all(20.w),
                          child: CircularProgressIndicator(
                            backgroundColor: LeooColorsJunPro.leooBtnBgJunPro,
                            valueColor: AlwaysStoppedAnimation<Color>(
                              LeooColorsJunPro.leooAppJunPro,
                            ),
                          ),
                        ),
                ),
                if (!widget.mine &&
                    infoEntity != null &&
                    _controller?.value.isInitialized == true)
                  Positioned(
                    bottom: ScreenUtil().bottomBarHeight + 80.w,
                    right: 20.w,
                    child: Column(
                      mainAxisSize: MainAxisSize.min,
                      children: [
                        IconButton(
                          padding: const EdgeInsets.all(0),
                          icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                            widget.videoInfo.likeStatus == true
                                ? LeooIconsJunPro.leooListFireYesJunPro
                                : LeooIconsJunPro.leooListFireJunPro,
                            width: 50.w,
                            height: 50.w,
                          ),
                          iconSize: 48.w,
                          onPressed:
                              LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                            LeooDialogUtilsJunPro.instance
                                .showLoadingDialog(context);
                            (widget.videoInfo.likeStatus == true
                                    ? LeooMainDaoJunPro.leooVideoUnLikeJunPro(
                                        widget.videoInfo.id)
                                    : LeooMainDaoJunPro.leooVideoLikeJunPro(
                                        widget.videoInfo.id))
                                .then((res) {
                              Navigator.pop(context);
                              if (res.result) {
                                LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
                                    S.of(context).appComplete(
                                        widget.videoInfo.likeStatus == true
                                            ? S.of(context).videoPlayUnLike
                                            : S.of(context).videoPlayLike));
                                widget.videoInfo.likeCount =
                                    (widget.videoInfo.likeCount ?? 0) +
                                        (widget.videoInfo.likeStatus == true
                                            ? -1
                                            : 1);
                                widget.videoInfo.likeStatus =
                                    !(widget.videoInfo.likeStatus ?? false);
                                if (widget.videoInfo.likeStatus == false) {
                                  eventBus.fire(LeooVideoInfoUnLikeEventJunPro(
                                      widget.videoInfo.id));
                                }
                                LeooCodeUtilsJunPro.onSetState(this);
                              } else {
                                LeooCommonUtilsJunPro.leooShowErrorToastJunPro(
                                    res);
                              }
                            });
                          }),
                        ),
                        SizedBox(height: 5.w),
                        Text('${widget.videoInfo.likeCount ?? 0}',
                            style: LeooTextJunPro.leooGetTextStyleJunPro(16)),
                        SizedBox(height: 15.w),
                        IconButton(
                          padding: const EdgeInsets.all(0),
                          icon: LeooCommonUtilsJunPro.leooLottieJunPro(
                            LeooIconsJunPro.leooGiftJunPro,
                            width: 50.w,
                            height: 50.w,
                          ),
                          onPressed:
                              LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                            LeooRechargeUtilsJunPro.instance
                                .showGiftButton(context, userProvider)
                                .then((value) {
                              if (value != null) {
                                willSendGift(value);
                              }
                            });
                          }),
                        ),
                        SizedBox(height: 20.w),
                        IconButton(
                          padding: const EdgeInsets.all(0),
                          icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                            LeooIconsJunPro.leooListMessageJunPro,
                            width: 50.w,
                            height: 50.w,
                          ),
                          onPressed:
                              LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                            LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
                                context,
                                LeooChatJunPro(infoEntity?.id, infoEntity,
                                    'VideoPlayChat${infoEntity?.id}'),
                                'LeooChatJunPro',
                                add: true);
                          }),
                        ),
                        SizedBox(height: 20.w),
                        IconButton(
                          padding: const EdgeInsets.all(0),
                          icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                            LeooIconsJunPro.leooListVideoJunPro,
                            width: 50.w,
                            height: 50.w,
                          ),
                          onPressed:
                              LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                            LeooVideoUtilsJunPro.instance
                                .requestVideoPermission(context, infoEntity?.id,
                                    infoEntity: infoEntity);
                          }),
                        ),
                      ],
                    ),
                  ),
                if (!widget.mine &&
                    infoEntity != null &&
                    _controller?.value.isInitialized == true)
                  Positioned(
                    bottom: ScreenUtil().bottomBarHeight + 50.w,
                    left: 20.w,
                    right: 80.w,
                    child: Column(
                      crossAxisAlignment: CrossAxisAlignment.start,
                      children: [
                        Row(
                          children: [
                            InkWell(
                              child: ClipOval(
                                child: LeooCommonUtilsJunPro
                                    .leooGetLoadWidgetJunPro(
                                  infoEntity?.header,
                                  width: 50.w,
                                  height: 50.w,
                                  load: LeooIconsJunPro.leooLoadHeadJunPro,
                                ),
                              ),
                              onTap:
                                  LeooNavigatorUtilsJunPro.leooDebounceJunPro(
                                      () {
                                LeooNavigatorUtilsJunPro.leooInfoPageJunPro
                                        ?.call(context, infoEntity?.id,
                                            following: infoEntity?.following,
                                            infoEntity: infoEntity) ??
                                    LeooNavigatorUtilsJunPro
                                        .leooNavigatorPushJunPro(
                                            context,
                                            LeooInfoJunPro(
                                                infoEntity?.id,
                                                infoEntity,
                                                'VideoPlayInfo${infoEntity?.id}'),
                                            'LeooInfoJunPro',
                                            add: true);
                              }),
                            ),
                            SizedBox(width: 5.w),
                            Expanded(
                              child: Column(
                                crossAxisAlignment: CrossAxisAlignment.start,
                                children: [
                                  Row(
                                    children: [
                                      Container(
                                        constraints:
                                            BoxConstraints(maxWidth: .3.sw),
                                        child: Text(
                                          infoEntity?.getNameAge() ?? '',
                                          style: LeooTextJunPro
                                              .leooGetTextStyleJunPro(
                                                  20, FontWeight.bold),
                                        ),
                                      ),
                                      InkWell(
                                        onTap: LeooNavigatorUtilsJunPro
                                            .leooDebounceJunPro(() {
                                          LeooWidgetUtilsJunPro
                                              .leooShowCareDialogJunPro(
                                                  context,
                                                  infoEntity?.following,
                                                  infoEntity?.id, (care) {
                                            infoEntity?.following = care;
                                            eventBus.fire(
                                                LeooVideoInfoFollowEventJunPro(
                                                    infoEntity?.id,
                                                    infoEntity?.following));
                                            LeooCodeUtilsJunPro.onSetState(
                                                this);
                                          },
                                                  log: '详细页',
                                                  nickname:
                                                      infoEntity?.nickname,
                                                  age: infoEntity?.age,
                                                  gender: infoEntity?.gender,
                                                  country: infoEntity?.country,
                                                  header: infoEntity?.header,
                                                  description:
                                                      infoEntity?.description);
                                        }),
                                        child: Padding(
                                          padding: EdgeInsets.all(5.w),
                                          child: LeooCommonUtilsJunPro
                                              .leooGetLoadWidgetJunPro(
                                            infoEntity?.following == 1
                                                ? LeooIconsJunPro
                                                    .leooInfoLikedJunPro
                                                : LeooIconsJunPro
                                                    .leooInfoLikeJunPro,
                                            width: 20.w,
                                            height: 20.w,
                                          ),
                                        ),
                                      ),
                                    ],
                                  ),
                                  if (infoEntity?.country?.isEmpty == false)
                                    LeooWidgetUtilsJunPro
                                        .leooGetCountryWidgetJunPro(
                                            context, infoEntity?.country,
                                            item: false),
                                ],
                              ),
                            ),
                          ],
                        ),
                        SizedBox(height: 5.w),
                        Text(
                          infoEntity?.description ?? '',
                          style: LeooTextJunPro.leooGetTextStyleJunPro(16),
                        ),
                      ],
                    ),
                  ),
                Positioned(
                  bottom: ScreenUtil().bottomBarHeight + 30.w,
                  child: SizedBox(
                    width: 1.sw,
                    height: 5.w,
                    child: _controller != null &&
                            _controller?.value.isInitialized == true
                        ? VideoProgressIndicator(_controller!,
                            allowScrubbing: false,
                            colors: const VideoProgressColors(
                                playedColor: Colors.white,
                                bufferedColor: Colors.white60,
                                backgroundColor: Colors.white24),
                            padding: const EdgeInsets.all(0))
                        : const LinearProgressIndicator(
                            backgroundColor: Colors.white24,
                            valueColor:
                                AlwaysStoppedAnimation<Color>(Colors.white),
                          ),
                  ),
                ),
                widget.videoInfo.feeType == 1 &&
                        widget.videoInfo.unlockStatus == 0 &&
                        !widget.mine &&
                        infoEntity != null
                    ? Container(
                        color: Colors.black.withOpacity(.3),
                        width: 1.sw,
                        height: 1.sh,
                        child: Column(
                          mainAxisAlignment: MainAxisAlignment.center,
                          children: [
                            LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                              LeooIconsJunPro.leooVideoLockJunPro,
                              width: 100.w,
                              height: 100.w,
                            ),
                            Text.rich(
                              TextSpan(
                                text: '${widget.videoInfo.feeGold ?? 0}',
                                style: LeooTextJunPro.leooGetTextStyleAppJunPro(
                                    24, FontWeight.bold),
                                children: <TextSpan>[
                                  TextSpan(
                                      text: S.of(context).videoPlayUnlockTip,
                                      style:
                                          LeooTextJunPro.leooGetTextStyleJunPro(
                                              24, FontWeight.bold)),
                                ],
                              ),
                              textAlign: TextAlign.center,
                            ),
                            SizedBox(height: 30.w),
                            Padding(
                              padding: EdgeInsets.only(
                                left: 35.w,
                                right: 35.w,
                              ),
                              child: LeooButtonWidgetJunPro(
                                S.of(context).paidVideoUnlock,
                                LeooTextJunPro.leooGetTextStyleJunPro(
                                    20, FontWeight.bold),
                                color: LeooColorsJunPro.leooAppJunPro,
                                colorRight: LeooColorsJunPro.leooApp2JunPro,
                                shape: const RoundedRectangleBorder(
                                  borderRadius:
                                      BorderRadius.all(Radius.circular(20)),
                                ),
                                onPressed:
                                    LeooNavigatorUtilsJunPro.leooDebounceJunPro(
                                        () {
                                  checkPlay();
                                }),
                              ),
                            ),
                          ],
                        ),
                      )
                    : _controller?.value.isInitialized == true &&
                            _controller?.value.isPlaying == false
                        ? LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                            LeooIconsJunPro.leooVideoPlayJunPro,
                            width: 100.w,
                            height: 100.w)
                        : Container()
              ],
            ),
          ),
          Positioned(
            top: ScreenUtil().statusBarHeight + 4.w,
            left: 4.w,
            child: IconButton(
              iconSize: 40.w,
              padding: const EdgeInsets.all(0),
              icon: Container(
                decoration: ShapeDecoration(
                    shape: const CircleBorder(),
                    color: Colors.black.withOpacity(.1)),
                child: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                    LeooIconsJunPro.leooTopBackJunPro,
                    width: 40.w,
                    height: 40.w),
              ),
              onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                _controller?.pause();
                Navigator.pop(context);
              }),
            ),
          ),
          Positioned(
            top: ScreenUtil().statusBarHeight + 4.w,
            right: 4.w,
            child: IconButton(
              iconSize: 40.w,
              padding: const EdgeInsets.all(0),
              icon: Container(
                padding: EdgeInsets.all(widget.mine ? 10.w : 0),
                decoration: ShapeDecoration(
                    shape: const CircleBorder(),
                    color: Colors.black.withOpacity(.1)),
                child: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                  widget.mine
                      ? LeooIconsJunPro.leooMsgListDeleteJunPro
                      : LeooIconsJunPro.leooInfoMoreJunPro,
                  width: 40.w,
                  height: 40.w,
                ),
              ),
              onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                if (widget.mine) {
                  LeooDialogUtilsJunPro.instance
                      .showCustomDialog(context,
                          content: S.of(context).videoDeleteTip,
                          right: S.of(context).deleteOk)
                      .then((value) {
                    if (value == true) {
                      LeooDialogUtilsJunPro.instance.showLoadingDialog(context);
                      LeooMainDaoJunPro.leooVideoDeleteJunPro(
                              widget.videoInfo.id)
                          .then((res) {
                        Navigator.pop(context);
                        if (res.result) {
                          LeooCommonUtilsJunPro.leooShowCustomToastJunPro(S
                              .of(context)
                              .appComplete(S.of(context).deleteOk));
                          eventBus.fire(LeooVideoListMyEventJunPro());
                          Navigator.pop(context);
                        } else {
                          LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
                        }
                      });
                    }
                  });
                } else {
                  LeooDialogUtilsJunPro.instance.showReportBlack(
                      context, infoEntity?.id,
                      title: S.of(context).reportVideo,
                      nickname: infoEntity?.nickname,
                      age: infoEntity?.age,
                      gender: infoEntity?.gender,
                      country: infoEntity?.country,
                      header: infoEntity?.header,
                      description: infoEntity?.description,
                      follow: infoEntity?.following != 1
                          ? () {
                              LeooWidgetUtilsJunPro.leooShowCareDialogJunPro(
                                  context,
                                  infoEntity?.following,
                                  infoEntity?.id, (care) {
                                infoEntity?.following = care;
                                LeooCodeUtilsJunPro.onSetState(this);
                              },
                                  log: '详细页',
                                  nickname: infoEntity?.nickname,
                                  age: infoEntity?.age,
                                  gender: infoEntity?.gender,
                                  country: infoEntity?.country,
                                  header: infoEntity?.header,
                                  description: infoEntity?.description);
                            }
                          : null);
                }
              }),
            ),
          ),
        ],
      );
    });
  }

  void setVideoPlay(String url, {bool play = false}) {
    _controller = VideoPlayerController.network(url);
    _controller!.setLooping(true);
    _controller!.initialize().then((value) {
      if ((widget.list
              ? list.LeooVideoListJunPro.leooIndexJunPro == widget.position
              : LeooVideoListJunPro.leooIndexJunPro == widget.position) &&
          play &&
          !(widget.videoInfo.feeType == 1 &&
              widget.videoInfo.unlockStatus == 0)) {
        _controller?.play();
        LeooCodeUtilsJunPro.onSetState(this);
      } else {
        LeooCodeUtilsJunPro.onSetState(this);
      }
    });
    this.play = false;
  }

  void checkPlay([bool check = true]) {
    if (widget.videoInfo.feeType == 1 && widget.videoInfo.unlockStatus == 0) {
      if (!check) {
        return;
      }
      LeooDialogUtilsJunPro.instance
          .showCustomDialog(context,
              title: S.of(context).paidVideo,
              content:
                  S.of(context).paidVideoTip(widget.videoInfo.feeGold ?? 0),
              right: S.of(context).paidVideoUnlock)
          .then((value) {
        if (value == true) {
          LeooDialogUtilsJunPro.instance.showLoadingDialog(context);
          LeooMainDaoJunPro.leooVideoUnlockJunPro(widget.videoInfo.id)
              .then((res) {
            Navigator.pop(context);
            if (res.result) {
              widget.videoInfo.unlockStatus = 1;
              LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
                  S.of(context).appComplete(S.of(context).paidVideoUnlock));
              setVideoPlay(widget.videoInfo.videoUrl ?? '', play: true);
              LeooCodeUtilsJunPro.onSetState(this);
              eventBus.fire(LeooVideoInfoUnlockEventJunPro(widget.position));
            } else {
              LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
            }
          });
        }
      });
    } else {
      _controller?.play();
      LeooCodeUtilsJunPro.onSetState(this);
    }
  }

  void willSendGift(LeooGiftEntity gift) async {
    LeooRechargeUtilsJunPro.instance
        .willSendGift(context, userProvider, gift, infoEntity?.id, send: true);
  }
}
