import 'dart:io';

import 'package:extended_image/extended_image.dart';
import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';

///图片预览-放大缩小
class LeooViewImageJunPro extends StatefulWidget {
  static bool leooOpenJunPro = false;
  final bool single;
  final String? localPath;
  final String? imageUri;
  final bool? imUri;
  final List<String>? pics;
  final int? currentIndex;
  final String? hero;
  final Map<String, String>? headers;

  const LeooViewImageJunPro(
      {Key? key,
      this.single = true,
      this.localPath,
      this.imageUri,
      this.imUri,
      this.pics,
      this.currentIndex,
      this.hero,
      this.headers})
      : super(key: key);

  @override
  _LeooViewImageState createState() => _LeooViewImageState();
}

class _LeooViewImageState extends State<LeooViewImageJunPro> {
  late bool single;
  int? currentIndex;
  bool isLocal = false;
  File? file;

  @override
  void initState() {
    super.initState();
    LeooViewImageJunPro.leooOpenJunPro = true;
    single = widget.single;
    currentIndex = widget.currentIndex;
    if (single && widget.localPath != null) {
      String path =
          LeooCodeUtilsJunPro.leooGetImageFileJunPro(widget.localPath);
      file = File(path);
      if (file?.existsSync() == true) {
        isLocal = true;
      }
    }
  }

  @override
  void dispose() {
    LeooViewImageJunPro.leooOpenJunPro = false;
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return ExtendedImageSlidePage(
      slidePageBackgroundHandler: ((Offset offset, Size pageSize) {
        return defaultSlidePageBackgroundHandler(
            offset: offset,
            pageSize: pageSize,
            color: LeooColorsJunPro.leooBgJunPro,
            pageGestureAxis: SlideAxis.both);
      }),
      child: ExtendedImageSlidePageHandler(
        heroBuilderForSlidingPage: (Widget result) {
          return Hero(
            tag: widget.hero ?? '',
            child: result,
            flightShuttleBuilder: (BuildContext flightContext,
                Animation<double> animation,
                HeroFlightDirection flightDirection,
                BuildContext fromHeroContext,
                BuildContext toHeroContext) {
              final Hero hero = (flightDirection == HeroFlightDirection.pop
                  ? fromHeroContext.widget
                  : toHeroContext.widget) as Hero;
              return hero.child;
            },
          );
        },
        child: Scaffold(
          resizeToAvoidBottomInset: false,
          backgroundColor: Colors.transparent,
          body: Stack(
            fit: StackFit.expand,
            children: <Widget>[
              single
                  ? getExtendedImage(widget.imageUri)
                  : ExtendedImageGesturePageView.builder(
                      itemBuilder: (BuildContext context, int index) {
                        var item = widget.pics![index];
                        return getExtendedImage(item);
                      },
                      itemCount: widget.pics!.length,
                      onPageChanged: (int index) {
                        currentIndex = index;
                      },
                      controller: ExtendedPageController(
                        initialPage: currentIndex!,
                      ),
                      scrollDirection: Axis.horizontal),
              Positioned(
                  top: ScreenUtil().statusBarHeight + 4.w,
                  left: 4.w,
                  child: IconButton(
                    iconSize: 40.w,
                    padding: const EdgeInsets.all(0),
                    icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                        LeooIconsJunPro.leooTopBackJunPro,
                        width: 40.w,
                        height: 40.w),
                    onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(
                        () => Navigator.pop(context)),
                  ))
            ],
          ),
        ),
      ),
    );
  }

  Widget getExtendedImage(String? url) {
    if (isLocal && file != null) {
      return ExtendedImage.file(
        file!,
        enableSlideOutPage: true,
        mode: ExtendedImageMode.gesture,
        enableLoadState: true,
        loadStateChanged: ((ExtendedImageState state) {
          switch (state.extendedImageLoadState) {
            case LoadState.loading:
              return LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                LeooIconsJunPro.leooLoadPicJunPro,
                fit: BoxFit.fitWidth,
              );
            case LoadState.completed:
              return InkWell(
                child: state.completedWidget,
                onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(
                    () => Navigator.pop(context)),
              );
            default:
              return InkWell(
                child: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                  LeooIconsJunPro.leooLoadPicJunPro,
                  fit: BoxFit.fitWidth,
                ),
                onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(
                    () => state.reLoadImage()),
              );
          }
        }),
      );
    } else {
      return ExtendedImage.network(
        widget.headers != null || widget.imUri!
            ? url!
            : LeooCodeUtilsJunPro.leooCompressImageUrlJunPro(url!),
        enableSlideOutPage: true,
        mode: ExtendedImageMode.gesture,
        enableLoadState: true,
        handleLoadingProgress: true,
        headers: widget.headers,
        loadStateChanged: ((ExtendedImageState state) {
          switch (state.extendedImageLoadState) {
            case LoadState.loading:
              if (state.loadingProgress == null) {
                return LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                  LeooIconsJunPro.leooLoadPicJunPro,
                  fit: BoxFit.fitWidth,
                );
              }
              return Center(
                  child: CircularProgressIndicator(
                      valueColor: AlwaysStoppedAnimation<Color>(
                          LeooColorsJunPro.leooBtnBgJunPro),
                      value: state.loadingProgress!.expectedTotalBytes != null
                          ? state.loadingProgress!.cumulativeBytesLoaded /
                              state.loadingProgress!.expectedTotalBytes!
                          : null));
            case LoadState.completed:
              return InkWell(
                child: state.completedWidget,
                onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(
                    () => Navigator.pop(context)),
              );
            default:
              return InkWell(
                child: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                  LeooIconsJunPro.leooLoadPicJunPro,
                  fit: BoxFit.fitWidth,
                ),
                onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(
                    () => state.reLoadImage()),
              );
          }
        }),
      );
    }
  }
}
