import 'dart:async';
import 'dart:core';

import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leooappconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoohostdaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoomaindaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoohostinfoentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoouserentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoouserlistentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooeventjunpro/leooindexjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooeventjunpro/leoomaineventjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooproviderjunpro/leoouserproviderjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoovideoutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoowidgetutilsjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leooinfojunpro/leoohostinfojunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leooinfojunpro/leooinfojunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoolistjunpro/leoolistjunpro.dart';
import 'package:provider/provider.dart';
import 'package:pull_to_refresh/pull_to_refresh.dart';

///列表zb
class LeooListItemJunPro extends StatefulWidget {
  final int type;

  const LeooListItemJunPro(this.type, {Key? key}) : super(key: key);

  @override
  _LeooListItemState createState() => _LeooListItemState();
}

class _LeooListItemState extends State<LeooListItemJunPro>
    with AutomaticKeepAliveClientMixin<LeooListItemJunPro> {
  @override
  bool get wantKeepAlive => true;

  final RefreshController _refreshController = RefreshController();
  int page = 1;
  List<dynamic> allList = [];
  int status = LeooCommonUtilsJunPro.leooPageStatusLoadingJunPro;
  late StreamSubscription subscription;
  late LeooUserProviderJunPro userProvider;

  @override
  void initState() {
    super.initState();
    subscription = eventBus.on<LeooListEventJunPro>().listen((event) {
      status = LeooCommonUtilsJunPro.leooPageStatusLoadingJunPro;
      LeooCodeUtilsJunPro.onSetState(this);
      page = 1;
      getList();
    });
    getList();
  }

  @override
  void dispose() {
    subscription.cancel();
    super.dispose();
  }

  void getList() {
    LeooMainDaoJunPro.leooUserAnchorListJunPro(
            page, widget.type, LeooListJunPro.leooLanguageJunPro?.id)
        .then((res) async {
      if (res.result) {
        if (page == 1) {
          allList.clear();
        }
        if (LeooAppConfigJunPro.leooShowThreeJunPro &&
            userProvider.userEntity.userType == 0) {
          List<LeooUserListEntity> onlineList = [];
          List<LeooUserListEntity> lineList = [];
          for (var item in res.data) {
            if (item.onlineStatus == 2) {
              onlineList.add(item);
            } else {
              lineList.add(item);
            }
          }
          allList.addAll(onlineList);
          getHostList(lineList);
        } else {
          allList.addAll(res.data);
          if (allList.isEmpty) {
            status = LeooCommonUtilsJunPro.leooPageStatusEmptyJunPro;
          } else {
            status = LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro;
          }
          LeooCodeUtilsJunPro.onSetState(this);
          if (page == 1) {
            _refreshController.refreshCompleted();
            _refreshController.loadComplete();
          } else if (res.data.isEmpty) {
            _refreshController.loadNoData();
          } else {
            _refreshController.loadComplete();
          }
        }
      } else {
        if (allList.isEmpty) {
          status = LeooCommonUtilsJunPro.leooPageStatusErrorJunPro;
          LeooCodeUtilsJunPro.onSetState(this);
        } else if (page == 1) {
          _refreshController.refreshFailed();
        } else {
          _refreshController.loadFailed();
        }
        LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
      }
    });
  }

  void getHostList(List<LeooUserListEntity> lineList) {
    LeooHostDaoJunPro.leooHostListJunPro(page).then((res) async {
      if (res.result) {
        allList.addAll(res.data);
        allList.addAll(lineList);
        if (allList.isEmpty) {
          status = LeooCommonUtilsJunPro.leooPageStatusEmptyJunPro;
        } else {
          status = LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro;
        }
        LeooCodeUtilsJunPro.onSetState(this);
        if (page == 1) {
          _refreshController.refreshCompleted();
          _refreshController.loadComplete();
        } else if (res.data.isEmpty) {
          _refreshController.loadNoData();
        } else {
          _refreshController.loadComplete();
        }
      } else {
        if (allList.isEmpty) {
          status = LeooCommonUtilsJunPro.leooPageStatusErrorJunPro;
          LeooCodeUtilsJunPro.onSetState(this);
        } else if (page == 1) {
          _refreshController.refreshFailed();
        } else {
          _refreshController.loadFailed();
        }
        LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
      }
    });
  }

  @override
  Widget build(BuildContext context) {
    super.build(context);
    return Consumer<LeooUserProviderJunPro>(
        builder: (_, LeooUserProviderJunPro userProvider, __) {
      this.userProvider = userProvider;
      return status != LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro
          ? LeooCommonUtilsJunPro.leooCheckPageStatusJunPro(
              context,
              status,
              onTap: () {
                status = LeooCommonUtilsJunPro.leooPageStatusLoadingJunPro;
                LeooCodeUtilsJunPro.onSetState(this);
                getList();
              },
            )
          : SmartRefresher(
              controller: _refreshController,
              header: const ClassicHeader(),
              footer: const ClassicFooter(),
              enablePullUp:
                  allList.length * 3 >= LeooAppConfigJunPro.leooPageSizeJunPro,
              onRefresh: () {
                page = 1;
                getList();
              },
              onLoading: () {
                page++;
                getList();
              },
              child: GridView.builder(
                  physics: const BouncingScrollPhysics(),
                  itemCount: allList.length,
                  padding: EdgeInsets.all(5.w),
                  gridDelegate: SliverGridDelegateWithFixedCrossAxisCount(
                      crossAxisCount: 2,
                      childAspectRatio: .64,
                      mainAxisSpacing: 5.w,
                      crossAxisSpacing: 5.w),
                  itemBuilder: (BuildContext itemContext, int index) {
                    dynamic item = allList[index];
                    if (item is LeooHostInfoEntity) {
                      return getHostListChildWidget(userProvider, item, index);
                    } else {
                      return getListChildWidget(userProvider, item, index);
                    }
                  }),
            );
    });
  }

  Widget getListChildWidget(userProvider, LeooUserListEntity item, int index) {
    String hero = '${widget.type}${item.userId}listitem$index';
    return InkWell(
      child: Stack(
        children: <Widget>[
          Hero(
            tag: hero,
            transitionOnUserGestures: true,
            child: ClipRRect(
              borderRadius: BorderRadius.circular(20),
              child: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                item.header,
                width: .5.sw,
                height: .5.sh,
                load: LeooIconsJunPro.leooLoadHeadJunPro,
              ),
            ),
          ),
          Positioned(
              left: 10.w,
              top: 10.w,
              child: LeooWidgetUtilsJunPro.leooGetOnlineTextJunPro(
                  context, item.onlineStatus)),
          Positioned(
            left: 0,
            right: 0,
            bottom: 0,
            child: Container(
              padding: EdgeInsets.fromLTRB(10.w, 10.w, 60.w, 10.w),
              decoration: BoxDecoration(
                gradient: LinearGradient(
                  begin: Alignment.topCenter,
                  end: Alignment.bottomCenter,
                  colors: [
                    LeooColorsJunPro.leooBgJunPro.withOpacity(0),
                    LeooColorsJunPro.leooBgJunPro.withOpacity(.7),
                  ],
                ),
              ),
              child: Column(
                crossAxisAlignment: CrossAxisAlignment.start,
                children: [
                  Text(
                    item.nickname ?? '',
                    style: LeooTextJunPro.leooGetTextStyleJunPro(
                        20, FontWeight.bold),
                    maxLines: 2,
                    overflow: TextOverflow.ellipsis,
                  ),
                  if (item.countryName?.isEmpty == false) SizedBox(height: 2.w),
                  if (item.countryName?.isEmpty == false)
                    LeooWidgetUtilsJunPro.leooGetCountryWidgetJunPro(
                        context, item.countryName,
                        name: true),
                ],
              ),
            ),
          ),
          Positioned(
            right: 10.w,
            bottom: 10.w,
            child: IconButton(
              padding: const EdgeInsets.all(0),
              iconSize: 50.w,
              icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                LeooIconsJunPro.leooListVideoJunPro,
                width: 50.w,
                height: 50.w,
              ),
              onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                LeooUserEntity infoEntity = LeooUserEntity(
                  id: item.userId,
                  nickname: item.nickname,
                  header: item.header,
                );
                LeooVideoUtilsJunPro.instance.requestVideoPermission(
                    context, item.userId,
                    infoEntity: infoEntity);
              }),
            ),
          ),
        ],
      ),
      onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
        LeooUserEntity infoEntity = LeooUserEntity(
          id: item.userId,
          nickname: item.nickname,
          header: item.header,
        );
        LeooNavigatorUtilsJunPro.leooInfoPageJunPro
                ?.call(context, item.userId, infoEntity: infoEntity) ??
            LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(context,
                LeooInfoJunPro(item.userId, infoEntity, hero), 'LeooInfoJunPro',
                add: true);
      }),
    );
  }

  Widget getHostListChildWidget(
      userProvider, LeooHostInfoEntity item, int index) {
    String hero = '${widget.type}${item.uid}listitem$index';
    return InkWell(
      child: Stack(
        children: <Widget>[
          Hero(
            tag: hero,
            transitionOnUserGestures: true,
            child: ClipRRect(
              borderRadius: BorderRadius.circular(20),
              child: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                item.avatar,
                width: .5.sw,
                height: .5.sh,
                load: LeooIconsJunPro.leooLoadHeadJunPro,
              ),
            ),
          ),
          Positioned(
              left: 10.w,
              top: 10.w,
              child: LeooWidgetUtilsJunPro.leooGetOnlineTextJunPro(
                  context, item.chatStatus, true)),
          Positioned(
              left: 0,
              right: 0,
              bottom: 0,
              height: 70.w,
              child: Container(
                decoration: BoxDecoration(
                  gradient: LinearGradient(
                    begin: Alignment.topCenter,
                    end: Alignment.bottomCenter,
                    colors: [
                      LeooColorsJunPro.leooBgJunPro.withOpacity(0),
                      LeooColorsJunPro.leooBgJunPro.withOpacity(.7),
                    ],
                  ),
                ),
              )),
          Positioned(
            left: 10.w,
            right: 60.w,
            bottom: 10.w,
            child: Column(
              crossAxisAlignment: CrossAxisAlignment.start,
              children: [
                Text(
                  item.nickname ?? '',
                  style: LeooTextJunPro.leooGetTextStyleJunPro(
                      20, FontWeight.bold),
                  maxLines: 2,
                  overflow: TextOverflow.ellipsis,
                ),
                if (item.regionCode?.isEmpty == false) SizedBox(height: 2.w),
                if (item.regionCode?.isEmpty == false)
                  LeooWidgetUtilsJunPro.leooGetCountryWidgetJunPro(
                      context, item.regionCode),
              ],
            ),
          ),
          Positioned(
            right: 10.w,
            bottom: 10.w,
            child: IconButton(
              padding: const EdgeInsets.all(0),
              iconSize: 50.w,
              icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                LeooIconsJunPro.leooListVideoJunPro,
                width: 50.w,
                height: 50.w,
              ),
              onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                LeooVideoUtilsJunPro.instance.requestVideoPermission(
                    context, item.uid,
                    infoHostEntity: item);
              }),
            ),
          ),
        ],
      ),
      onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
        LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(context,
            LeooHostInfoJunPro(item.uid, item, hero), 'LeooHostInfoJunPro',
            add: true);
      }),
    );
  }
}
