import 'dart:convert';

import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leooappconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leoonetconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoomaindaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoolanguageentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooeventjunpro/leooindexjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooeventjunpro/leoomaineventjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooproviderjunpro/leoouserproviderjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoodialogutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoocustomtabsjunpro.dart'
    as custom_tabs;
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leootabbarwidgetjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoolistjunpro/leoolistitemjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leootopjunpro/leootopjunpro.dart';
import 'package:provider/provider.dart';
import 'package:sp_util/sp_util.dart';

///列表
class LeooListJunPro extends StatefulWidget {
  static LeooLanguageEntity? leooLanguageJunPro;

  const LeooListJunPro({Key? key}) : super(key: key);

  @override
  _LeooListState createState() => _LeooListState();
}

class _LeooListState extends State<LeooListJunPro>
    with AutomaticKeepAliveClientMixin<LeooListJunPro> {
  @override
  bool get wantKeepAlive => true;
  List<LeooLanguageEntity> languageList = [];
  bool first = true;

  void getLanguageList([bool show = false]) {
    if (languageList.isEmpty) {
      if (show) {
        LeooDialogUtilsJunPro.instance.showLoadingDialog(context);
      }
      LeooMainDaoJunPro.leooGetLanguageListJunPro().then((res) async {
        if (show) {
          Navigator.pop(context);
        }
        if (res.result) {
          languageList.addAll(res.data);
          LeooLanguageEntity all = LeooLanguageEntity();
          all.enName = S.of(context).language;
          languageList.insert(0, all);
          if (show) {
            List<String> list =
                languageList.map((e) => e.enName ?? '').toList();
            LeooDialogUtilsJunPro.leooShowCommitOptionDialogJunPro(
                    context,
                    list,
                    S.of(context).languageChoose,
                    LeooListJunPro.leooLanguageJunPro?.enName ?? '',
                    name: 'showLanguageDialog',
                    okTip: S.of(context).appOk)
                .then((value) {
              if (value != null) {
                LeooListJunPro.leooLanguageJunPro = languageList
                    .firstWhere((element) => element.enName == value);
                SpUtil.putString(LeooAppConfigJunPro.leooLanguageJunPro,
                    jsonEncode(LeooListJunPro.leooLanguageJunPro));
                eventBus.fire(LeooListEventJunPro());
                LeooCodeUtilsJunPro.onSetState(this);
              }
            });
          } else {
            LeooListJunPro.leooLanguageJunPro = languageList.first;
            LeooCodeUtilsJunPro.onSetState(this);
          }
        } else {
          LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
        }
      });
    } else {
      List<String> list = languageList.map((e) => e.enName ?? '').toList();
      LeooDialogUtilsJunPro.leooShowCommitOptionDialogJunPro(
              context,
              list,
              S.of(context).languageChoose,
              LeooListJunPro.leooLanguageJunPro?.enName ?? '',
              name: 'showLanguageDialog',
              okTip: S.of(context).appOk)
          .then((value) {
        if (value != null) {
          LeooListJunPro.leooLanguageJunPro =
              languageList.firstWhere((element) => element.enName == value);
          SpUtil.putString(LeooAppConfigJunPro.leooLanguageJunPro,
              jsonEncode(LeooListJunPro.leooLanguageJunPro));
          eventBus.fire(LeooListEventJunPro());
          LeooCodeUtilsJunPro.onSetState(this);
        }
      });
    }
  }

  @override
  Widget build(BuildContext context) {
    super.build(context);
    return Consumer<LeooUserProviderJunPro>(
        builder: (_, LeooUserProviderJunPro userProvider, __) {
      if (first) {
        first = false;
        if (userProvider.userEntity.userType == 0) {
          try {
            String? language =
                SpUtil.getString(LeooAppConfigJunPro.leooLanguageJunPro);
            if (language?.isEmpty == false) {
              LeooListJunPro.leooLanguageJunPro =
                  LeooLanguageEntity.fromJson(jsonDecode(language!));
            } else {
              getLanguageList();
            }
          } catch (e) {
            LeooNetConfigJunPro.leooPrintLogJunPro(e);
            getLanguageList();
          }
        }
      }
      return SafeArea(
        maintainBottomViewPadding: true,
        child: Stack(
          children: [
            LeooTabBarWidgetJunPro(
              [
                custom_tabs.Tab(text: S.of(context).listActive),
                custom_tabs.Tab(text: S.of(context).listHot),
                custom_tabs.Tab(text: S.of(context).listNew),
              ],
              const [
                LeooListItemJunPro(0),
                LeooListItemJunPro(1),
                LeooListItemJunPro(2),
              ],
              type: LeooTabBarWidgetJunPro.leooTaoTopJunPro,
              isScrollable: true,
              top: false,
              alignment: Alignment.bottomLeft,
              margin: EdgeInsets.only(left: 5.w, right: .3.sw, bottom: 10.w),
              padding: EdgeInsets.only(top: 10.w),
              indicatorColor: LeooColorsJunPro.leooAppJunPro,
              unselectedLabelColor: LeooColorsJunPro.leooTextJunPro,
              onPageChanged: (index) {},
            ),
            Positioned(
              top: 4.w,
              right: 15.w,
              child: Row(
                children: [
                  IconButton(
                    iconSize: 40.w,
                    padding: const EdgeInsets.all(0),
                    icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                      LeooIconsJunPro.leooMainRankJunPro,
                      width: 40.w,
                      height: 40.w,
                    ),
                    onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                      LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
                          context, const LeooTopJunPro(), 'LeooTopJunPro');
                    }),
                  ),
                  if (userProvider.userEntity.userType == 0)
                    InkWell(
                      child: Container(
                        decoration: ShapeDecoration(
                            shape: const StadiumBorder(),
                            color: LeooColorsJunPro.leooBtnBg2JunPro
                                .withOpacity(.5)),
                        padding: EdgeInsets.all(4.w),
                        child: Row(
                          children: [
                            LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                              LeooIconsJunPro.leooMainLanguageJunPro,
                              width: 20.w,
                              height: 20.w,
                            ),
                            Padding(
                              padding: EdgeInsets.only(left: 10.w, right: 12.w),
                              child: Text(
                                LeooListJunPro.leooLanguageJunPro?.enName ?? '',
                                style: LeooTextJunPro.leooGetTextStyleJunPro(
                                    14, FontWeight.bold),
                              ),
                            ),
                          ],
                        ),
                      ),
                      onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                        getLanguageList(true);
                      }),
                    ),
                ],
              ),
            ),
          ],
        ),
      );
    });
  }
}
