import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leooproviderjunpro/leoouserproviderjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoowidgetutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoocustomtabsjunpro.dart'
    as custom_tabs;
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leootabbarwidgetjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoocamerajunpro/leoocamerajunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoolistjunpro/leoovideoitemjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leootopjunpro/leootopjunpro.dart';
import 'package:provider/provider.dart';

///列表
class LeooVideoJunPro extends StatefulWidget {
  const LeooVideoJunPro({Key? key}) : super(key: key);

  @override
  _LeooVideoState createState() => _LeooVideoState();
}

class _LeooVideoState extends State<LeooVideoJunPro>
    with AutomaticKeepAliveClientMixin<LeooVideoJunPro> {
  @override
  bool get wantKeepAlive => true;

  @override
  Widget build(BuildContext context) {
    super.build(context);
    return Consumer<LeooUserProviderJunPro>(
        builder: (_, LeooUserProviderJunPro userProvider, __) {
      return SafeArea(
        maintainBottomViewPadding: true,
        child: Stack(
          children: [
            LeooTabBarWidgetJunPro(
              userProvider.userEntity.userType == 0
                  ? [
                      custom_tabs.Tab(text: S.of(context).listVideo),
                      custom_tabs.Tab(text: S.of(context).listFollowing),
                    ]
                  : [custom_tabs.Tab(text: S.of(context).mineVideo)],
              userProvider.userEntity.userType == 0
                  ? [
                      const LeooVideoItemJunPro(1),
                      const LeooVideoItemJunPro(2),
                    ]
                  : [const LeooVideoItemJunPro(3)],
              type: LeooTabBarWidgetJunPro.leooTaoTopJunPro,
              isScrollable: true,
              top: false,
              alignment: Alignment.bottomLeft,
              margin: EdgeInsets.only(left: 5.w, right: .3.sw, bottom: 10.w),
              padding: EdgeInsets.only(top: 10.w),
              indicatorColor: LeooColorsJunPro.leooAppJunPro,
              unselectedLabelColor: LeooColorsJunPro.leooTextJunPro,
              onPageChanged: (index) {},
            ),
            Positioned(
              top: 4.w,
              right: 15.w,
              child: Row(
                children: [
                  IconButton(
                    iconSize: 40.w,
                    padding: const EdgeInsets.all(0),
                    icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                      LeooIconsJunPro.leooMainRankJunPro,
                      width: 40.w,
                      height: 40.w,
                    ),
                    onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                      LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
                          context, const LeooTopJunPro(), 'LeooTopJunPro');
                    }),
                  ),
                  if (userProvider.userEntity.userType == 0)
                    LeooWidgetUtilsJunPro.leooGetMainCoinsWidgetJunPro(
                        context, userProvider.userEntity.amount),
                ],
              ),
            ),
            if (userProvider.userEntity.userType == 1)
              Positioned(
                bottom: 15.w,
                right: 15.w,
                child: IconButton(
                  iconSize: 70.w,
                  padding: const EdgeInsets.all(0),
                  icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                    LeooIconsJunPro.leooCameraAddJunPro,
                    width: 70.w,
                    height: 70.w,
                  ),
                  onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                    LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
                        context, const LeooCameraJunPro(), 'LeooCameraJunPro',
                        fullscreenDialog: true);
                  }),
                ),
              ),
          ],
        ),
      );
    });
  }
}
