import 'dart:async';
import 'dart:io';
import 'dart:math';

import 'package:agora_rtm/agora_rtm.dart';
import 'package:badges/badges.dart';
import 'package:flutter/material.dart';
import 'package:flutter_app_badger/flutter_app_badger.dart';
import 'package:flutter_background/flutter_background.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:im_flutter_sdk/im_flutter_sdk.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leooappconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leoonetconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoomaindaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoogiftentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoorechargeentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoortmentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoouserentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooeventjunpro/leooindexjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooeventjunpro/leoomaineventjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooeventjunpro/leoorechargeeventjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooproviderjunpro/leoouserproviderjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostringjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoodialogutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leooimutils.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoorechargeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoovideoutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoocustomtabsjunpro.dart'
    as custom_tabs;
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoomovestackwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leootabbarwidgetjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoocalljunpro/leoovideocalljunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoolistjunpro/leoolistjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoolistjunpro/leoovideojunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoomatjunpro/leoomatjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoomejunpro/leoominejunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoomejunpro/leoorechargenewjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoomsgjunpro/leoomsgjunpro.dart';
import 'package:leoo_junpro/leoorouterjunpro.dart';
import 'package:provider/provider.dart';
import 'package:sp_util/sp_util.dart';

//主页加载器
class LeooMainJunPro extends StatefulWidget {
  static const String leooNameJunPro = 'LeooMainJunPro';
  static int leooCurIndexJunPro = 0;
  static bool leooUpdateJunPro = false;

  const LeooMainJunPro({Key? key}) : super(key: key);

  @override
  _LeooMainState createState() => _LeooMainState();
}

class _LeooMainState extends State<LeooMainJunPro>
    with
        WidgetsBindingObserver,
        RouteAware,
        OnImPluginDelegate,
        OnRtmPluginDelegate {
  bool _load = false;
  PageController pageController =
      PageController(initialPage: LeooMainJunPro.leooCurIndexJunPro);
  late LeooUserProviderJunPro uProvider;

  Timer? backTimer;
  List localStr = [];
  int unreadCount = 0;

  late StreamSubscription subscription;
  late StreamSubscription subscriptionRecharge;

  LeooRechargeEntity? rechargeBean;
  bool showRecharge = false;
  late Timer timer;

  @override
  void initState() {
    super.initState();
    SpUtil.putBool(LeooAppConfigJunPro.leooLoginJunPro, true);
    LeooImUtilsJunPro.instance.imPluginDelegateList.add(this);
    LeooVideoUtilsJunPro.instance.rtmPluginDelegateList.add(this);
    getUnreadCount();
    LeooVideoUtilsJunPro.instance.createRtmClient(context,
        userId: SpUtil.getInt(LeooAppConfigJunPro.leooUserIdJunPro).toString());
    WidgetsBinding.instance!.addObserver(this);
    subscription = eventBus.on<LeooMainUnReadEventJunPro>().listen((event) {
      getUnreadCount();
    });
    subscriptionRecharge =
        eventBus.on<LeooRechargeEventJunPro>().listen((event) {
      uProvider.setMoney(event.amount);
      if (rechargeBean != null) {
        rechargeBean = null;
        LeooCodeUtilsJunPro.onSetState(this);
      }
      if (showRecharge) {
        showRecharge = false;
        Navigator.pop(context);
      }
    });
    timer = Timer.periodic(const Duration(seconds: 10), (timer) {
      int status = 0;
      if (LeooVideoCallJunPro.leooOpenJunPro) {
        status = 1;
      } else if (LeooVideoUtilsJunPro.instance.rtmLogin) {
        status = 2;
      }
      LeooMainDaoJunPro.leooOnlineHeartbeatJunPro(status);
    });
    LeooMainDaoJunPro.leooOnlineHeartbeatJunPro(2);
    Future.delayed(const Duration(milliseconds: 500), () {
      setBackground();
    });
  }

  Future setBackground() async {
    try {
      if (!FlutterBackground.isBackgroundExecutionEnabled &&
          SpUtil.getBool(LeooAppConfigJunPro.leooBackgroundJunPro) == true) {
        bool init = await getBackground();
        if (init) {
          await FlutterBackground.enableBackgroundExecution();
        }
      }
    } catch (e) {
      LeooNetConfigJunPro.leooPrintLogJunPro(e);
    }
  }

  Future<bool> getBackground() async {
    try {
      final androidConfig = FlutterBackgroundAndroidConfig(
        notificationTitle: LeooNetConfigJunPro.leooAppNameJunPro,
        notificationText:
            S.of(context).backgroundTip(LeooNetConfigJunPro.leooAppNameJunPro),
        notificationImportance: AndroidNotificationImportance.Default,
        notificationIcon:
            const AndroidResource(name: 'ic_launcher', defType: 'drawable'),
      );
      return await FlutterBackground.initialize(androidConfig: androidConfig);
    } catch (e) {
      LeooNetConfigJunPro.leooPrintLogJunPro(e);
      return false;
    }
  }

  @override
  void didChangeAppLifecycleState(AppLifecycleState state) {
    super.didChangeAppLifecycleState(state);
    if (state == AppLifecycleState.resumed) {
      if (!LeooVideoUtilsJunPro.instance.isReception) {
        LeooVideoUtilsJunPro.instance.isReception = true;
        if (Platform.isAndroid) {
          LeooRechargeUtilsJunPro.instance.queryPastPurchases();
        }
        LeooVideoUtilsJunPro.instance.onReceivedByPeer(context);
        FlutterAppBadger.updateBadgeCount(unreadCount);
        LeooRechargeUtilsJunPro.instance.flutterLocalNotificationsPlugin
            .cancelAll();
        LeooCommonUtilsJunPro.leooCheckIsCurrentJunPro(context, () {
          eventBus.fire(LeooMsgListEventJunPro());
          getUserInfo();
        });
      }
    } else if (state == AppLifecycleState.paused) {
      LeooVideoUtilsJunPro.instance.isReception = false;
      if (localStr.isEmpty) {
        localStr.add(LeooStringJunPro.leooStrNotificationTip1JunPro);
        localStr.add(LeooStringJunPro.leooStrNotificationTip2JunPro);
        localStr.add(LeooStringJunPro.leooStrNotificationTip3JunPro);
        localStr.add(LeooStringJunPro.leooStrNotificationTip4JunPro);
        localStr.add(LeooStringJunPro.leooStrNotificationTip5JunPro);
        localStr.add(LeooStringJunPro.leooStrNotificationTip6JunPro);
        localStr.add(LeooStringJunPro.leooStrNotificationTip7JunPro);
        localStr.add(LeooStringJunPro.leooStrNotificationTip8JunPro);
        localStr.add(LeooStringJunPro.leooStrNotificationTip9JunPro);
        localStr.add(LeooStringJunPro.leooStrNotificationTip10JunPro);
      }
      backTimer?.cancel();
      backTimer = Timer(const Duration(seconds: 8), () async {
        if (!LeooVideoUtilsJunPro.instance.isReception) {
          var time = DateTime.fromMillisecondsSinceEpoch(
              DateTime.now().millisecondsSinceEpoch + 500);
          LeooRechargeUtilsJunPro.instance.flutterLocalNotificationsPlugin.show(
              time.millisecond,
              LeooNetConfigJunPro.leooAppNameJunPro,
              localStr[Random().nextInt(9) + 1],
              LeooRechargeUtilsJunPro.instance.platformChannelSpecifics);
        }
      });
    }
  }

  @override
  void didChangeDependencies() {
    super.didChangeDependencies();
    LeooRouterJunPro.leooRouteObserverJunPro
        .subscribe(this, ModalRoute.of(context) as PageRoute<dynamic>);
  }

  @override
  void didPopNext() {
    super.didPopNext();
    LeooCommonUtilsJunPro.leooCheckIsCurrentJunPro(context, () {
      getUserInfo();
    });
  }

  @override
  void dispose() {
    timer.cancel();
    subscription.cancel();
    subscriptionRecharge.cancel();
    LeooImUtilsJunPro.instance.connectIM();
    LeooVideoUtilsJunPro.instance.logoutRtmClient();
    WidgetsBinding.instance!.removeObserver(this);
    LeooRouterJunPro.leooRouteObserverJunPro.unsubscribe(this);
    LeooImUtilsJunPro.instance.imPluginDelegateList.remove(this);
    LeooVideoUtilsJunPro.instance.rtmPluginDelegateList.remove(this);
    super.dispose();
  }

  void initIM(LeooUserEntity? userInfo) async {
    await LeooImUtilsJunPro.instance.connectIM(
        context: context,
        userId: userInfo?.id.toString(),
        name: userInfo?.nickname,
        headImage: userInfo?.header);
  }

  @override
  Widget build(BuildContext context) {
    LeooRouterJunPro.leooContextJunPro = context;
    return Consumer(
      builder: (_, LeooUserProviderJunPro userProvider, __) {
        uProvider = userProvider;
        if (!_load) {
          _load = true;
          initIM(userProvider.userEntity);
          getUserInfo();
          getNewRecharge(first: true);
        }
        return WillPopScope(
          onWillPop: () =>
              LeooCommonUtilsJunPro.leooDialogExitAppJunPro(context),
          child: Scaffold(
            resizeToAvoidBottomInset: false,
            body: Stack(
              children: <Widget>[
                LeooTabBarWidgetJunPro(
                  [
                    custom_tabs.Tab(
                      icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                        LeooMainJunPro.leooCurIndexJunPro == 0
                            ? LeooIconsJunPro.leooMainListJunPro
                            : LeooIconsJunPro.leooMainListNoJunPro,
                        width: 30.w,
                        height: 30.w,
                      ),
                    ),
                    custom_tabs.Tab(
                      icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                        LeooMainJunPro.leooCurIndexJunPro == 1
                            ? LeooIconsJunPro.leooMainVideoJunPro
                            : LeooIconsJunPro.leooMainVideoNoJunPro,
                        width: 30.w,
                        height: 30.w,
                      ),
                    ),
                    custom_tabs.Tab(
                      icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                        LeooMainJunPro.leooCurIndexJunPro == 2
                            ? LeooIconsJunPro.leooMainMatchJunPro
                            : LeooIconsJunPro.leooMainMatchNoJunPro,
                        width: 30.w,
                        height: 30.w,
                      ),
                    ),
                    custom_tabs.Tab(
                      icon: Badge(
                        showBadge: unreadCount > 0,
                        padding: EdgeInsets.all(unreadCount >= 10 ? 3.w : 5.w),
                        badgeContent: Text(
                          unreadCount > 99 ? '99+' : '$unreadCount',
                          style: LeooTextJunPro.leooGetTextStyleJunPro(12),
                        ),
                        child: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                          LeooMainJunPro.leooCurIndexJunPro == 3
                              ? LeooIconsJunPro.leooMainMsgJunPro
                              : LeooIconsJunPro.leooMainMsgNoJunPro,
                          width: 30.w,
                          height: 30.w,
                        ),
                      ),
                    ),
                    custom_tabs.Tab(
                      icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                        LeooMainJunPro.leooCurIndexJunPro == 4
                            ? LeooIconsJunPro.leooMainSetJunPro
                            : LeooIconsJunPro.leooMainSetNoJunPro,
                        width: 30.w,
                        height: 30.w,
                      ),
                    ),
                  ],
                  const [
                    LeooListJunPro(),
                    LeooVideoJunPro(),
                    LeooMatJunPro(),
                    LeooMsgJunPro(),
                    LeooMineJunPro(),
                  ],
                  type: LeooTabBarWidgetJunPro.leooTabBottomJunPro,
                  pageController: pageController,
                  position: LeooMainJunPro.leooCurIndexJunPro,
                  onPageChanged: (index) {
                    LeooMainJunPro.leooCurIndexJunPro = index;
                    if (index == 4) {
                      getUserInfo();
                    }
                    eventBus.fire(LeooHomeEventJunPro(start: index == 2));
                    LeooCodeUtilsJunPro.onSetState(this);
                  },
                ),
                if (rechargeBean != null)
                  LeooMoveStackWidgetJunPro(
                    InkWell(
                      child: LeooCommonUtilsJunPro.leooLottieJunPro(
                        LeooIconsJunPro.leooNewUserJunPro,
                        width: 55.w,
                        height: 55.w,
                      ),
                      onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                        showNewRecharge();
                      }),
                    ),
                    1.sw - 65.w,
                    1.sh - 120.w - ScreenUtil().bottomBarHeight,
                    width: 55.w,
                  ),
              ],
            ),
          ),
        );
      },
    );
  }

  void getUserInfo() {
    LeooMainDaoJunPro.leooUserInfoJunPro(uProvider);
  }

  Future showNewRecharge() {
    showRecharge = true;
    return LeooDialogUtilsJunPro.instance
        .showNewDialog(context, rechargeBean)
        .then((value) {
      showRecharge = false;
      return value;
    });
  }

  void getNewRecharge({bool first = false}) {
    if (uProvider.userEntity.userType == 1) {
      return;
    }
    LeooMainDaoJunPro.leooListConfigJunPro(1).then((res) {
      if (res.result) {
        List<LeooRechargeEntity> rechargePay = res.data;
        if (rechargePay.isNotEmpty) {
          rechargeBean = rechargePay.first;
          LeooCodeUtilsJunPro.onSetState(this);
          if (first) {
            showNewRecharge().then((value) => getSignInfo());
          } else {
            getSignInfo();
          }
          return;
        }
      }
      rechargeBean = null;
      LeooCodeUtilsJunPro.onSetState(this);
      getSignInfo();
    });
  }

  void getUnreadCount() async {
    try {
      unreadCount =
          await EMClient.getInstance.chatManager.getUnreadMessageCount();
      FlutterAppBadger.updateBadgeCount(unreadCount);
      LeooCodeUtilsJunPro.onSetState(this);
    } catch (e) {
      LeooNetConfigJunPro.leooPrintLogJunPro(e);
    }
  }

  void getSignInfo() {
    LeooMainDaoJunPro.leooSignInfoJunPro().then((res) async {
      if (res.result) {
        LeooDialogUtilsJunPro.instance
            .showSignInfoDialog(context, res.data, uProvider, checkShow: true)
            ?.then((value) {
          if (value == true) {
            LeooDialogUtilsJunPro.instance.signReward(context, uProvider);
          }
        });
      } else {
        LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
      }
    });
  }

  @override
  void onMessageReceived(List<EMMessage> messages) {
    getUnreadCount();
    for (var element in messages) {
      LeooVideoUtilsJunPro.instance.receivedByPeerShow(context, element);
      if (element.body is EMCustomMessageBody) {
        EMCustomMessageBody body = element.body as EMCustomMessageBody;
        if (body.event == LeooAppConfigJunPro.leooGiftEventJunPro) {
          LeooGiftEntity gift =
              LeooGiftEntity.fromJson(body.params!.cast<String, dynamic>());
          LeooRechargeUtilsJunPro.instance.showGiftView(context, gift);
        }
      }
    }
  }

  @override
  void onConnectionStatusChange(bool connected) {
    if (connected) {
      getUnreadCount();
    }
  }

  @override
  void onRtmMessageReceived(LeooRtmEntity rtmEntity) {
    if (rtmEntity.type == 4) {
      LeooCommonUtilsJunPro.leooCheckIsCurrentJunPro(context, () {
        LeooVideoCallJunPro.leooOpenCloseJunPro = true;
      }, () {
        if (LeooVideoCallJunPro.leooOpenJunPro &&
            !LeooRechargeNewJunPro.leooOpenJunPro) {
          LeooVideoCallJunPro.leooOpenJunPro = false;
          LeooNavigatorUtilsJunPro.leooPopUntilJunPro(
              context,
              LeooAppConfigJunPro.leooMainNameJunPro ??
                  LeooMainJunPro.leooNameJunPro);
        }
      });
    }
  }

  @override
  void onRemoteInvitationCanceled(AgoraRtmRemoteInvitation invite) {
    if (LeooVideoCallJunPro.leooOpenJunPro &&
        !LeooRechargeNewJunPro.leooOpenJunPro) {
      LeooVideoCallJunPro.leooOpenJunPro = false;
      LeooNavigatorUtilsJunPro.leooPopUntilJunPro(
          context,
          LeooAppConfigJunPro.leooMainNameJunPro ??
              LeooMainJunPro.leooNameJunPro);
    }
  }
}
