import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leoonetconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoowidgetutilsjunpro.dart';
import 'package:webview_flutter/webview_flutter.dart';

///内部网页
class LeooWebViewJunPro extends StatefulWidget {
  final String webTitle;
  final String webUrl;
  final bool back;

  const LeooWebViewJunPro(this.webTitle, this.webUrl,
      {Key? key, this.back = false})
      : super(key: key);

  @override
  _LeooWebViewState createState() => _LeooWebViewState();
}

class _LeooWebViewState extends State<LeooWebViewJunPro> {
  int status = LeooCommonUtilsJunPro.leooPageStatusLoadingJunPro;
  bool canBack = false;
  WebViewController? controller;
  FocusNode focusNode = FocusNode();
  late String webTitle;

  @override
  void initState() {
    super.initState();
    webTitle = widget.webTitle;
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      resizeToAvoidBottomInset: false,
      body: SafeArea(
        maintainBottomViewPadding: true,
        child: Column(
          children: <Widget>[
            LeooWidgetUtilsJunPro.leooGetAppBarWidgetJunPro(
              context,
              webTitle,
              rightChild: canBack
                  ? InkWell(
                      child: Padding(
                        padding: EdgeInsets.fromLTRB(12.w, 6.w, 12.w, 6.w),
                        child: Text(S.of(context).appBack,
                            style: status ==
                                        LeooCommonUtilsJunPro
                                            .leooPageStatusSuccessJunPro &&
                                    canBack
                                ? LeooTextJunPro.leooGetTextStyleJunPro(14)
                                : LeooTextJunPro.leooGetTextStyleHintJunPro(
                                    14)),
                      ),
                      onTap:
                          LeooNavigatorUtilsJunPro.leooDebounceJunPro(() async {
                        if (status ==
                                LeooCommonUtilsJunPro
                                    .leooPageStatusSuccessJunPro &&
                            await controller?.canGoBack() == true) {
                          controller?.goBack();
                          status =
                              LeooCommonUtilsJunPro.leooPageStatusLoadingJunPro;
                          LeooCodeUtilsJunPro.onSetState(this);
                        }
                      }),
                    )
                  : null,
            ),
            Expanded(
              child: Stack(
                children: <Widget>[
                  TextField(focusNode: focusNode),
                  WebView(
                    debuggingEnabled: LeooNetConfigJunPro.leooDeBugJunPro,
                    initialUrl: widget.webUrl,
                    javascriptMode: JavascriptMode.unrestricted,
                    onWebViewCreated: (controller) =>
                        this.controller = controller,
                    onPageStarted: (url) {
                      status =
                          LeooCommonUtilsJunPro.leooPageStatusProgressJunPro;
                      LeooCodeUtilsJunPro.onSetState(this);
                    },
                    onPageFinished: (url) async {
                      canBack = await controller?.canGoBack() ?? false;
                      status =
                          LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro;
                      LeooCodeUtilsJunPro.onSetState(this);
                      if (await controller?.canGoBack() == true) {
                        FocusScope.of(context).requestFocus(focusNode);
                        Future.delayed(const Duration(milliseconds: 500), () {
                          FocusScope.of(context).unfocus();
                        });
                      }
                    },
                  ),
                  if (status !=
                      LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro)
                    Container(
                      color: LeooColorsJunPro.leooBgJunPro,
                      child: LeooCommonUtilsJunPro.leooCheckPageStatusJunPro(
                          context, status),
                    ),
                ],
              ),
            ),
          ],
        ),
      ),
    );
  }
}
