import 'dart:async';
import 'dart:core';

import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leooappconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooeventjunpro/leooindexjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooeventjunpro/leoomaineventjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooproviderjunpro/leoouserproviderjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoodialogutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoomediautilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoorechargeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoowidgetutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoobuttonwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoospinwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leootextwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoowidgetjunpro/leoonumbertextwidgetjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoocalljunpro/leoovideocalljunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoomainjunpro/leoomainjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoomatjunpro/leoomatwaitjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leootopjunpro/leootopjunpro.dart';
import 'package:leoo_junpro/leoorouterjunpro.dart';
import 'package:provider/provider.dart';
import 'package:sp_util/sp_util.dart';

///房间等待-new
class LeooMatNewJunPro extends StatefulWidget {
  const LeooMatNewJunPro({Key? key}) : super(key: key);

  @override
  _LeooMatchState createState() => _LeooMatchState();
}

class _LeooMatchState extends State<LeooMatNewJunPro>
    with
        AutomaticKeepAliveClientMixin<LeooMatNewJunPro>,
        RouteAware,
        WidgetsBindingObserver {
  @override
  bool get wantKeepAlive => true;
  GlobalKey<LeooButtonWidgetState> buttonKey = GlobalKey();
  Timer? timer;
  int lastSize = 0;
  GlobalKey<LeooNumberTextWidgetState> timeKey = GlobalKey();
  late StreamSubscription subscription;

  @override
  void initState() {
    super.initState();
    WidgetsBinding.instance!.addObserver(this);
    lastSize = SpUtil.getInt(LeooAppConfigJunPro.leooMatchJunPro,
        defValue: LeooRechargeUtilsJunPro.instance.getRoomSize(lastSize))!;
    subscription = eventBus.on<LeooHomeEventJunPro>().listen((event) {
      if (event.start) {
        startTimer();
      } else {
        timer?.cancel();
      }
    });
    startTimer();
  }

  @override
  void didChangeAppLifecycleState(AppLifecycleState state) {
    super.didChangeAppLifecycleState(state);
    if (state == AppLifecycleState.resumed) {
      if (!LeooVideoCallJunPro.leooOpenJunPro) {
        startTimer();
      }
    } else if (state == AppLifecycleState.paused) {
      timer?.cancel();
    }
  }

  @override
  void didChangeDependencies() {
    super.didChangeDependencies();
    LeooRouterJunPro.leooRouteObserverJunPro
        .subscribe(this, ModalRoute.of(context) as PageRoute<dynamic>);
  }

  @override
  void didPopNext() {
    super.didPopNext();
    startTimer();
  }

  @override
  void didPushNext() {
    super.didPushNext();
    timer?.cancel();
    LeooCodeUtilsJunPro.onSetState(this);
  }

  void startTimer() {
    LeooCommonUtilsJunPro.leooCheckIsCurrentJunPro(context, () {
      if (LeooMainJunPro.leooCurIndexJunPro == 2) {
        timer?.cancel();
        timer = Timer.periodic(const Duration(seconds: 3), (timer) {
          LeooCommonUtilsJunPro.leooCheckIsCurrentJunPro(context, () {
            if (LeooMainJunPro.leooCurIndexJunPro != 2) {
              timer.cancel();
              SpUtil.putInt(LeooAppConfigJunPro.leooMatchJunPro, lastSize);
            } else {
              lastSize = LeooRechargeUtilsJunPro.instance.getRoomSize(lastSize);
              SpUtil.putInt(LeooAppConfigJunPro.leooMatchJunPro, lastSize);
              timeKey.currentState?.onSetState(lastSize);
            }
          }, () {
            timer.cancel();
            SpUtil.putInt(LeooAppConfigJunPro.leooMatchJunPro, lastSize);
          });
        });
      }
    });
  }

  @override
  void dispose() {
    WidgetsBinding.instance!.removeObserver(this);
    LeooRouterJunPro.leooRouteObserverJunPro.unsubscribe(this);
    timer?.cancel();
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    super.build(context);
    return Consumer<LeooUserProviderJunPro>(
        builder: (_, LeooUserProviderJunPro userProvider, __) {
      return SafeArea(
        maintainBottomViewPadding: true,
        child: Column(
          children: [
            SizedBox(height: 5.w),
            Row(
              children: [
                SizedBox(width: 15.w),
                Expanded(
                  child: Text(S.of(context).matchCall.toUpperCase(),
                      style: LeooTextJunPro.leooGetTextStyleAppJunPro(
                          24, FontWeight.bold)),
                ),
                Row(
                  children: [
                    IconButton(
                      iconSize: 40.w,
                      padding: const EdgeInsets.all(0),
                      icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                        LeooIconsJunPro.leooMainRankJunPro,
                        width: 40.w,
                        height: 40.w,
                      ),
                      onPressed:
                          LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                        LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
                            context, const LeooTopJunPro(), 'LeooTopJunPro');
                      }),
                    ),
                    if (userProvider.userEntity.userType == 0)
                      LeooWidgetUtilsJunPro.leooGetMainCoinsWidgetJunPro(
                          context, userProvider.userEntity.amount),
                  ],
                ),
                SizedBox(width: 15.w),
              ],
            ),
            Expanded(
              child: Column(
                children: [
                  Expanded(
                    child: Hero(
                      tag: 'LeooMatWaitJunPro',
                      transitionOnUserGestures: true,
                      child: Stack(
                        alignment: Alignment.center,
                        children: [
                          LeooCommonUtilsJunPro.leooLottieJunPro(
                            LeooIconsJunPro.leooMatWaitJunPro,
                            width: 1.sw,
                            height: 1.sw,
                          ),
                          LeooSpinWidgetJunPro(
                            seconds: 15,
                            child: Container(
                              width: 120.w,
                              height: 120.w,
                              decoration: ShapeDecoration(
                                shape: CircleBorder(
                                  side: BorderSide(
                                    color: LeooColorsJunPro.leooLine3JunPro,
                                    width: 4.w,
                                  ),
                                ),
                              ),
                              child: ClipOval(
                                child: LeooCommonUtilsJunPro
                                    .leooGetLoadWidgetJunPro(
                                  userProvider.userEntity.header,
                                  width: 120.w,
                                  height: 120.w,
                                  load: LeooIconsJunPro.leooLoadHeadJunPro,
                                ),
                              ),
                            ),
                          ),
                        ],
                      ),
                    ),
                  ),
                  Column(
                    children: [
                      lastSize != 0
                          ? LeooNumberTextWidgetJunPro(
                              timeKey,
                              LeooTextJunPro.leooGetTextStyleJunPro(
                                  40, FontWeight.bold),
                              lastSize)
                          : Text('----',
                              style: LeooTextJunPro.leooGetTextStyleJunPro(
                                  40, FontWeight.bold)),
                      Text(
                        S.of(context).matchPeople,
                        style: LeooTextJunPro.leooGetTextStyleJunPro(
                            16, FontWeight.bold),
                      ),
                      SizedBox(height: 10.w),
                      LeooTextWidgetJunPro(
                        userProvider.userEntity.userType == 1
                            ? S.of(context).matchCallCoins(
                                LeooAppConfigJunPro.leooMatchingCostJunPro)
                            : S.of(context).coinsMatch(
                                LeooAppConfigJunPro.leooMatchingCostJunPro),
                        LeooTextJunPro.leooGetTextStyleJunPro(14),
                        iconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                          LeooIconsJunPro.leooMainCoinsJunPro,
                          width: 20.w,
                          height: 20.w,
                        ),
                        iconPadding: 2.5.w,
                        padding: EdgeInsets.fromLTRB(8.w, 5.w, 10.w, 5.w),
                        decoration: ShapeDecoration(
                            shape: StadiumBorder(),
                            color: LeooColorsJunPro.leooBtnBgJunPro),
                        mainAxisSize: MainAxisSize.min,
                      ),
                      SizedBox(height: 30.w),
                      Padding(
                        padding: EdgeInsets.only(left: 40.w, right: 40.w),
                        child: LeooButtonWidgetJunPro(
                          S.of(context).matchStart,
                          LeooTextJunPro.leooGetTextStyleJunPro(
                              20, FontWeight.bold),
                          shape: const RoundedRectangleBorder(
                            borderRadius: BorderRadius.all(Radius.circular(20)),
                          ),
                          color: LeooColorsJunPro.leooAppJunPro,
                          colorRight: LeooColorsJunPro.leooApp2JunPro,
                          onPressed:
                              LeooNavigatorUtilsJunPro.leooDebounceJunPro(
                                  () async {
                            if (await LeooMediaUtilsJunPro.instance
                                    .grantedPermissions(context) ==
                                true) {
                              LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
                                context,
                                LeooMatWaitJunPro(
                                    userProvider.userEntity.userType == 0),
                                'LeooMatchWaitJunPro',
                                fullscreenDialog: true,
                                match: true,
                                center: Offset(.5.sw, .5.sh),
                              );
                            } else {
                              LeooDialogUtilsJunPro.instance
                                  .showPermissionDialog(context, (value) {
                                if (value) {
                                  LeooNavigatorUtilsJunPro
                                      .leooNavigatorPushJunPro(
                                    context,
                                    LeooMatWaitJunPro(
                                        userProvider.userEntity.userType == 0),
                                    'LeooMatchWaitJunPro',
                                    fullscreenDialog: true,
                                    match: true,
                                    center: Offset(.5.sw, .5.sh),
                                  );
                                }
                              });
                            }
                          }),
                        ),
                      ),
                      SizedBox(height: 40.w),
                    ],
                  ),
                ],
              ),
            ),
          ],
        ),
      );
    });
  }
}
