import 'package:auto_size_text/auto_size_text.dart';
import 'package:collection/collection.dart';
import 'package:country_pickers/country_picker_dialog.dart';
import 'package:flutter/material.dart';
import 'package:flutter_picker/flutter_picker.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leooappconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoomaindaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoolanguageentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoouserentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooproviderjunpro/leoouserproviderjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocountryutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoodialogutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoowidgetutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoobuttonwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leooedittextwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoowidgetjunpro/leookeyboardheightwidgetjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoomejunpro/leooapplyokjunpro.dart';
import 'package:provider/provider.dart';

class LeooApplyEditJunPro extends StatefulWidget {
  const LeooApplyEditJunPro({Key? key}) : super(key: key);

  @override
  _LeooApplyState createState() => _LeooApplyState();
}

class _LeooApplyState extends State<LeooApplyEditJunPro> {
  bool first = true;
  int status = LeooCommonUtilsJunPro.leooPageStatusLoadingJunPro;
  FocusNode focusNode = FocusNode();
  FocusNode focusNode1 = FocusNode();
  FocusNode focusNode2 = FocusNode();
  FocusNode focusNode3 = FocusNode();
  FocusNode focusNode4 = FocusNode();
  FocusNode focusNode5 = FocusNode();
  FocusNode focusNode6 = FocusNode();
  late LeooUserEntity userEntity;
  List<String> _userPic = [];
  int cover = 0;
  List<LeooLanguageEntity> languageList = [];
  List<LeooLanguageEntity> tagList = [];
  List<String> cupList = [];

  @override
  void initState() {
    super.initState();
    getLanguageList();
  }

  void getLanguageList() {
    LeooMainDaoJunPro.leooGetLanguageListJunPro().then((res) async {
      if (res.result) {
        languageList.addAll(res.data);
        getTagList();
      } else {
        LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
        status = LeooCommonUtilsJunPro.leooPageStatusErrorJunPro;
        LeooCodeUtilsJunPro.onSetState(this);
      }
    });
  }

  void getTagList() {
    LeooMainDaoJunPro.leooGetTagListJunPro().then((res) async {
      if (res.result) {
        tagList = res.data;
        cupList = [
          S.of(context).applyCup1,
          S.of(context).applyCup2,
          S.of(context).applyCup3,
          S.of(context).applyCup4,
          S.of(context).applyCup5
        ];
        status = LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro;
        LeooCodeUtilsJunPro.onSetState(this);
      } else {
        LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
        status = LeooCommonUtilsJunPro.leooPageStatusErrorJunPro;
        LeooCodeUtilsJunPro.onSetState(this);
      }
    });
  }

  @override
  Widget build(BuildContext context) {
    return Consumer<LeooUserProviderJunPro>(
        builder: (_, LeooUserProviderJunPro userProvider, __) {
      if (first) {
        first = false;
        userEntity = userProvider.userEntity;
        _userPic = userEntity.albums ?? [];
        userEntity.heightUnit ??= 1;
        userEntity.weightUnit ??= 1;
      }
      return WillPopScope(
        onWillPop: () {
          return Future.value(true);
        },
        child: GestureDetector(
          behavior: HitTestBehavior.opaque,
          onTap: () {
            focusNode.unfocus();
            focusNode1.unfocus();
            focusNode2.unfocus();
            focusNode3.unfocus();
            focusNode4.unfocus();
            focusNode5.unfocus();
            focusNode6.unfocus();
          },
          child: Scaffold(
            resizeToAvoidBottomInset: false,
            body: SafeArea(
              maintainBottomViewPadding: true,
              child: Column(
                children: [
                  LeooWidgetUtilsJunPro.leooGetAppBarWidgetJunPro(
                      context, S.of(context).mineAnchorEdit),
                  Expanded(
                    child: status !=
                            LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro
                        ? LeooCommonUtilsJunPro.leooCheckPageStatusJunPro(
                            context,
                            status,
                            onTap: () {
                              status = LeooCommonUtilsJunPro
                                  .leooPageStatusLoadingJunPro;
                              LeooCodeUtilsJunPro.onSetState(this);
                              getLanguageList();
                            },
                          )
                        : SingleChildScrollView(
                            physics: const BouncingScrollPhysics(),
                            child: Column(
                              crossAxisAlignment: CrossAxisAlignment.start,
                              children: [
                                Padding(
                                  padding:
                                      EdgeInsets.only(left: 10.w, right: 10.w),
                                  child: GridView.builder(
                                    shrinkWrap: true,
                                    physics:
                                        const NeverScrollableScrollPhysics(),
                                    itemCount: 9,
                                    gridDelegate:
                                        SliverGridDelegateWithFixedCrossAxisCount(
                                            crossAxisCount: 3,
                                            childAspectRatio: .77,
                                            mainAxisSpacing: 5.w,
                                            crossAxisSpacing: 5.w),
                                    itemBuilder:
                                        (BuildContext itemContext, int index) {
                                      if (index < _userPic.length) {
                                        return getPicChildWidget(
                                            _userPic[index], index);
                                      } else {
                                        return InkWell(
                                          child: ClipRRect(
                                            borderRadius:
                                                BorderRadius.circular(10),
                                            child: LeooCommonUtilsJunPro
                                                .leooGetLoadWidgetJunPro(
                                              LeooIconsJunPro
                                                  .leooAboutAddJunPro,
                                              width: .3.sw,
                                              height: 150.w,
                                              fit: BoxFit.cover,
                                            ),
                                          ),
                                          onTap: LeooNavigatorUtilsJunPro
                                              .leooDebounceJunPro(() {
                                            LeooDialogUtilsJunPro.instance
                                                .showImageView(context, (path) {
                                              if (path.length +
                                                      _userPic.length >
                                                  9) {
                                                _userPic.addAll(path.sublist(
                                                    0, 9 - _userPic.length));
                                              } else {
                                                _userPic.addAll(path);
                                              }
                                              LeooCodeUtilsJunPro.onSetState(
                                                  this);
                                            }, multi: true);
                                          }),
                                        );
                                      }
                                    },
                                  ),
                                ),
                                SizedBox(height: 10.w),
                                Padding(
                                  padding: EdgeInsets.only(
                                      left: 15.w, right: 15.w, bottom: 15.w),
                                  child: Column(
                                    crossAxisAlignment:
                                        CrossAxisAlignment.start,
                                    children: [
                                      Text(S.of(context).aboutCoverHint,
                                          style: LeooTextJunPro
                                              .leooGetTextStyleRedJunPro(16)),
                                      SizedBox(height: 20.w),
                                      Container(
                                        decoration: BoxDecoration(
                                          borderRadius:
                                              BorderRadius.circular(20),
                                          color: Colors.white.withOpacity(.1),
                                        ),
                                        padding: EdgeInsets.fromLTRB(
                                            15.w, 5.w, 15.w, 5.w),
                                        child: Row(
                                          children: [
                                            Text(
                                              S.of(context).aboutName,
                                              style: LeooTextJunPro
                                                  .leooGetTextStyleHintJunPro(
                                                      16, FontWeight.bold),
                                            ),
                                            Expanded(
                                              child: LeooEditTextWidgetJunPro(
                                                  keyboardType:
                                                      ITextInputType.text,
                                                  maxLines: 1,
                                                  textStyle: LeooTextJunPro
                                                      .leooGetTextStyleJunPro(
                                                          18, FontWeight.bold),
                                                  inputText:
                                                      userEntity.nickname ?? '',
                                                  fieldCallBack: (content) {
                                                    userEntity.nickname =
                                                        content;
                                                  },
                                                  focusNode: focusNode,
                                                  textAlign: TextAlign.end,
                                                  contentPadding:
                                                      EdgeInsets.fromLTRB(
                                                          13.w, 13.w, 0, 13.w),
                                                  hintText:
                                                      S.of(context).aboutName,
                                                  hintStyle: LeooTextJunPro
                                                      .leooGetTextStyleHintJunPro(
                                                          18, FontWeight.bold),
                                                  inputMaxLength: 100),
                                            ),
                                          ],
                                        ),
                                      ),
                                      SizedBox(height: 15.w),
                                      InkWell(
                                        child: Container(
                                          decoration: BoxDecoration(
                                            borderRadius:
                                                BorderRadius.circular(20),
                                            color: Colors.white.withOpacity(.1),
                                          ),
                                          padding: EdgeInsets.fromLTRB(
                                              15.w, 18.w, 15.w, 18.w),
                                          child: Row(
                                            children: [
                                              Expanded(
                                                child: Text(
                                                  S.of(context).aboutAge,
                                                  style: LeooTextJunPro
                                                      .leooGetTextStyleHintJunPro(
                                                          16, FontWeight.bold),
                                                ),
                                              ),
                                              Text(
                                                (userEntity.age ?? 0) > 0
                                                    ? '${userEntity.age}'
                                                    : S.of(context).aboutAge,
                                                style: (userEntity.age ?? 0) > 0
                                                    ? LeooTextJunPro
                                                        .leooGetTextStyleJunPro(
                                                            20, FontWeight.bold)
                                                    : LeooTextJunPro
                                                        .leooGetTextStyleHintJunPro(
                                                            20,
                                                            FontWeight.bold),
                                              ),
                                            ],
                                          ),
                                        ),
                                        onTap: LeooNavigatorUtilsJunPro
                                            .leooDebounceJunPro(() {
                                          LeooWidgetUtilsJunPro
                                              .leooShowPickerWidgetJunPro(
                                            context,
                                            NumberPickerAdapter(data: [
                                              const NumberPickerColumn(
                                                  begin: 18, end: 80),
                                            ]),
                                            [(userEntity.age ?? 18) - 18],
                                            S.of(context).aboutAge,
                                            (Picker picker, List value) {
                                              userEntity.age =
                                                  picker.getSelectedValues()[0];
                                              LeooCodeUtilsJunPro.onSetState(
                                                  this);
                                            },
                                          );
                                        }),
                                      ),
                                      SizedBox(height: 15.w),
                                      InkWell(
                                        child: Container(
                                          decoration: BoxDecoration(
                                            borderRadius:
                                                BorderRadius.circular(20),
                                            color: Colors.white.withOpacity(.1),
                                          ),
                                          padding: EdgeInsets.fromLTRB(
                                              15.w, 18.w, 15.w, 18.w),
                                          child: Row(
                                            children: [
                                              Expanded(
                                                child: Text(
                                                  S.of(context).aboutGender,
                                                  style: LeooTextJunPro
                                                      .leooGetTextStyleHintJunPro(
                                                          16, FontWeight.bold),
                                                ),
                                              ),
                                              Text(
                                                userEntity.gender == 1
                                                    ? S.of(context).aboutMale
                                                    : userEntity.gender == 2
                                                        ? S
                                                            .of(context)
                                                            .aboutFemale
                                                        : S
                                                            .of(context)
                                                            .aboutGender,
                                                style: userEntity.gender == 1 ||
                                                        userEntity.gender == 2
                                                    ? LeooTextJunPro
                                                        .leooGetTextStyleJunPro(
                                                            20, FontWeight.bold)
                                                    : LeooTextJunPro
                                                        .leooGetTextStyleHintJunPro(
                                                            20,
                                                            FontWeight.bold),
                                              ),
                                            ],
                                          ),
                                        ),
                                        onTap: LeooNavigatorUtilsJunPro
                                            .leooDebounceJunPro(() {
                                          List<String> list = [
                                            S.of(context).aboutGenderHide,
                                            S.of(context).aboutMale,
                                            S.of(context).aboutFemale
                                          ];
                                          LeooWidgetUtilsJunPro
                                              .leooShowPickerWidgetJunPro(
                                            context,
                                            PickerDataAdapter<String>(
                                                pickerdata: list),
                                            [userEntity.gender ?? 0],
                                            S.of(context).aboutGender,
                                            (Picker picker, List value) {
                                              userEntity.gender =
                                                  picker.selecteds[0];
                                              LeooCodeUtilsJunPro.onSetState(
                                                  this);
                                            },
                                          );
                                        }),
                                      ),
                                      SizedBox(height: 15.w),
                                      InkWell(
                                        child: Container(
                                          decoration: BoxDecoration(
                                            borderRadius:
                                                BorderRadius.circular(20),
                                            color: Colors.white.withOpacity(.1),
                                          ),
                                          padding: EdgeInsets.fromLTRB(
                                              15.w, 18.w, 15.w, 18.w),
                                          child: Row(
                                            children: [
                                              Expanded(
                                                child: Text(
                                                    S.of(context).aboutCountry,
                                                    style: LeooTextJunPro
                                                        .leooGetTextStyleHintJunPro(
                                                            16,
                                                            FontWeight.bold)),
                                              ),
                                              Text(
                                                LeooCountryPickerUtilsJunPro
                                                            .getCountryByIsoCode(
                                                                userEntity
                                                                    .country)
                                                        ?.name ??
                                                    S.of(context).aboutCountry,
                                                style: LeooCountryPickerUtilsJunPro
                                                                .getCountryByIsoCode(
                                                                    userEntity
                                                                        .country)
                                                            ?.name
                                                            .isEmpty ==
                                                        false
                                                    ? LeooTextJunPro
                                                        .leooGetTextStyleJunPro(
                                                            20, FontWeight.bold)
                                                    : LeooTextJunPro
                                                        .leooGetTextStyleHintJunPro(
                                                            20,
                                                            FontWeight.bold),
                                              ),
                                            ],
                                          ),
                                        ),
                                        onTap: LeooNavigatorUtilsJunPro
                                            .leooDebounceJunPro(() {
                                          LeooNavigatorUtilsJunPro
                                              .leooShowBaseDialogJunPro(context,
                                                  name: 'CountryPickerDialog',
                                                  builder: (BuildContext
                                                      showContext) {
                                            return SafeArea(
                                                maintainBottomViewPadding: true,
                                                child: CountryPickerDialog(
                                                    titlePadding:
                                                        EdgeInsets.all(8.w),
                                                    searchCursorColor: LeooColorsJunPro
                                                        .leooAppJunPro,
                                                    searchInputDecoration: InputDecoration(
                                                        hintText: S
                                                            .of(context)
                                                            .aboutCountrySearch,
                                                        hintStyle: LeooTextJunPro
                                                            .leooGetTextStyleJunPro(
                                                                14)),
                                                    isSearchable: true,
                                                    title: Text(
                                                        S
                                                            .of(context)
                                                            .aboutCountryChoose,
                                                        style: LeooTextJunPro
                                                            .leooGetTextStyleJunPro(
                                                                24,
                                                                FontWeight
                                                                    .bold)),
                                                    onValuePicked: (country) {
                                                      userEntity.country =
                                                          country.isoCode;
                                                      LeooCodeUtilsJunPro
                                                          .onSetState(this);
                                                    },
                                                    itemBuilder: LeooWidgetUtilsJunPro
                                                        .leooGetCountryItemJunPro));
                                          });
                                        }),
                                      ),
                                      SizedBox(height: 15.w),
                                      Text(S.of(context).applyLanguage,
                                          style: LeooTextJunPro
                                              .leooGetTextStyleJunPro(
                                                  20, FontWeight.bold)),
                                      SizedBox(height: 10.w),
                                      GridView.builder(
                                          shrinkWrap: true,
                                          physics:
                                              const BouncingScrollPhysics(),
                                          itemCount: languageList.length,
                                          gridDelegate:
                                              SliverGridDelegateWithFixedCrossAxisCount(
                                                  crossAxisCount: 3,
                                                  childAspectRatio: 2.2,
                                                  mainAxisSpacing: 5.w,
                                                  crossAxisSpacing: 5.w),
                                          itemBuilder:
                                              (BuildContext itemContext,
                                                  int index) {
                                            LeooLanguageEntity item =
                                                languageList[index];
                                            return InkWell(
                                              child: Container(
                                                alignment: Alignment.center,
                                                decoration: BoxDecoration(
                                                  borderRadius:
                                                      BorderRadius.circular(10),
                                                  color: userEntity.languageIds
                                                              ?.firstWhereOrNull(
                                                                  (element) =>
                                                                      element ==
                                                                      item
                                                                          .id) !=
                                                          null
                                                      ? LeooColorsJunPro
                                                          .leooAppJunPro
                                                      : LeooColorsJunPro
                                                          .leooBtnBgJunPro,
                                                ),
                                                padding: EdgeInsets.all(5.w),
                                                child: AutoSizeText(
                                                  item.enName ?? '',
                                                  style: LeooTextJunPro
                                                      .leooGetTextStyleJunPro(
                                                          20, FontWeight.bold),
                                                  maxLines: 1,
                                                ),
                                              ),
                                              onTap: LeooNavigatorUtilsJunPro
                                                  .leooDebounceJunPro(() {
                                                if (userEntity.languageIds
                                                        ?.firstWhereOrNull(
                                                            (element) =>
                                                                element ==
                                                                item.id) !=
                                                    null) {
                                                  userEntity.languageIds
                                                      ?.remove(item.id!);
                                                } else {
                                                  userEntity.languageIds
                                                      ?.add(item.id!);
                                                }
                                                LeooCodeUtilsJunPro.onSetState(
                                                    this);
                                              }),
                                            );
                                          }),
                                      SizedBox(height: 15.w),
                                      Container(
                                        decoration: BoxDecoration(
                                          borderRadius:
                                              BorderRadius.circular(20),
                                          color: Colors.white.withOpacity(.1),
                                        ),
                                        padding: EdgeInsets.fromLTRB(
                                            15.w, 5.w, 5.w, 5.w),
                                        child: Row(
                                          children: [
                                            Expanded(
                                              child: Text(
                                                S.of(context).applyHeight,
                                                style: LeooTextJunPro
                                                    .leooGetTextStyleHintJunPro(
                                                        16, FontWeight.bold),
                                              ),
                                            ),
                                            Expanded(
                                              child: LeooEditTextWidgetJunPro(
                                                  keyboardType:
                                                      ITextInputType.number,
                                                  maxLines: 1,
                                                  textStyle: LeooTextJunPro
                                                      .leooGetTextStyleJunPro(
                                                          18, FontWeight.bold),
                                                  inputText:
                                                      '${userEntity.height ?? ''}',
                                                  fieldCallBack: (content) {
                                                    userEntity.height =
                                                        int.parse(content);
                                                  },
                                                  focusNode: focusNode3,
                                                  textAlign: TextAlign.end,
                                                  contentPadding:
                                                      EdgeInsets.fromLTRB(
                                                          13.w, 13.w, 0, 13.w),
                                                  hintText:
                                                      S.of(context).applyHeight,
                                                  hintStyle: LeooTextJunPro
                                                      .leooGetTextStyleHintJunPro(
                                                          18, FontWeight.bold),
                                                  inputMaxLength: 100),
                                            ),
                                            InkWell(
                                              child: Padding(
                                                padding: EdgeInsets.all(10.w),
                                                child: Text(
                                                    LeooAppConfigJunPro
                                                            .leooHeightUnitListJunPro[
                                                        (userEntity.heightUnit ??
                                                                1) -
                                                            1],
                                                    style: LeooTextJunPro
                                                        .leooGetTextStyleJunPro(
                                                            20,
                                                            FontWeight.bold)),
                                              ),
                                              onTap: LeooNavigatorUtilsJunPro
                                                  .leooDebounceJunPro(() {
                                                LeooWidgetUtilsJunPro
                                                    .leooShowPickerWidgetJunPro(
                                                  context,
                                                  PickerDataAdapter<String>(
                                                      pickerdata:
                                                          LeooAppConfigJunPro
                                                              .leooHeightUnitListJunPro),
                                                  [
                                                    (userEntity.heightUnit ??
                                                            1) -
                                                        1
                                                  ],
                                                  S.of(context).applyHeightUnit,
                                                  (Picker picker, List value) {
                                                    userEntity.heightUnit =
                                                        picker.selecteds[0] + 1;
                                                    LeooCodeUtilsJunPro
                                                        .onSetState(this);
                                                  },
                                                );
                                              }),
                                            ),
                                          ],
                                        ),
                                      ),
                                      SizedBox(height: 15.w),
                                      Container(
                                        decoration: BoxDecoration(
                                          borderRadius:
                                              BorderRadius.circular(20),
                                          color: Colors.white.withOpacity(.1),
                                        ),
                                        padding: EdgeInsets.fromLTRB(
                                            15.w, 5.w, 5.w, 5.w),
                                        child: Row(
                                          children: [
                                            Expanded(
                                              child: Text(
                                                S.of(context).applyWeight,
                                                style: LeooTextJunPro
                                                    .leooGetTextStyleHintJunPro(
                                                        16, FontWeight.bold),
                                              ),
                                            ),
                                            Expanded(
                                              child: LeooEditTextWidgetJunPro(
                                                  keyboardType:
                                                      ITextInputType.number,
                                                  maxLines: 1,
                                                  textStyle: LeooTextJunPro
                                                      .leooGetTextStyleJunPro(
                                                          18, FontWeight.bold),
                                                  inputText:
                                                      '${userEntity.weight ?? ''}',
                                                  fieldCallBack: (content) {
                                                    userEntity.weight =
                                                        int.parse(content);
                                                  },
                                                  focusNode: focusNode4,
                                                  textAlign: TextAlign.end,
                                                  contentPadding:
                                                      EdgeInsets.fromLTRB(
                                                          13.w, 13.w, 0, 13.w),
                                                  hintText:
                                                      S.of(context).applyWeight,
                                                  hintStyle: LeooTextJunPro
                                                      .leooGetTextStyleHintJunPro(
                                                          18, FontWeight.bold),
                                                  inputMaxLength: 100),
                                            ),
                                            InkWell(
                                              child: Padding(
                                                padding: EdgeInsets.all(10.w),
                                                child: Text(
                                                    LeooAppConfigJunPro
                                                            .leooWeightUnitListJunPro[
                                                        (userEntity.weightUnit ??
                                                                1) -
                                                            1],
                                                    style: LeooTextJunPro
                                                        .leooGetTextStyleJunPro(
                                                            20,
                                                            FontWeight.bold)),
                                              ),
                                              onTap: LeooNavigatorUtilsJunPro
                                                  .leooDebounceJunPro(() {
                                                LeooWidgetUtilsJunPro
                                                    .leooShowPickerWidgetJunPro(
                                                  context,
                                                  PickerDataAdapter<String>(
                                                      pickerdata:
                                                          LeooAppConfigJunPro
                                                              .leooWeightUnitListJunPro),
                                                  [
                                                    (userEntity.weightUnit ??
                                                            1) -
                                                        1
                                                  ],
                                                  S.of(context).applyWeightUnit,
                                                  (Picker picker, List value) {
                                                    userEntity.weightUnit =
                                                        picker.selecteds[0] + 1;
                                                    LeooCodeUtilsJunPro
                                                        .onSetState(this);
                                                  },
                                                );
                                              }),
                                            ),
                                          ],
                                        ),
                                      ),
                                      SizedBox(height: 15.w),
                                      Text(
                                        S.of(context).applyCup,
                                        style: LeooTextJunPro
                                            .leooGetTextStyleHintJunPro(
                                                16, FontWeight.bold),
                                      ),
                                      SizedBox(height: 10.w),
                                      GridView.builder(
                                          shrinkWrap: true,
                                          physics:
                                              const BouncingScrollPhysics(),
                                          itemCount: cupList.length,
                                          gridDelegate:
                                              SliverGridDelegateWithFixedCrossAxisCount(
                                                  crossAxisCount: 3,
                                                  childAspectRatio: 2.2,
                                                  mainAxisSpacing: 5.w,
                                                  crossAxisSpacing: 5.w),
                                          itemBuilder:
                                              (BuildContext itemContext,
                                                  int index) {
                                            String item = cupList[index];
                                            return InkWell(
                                              child: Container(
                                                alignment: Alignment.center,
                                                decoration: BoxDecoration(
                                                  borderRadius:
                                                      BorderRadius.circular(10),
                                                  color: userEntity.cupSize ==
                                                          index
                                                      ? LeooColorsJunPro
                                                          .leooAppJunPro
                                                      : LeooColorsJunPro
                                                          .leooBtnBgJunPro,
                                                ),
                                                padding: EdgeInsets.all(5.w),
                                                child: AutoSizeText(
                                                  item,
                                                  style: LeooTextJunPro
                                                      .leooGetTextStyleJunPro(
                                                          20, FontWeight.bold),
                                                  maxLines: 1,
                                                ),
                                              ),
                                              onTap: LeooNavigatorUtilsJunPro
                                                  .leooDebounceJunPro(() {
                                                userEntity.cupSize = index;
                                                LeooCodeUtilsJunPro.onSetState(
                                                    this);
                                              }),
                                            );
                                          }),
                                      SizedBox(height: 15.w),
                                      Text(S.of(context).applyTag,
                                          style: LeooTextJunPro
                                              .leooGetTextStyleJunPro(
                                                  20, FontWeight.bold)),
                                      SizedBox(height: 10.w),
                                      GridView.builder(
                                          shrinkWrap: true,
                                          physics:
                                              const BouncingScrollPhysics(),
                                          itemCount: tagList.length,
                                          gridDelegate:
                                              SliverGridDelegateWithFixedCrossAxisCount(
                                                  crossAxisCount: 3,
                                                  childAspectRatio: 2.2,
                                                  mainAxisSpacing: 5.w,
                                                  crossAxisSpacing: 5.w),
                                          itemBuilder:
                                              (BuildContext itemContext,
                                                  int index) {
                                            LeooLanguageEntity item =
                                                tagList[index];
                                            return InkWell(
                                              child: Container(
                                                alignment: Alignment.center,
                                                decoration: BoxDecoration(
                                                  borderRadius:
                                                      BorderRadius.circular(10),
                                                  color: userEntity.tagIds
                                                              ?.firstWhereOrNull(
                                                                  (element) =>
                                                                      element ==
                                                                      item
                                                                          .id) !=
                                                          null
                                                      ? LeooColorsJunPro
                                                          .leooAppJunPro
                                                      : LeooColorsJunPro
                                                          .leooBtnBgJunPro,
                                                ),
                                                padding: EdgeInsets.all(5.w),
                                                child: AutoSizeText(
                                                  item.enName ?? '',
                                                  style: LeooTextJunPro
                                                      .leooGetTextStyleJunPro(
                                                          20, FontWeight.bold),
                                                  maxLines: 1,
                                                ),
                                              ),
                                              onTap: LeooNavigatorUtilsJunPro
                                                  .leooDebounceJunPro(() {
                                                if (userEntity.tagIds
                                                        ?.firstWhereOrNull(
                                                            (element) =>
                                                                element ==
                                                                item.id) !=
                                                    null) {
                                                  userEntity.tagIds
                                                      ?.remove(item.id!);
                                                } else {
                                                  userEntity.tagIds
                                                      ?.add(item.id!);
                                                }
                                                LeooCodeUtilsJunPro.onSetState(
                                                    this);
                                              }),
                                            );
                                          }),
                                      SizedBox(height: 15.w),
                                      Text(S.of(context).aboutBio,
                                          style: LeooTextJunPro
                                              .leooGetTextStyleJunPro(
                                                  20, FontWeight.bold)),
                                      SizedBox(height: 10.w),
                                      LeooEditTextWidgetJunPro(
                                          keyboardType: ITextInputType.text,
                                          minLines: 4,
                                          maxLines: 4,
                                          textStyle: LeooTextJunPro
                                              .leooGetTextStyleJunPro(
                                                  18, FontWeight.bold),
                                          inputText:
                                              userEntity.description ?? '',
                                          fieldCallBack: (content) {
                                            userEntity.description = content;
                                          },
                                          focusNode: focusNode2,
                                          inputBorder: OutlineInputBorder(
                                              borderRadius:
                                                  BorderRadius.circular(20),
                                              borderSide: BorderSide.none),
                                          fillColor:
                                              Colors.white.withOpacity(.1),
                                          hintText: S.of(context).aboutBioHint,
                                          hintStyle: LeooTextJunPro
                                              .leooGetTextStyleHintJunPro(
                                                  18, FontWeight.bold),
                                          inputMaxLength: 100),
                                      SizedBox(height: 30.w),
                                      Padding(
                                        padding: EdgeInsets.only(
                                            left: 20.w, right: 20.w),
                                        child: LeooButtonWidgetJunPro(
                                          S.of(context).appSubmit,
                                          LeooTextJunPro.leooGetTextStyleJunPro(
                                              20, FontWeight.bold),
                                          color: LeooColorsJunPro.leooAppJunPro,
                                          colorRight:
                                              LeooColorsJunPro.leooApp2JunPro,
                                          shape: const RoundedRectangleBorder(
                                            borderRadius: BorderRadius.all(
                                                Radius.circular(20)),
                                          ),
                                          onPressed: LeooNavigatorUtilsJunPro
                                              .leooDebounceJunPro(() {
                                            if (_userPic.length < 3) {
                                              LeooCommonUtilsJunPro
                                                  .leooShowCustomToastJunPro(
                                                      S
                                                          .of(context)
                                                          .aboutCover3Tip,
                                                      true);
                                            } else if (userEntity
                                                    .nickname?.isEmpty !=
                                                false) {
                                              LeooCommonUtilsJunPro
                                                  .leooShowCustomToastJunPro(
                                                      S
                                                          .of(context)
                                                          .aboutNameHint,
                                                      true);
                                            } else if ((userEntity.age ?? 0) ==
                                                0) {
                                              LeooCommonUtilsJunPro
                                                  .leooShowCustomToastJunPro(
                                                      S
                                                          .of(context)
                                                          .aboutAgeHint,
                                                      true);
                                            } else if (userEntity
                                                        .country?.isEmpty !=
                                                    false ||
                                                LeooCountryPickerUtilsJunPro
                                                            .getCountryByIsoCode(
                                                                userEntity
                                                                    .country)
                                                        ?.name
                                                        .isEmpty !=
                                                    false) {
                                              LeooCommonUtilsJunPro
                                                  .leooShowCustomToastJunPro(
                                                      S
                                                          .of(context)
                                                          .aboutCountryHint,
                                                      true);
                                            } else if (userEntity
                                                    .languageIds?.isEmpty !=
                                                false) {
                                              LeooCommonUtilsJunPro
                                                  .leooShowCustomToastJunPro(
                                                      S
                                                          .of(context)
                                                          .applyLanguageTip,
                                                      true);
                                            } else if (userEntity.height ==
                                                null) {
                                              LeooCommonUtilsJunPro
                                                  .leooShowCustomToastJunPro(
                                                      S
                                                          .of(context)
                                                          .applyHeightHint,
                                                      true);
                                            } else if (userEntity.weight ==
                                                null) {
                                              LeooCommonUtilsJunPro
                                                  .leooShowCustomToastJunPro(
                                                      S
                                                          .of(context)
                                                          .applyWeightHint,
                                                      true);
                                            } else if (userEntity.cupSize ==
                                                null) {
                                              LeooCommonUtilsJunPro
                                                  .leooShowCustomToastJunPro(
                                                      S.of(context).applyCupTip,
                                                      true);
                                            } else if (userEntity
                                                    .tagIds?.isEmpty !=
                                                false) {
                                              LeooCommonUtilsJunPro
                                                  .leooShowCustomToastJunPro(
                                                      S.of(context).applyTagTip,
                                                      true);
                                            } else {
                                              uploadList(userProvider);
                                            }
                                          }),
                                        ),
                                      ),
                                    ],
                                  ),
                                ),
                              ],
                            ),
                          ),
                  ),
                  const LeooKeyBoardHeightWidgetJunPro(),
                ],
              ),
            ),
          ),
        ),
      );
    });
  }

  void uploadList(LeooUserProviderJunPro userProvider) {
    LeooDialogUtilsJunPro.instance.showLoadingDialog(context);
    if (_userPic.isNotEmpty) {
      LeooMainDaoJunPro.leooUploadListJunPro(_userPic).then((res) {
        if (res.result) {
          _userPic = res.data;
          saveUserInfo(userProvider);
        } else {
          Navigator.pop(context);
          LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
        }
      });
    } else {
      saveUserInfo(userProvider);
    }
  }

  void saveUserInfo(LeooUserProviderJunPro userProvider) {
    var header = _userPic[cover];
    userEntity.albums = _userPic;
    if (cover > 0) {
      userEntity.albums!.remove(header);
      userEntity.albums!.insert(0, header);
    }
    userEntity.header = header;
    LeooMainDaoJunPro.leooUpdateJunPro(userEntity, userProvider, false)
        .then((res) {
      Navigator.pop(context);
      if (res.result) {
        LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
            S.of(context).appComplete(S.of(context).appSubmit));
        Navigator.pop(context);
        LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
            context, const LeooApplyOkJunPro(edit: true), 'LeooApplyOkJunPro');
      } else {
        LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
      }
    });
  }

  Widget getPicChildWidget(String item, int index) {
    return InkWell(
      child: Stack(
        fit: StackFit.expand,
        children: <Widget>[
          ClipRRect(
            borderRadius: BorderRadius.circular(10),
            child: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
              item,
              width: 115.w,
              height: 150.w,
              load: LeooIconsJunPro.leooLoadHeadJunPro,
            ),
          ),
          Positioned(
            right: 0,
            top: 0,
            child: IconButton(
              iconSize: 24.w,
              padding: const EdgeInsets.all(0),
              icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                  LeooIconsJunPro.leooAboutDeleteJunPro,
                  width: 24.w,
                  height: 24.w),
              alignment: Alignment.topRight,
              onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                _userPic.remove(item);
                if (cover == index && _userPic.isNotEmpty) {
                  cover = 0;
                }
                LeooCodeUtilsJunPro.onSetState(this);
              }),
            ),
          ),
          if (cover == index)
            Positioned(
              left: 0,
              right: 0,
              bottom: 0,
              child: Container(
                decoration: BoxDecoration(
                  color: Colors.black.withOpacity(.4),
                  borderRadius: const BorderRadius.only(
                    bottomLeft: Radius.circular(10),
                    bottomRight: Radius.circular(10),
                  ),
                ),
                padding: EdgeInsets.only(top: 5.5.w, bottom: 5.5.w),
                child: Text(S.of(context).aboutCover,
                    style: LeooTextJunPro.leooGetTextStyleJunPro(16),
                    textAlign: TextAlign.center),
              ),
            ),
        ],
      ),
      onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
        cover = index;
        LeooCodeUtilsJunPro.onSetState(this);
      }),
    );
  }
}
