import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoomaindaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooproviderjunpro/leoouserproviderjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoodialogutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoowidgetutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoobuttonwidgetjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoomejunpro/leooapplyjunpro.dart';
import 'package:provider/provider.dart';

///申请成功
class LeooApplyOkJunPro extends StatefulWidget {
  static bool leooOpenJunPro = false;
  final bool edit;

  const LeooApplyOkJunPro({Key? key, this.edit = false}) : super(key: key);

  @override
  _LeooApplyOkState createState() => _LeooApplyOkState();
}

class _LeooApplyOkState extends State<LeooApplyOkJunPro> {
  @override
  void initState() {
    super.initState();
    LeooApplyOkJunPro.leooOpenJunPro = true;
  }

  @override
  void dispose() {
    LeooApplyOkJunPro.leooOpenJunPro = false;
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    return Consumer<LeooUserProviderJunPro>(
        builder: (_, LeooUserProviderJunPro userProvider, __) {
      return Scaffold(
        resizeToAvoidBottomInset: false,
        body: SafeArea(
          maintainBottomViewPadding: true,
          child: Column(
            children: <Widget>[
              LeooWidgetUtilsJunPro.leooGetAppBarWidgetJunPro(context, ''),
              Expanded(
                child: Column(
                  children: [
                    SizedBox(height: 100.w),
                    LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                        userProvider.userEntity.anchorCheckStatus == 1 &&
                                !widget.edit
                            ? LeooIconsJunPro.leooVideoReportJunPro
                            : LeooIconsJunPro.leooApplyOkJunPro,
                        width: 100.w,
                        height: 100.w),
                    SizedBox(height: 30.w),
                    Text(
                        userProvider.userEntity.anchorCheckStatus == 1 &&
                                !widget.edit
                            ? S.of(context).applyRejected
                            : S.of(context).applyOk,
                        style: LeooTextJunPro.leooGetTextStyleJunPro(
                            24, FontWeight.bold),
                        textAlign: TextAlign.center),
                    SizedBox(height: 10.w),
                    Padding(
                        padding: EdgeInsets.fromLTRB(40.w, 30.w, 40.w, 60.w),
                        child: Text(
                            widget.edit
                                ? S.of(context).applyEditTip
                                : userProvider.userEntity.anchorCheckStatus == 1
                                    ? S.of(context).applyRejectedTip
                                    : S.of(context).applyOkTip,
                            style: LeooTextJunPro.leooGetTextStyleJunPro(16),
                            textAlign: TextAlign.center)),
                    Padding(
                      padding: EdgeInsets.only(left: 100.w, right: 100.w),
                      child: LeooButtonWidgetJunPro(
                        widget.edit
                            ? S.of(context).appOk
                            : userProvider.userEntity.anchorCheckStatus == 1
                                ? S.of(context).applyRejectedRefresh
                                : S.of(context).applyOkRefresh,
                        LeooTextJunPro.leooGetTextStyleJunPro(
                            20, FontWeight.bold),
                        color: LeooColorsJunPro.leooAppJunPro,
                        colorRight: LeooColorsJunPro.leooApp2JunPro,
                        shape: const RoundedRectangleBorder(
                          borderRadius: BorderRadius.all(Radius.circular(20)),
                        ),
                        onPressed:
                            LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                          if (widget.edit) {
                            Navigator.pop(context);
                          } else if (userProvider
                                  .userEntity.anchorCheckStatus ==
                              1) {
                            Navigator.pop(context);
                            LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
                                context,
                                const LeooApplyJunPro(),
                                'LeooApplyJunPro');
                          } else {
                            LeooDialogUtilsJunPro.instance
                                .showLoadingDialog(context);
                            LeooMainDaoJunPro.leooUserInfoJunPro(userProvider)
                                .then((res) {
                              Navigator.pop(context);
                              if (res.result) {
                                if (LeooMainDaoJunPro.leooUserTypeJunPro == 1) {
                                  LeooNavigatorUtilsJunPro.leooGoHomeJunPro(
                                      context);
                                } else {
                                  LeooCommonUtilsJunPro
                                      .leooShowCustomToastJunPro(
                                          S.of(context).applyOkTip);
                                }
                              } else {
                                LeooCommonUtilsJunPro.leooShowErrorToastJunPro(
                                    res);
                              }
                            });
                          }
                        }),
                      ),
                    ),
                  ],
                ),
              )
            ],
          ),
        ),
      );
    });
  }
}
