import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoomaindaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoodataentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';

///dataitem
class LeooDataItemJunPro extends StatefulWidget {
  final int type;

  const LeooDataItemJunPro(this.type, {Key? key}) : super(key: key);

  @override
  _LeooDataItemState createState() => _LeooDataItemState();
}

class _LeooDataItemState extends State<LeooDataItemJunPro>
    with AutomaticKeepAliveClientMixin<LeooDataItemJunPro> {
  @override
  bool get wantKeepAlive => true;
  LeooDataEntity? dataEntity;
  int status = LeooCommonUtilsJunPro.leooPageStatusLoadingJunPro;

  void getStatistics() {
    LeooMainDaoJunPro.leooStatisticsJunPro(widget.type).then((res) {
      if (res.result) {
        dataEntity = res.data;
        status = LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro;
        LeooCodeUtilsJunPro.onSetState(this);
      } else {
        status = LeooCommonUtilsJunPro.leooPageStatusErrorJunPro;
        LeooCodeUtilsJunPro.onSetState(this);
        LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
      }
    });
  }

  @override
  void initState() {
    super.initState();
    getStatistics();
  }

  @override
  Widget build(BuildContext context) {
    super.build(context);
    return status != LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro
        ? LeooCommonUtilsJunPro.leooCheckPageStatusJunPro(
            context,
            status,
            onTap: () {
              status = LeooCommonUtilsJunPro.leooPageStatusLoadingJunPro;
              LeooCodeUtilsJunPro.onSetState(this);
              getStatistics();
            },
          )
        : Padding(
            padding: EdgeInsets.all(15.w),
            child: Column(
              children: [
                Container(
                  width: 1.sw,
                  decoration: BoxDecoration(
                      borderRadius: BorderRadius.circular(20),
                      color: LeooColorsJunPro.leooBtnBgJunPro),
                  padding: EdgeInsets.only(top: 20.w, bottom: 20.w),
                  child: Column(
                    children: [
                      Text(S.of(context).dataOnline,
                          style: LeooTextJunPro.leooGetTextStyleJunPro(
                              16, FontWeight.bold)),
                      SizedBox(height: 10.w),
                      Text('${dataEntity?.onlineTime ?? 0}',
                          style: LeooTextJunPro.leooGetTextStyleJunPro(
                              24, FontWeight.bold)),
                    ],
                  ),
                ),
                SizedBox(height: 10.w),
                Container(
                  decoration: BoxDecoration(
                      borderRadius: BorderRadius.circular(20),
                      color: LeooColorsJunPro.leooBtnBgJunPro),
                  padding: EdgeInsets.only(top: 15.w, bottom: 15.w),
                  child: Row(
                    children: [
                      Expanded(
                        child: Column(
                          children: [
                            SizedBox(height: 10.w),
                            Text(S.of(context).dataCalls,
                                style: LeooTextJunPro.leooGetTextStyleJunPro(
                                    16, FontWeight.bold)),
                            SizedBox(height: 5.w),
                            Text('${dataEntity?.calls ?? 0}',
                                style: LeooTextJunPro.leooGetTextStyleJunPro(
                                    24, FontWeight.bold)),
                          ],
                        ),
                      ),
                      Container(
                          height: 40.w,
                          width: 1.w,
                          color: LeooColorsJunPro.leooTextHintJunPro),
                      Expanded(
                        child: Column(
                          children: [
                            SizedBox(height: 10.w),
                            Text(S.of(context).dataConnect,
                                style: LeooTextJunPro.leooGetTextStyleJunPro(
                                    16, FontWeight.bold)),
                            SizedBox(height: 5.w),
                            Text('${dataEntity?.connect ?? 0}',
                                style: LeooTextJunPro.leooGetTextStyleJunPro(
                                    24, FontWeight.bold)),
                          ],
                        ),
                      ),
                      Container(
                          height: 40.w,
                          width: 1.w,
                          color: LeooColorsJunPro.leooTextHintJunPro),
                      Expanded(
                        child: Column(
                          children: [
                            Text(S.of(context).dataConnection,
                                style: LeooTextJunPro.leooGetTextStyleJunPro(
                                    16, FontWeight.bold),
                                textAlign: TextAlign.center),
                            Text('${dataEntity?.connectionRate ?? 0}',
                                style: LeooTextJunPro.leooGetTextStyleJunPro(
                                    24, FontWeight.bold)),
                          ],
                        ),
                      ),
                    ],
                  ),
                ),
                SizedBox(height: 10.w),
                Container(
                  decoration: BoxDecoration(
                      borderRadius: BorderRadius.circular(20),
                      color: LeooColorsJunPro.leooBtnBgJunPro),
                  padding: EdgeInsets.only(top: 15.w, bottom: 15.w),
                  child: Row(
                    children: [
                      Expanded(
                        child: Column(
                          children: [
                            SizedBox(height: 10.w),
                            Text(S.of(context).dataPraise,
                                style: LeooTextJunPro.leooGetTextStyleJunPro(
                                    16, FontWeight.bold)),
                            SizedBox(height: 5.w),
                            Text('${dataEntity?.praise ?? 0}',
                                style: LeooTextJunPro.leooGetTextStyleJunPro(
                                    24, FontWeight.bold)),
                          ],
                        ),
                      ),
                      Container(
                          height: 40.w,
                          width: 1.w,
                          color: LeooColorsJunPro.leooTextHintJunPro),
                      Expanded(
                        child: Column(
                          children: [
                            Text(S.of(context).dataNegative,
                                style: LeooTextJunPro.leooGetTextStyleJunPro(
                                    16, FontWeight.bold),
                                textAlign: TextAlign.center),
                            Text('${dataEntity?.negativeRatings ?? 0}',
                                style: LeooTextJunPro.leooGetTextStyleJunPro(
                                    24, FontWeight.bold)),
                          ],
                        ),
                      ),
                      Container(
                          height: 40.w,
                          width: 1.w,
                          color: LeooColorsJunPro.leooTextHintJunPro),
                      Expanded(
                        child: Column(
                          children: [
                            Text(S.of(context).dataFavorable,
                                style: LeooTextJunPro.leooGetTextStyleJunPro(
                                    16, FontWeight.bold),
                                textAlign: TextAlign.center),
                            Text('${dataEntity?.favorableRate ?? 0}',
                                style: LeooTextJunPro.leooGetTextStyleJunPro(
                                    24, FontWeight.bold)),
                          ],
                        ),
                      ),
                    ],
                  ),
                ),
              ],
            ),
          );
  }
}
