import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoowidgetutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoocustomtabsjunpro.dart'
    as custom_tabs;
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leootabbarwidgetjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoomejunpro/leoodataitemjunpro.dart';

///数据统计
class LeooDataJunPro extends StatefulWidget {
  const LeooDataJunPro({Key? key}) : super(key: key);

  @override
  _LeooDataState createState() => _LeooDataState();
}

class _LeooDataState extends State<LeooDataJunPro> {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      resizeToAvoidBottomInset: false,
      body: SafeArea(
        maintainBottomViewPadding: true,
        child: Column(
          children: <Widget>[
            LeooWidgetUtilsJunPro.leooGetAppBarWidgetJunPro(
                context, S.of(context).data),
            Expanded(
              child: LeooTabBarWidgetJunPro(
                [
                  custom_tabs.Tab(text: S.of(context).dataToday),
                  custom_tabs.Tab(text: S.of(context).dataYesterday),
                  custom_tabs.Tab(text: S.of(context).topWeek),
                ],
                const [
                  LeooDataItemJunPro(1),
                  LeooDataItemJunPro(2),
                  LeooDataItemJunPro(3),
                ],
                type: LeooTabBarWidgetJunPro.leooTaoTopJunPro,
                alignment: Alignment.bottomCenter,
                height: -15.w,
                isScrollable: true,
                top: false,
                indicatorColor: LeooColorsJunPro.leooAppJunPro,
                unselectedLabelColor: LeooColorsJunPro.leooTextJunPro,
              ),
            ),
          ],
        ),
      ),
    );
  }
}
