import 'package:flutter/material.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leooappconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoomaindaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoouserentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoowidgetutilsjunpro.dart';
import 'package:leoo_junpro/leoorouterjunpro.dart';
import 'package:pull_to_refresh/pull_to_refresh.dart';

///关注我的
class LeooFollowerJunPro extends StatefulWidget {
  const LeooFollowerJunPro({Key? key}) : super(key: key);

  @override
  _LeooFollowerState createState() => _LeooFollowerState();
}

class _LeooFollowerState extends State<LeooFollowerJunPro>
    with RouteAware, AutomaticKeepAliveClientMixin<LeooFollowerJunPro> {
  @override
  bool get wantKeepAlive => true;
  final RefreshController _refreshController = RefreshController();
  List<LeooUserEntity> followerList = [];
  int page = 1;
  int status = LeooCommonUtilsJunPro.leooPageStatusLoadingJunPro;

  void getFollowerList() {
    LeooMainDaoJunPro.leooListFollowerJunPro(page).then((res) {
      if (res.result) {
        if (page == 1) {
          followerList.clear();
        }
        followerList.addAll(res.data);
        if (followerList.isEmpty) {
          status = LeooCommonUtilsJunPro.leooPageStatusEmptyJunPro;
        } else {
          status = LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro;
        }
        LeooCodeUtilsJunPro.onSetState(this);
        if (page == 1) {
          _refreshController.refreshCompleted();
          _refreshController.loadComplete();
        } else if (res.data.isEmpty) {
          _refreshController.loadNoData();
        } else {
          _refreshController.loadComplete();
        }
      } else {
        if (followerList.isEmpty) {
          status = LeooCommonUtilsJunPro.leooPageStatusErrorJunPro;
          LeooCodeUtilsJunPro.onSetState(this);
        } else if (page == 1) {
          _refreshController.refreshFailed();
        } else {
          _refreshController.loadFailed();
        }
        LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
      }
    });
  }

  @override
  void initState() {
    super.initState();
    getFollowerList();
  }

  @override
  void didChangeDependencies() {
    super.didChangeDependencies();
    LeooRouterJunPro.leooRouteObserverJunPro
        .subscribe(this, ModalRoute.of(context) as PageRoute<dynamic>);
  }

  @override
  void didPopNext() {
    super.didPopNext();
    LeooCommonUtilsJunPro.leooCheckIsCurrentJunPro(context, () {
      getFollowerList();
    });
  }

  @override
  void dispose() {
    LeooRouterJunPro.leooRouteObserverJunPro.unsubscribe(this);
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    super.build(context);
    return status != LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro
        ? LeooCommonUtilsJunPro.leooCheckPageStatusJunPro(
            context,
            status,
            onTap: () {
              status = LeooCommonUtilsJunPro.leooPageStatusLoadingJunPro;
              LeooCodeUtilsJunPro.onSetState(this);
              getFollowerList();
            },
          )
        : SmartRefresher(
            controller: _refreshController,
            header: const ClassicHeader(),
            footer: const ClassicFooter(),
            enablePullUp:
                followerList.length >= LeooAppConfigJunPro.leooListSizeJunPro,
            onRefresh: () {
              page = 1;
              getFollowerList();
            },
            onLoading: () {
              page++;
              getFollowerList();
            },
            child: ListView.builder(
                physics: const BouncingScrollPhysics(),
                itemCount: followerList.length,
                itemBuilder: (BuildContext itemContext, int index) {
                  return LeooWidgetUtilsJunPro
                      .leooGetFollowListChildWidgetJunPro(
                          context,
                          followerList[index],
                          '${followerList[index].id}follower$index');
                }),
          );
  }
}
