import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leooproviderjunpro/leoouserproviderjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoocustomtabsjunpro.dart'
    as custom_tabs;
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leootabbarwidgetjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoomejunpro/leoofollowerjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoomejunpro/leoofollowingjunpro.dart';
import 'package:provider/provider.dart';

///关注中间页面
class LeooFollowsJunPro extends StatefulWidget {
  final int position;

  const LeooFollowsJunPro(this.position, {Key? key}) : super(key: key);

  @override
  _LeooFollowsState createState() => _LeooFollowsState();
}

class _LeooFollowsState extends State<LeooFollowsJunPro> {
  @override
  Widget build(BuildContext context) {
    return Consumer<LeooUserProviderJunPro>(
        builder: (_, LeooUserProviderJunPro userProvider, __) {
      return Scaffold(
        resizeToAvoidBottomInset: false,
        body: Stack(
          children: [
            LeooTabBarWidgetJunPro(
              [
                custom_tabs.Tab(text: S.of(context).videoPlayFollow),
                custom_tabs.Tab(text: S.of(context).followers)
              ],
              const [
                LeooFollowingJunPro(),
                LeooFollowerJunPro(),
              ],
              type: LeooTabBarWidgetJunPro.leooTaoTopJunPro,
              alignment: Alignment.bottomCenter,
              isScrollable: true,
              indicatorColor: LeooColorsJunPro.leooAppJunPro,
              unselectedLabelColor: LeooColorsJunPro.leooTextJunPro,
              position: widget.position,
              margin: EdgeInsets.fromLTRB(
                  30.w, ScreenUtil().statusBarHeight, 30.w, 16.w),
              padding: EdgeInsets.only(top: 10.w),
              height: -30.w,
            ),
            Positioned(
              top: ScreenUtil().statusBarHeight + 4.w,
              left: 4.w,
              child: IconButton(
                iconSize: 40.w,
                padding: const EdgeInsets.all(0),
                icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                    LeooIconsJunPro.leooTopBackJunPro,
                    width: 40.w,
                    height: 40.w),
                onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                  Navigator.pop(context);
                }),
              ),
            ),
          ],
        ),
      );
    });
  }
}
