import 'package:flutter/material.dart';
import 'package:flutter_background/flutter_background.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leooappconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoomaindaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooproviderjunpro/leoouserproviderjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoodialogutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoorechargeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoowidgetutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoobuttonwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leootextwidgetjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoofirstjunpro/leooaboutjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoomejunpro/leooapplyeditjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoomejunpro/leooapplyjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoomejunpro/leooapplyokjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoomejunpro/leoodatajunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoomejunpro/leoodetailjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoomejunpro/leoofollowsjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoomejunpro/leoophotosjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoomejunpro/leoovideolikejunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoomejunpro/leoowithdrawjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoosetjunpro/leooblacklistjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoosetjunpro/leoofaqjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoosetjunpro/leoofeedbackjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoosetjunpro/leoopermissionjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoosetjunpro/leoosettingjunpro.dart';
import 'package:provider/provider.dart';

///个人中心
class LeooMineJunPro extends StatefulWidget {
  const LeooMineJunPro({Key? key}) : super(key: key);

  @override
  _LeooMineState createState() => _LeooMineState();
}

class _LeooMineState extends State<LeooMineJunPro>
    with AutomaticKeepAliveClientMixin<LeooMineJunPro> {
  @override
  bool get wantKeepAlive => true;
  late LeooUserProviderJunPro userProvider;

  @override
  Widget build(BuildContext context) {
    super.build(context);
    return Consumer<LeooUserProviderJunPro>(
        builder: (_, LeooUserProviderJunPro userProvider, __) {
      this.userProvider = userProvider;
      return SafeArea(
        maintainBottomViewPadding: true,
        child: SingleChildScrollView(
          physics: const BouncingScrollPhysics(),
          child: Column(
            children: [
              SizedBox(height: 40.w),
              Stack(
                clipBehavior: Clip.none,
                children: [
                  ClipOval(
                    child: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                      userProvider.userEntity.header,
                      width: 90.w,
                      height: 90.w,
                      load: LeooIconsJunPro.leooLoadHeadJunPro,
                    ),
                  ),
                  Positioned(
                    right: -8.w,
                    bottom: -8.w,
                    child: IconButton(
                      iconSize: 30.w,
                      padding: const EdgeInsets.all(0),
                      icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                        LeooIconsJunPro.leooMineEditJunPro,
                        width: 30.w,
                        height: 30.w,
                      ),
                      onPressed:
                          LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                        if (userProvider.userEntity.userType == 1) {
                          LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
                              context,
                              const LeooApplyEditJunPro(),
                              'LeooApplyEditJunPro');
                        } else {
                          LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
                              context,
                              const LeooAboutJunPro(edit: true),
                              'LeooAboutJunPro');
                        }
                      }),
                    ),
                  ),
                ],
              ),
              SizedBox(height: 10.w),
              Text(userProvider.userEntity.getNameAge(),
                  style: LeooTextJunPro.leooGetTextStyleJunPro(
                      24, FontWeight.bold)),
              SizedBox(height: 5.w),
              Row(
                mainAxisAlignment: MainAxisAlignment.center,
                children: [
                  Container(
                    decoration: ShapeDecoration(
                      shape: StadiumBorder(),
                      color: LeooColorsJunPro.leooBtnBgJunPro,
                    ),
                    padding: EdgeInsets.fromLTRB(15.w, 5.5.w, 15.w, 5.5.w),
                    child: Text(
                      S.of(context).infoId + ' ${userProvider.userEntity.id}',
                      style: LeooTextJunPro.leooGetTextStyleJunPro(16),
                    ),
                  ),
                  if ((userProvider.userEntity.userType == 1 ||
                      userProvider.userEntity.brokerType == 1))
                    Container(
                      margin: EdgeInsets.only(left: 10.w),
                      padding: EdgeInsets.fromLTRB(15.w, 5.5.w, 15.w, 5.5.w),
                      decoration: ShapeDecoration(
                          shape: StadiumBorder(),
                          color: LeooColorsJunPro.leooAppJunPro),
                      child: Text(
                          userProvider.userEntity.brokerType == 1
                              ? S.of(context).mineBrokerTip
                              : S.of(context).mineAnchorTip,
                          style: LeooTextJunPro.leooGetTextStyleJunPro(
                              16, FontWeight.bold)),
                    )
                ],
              ),
              if (userProvider.userEntity.country?.isEmpty == false)
                SizedBox(height: 15.w),
              if (userProvider.userEntity.country?.isEmpty == false)
                LeooWidgetUtilsJunPro.leooGetCountryWidgetJunPro(
                    context, userProvider.userEntity.country,
                    item: false),
              SizedBox(height: 15.w),
              Row(
                children: [
                  Expanded(
                    child: InkWell(
                      onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                        LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
                            context,
                            const LeooFollowsJunPro(0),
                            'LeooFollowsJunPro');
                      }),
                      child: Column(
                        children: [
                          Text(
                              '${userProvider.userEntity.followingNumber ?? 0}',
                              style: LeooTextJunPro.leooGetTextStyleJunPro(
                                  24, FontWeight.bold)),
                          SizedBox(height: 10.w),
                          Text(S.of(context).videoPlayFollow,
                              style: LeooTextJunPro.leooGetTextStyleJunPro(14)),
                        ],
                      ),
                    ),
                  ),
                  Expanded(
                    child: InkWell(
                      onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                        LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
                            context,
                            const LeooFollowsJunPro(1),
                            'LeooFollowsJunPro');
                      }),
                      child: Column(
                        children: [
                          Text('${userProvider.userEntity.followerNumber ?? 0}',
                              style: LeooTextJunPro.leooGetTextStyleJunPro(
                                  24, FontWeight.bold)),
                          SizedBox(height: 10.w),
                          Text(S.of(context).followers,
                              style: LeooTextJunPro.leooGetTextStyleJunPro(14)),
                        ],
                      ),
                    ),
                  ),
                  Expanded(
                    child: InkWell(
                      onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                        LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
                            context,
                            const LeooVideoLikeJunPro(),
                            'LeooVideoLikeJunPro');
                      }),
                      child: Column(
                        children: [
                          Text('${userProvider.userEntity.likesNumber ?? 0}',
                              style: LeooTextJunPro.leooGetTextStyleJunPro(
                                  24, FontWeight.bold)),
                          SizedBox(height: 10.w),
                          Text(S.of(context).mineLikes,
                              style: LeooTextJunPro.leooGetTextStyleJunPro(14)),
                        ],
                      ),
                    ),
                  ),
                ],
              ),
              SizedBox(height: 20.w),
              if ((userProvider.userEntity.userType == 1 ||
                  userProvider.userEntity.brokerType == 1))
                Stack(
                  alignment: Alignment.center,
                  children: [
                    Container(
                      decoration: BoxDecoration(
                        borderRadius: BorderRadius.circular(28),
                        gradient: LinearGradient(
                          begin: Alignment.topCenter,
                          end: Alignment.bottomCenter,
                          colors: [
                            LeooColorsJunPro.leooAppJunPro,
                            LeooColorsJunPro.leooApp2JunPro,
                          ],
                        ),
                        boxShadow: [
                          BoxShadow(
                            color: LeooColorsJunPro.leooAppJunPro,
                            offset: const Offset(0, 3),
                            blurRadius: 10.w,
                          ),
                        ],
                      ),
                      width: 1.sw,
                      margin: EdgeInsets.only(
                        left: 20.w,
                        right: 20.w,
                      ),
                      padding: EdgeInsets.all(15.w),
                      child: Column(
                        crossAxisAlignment: CrossAxisAlignment.start,
                        children: [
                          Text(
                            S.of(context).balance,
                            style: LeooTextJunPro.leooGetTextStyleJunPro(
                                20, FontWeight.bold),
                          ),
                          SizedBox(height: 10.w),
                          LeooTextWidgetJunPro(
                            '${userProvider.userEntity.commissionAmount ?? 0}',
                            LeooTextJunPro.leooGetTextStyleJunPro(
                                24, FontWeight.bold),
                            iconData:
                                LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                              LeooIconsJunPro.leooMineAmountJunPro,
                              width: 32.w,
                              height: 32.w,
                            ),
                            iconPadding: 5.w,
                            mainAxisSize: MainAxisSize.min,
                          ),
                          SizedBox(height: 10.w),
                          Row(
                            children: [
                              Expanded(
                                child: Text(
                                  S.of(context).including(userProvider
                                          .userEntity.commissionAmount ??
                                      0),
                                  style:
                                      LeooTextJunPro.leooGetTextStyleJunPro(14)
                                          .copyWith(
                                              color: LeooColorsJunPro
                                                  .leooTextJunPro
                                                  .withOpacity(.5)),
                                ),
                              ),
                              LeooButtonWidgetJunPro(
                                S.of(context).detail,
                                LeooTextJunPro.leooGetTextStyleJunPro(
                                    16, FontWeight.bold),
                                padding: const EdgeInsets.all(0),
                                iconData: LeooCommonUtilsJunPro
                                    .leooGetLoadWidgetJunPro(
                                  LeooIconsJunPro.leooMineRightJunPro,
                                  width: 30.w,
                                  height: 30.w,
                                ),
                                right: true,
                                mainAxisSize: MainAxisSize.min,
                                onPressed:
                                    LeooNavigatorUtilsJunPro.leooDebounceJunPro(
                                        () {
                                  LeooNavigatorUtilsJunPro
                                      .leooNavigatorPushJunPro(
                                          context,
                                          const LeooDetailJunPro(),
                                          'LeooDetailJunPro');
                                }),
                              ),
                            ],
                          ),
                        ],
                      ),
                    ),
                    Positioned(
                      top: 15.w,
                      right: 36.w,
                      child: LeooButtonWidgetJunPro(
                        S.of(context).withdraw,
                        LeooTextJunPro.leooGetTextStyleAppJunPro(
                            16, FontWeight.bold),
                        color: Colors.white,
                        shape: const RoundedRectangleBorder(
                          borderRadius: BorderRadius.all(Radius.circular(16)),
                        ),
                        padding:
                            EdgeInsets.fromLTRB(15.w, 10.5.w, 15.w, 10.5.w),
                        onPressed:
                            LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                          LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
                              context,
                              const LeooWithdrawJunPro(),
                              'LeooWithdrawJunPro');
                        }),
                      ),
                    ),
                  ],
                ),
              if (userProvider.userEntity.userType == 0 &&
                  userProvider.userEntity.brokerType == 1)
                SizedBox(height: 20.w),
              if (userProvider.userEntity.userType == 0)
                Stack(
                  alignment: Alignment.center,
                  children: [
                    Container(
                      decoration: ShapeDecoration(
                        shape: const RoundedRectangleBorder(
                          borderRadius: BorderRadius.all(Radius.circular(28)),
                        ),
                        gradient: LinearGradient(
                          begin: Alignment.topCenter,
                          end: Alignment.bottomCenter,
                          colors: [
                            LeooColorsJunPro.leooAppJunPro,
                            LeooColorsJunPro.leooApp2JunPro,
                          ],
                        ),
                        shadows: [
                          BoxShadow(
                            color: LeooColorsJunPro.leooAppJunPro,
                            offset: const Offset(0, 3),
                            blurRadius: 10.w,
                          ),
                        ],
                      ),
                      width: 1.sw,
                      height: 75.w,
                      margin: EdgeInsets.only(
                        left: 20.w,
                        right: 20.w,
                      ),
                    ),
                    Positioned(
                      left: 40.w,
                      child: LeooTextWidgetJunPro(
                        '${userProvider.userEntity.amount ?? 0}',
                        LeooTextJunPro.leooGetTextStyleJunPro(
                            24, FontWeight.bold),
                        iconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                          LeooIconsJunPro.leooMainCoinsJunPro,
                          width: 40.w,
                          height: 40.w,
                        ),
                        iconPadding: 5.w,
                        mainAxisSize: MainAxisSize.min,
                      ),
                    ),
                    Positioned(
                      right: 40.w,
                      child: LeooButtonWidgetJunPro(
                        S.of(context).recharge.toUpperCase(),
                        LeooTextJunPro.leooGetTextStyleAppJunPro(
                            16, FontWeight.bold),
                        color: Colors.white,
                        shape: const RoundedRectangleBorder(
                          borderRadius: BorderRadius.all(Radius.circular(16)),
                        ),
                        padding:
                            EdgeInsets.fromLTRB(15.w, 10.5.w, 15.w, 10.5.w),
                        onPressed:
                            LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                          LeooRechargeUtilsJunPro.instance
                              .goRechargePage(context);
                        }),
                      ),
                    ),
                  ],
                ),
              SizedBox(height: 20.w),
              LeooButtonWidgetJunPro(
                S.of(context).permission,
                LeooTextJunPro.leooGetTextStyleJunPro(16, FontWeight.bold),
                leftIconData: Stack(
                  clipBehavior: Clip.none,
                  children: [
                    LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                      LeooIconsJunPro.leooMineNotificationJunPro,
                      width: 40.w,
                      height: 40.w,
                    ),
                    if (!FlutterBackground.isBackgroundExecutionEnabled)
                      Positioned(
                        top: 5.w,
                        right: 9.w,
                        child: Container(
                          decoration: const ShapeDecoration(
                              shape: CircleBorder(),
                              color: LeooColorsJunPro.leooBusyJunPro),
                          width: 8.w,
                          height: 8.w,
                        ),
                      )
                  ],
                ),
                leftIconPadding: 2.5.w,
                iconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                  LeooIconsJunPro.leooMineRightJunPro,
                  width: 40.w,
                  height: 40.w,
                ),
                padding: EdgeInsets.fromLTRB(15.w, 10.w, 15.w, 10.w),
                right: true,
                textExpanded: true,
                onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                  LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(context,
                          const LeooPermissionJunPro(), 'LeooPermissionJunPro')
                      .then((value) => LeooCodeUtilsJunPro.onSetState(this));
                }),
              ),
              if (userProvider.userEntity.userType == 0)
                LeooButtonWidgetJunPro(
                  S.of(context).daily,
                  LeooTextJunPro.leooGetTextStyleJunPro(16, FontWeight.bold),
                  leftIconData: Stack(
                    clipBehavior: Clip.none,
                    children: [
                      LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                        LeooIconsJunPro.leooMineDailyJunPro,
                        width: 40.w,
                        height: 40.w,
                      ),
                      if (LeooDialogUtilsJunPro.instance.checkSign)
                        Positioned(
                          top: 5.w,
                          right: 5.w,
                          child: Container(
                            decoration: const ShapeDecoration(
                                shape: CircleBorder(),
                                color: LeooColorsJunPro.leooBusyJunPro),
                            width: 8.w,
                            height: 8.w,
                          ),
                        )
                    ],
                  ),
                  leftIconPadding: 2.5.w,
                  iconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                    LeooIconsJunPro.leooMineRightJunPro,
                    width: 40.w,
                    height: 40.w,
                  ),
                  padding: EdgeInsets.fromLTRB(15.w, 10.w, 15.w, 10.w),
                  right: true,
                  textExpanded: true,
                  onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                    getSignInfo();
                  }),
                ),
              if (userProvider.userEntity.userType == 1)
                LeooButtonWidgetJunPro(
                  S.of(context).photos,
                  LeooTextJunPro.leooGetTextStyleJunPro(16, FontWeight.bold),
                  leftIconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                    LeooIconsJunPro.leooMinePhotosJunPro,
                    width: 40.w,
                    height: 40.w,
                  ),
                  leftIconPadding: 2.5.w,
                  iconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                    LeooIconsJunPro.leooMineRightJunPro,
                    width: 40.w,
                    height: 40.w,
                  ),
                  padding: EdgeInsets.fromLTRB(15.w, 10.w, 15.w, 10.w),
                  right: true,
                  textExpanded: true,
                  onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                    LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
                        context, const LeooPhotosJunPro(), 'LeooPhotosJunPro');
                  }),
                ),
              if (userProvider.userEntity.userType == 1)
                LeooButtonWidgetJunPro(
                  S.of(context).data,
                  LeooTextJunPro.leooGetTextStyleJunPro(16, FontWeight.bold),
                  leftIconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                    LeooIconsJunPro.leooMineDataJunPro,
                    width: 40.w,
                    height: 40.w,
                  ),
                  leftIconPadding: 2.5.w,
                  iconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                    LeooIconsJunPro.leooMineRightJunPro,
                    width: 40.w,
                    height: 40.w,
                  ),
                  padding: EdgeInsets.fromLTRB(15.w, 10.w, 15.w, 10.w),
                  right: true,
                  textExpanded: true,
                  onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                    LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
                        context, const LeooDataJunPro(), 'LeooDataJunPro');
                  }),
                ),
              if (userProvider.userEntity.userType == 0 &&
                  LeooAppConfigJunPro.leooShowApplyJunPro)
                LeooButtonWidgetJunPro(
                  S.of(context).mineAnchor,
                  LeooTextJunPro.leooGetTextStyleJunPro(16, FontWeight.bold),
                  leftIconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                    LeooIconsJunPro.leooMineAnchorJunPro,
                    width: 40.w,
                    height: 40.w,
                  ),
                  leftIconPadding: 2.5.w,
                  iconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                    LeooIconsJunPro.leooMineRightJunPro,
                    width: 40.w,
                    height: 40.w,
                  ),
                  padding: EdgeInsets.fromLTRB(15.w, 10.w, 15.w, 10.w),
                  right: true,
                  textExpanded: true,
                  onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                    if (userProvider.userEntity.anchorCheckStatus != 0) {
                      LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(context,
                          const LeooApplyOkJunPro(), 'LeooApplyOkJunPro');
                    } else {
                      LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
                          context, const LeooApplyJunPro(), 'LeooApplyJunPro');
                    }
                  }),
                ),
              LeooButtonWidgetJunPro(
                S.of(context).feed,
                LeooTextJunPro.leooGetTextStyleJunPro(16, FontWeight.bold),
                leftIconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                  LeooIconsJunPro.leooMineFeedbackJunPro,
                  width: 40.w,
                  height: 40.w,
                ),
                leftIconPadding: 2.5.w,
                iconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                  LeooIconsJunPro.leooMineRightJunPro,
                  width: 40.w,
                  height: 40.w,
                ),
                padding: EdgeInsets.fromLTRB(15.w, 10.w, 15.w, 10.w),
                right: true,
                textExpanded: true,
                onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                  LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(context,
                      const LeooFeedbackJunPro(), 'LeooFeedbackJunPro');
                }),
              ),
              LeooButtonWidgetJunPro(
                S.of(context).blacklist,
                LeooTextJunPro.leooGetTextStyleJunPro(16, FontWeight.bold),
                leftIconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                  LeooIconsJunPro.leooMineBlacklistJunPro,
                  width: 40.w,
                  height: 40.w,
                ),
                leftIconPadding: 2.5.w,
                iconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                  LeooIconsJunPro.leooMineRightJunPro,
                  width: 40.w,
                  height: 40.w,
                ),
                padding: EdgeInsets.fromLTRB(15.w, 10.w, 15.w, 10.w),
                right: true,
                textExpanded: true,
                onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                  LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(context,
                      const LeooBlacklistJunPro(), 'LeooBlacklistJunPro');
                }),
              ),
              LeooButtonWidgetJunPro(
                S.of(context).mineFAQ,
                LeooTextJunPro.leooGetTextStyleJunPro(16, FontWeight.bold),
                leftIconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                  LeooIconsJunPro.leooMineFAQJunPro,
                  width: 40.w,
                  height: 40.w,
                ),
                leftIconPadding: 2.5.w,
                iconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                  LeooIconsJunPro.leooMineRightJunPro,
                  width: 40.w,
                  height: 40.w,
                ),
                padding: EdgeInsets.fromLTRB(15.w, 10.w, 15.w, 10.w),
                right: true,
                textExpanded: true,
                onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                  LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
                      context, const LeooFAQJunPro(), 'LeooFAQJunPro');
                }),
              ),
              LeooButtonWidgetJunPro(
                S.of(context).setting,
                LeooTextJunPro.leooGetTextStyleJunPro(16, FontWeight.bold),
                leftIconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                  LeooIconsJunPro.leooMineSetJunPro,
                  width: 40.w,
                  height: 40.w,
                ),
                leftIconPadding: 2.5.w,
                iconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                  LeooIconsJunPro.leooMineRightJunPro,
                  width: 40.w,
                  height: 40.w,
                ),
                padding: EdgeInsets.fromLTRB(15.w, 10.w, 15.w, 10.w),
                right: true,
                textExpanded: true,
                onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                  LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
                      context, const LeooSettingJunPro(), 'LeooSettingJunPro');
                }),
              ),
              SizedBox(height: 60.w),
            ],
          ),
        ),
      );
    });
  }

  void getSignInfo() {
    LeooDialogUtilsJunPro.instance.showLoadingDialog(context);
    LeooMainDaoJunPro.leooSignInfoJunPro().then((res) async {
      Navigator.pop(context);
      if (res.result) {
        LeooDialogUtilsJunPro.instance
            .showSignInfoDialog(context, res.data, userProvider)
            ?.then((value) {
          if (value == true) {
            LeooDialogUtilsJunPro.instance
                .signReward(context, userProvider)
                .then((value) => LeooCodeUtilsJunPro.onSetState(this));
          }
        });
      } else {
        LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
      }
    });
  }
}
