import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoomaindaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoouserentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooproviderjunpro/leoouserproviderjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoodialogutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoowidgetutilsjunpro.dart';
import 'package:provider/provider.dart';

class LeooPhotosJunPro extends StatefulWidget {
  const LeooPhotosJunPro({Key? key}) : super(key: key);

  @override
  _LeooAboutState createState() => _LeooAboutState();
}

class _LeooAboutState extends State<LeooPhotosJunPro> {
  bool first = true;
  FocusNode focusNode = FocusNode();
  FocusNode focusNode1 = FocusNode();
  FocusNode focusNode2 = FocusNode();
  late LeooUserEntity userEntity;
  List<String> _userPic = [];
  int cover = 0;

  @override
  Widget build(BuildContext context) {
    return Consumer<LeooUserProviderJunPro>(
        builder: (_, LeooUserProviderJunPro userProvider, __) {
      if (first) {
        first = false;
        userEntity = userProvider.userEntity;
        _userPic = userEntity.lifePictures ?? [];
      }
      return Scaffold(
        resizeToAvoidBottomInset: false,
        body: SafeArea(
          maintainBottomViewPadding: true,
          child: Column(
            children: [
              LeooWidgetUtilsJunPro.leooGetAppBarWidgetJunPro(
                context,
                S.of(context).photos,
                rightChild: InkWell(
                  child: Padding(
                    padding: EdgeInsets.all(6.w),
                    child: Text(S.of(context).appSave,
                        style: LeooTextJunPro.leooGetTextStyleAppJunPro(
                            16, FontWeight.bold)),
                  ),
                  onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                    if (_userPic.length < 3) {
                      LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
                          S.of(context).aboutCover3Tip, true);
                    } else {
                      uploadList();
                    }
                  }),
                ),
              ),
              Expanded(
                child: Column(
                  crossAxisAlignment: CrossAxisAlignment.start,
                  children: [
                    Padding(
                      padding: EdgeInsets.only(left: 10.w, right: 10.w),
                      child: GridView.builder(
                        shrinkWrap: true,
                        physics: const NeverScrollableScrollPhysics(),
                        itemCount: 9,
                        gridDelegate: SliverGridDelegateWithFixedCrossAxisCount(
                            crossAxisCount: 3,
                            childAspectRatio: .77,
                            mainAxisSpacing: 5.w,
                            crossAxisSpacing: 5.w),
                        itemBuilder: (BuildContext itemContext, int index) {
                          if (index < _userPic.length) {
                            return getPicChildWidget(_userPic[index], index);
                          } else {
                            return InkWell(
                              child: ClipRRect(
                                borderRadius: BorderRadius.circular(10),
                                child: LeooCommonUtilsJunPro
                                    .leooGetLoadWidgetJunPro(
                                  LeooIconsJunPro.leooAboutAddJunPro,
                                  width: .3.sw,
                                  height: 150.w,
                                  fit: BoxFit.cover,
                                ),
                              ),
                              onTap:
                                  LeooNavigatorUtilsJunPro.leooDebounceJunPro(
                                      () {
                                LeooDialogUtilsJunPro.instance
                                    .showImageView(context, (path) {
                                  if (path.length + _userPic.length > 9) {
                                    _userPic.addAll(
                                        path.sublist(0, 9 - _userPic.length));
                                  } else {
                                    _userPic.addAll(path);
                                  }
                                  LeooCodeUtilsJunPro.onSetState(this);
                                }, multi: true);
                              }),
                            );
                          }
                        },
                      ),
                    ),
                    SizedBox(height: 10.w),
                    Padding(
                      padding: EdgeInsets.only(left: 15.w, right: 15.w),
                      child: Text(S.of(context).aboutCoverHint,
                          style: LeooTextJunPro.leooGetTextStyleRedJunPro(16)),
                    ),
                  ],
                ),
              ),
            ],
          ),
        ),
      );
    });
  }

  void uploadList() {
    LeooDialogUtilsJunPro.instance.showLoadingDialog(context);
    if (_userPic.isNotEmpty) {
      LeooMainDaoJunPro.leooUploadListJunPro(_userPic).then((res) {
        if (res.result) {
          _userPic = res.data;
          saveUserInfo();
        } else {
          Navigator.pop(context);
          LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
        }
      });
    } else {
      saveUserInfo();
    }
  }

  void saveUserInfo() {
    var header = _userPic[cover];
    userEntity.lifePictures = _userPic;
    if (cover > 0) {
      userEntity.lifePictures!.remove(header);
      userEntity.lifePictures!.insert(0, header);
    }
    userEntity.header = header;
    LeooMainDaoJunPro.leooUpdatePhotosJunPro(userEntity).then((res) {
      Navigator.pop(context);
      if (res.result) {
        LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
            S.of(context).appComplete(S.of(context).appSave));
        Navigator.pop(context);
      } else {
        LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
      }
    });
  }

  Widget getPicChildWidget(String item, int index) {
    return InkWell(
      child: Stack(
        fit: StackFit.expand,
        children: <Widget>[
          ClipRRect(
            borderRadius: BorderRadius.circular(10),
            child: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
              item,
              width: 115.w,
              height: 150.w,
              load: LeooIconsJunPro.leooLoadHeadJunPro,
            ),
          ),
          Positioned(
            right: 0,
            top: 0,
            child: IconButton(
              iconSize: 24.w,
              padding: const EdgeInsets.all(0),
              icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                  LeooIconsJunPro.leooAboutDeleteJunPro,
                  width: 24.w,
                  height: 24.w),
              alignment: Alignment.topRight,
              onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                _userPic.remove(item);
                if (cover == index && _userPic.isNotEmpty) {
                  cover = 0;
                }
                LeooCodeUtilsJunPro.onSetState(this);
              }),
            ),
          ),
          if (cover == index)
            Positioned(
              left: 0,
              right: 0,
              bottom: 0,
              child: Container(
                decoration: BoxDecoration(
                  color: Colors.black.withOpacity(.4),
                  borderRadius: const BorderRadius.only(
                    bottomLeft: Radius.circular(10),
                    bottomRight: Radius.circular(10),
                  ),
                ),
                padding: EdgeInsets.only(top: 5.5.w, bottom: 5.5.w),
                child: Text(S.of(context).aboutCover,
                    style: LeooTextJunPro.leooGetTextStyleJunPro(16),
                    textAlign: TextAlign.center),
              ),
            ),
        ],
      ),
      onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
        cover = index;
        LeooCodeUtilsJunPro.onSetState(this);
      }),
    );
  }
}
