import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leooappconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoomaindaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoolanguageentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooproviderjunpro/leoouserproviderjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoodialogutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoowidgetutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoobuttonwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leooedittextwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoowidgetjunpro/leookeyboardheightwidgetjunpro.dart';
import 'package:provider/provider.dart';
import 'package:sp_util/sp_util.dart';

///tx
class LeooWithdrawJunPro extends StatefulWidget {
  const LeooWithdrawJunPro({Key? key}) : super(key: key);

  @override
  _LeooWithdrawState createState() => _LeooWithdrawState();
}

class _LeooWithdrawState extends State<LeooWithdrawJunPro> {
  int? payeeMethodId;
  String? payeeName;
  String? account;
  double? amount;
  FocusNode focusNode = FocusNode();
  FocusNode focusNode1 = FocusNode();
  FocusNode focusNode2 = FocusNode();
  int status = LeooCommonUtilsJunPro.leooPageStatusLoadingJunPro;
  List<LeooLanguageEntity> list = [];

  void getMethodList() {
    LeooMainDaoJunPro.leooListMethodJunPro().then((res) {
      if (res.result) {
        list = res.data;
        if (list.isEmpty) {
          status = LeooCommonUtilsJunPro.leooPageStatusEmptyJunPro;
        } else {
          payeeMethodId ??= list.first.id;
          status = LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro;
        }
        LeooCodeUtilsJunPro.onSetState(this);
      } else {
        status = LeooCommonUtilsJunPro.leooPageStatusErrorJunPro;
        LeooCodeUtilsJunPro.onSetState(this);
        LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
      }
    });
  }

  @override
  void initState() {
    super.initState();
    payeeMethodId = SpUtil.getInt(LeooAppConfigJunPro.leooWithTypeJunPro,
        defValue: payeeMethodId);
    payeeName = SpUtil.getString(LeooAppConfigJunPro.leooWithNameJunPro,
        defValue: payeeName);
    account = SpUtil.getString(LeooAppConfigJunPro.leooWithAccountJunPro,
        defValue: account);
    getMethodList();
  }

  @override
  Widget build(BuildContext context) {
    return Consumer<LeooUserProviderJunPro>(
      builder: (_, LeooUserProviderJunPro userProvider, __) {
        return GestureDetector(
            behavior: HitTestBehavior.opaque,
            onTap: () {
              focusNode.unfocus();
              focusNode1.unfocus();
              focusNode2.unfocus();
            },
            child: Scaffold(
              resizeToAvoidBottomInset: false,
              body: SafeArea(
                maintainBottomViewPadding: true,
                child: Column(
                  children: <Widget>[
                    LeooWidgetUtilsJunPro.leooGetAppBarWidgetJunPro(
                        context, S
                        .of(context)
                        .withdraw),
                    Expanded(
                      child: status !=
                          LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro
                          ? LeooCommonUtilsJunPro.leooCheckPageStatusJunPro(
                        context,
                        status,
                        onTap: () {
                          status = LeooCommonUtilsJunPro
                              .leooPageStatusLoadingJunPro;
                          LeooCodeUtilsJunPro.onSetState(this);
                          getMethodList();
                        },
                      )
                          : SingleChildScrollView(
                        physics: const BouncingScrollPhysics(),
                        child: Padding(
                          padding: EdgeInsets.all(15.w),
                          child: Column(
                            children: <Widget>[
                              Column(
                                mainAxisAlignment:
                                MainAxisAlignment.spaceAround,
                                crossAxisAlignment:
                                CrossAxisAlignment.start,
                                children: <Widget>[
                                  Text(
                                    S
                                        .of(context)
                                        .withdrawMethod,
                                    style: LeooTextJunPro
                                        .leooGetTextStyleJunPro(
                                        20, FontWeight.bold),
                                  ),
                                  SizedBox(height: 10.w),
                                  Wrap(
                                    spacing: 12.w,
                                    runSpacing: 12.w,
                                    children: list
                                        .asMap()
                                        .values
                                        .map(
                                            (e) => getLabelChildWidget(e))
                                        .toList(),
                                  ),
                                  SizedBox(height: 20.w),
                                  Text(
                                    S
                                        .of(context)
                                        .withdrawName,
                                    style: LeooTextJunPro
                                        .leooGetTextStyleJunPro(
                                        20, FontWeight.bold),
                                  ),
                                  SizedBox(height: 10.w),
                                  LeooEditTextWidgetJunPro(
                                      keyboardType: ITextInputType.text,
                                      hintText:
                                      S
                                          .of(context)
                                          .withdrawNameHint,
                                      hintStyle: LeooTextJunPro
                                          .leooGetTextStyleHintJunPro(
                                          18, FontWeight.bold),
                                      inputText: payeeName ?? '',
                                      textStyle: LeooTextJunPro
                                          .leooGetTextStyleJunPro(
                                          18, FontWeight.bold),
                                      fieldCallBack: (content) {
                                        payeeName = content;
                                        LeooCodeUtilsJunPro.onSetState(
                                            this);
                                      },
                                      focusNode: focusNode,
                                      inputBorder: OutlineInputBorder(
                                        borderSide: BorderSide.none,
                                        borderRadius:
                                        BorderRadius.circular(20),
                                      ),
                                      contentPadding: EdgeInsets.fromLTRB(
                                          15.w, 18.w, 15.w, 18.w),
                                      fillColor:
                                      Colors.white.withOpacity(.1),
                                      inputMaxLength: LeooAppConfigJunPro
                                          .leooTextSize200JunPro),
                                  SizedBox(height: 20.w),
                                  Text(
                                    S
                                        .of(context)
                                        .withdrawAccount,
                                    style: LeooTextJunPro
                                        .leooGetTextStyleJunPro(
                                        20, FontWeight.bold),
                                  ),
                                  SizedBox(height: 10.w),
                                  LeooEditTextWidgetJunPro(
                                      keyboardType: ITextInputType.text,
                                      hintText: S
                                          .of(context)
                                          .withdrawAccountHint,
                                      hintStyle: LeooTextJunPro
                                          .leooGetTextStyleHintJunPro(
                                          18, FontWeight.bold),
                                      inputText: account ?? '',
                                      textStyle: LeooTextJunPro
                                          .leooGetTextStyleJunPro(
                                          18, FontWeight.bold),
                                      fieldCallBack: (content) {
                                        account = content;
                                        LeooCodeUtilsJunPro.onSetState(
                                            this);
                                      },
                                      focusNode: focusNode1,
                                      inputBorder: OutlineInputBorder(
                                        borderSide: BorderSide.none,
                                        borderRadius:
                                        BorderRadius.circular(20),
                                      ),
                                      contentPadding: EdgeInsets.fromLTRB(
                                          15.w, 18.w, 15.w, 18.w),
                                      fillColor:
                                      Colors.white.withOpacity(.1),
                                      inputMaxLength: LeooAppConfigJunPro
                                          .leooTextSize200JunPro),
                                  SizedBox(height: 20.w),
                                  Text(
                                    S
                                        .of(context)
                                        .withdrawAmount,
                                    style: LeooTextJunPro
                                        .leooGetTextStyleJunPro(
                                        20, FontWeight.bold),
                                  ),
                                  SizedBox(height: 10.w),
                                  Stack(
                                    alignment: Alignment.centerRight,
                                    children: [
                                      LeooEditTextWidgetJunPro(
                                          keyboardType:
                                          ITextInputType.amount,
                                          hintText: LeooCodeUtilsJunPro
                                              .leooFormatNumJunPro(
                                              userProvider.userEntity
                                                  .commissionAmount ??
                                                  0,
                                              2),
                                          hintStyle:
                                          LeooTextJunPro
                                              .leooGetTextStyleHintJunPro(
                                              18, FontWeight.bold),
                                          inputText: (amount ?? .0) != .0
                                              ? LeooCodeUtilsJunPro
                                              .leooFormatNumJunPro(
                                              amount!, 2)
                                              : '',
                                          textStyle:
                                          LeooTextJunPro.leooGetTextStyleJunPro(
                                              18, FontWeight.bold),
                                          fieldCallBack: (content) {
                                            amount =
                                                double.parse(content);
                                          },
                                          focusNode: focusNode2,
                                          inputBorder: OutlineInputBorder(
                                            borderSide: BorderSide.none,
                                            borderRadius:
                                            BorderRadius.circular(20),
                                          ),
                                          contentPadding:
                                          EdgeInsets.fromLTRB(
                                              15.w, 18.w, 15.w, 18.w),
                                          fillColor:
                                          Colors.white.withOpacity(.1),
                                          inputMaxLength: LeooAppConfigJunPro
                                              .leooTextSize200JunPro),
                                      LeooButtonWidgetJunPro(
                                        S
                                            .of(context)
                                            .withdrawFull,
                                        LeooTextJunPro
                                            .leooGetTextStyleAppJunPro(
                                            20, FontWeight.bold),
                                        mainAxisSize: MainAxisSize.min,
                                        onPressed:
                                        LeooNavigatorUtilsJunPro
                                            .leooDebounceJunPro(() {
                                          amount = userProvider.userEntity
                                              .commissionAmount;
                                          LeooCodeUtilsJunPro.onSetState(
                                              this);
                                        }),
                                      ),
                                    ],
                                  ),
                                  SizedBox(height: 10.w),
                                  Text.rich(
                                      TextSpan(
                                        text: S
                                            .of(context)
                                            .withdrawAmountTip,
                                        style: LeooTextJunPro
                                            .leooGetTextStyleHintJunPro(
                                            16),
                                        children: <TextSpan>[
                                          TextSpan(
                                              text:
                                              '\$${LeooCodeUtilsJunPro
                                                  .leooFormatNumJunPro(
                                                  userProvider.userEntity
                                                      .commissionAmount ?? 0,
                                                  2)}',
                                              style: LeooTextJunPro
                                                  .leooGetTextStyleJunPro(
                                                  16))
                                        ],
                                      ),
                                      softWrap: true),
                                  SizedBox(height: 10.w),
                                  Text(
                                    S
                                        .of(context)
                                        .withdrawTip,
                                    style: LeooTextJunPro
                                        .leooGetTextStyleHintJunPro(16),
                                  ),
                                ],
                              ),
                              SizedBox(height: 60.w),
                              Padding(
                                padding: EdgeInsets.only(
                                    left: 20.w, right: 20.w),
                                child: LeooButtonWidgetJunPro(
                                  S
                                      .of(context)
                                      .appSubmit,
                                  LeooTextJunPro.leooGetTextStyleJunPro(
                                      20, FontWeight.bold),
                                  color: LeooColorsJunPro.leooAppJunPro,
                                  colorRight:
                                  LeooColorsJunPro.leooApp2JunPro,
                                  shape: const RoundedRectangleBorder(
                                    borderRadius: BorderRadius.all(
                                        Radius.circular(20)),
                                  ),
                                  onPressed: LeooNavigatorUtilsJunPro
                                      .leooDebounceJunPro(() {
                                    if (payeeMethodId == null) {
                                      LeooCommonUtilsJunPro
                                          .leooShowCustomToastJunPro(
                                          S
                                              .of(context)
                                              .withdrawMethodTip,
                                          true);
                                    } else if (payeeName?.isEmpty !=
                                        false) {
                                      LeooCommonUtilsJunPro
                                          .leooShowCustomToastJunPro(
                                          S
                                              .of(context)
                                              .withdrawNameHint,
                                          true);
                                    } else if (account?.isEmpty !=
                                        false) {
                                      LeooCommonUtilsJunPro
                                          .leooShowCustomToastJunPro(
                                          S
                                              .of(context)
                                              .withdrawAccountHint,
                                          true);
                                    } else {
                                      LeooDialogUtilsJunPro.instance
                                          .showLoadingDialog(context);
                                      LeooMainDaoJunPro
                                          .leooWithdrawRequestJunPro(
                                          payeeMethodId,
                                          payeeName,
                                          account,
                                          amount)
                                          .then((res) {
                                        Navigator.pop(context);
                                        if (res.result) {
                                          SpUtil.putInt(
                                              LeooAppConfigJunPro
                                                  .leooWithTypeJunPro,
                                              payeeMethodId!);
                                          SpUtil.putString(
                                              LeooAppConfigJunPro
                                                  .leooWithNameJunPro,
                                              payeeName!);
                                          SpUtil.putString(
                                              LeooAppConfigJunPro
                                                  .leooWithAccountJunPro,
                                              account!);
                                          LeooCommonUtilsJunPro
                                              .leooShowCustomToastJunPro(S
                                              .of(context)
                                              .appComplete(S
                                              .of(context)
                                              .withdraw));
                                          Navigator.pop(context);
                                        } else {
                                          LeooCommonUtilsJunPro
                                              .leooShowErrorToastJunPro(
                                              res);
                                        }
                                      });
                                    }
                                  }),
                                ),
                              ),
                            ],
                          ),
                        ),
                      ),
                    ),
                    const LeooKeyBoardHeightWidgetJunPro(),
                  ],
                ),
              ),
            ));
      },
    );
  }

  Widget getLabelChildWidget(LeooLanguageEntity item) {
    return InkWell(
      child: Container(
          decoration: ShapeDecoration(
            color: payeeMethodId == item.id
                ? LeooColorsJunPro.leooAppJunPro
                : LeooColorsJunPro.leooBtnBgJunPro,
            shape: const RoundedRectangleBorder(
              borderRadius: BorderRadius.all(Radius.circular(20)),
            ),
          ),
          padding: EdgeInsets.fromLTRB(25.w, 14.w, 25.w, 14.w),
          child: Text(
            item.name ?? '',
            style: payeeMethodId == item.id
                ? LeooTextJunPro.leooGetTextStyleJunPro(18, FontWeight.bold)
                : LeooTextJunPro.leooGetTextStyleHintJunPro(
                18, FontWeight.bold),
          )),
      onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
        payeeMethodId = item.id;
        LeooCodeUtilsJunPro.onSetState(this);
      }),
    );
  }
}
