import 'package:flutter/material.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leooappconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoomaindaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leootalkentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoowidgetutilsjunpro.dart';
import 'package:pull_to_refresh/pull_to_refresh.dart';

///match more
class LeooMsgCallJunPro extends StatefulWidget {
  const LeooMsgCallJunPro({Key? key}) : super(key: key);

  @override
  _LeooMsgCallState createState() => _LeooMsgCallState();
}

class _LeooMsgCallState extends State<LeooMsgCallJunPro>
    with AutomaticKeepAliveClientMixin<LeooMsgCallJunPro> {
  @override
  bool get wantKeepAlive => true;

  final RefreshController _refreshController = RefreshController();
  List<LeooTalkEntity> matchList = [];
  int page = 1;
  int status = LeooCommonUtilsJunPro.leooPageStatusLoadingJunPro;

  void getMatchList() {
    LeooMainDaoJunPro.leooListTalkedJunPro(page).then((res) {
      if (res.result) {
        if (page == 1) {
          matchList.clear();
        }
        matchList.addAll(res.data);
        if (matchList.isEmpty) {
          status = LeooCommonUtilsJunPro.leooPageStatusEmptyJunPro;
        } else {
          status = LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro;
        }
        LeooCodeUtilsJunPro.onSetState(this);
        if (page == 1) {
          _refreshController.refreshCompleted();
          _refreshController.loadComplete();
        } else if (res.data.isEmpty) {
          _refreshController.loadNoData();
        } else {
          _refreshController.loadComplete();
        }
      } else {
        if (matchList.isEmpty) {
          status = LeooCommonUtilsJunPro.leooPageStatusErrorJunPro;
          LeooCodeUtilsJunPro.onSetState(this);
        } else if (page == 1) {
          _refreshController.refreshFailed();
        } else {
          _refreshController.loadFailed();
        }
        LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
      }
    });
  }

  @override
  void initState() {
    super.initState();
    getMatchList();
  }

  @override
  Widget build(BuildContext context) {
    super.build(context);
    return status != LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro
        ? LeooCommonUtilsJunPro.leooCheckPageStatusJunPro(
            context,
            status,
            onTap: () {
              status = LeooCommonUtilsJunPro.leooPageStatusLoadingJunPro;
              LeooCodeUtilsJunPro.onSetState(this);
              getMatchList();
            },
          )
        : SmartRefresher(
            controller: _refreshController,
            header: const ClassicHeader(),
            footer: const ClassicFooter(),
            enablePullUp:
                matchList.length >= LeooAppConfigJunPro.leooListSizeJunPro,
            onRefresh: () {
              page = 1;
              getMatchList();
            },
            onLoading: () {
              page++;
              getMatchList();
            },
            child: ListView.builder(
                physics: const BouncingScrollPhysics(),
                itemCount: matchList.length,
                itemBuilder: (BuildContext itemContext, int index) {
                  return LeooWidgetUtilsJunPro.leooGetListTalkChildWidgetJunPro(
                      context,
                      matchList[index],
                      '${matchList[index].talkingId}call$index');
                }),
          );
  }
}
