import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leooproviderjunpro/leoouserproviderjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoowidgetutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoocustomtabsjunpro.dart'
    as custom_tabs;
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leootabbarwidgetjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoomsgjunpro/leoomsgcalljunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoomsgjunpro/leoomsglistjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoomsgjunpro/leoomsgmatjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leootopjunpro/leootopjunpro.dart';
import 'package:provider/provider.dart';

///列表
class LeooMsgJunPro extends StatefulWidget {
  const LeooMsgJunPro({Key? key}) : super(key: key);

  @override
  _LeooMsgState createState() => _LeooMsgState();
}

class _LeooMsgState extends State<LeooMsgJunPro>
    with AutomaticKeepAliveClientMixin<LeooMsgJunPro> {
  @override
  bool get wantKeepAlive => true;

  @override
  Widget build(BuildContext context) {
    super.build(context);
    return Consumer<LeooUserProviderJunPro>(
        builder: (_, LeooUserProviderJunPro userProvider, __) {
      return SafeArea(
        maintainBottomViewPadding: true,
        child: Stack(
          children: [
            LeooTabBarWidgetJunPro(
              [
                custom_tabs.Tab(text: S.of(context).msgMessage),
                custom_tabs.Tab(text: S.of(context).msgCall),
                custom_tabs.Tab(text: S.of(context).msgMatch),
              ],
              [
                const LeooMsgListJunPro(),
                const LeooMsgCallJunPro(),
                const LeooMsgMatJunPro(),
              ],
              type: LeooTabBarWidgetJunPro.leooTaoTopJunPro,
              isScrollable: true,
              top: false,
              alignment: Alignment.bottomLeft,
              margin: EdgeInsets.only(left: 5.w, right: .3.sw, bottom: 10.w),
              padding: EdgeInsets.only(top: 10.w),
              indicatorColor: LeooColorsJunPro.leooAppJunPro,
              unselectedLabelColor: LeooColorsJunPro.leooTextJunPro,
              onPageChanged: (index) {},
            ),
            Positioned(
              top: 11.w,
              right: 15.w,
              child: userProvider.userEntity.userType == 0
                  ? LeooWidgetUtilsJunPro.leooGetMainCoinsWidgetJunPro(
                      context, userProvider.userEntity.amount)
                  : IconButton(
                      iconSize: 40.w,
                      padding: const EdgeInsets.all(0),
                      icon: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                        LeooIconsJunPro.leooMainRankJunPro,
                        width: 40.w,
                        height: 40.w,
                      ),
                      onPressed:
                          LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                        LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
                            context, const LeooTopJunPro(), 'LeooTopJunPro');
                      }),
                    ),
            ),
          ],
        ),
      );
    });
  }
}
