import 'dart:async';

import 'package:collection/collection.dart';
import 'package:flutter/material.dart';
import 'package:flutter_slidable/flutter_slidable.dart';
import 'package:im_flutter_sdk/im_flutter_sdk.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leooappconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leoonetconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoomaindaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoouserentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooeventjunpro/leooindexjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooeventjunpro/leoomaineventjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooproviderjunpro/leoouserproviderjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leooimutils.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoovideoutilsjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoocalljunpro/leoochatjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoocalljunpro/leooitemjunpro/leooconversationlistjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leooinfojunpro/leooinfojunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoomsgjunpro/leooitemjunpro/leooconversationlistitemjunpro.dart';
import 'package:leoo_junpro/leoorouterjunpro.dart';
import 'package:provider/provider.dart';
import 'package:pull_to_refresh/pull_to_refresh.dart';

///列表-mode
class LeooMsgListJunPro extends StatefulWidget {
  const LeooMsgListJunPro({Key? key}) : super(key: key);

  @override
  _LeooMsgListState createState() => _LeooMsgListState();
}

class _LeooMsgListState extends State<LeooMsgListJunPro>
    with
        AutomaticKeepAliveClientMixin<LeooMsgListJunPro>,
        LeooConversationListItemDelegateJunPro,
        OnImPluginDelegate,
        RouteAware {
  @override
  bool get wantKeepAlive => true;

  final RefreshController _refreshController = RefreshController();
  int page = 1;
  List<EMConversation> allList = [];
  List<ConversationList> conList = [];
  int status = LeooCommonUtilsJunPro.leooPageStatusLoadingJunPro;

  late StreamSubscription subscription;

  @override
  void initState() {
    super.initState();
    LeooImUtilsJunPro.instance.imPluginDelegateList.add(this);
    subscription = eventBus.on<LeooMsgListEventJunPro>().listen((event) {
      updateConversationList(true);
    });
    updateConversationList(true);
  }

  @override
  void didChangeDependencies() {
    super.didChangeDependencies();
    LeooRouterJunPro.leooRouteObserverJunPro
        .subscribe(this, ModalRoute.of(context) as PageRoute<dynamic>);
  }

  @override
  void didPopNext() {
    super.didPopNext();
    LeooCommonUtilsJunPro.leooCheckIsCurrentJunPro(context, () {
      updateConversationList(true);
    });
  }

  @override
  void dispose() {
    subscription.cancel();
    LeooRouterJunPro.leooRouteObserverJunPro.unsubscribe(this);
    LeooImUtilsJunPro.instance.imPluginDelegateList.remove(this);
    super.dispose();
  }

  void updateConversationList([bool update = false]) async {
    if (update) {
      page = 1;
    } else {
      page++;
    }
    Future.delayed(const Duration(milliseconds: 500), () async {
      if (await EMClient.getInstance.isConnected()) {
        try {
          if (page == 1) {
            allList =
                await EMClient.getInstance.chatManager.loadAllConversations();
            if (allList.isEmpty) {
              allList = await EMClient.getInstance.chatManager
                  .getConversationsFromServer();
            }
          }
          List<EMConversation> nextList = allList.sublist(
              (page - 1) * LeooAppConfigJunPro.leooListSizeJunPro,
              page * LeooAppConfigJunPro.leooListSizeJunPro > allList.length
                  ? allList.length
                  : page * LeooAppConfigJunPro.leooListSizeJunPro);
          if (nextList.isNotEmpty) {
            bool update = false;
            nextList.removeWhere((element) {
              if (element.type != EMConversationType.Chat) {
                try {
                  element.markAllMessagesAsRead();
                } catch (e) {
                  LeooNetConfigJunPro.leooPrintLogJunPro(e);
                }
                update = true;
                return true;
              } else {
                return false;
              }
            });
            if (update) {
              eventBus.fire(LeooMainUnReadEventJunPro());
            }
            List<ConversationList> listName = [];
            listName.addAll(conList);
            if (page == 1) {
              conList.clear();
            }
            Map<String, int> userIdsMap = {};
            for (int i = 0; i < nextList.length; i++) {
              EMConversation item = nextList[i];
              EMUserInfo userInfo = EMUserInfo(item.id);
              var have = listName
                  .firstWhereOrNull((element) => item.id == element.info.id);
              if (have != null) {
                userInfo = have.userInfo;
              } else {
                userIdsMap[item.id] = i;
              }
              conList.add(ConversationList.obtain(item, userInfo));
            }
            if (userIdsMap.isNotEmpty) {
              Map<String?, EMUserInfo?> userMap = await EMClient
                  .getInstance.userInfoManager
                  .fetchUserInfoById(userIdsMap.keys.toList());
              userMap.forEach((key, value) {
                var msg = conList[userIdsMap[key]!];
                if (value?.nickName?.isEmpty == false) {
                  msg.userInfo = value!;
                  userIdsMap.remove(key);
                }
              });
            }
            if (userIdsMap.isNotEmpty) {
              List<int> userIds =
                  userIdsMap.keys.map((e) => int.parse(e)).toList();
              var res =
                  await LeooMainDaoJunPro.leooListJunPro(1, userIds: userIds);
              if (res.result) {
                List<LeooUserEntity> userInfos = res.data;
                for (var value in userInfos) {
                  var msg = conList[userIdsMap[value.id.toString()]!];
                  EMUserInfo userInfo = EMUserInfo(value.id.toString(),
                      nickName: value.nickname, avatarUrl: value.header);
                  msg.userInfo = userInfo;
                }
              }
            }
            eventBus.fire(LeooMainUnReadEventJunPro());
          }
          refreshUI(nextList.length < LeooAppConfigJunPro.leooListSizeJunPro);
        } catch (e) {
          LeooNetConfigJunPro.leooPrintLogJunPro(e);
          status = LeooCommonUtilsJunPro.leooPageStatusErrorJunPro;
          LeooCodeUtilsJunPro.onSetState(this);
        }
      } else if (conList.isEmpty ||
          status != LeooCommonUtilsJunPro.leooPageStatusErrorJunPro) {
        status = LeooCommonUtilsJunPro.leooPageStatusErrorJunPro;
        LeooCodeUtilsJunPro.onSetState(this);
      }
    });
  }

  void refreshUI(bool noData) {
    if (conList.isEmpty) {
      status = LeooCommonUtilsJunPro.leooPageStatusEmptyJunPro;
    } else {
      status = LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro;
    }
    LeooCodeUtilsJunPro.onSetState(this);
    if (page == 1) {
      _refreshController.refreshCompleted();
      _refreshController.loadComplete();
    } else if (noData) {
      _refreshController.loadNoData();
    } else {
      _refreshController.loadComplete();
    }
  }

  @override
  Widget build(BuildContext context) {
    super.build(context);
    return Consumer<LeooUserProviderJunPro>(
        builder: (_, LeooUserProviderJunPro userProvider, __) {
      return status != LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro
          ? LeooCommonUtilsJunPro.leooCheckPageStatusJunPro(
              context,
              status,
              onTap: () {
                status = LeooCommonUtilsJunPro.leooPageStatusLoadingJunPro;
                LeooCodeUtilsJunPro.onSetState(this);
                updateConversationList(true);
              },
              emptyIcon: LeooIconsJunPro.leooEmptyMessageJunPro,
              empty: S.of(context).emptyMessage,
            )
          : SlidableAutoCloseBehavior(
              child: SmartRefresher(
                controller: _refreshController,
                header: const ClassicHeader(),
                footer: const ClassicFooter(),
                enablePullUp:
                    conList.length >= LeooAppConfigJunPro.leooListSizeJunPro,
                onRefresh: () {
                  updateConversationList(true);
                },
                onLoading: () {
                  updateConversationList();
                },
                child: ListView.builder(
                    physics: const BouncingScrollPhysics(),
                    itemCount: conList.length,
                    itemBuilder: (BuildContext itemContext, int itemIndex) {
                      ConversationList item = conList[itemIndex];
                      return Slidable(
                        key: ValueKey(item.info.id),
                        groupTag: item.info.id,
                        enabled: LeooAppConfigJunPro.leooCustomerIdJunPro
                                .toString() !=
                            item.userInfo.userId,
                        child: LeooConversationListItemJunPro(
                          item,
                          delegate: this,
                        ),
                        endActionPane: ActionPane(
                          extentRatio: .32,
                          motion: const DrawerMotion(),
                          dragDismissible: false,
                          children: [
                            CustomSlidableAction(
                              onPressed: (BuildContext context) {
                                LeooUserEntity infoEntity = LeooUserEntity(
                                  id: int.parse(item.info.id),
                                  nickname: item.userInfo.nickName,
                                  header: item.userInfo.avatarUrl,
                                );
                                LeooVideoUtilsJunPro.instance
                                    .requestVideoPermission(
                                        context, int.parse(item.info.id),
                                        infoEntity: infoEntity);
                              },
                              backgroundColor: LeooColorsJunPro.leooAppJunPro,
                              child:
                                  LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                                LeooIconsJunPro.leooInfoVideoJunPro,
                              ),
                            ),
                            CustomSlidableAction(
                              onPressed: (BuildContext context) {
                                eventBus.fire(LeooMainUnReadEventJunPro());
                                conList.removeAt(itemIndex);
                                if (conList.isEmpty) {
                                  status = LeooCommonUtilsJunPro
                                      .leooPageStatusEmptyJunPro;
                                }
                                LeooCodeUtilsJunPro.onSetState(this);
                                try {
                                  EMClient.getInstance.chatManager
                                      .deleteConversation(item.info.id);
                                } catch (e) {
                                  LeooNetConfigJunPro.leooPrintLogJunPro(e);
                                }
                              },
                              backgroundColor: LeooColorsJunPro.leooRedJunPro,
                              child:
                                  LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                                      LeooIconsJunPro.leooMsgListDeleteJunPro),
                            ),
                          ],
                        ),
                      );
                    }),
              ),
            );
    });
  }

  @override
  void didTapConversation(ConversationList item, String hero) {
    LeooUserEntity infoEntity = LeooUserEntity(
        id: int.parse(item.info.id),
        nickname: item.userInfo.nickName,
        header: item.userInfo.avatarUrl);
    LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
        context,
        LeooChatJunPro(int.parse(item.info.id), infoEntity, hero),
        'LeooChatJunPro',
        add: true);
  }

  @override
  void didTapHeadConversation(ConversationList item, String hero) {
    if (LeooAppConfigJunPro.leooCustomerIdJunPro.toString() !=
        item.userInfo.userId) {
      LeooUserEntity infoEntity = LeooUserEntity(
          id: int.parse(item.info.id),
          nickname: item.userInfo.nickName,
          header: item.userInfo.avatarUrl);
      LeooNavigatorUtilsJunPro.leooInfoPageJunPro?.call(
              context, int.parse(item.info.id), infoEntity: infoEntity) ??
          LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
              context,
              LeooInfoJunPro(int.parse(item.info.id), infoEntity, hero),
              'LeooInfoJunPro',
              add: true);
    } else {
      didTapConversation(item, hero);
    }
  }

  @override
  void onMessageReceived(List<EMMessage?> messages) {
    updateConversationList(true);
  }

  @override
  void onConnectionStatusChange(bool connected) {
    if (!connected) {
      status = LeooCommonUtilsJunPro.leooPageStatusLoadingJunPro;
      LeooCodeUtilsJunPro.onSetState(this);
    } else {
      updateConversationList(true);
    }
  }
}
