import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:im_flutter_sdk/im_flutter_sdk.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leooappconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoomaindaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoouserentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoodialogutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoowidgetutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoobuttonwidgetjunpro.dart';
import 'package:pull_to_refresh/pull_to_refresh.dart';

///黑名单
class LeooBlacklistJunPro extends StatefulWidget {
  const LeooBlacklistJunPro({Key? key}) : super(key: key);

  @override
  _LeooBlacklistState createState() => _LeooBlacklistState();
}

class _LeooBlacklistState extends State<LeooBlacklistJunPro> {
  final RefreshController _refreshController = RefreshController();
  List<LeooUserEntity> blackList = [];
  int page = 1;
  int status = LeooCommonUtilsJunPro.leooPageStatusLoadingJunPro;

  void getBlackList() {
    LeooMainDaoJunPro.leooListBlacklistJunPro(page).then((res) {
      if (res.result) {
        if (page == 1) {
          blackList.clear();
        }
        blackList.addAll(res.data);
        if (blackList.isEmpty) {
          status = LeooCommonUtilsJunPro.leooPageStatusEmptyJunPro;
        } else {
          status = LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro;
        }
        LeooCodeUtilsJunPro.onSetState(this);
        if (page == 1) {
          _refreshController.refreshCompleted();
          _refreshController.loadComplete();
        } else if (res.data.isEmpty) {
          _refreshController.loadNoData();
        } else {
          _refreshController.loadComplete();
        }
      } else {
        if (blackList.isEmpty) {
          status = LeooCommonUtilsJunPro.leooPageStatusErrorJunPro;
          LeooCodeUtilsJunPro.onSetState(this);
        } else if (page == 1) {
          _refreshController.refreshFailed();
        } else {
          _refreshController.loadFailed();
        }
        LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
      }
    });
  }

  @override
  void initState() {
    super.initState();
    getBlackList();
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      resizeToAvoidBottomInset: false,
      body: SafeArea(
        maintainBottomViewPadding: true,
        child: Column(
          children: <Widget>[
            LeooWidgetUtilsJunPro.leooGetAppBarWidgetJunPro(
                context, S.of(context).blacklist),
            Expanded(
              child: status != LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro
                  ? LeooCommonUtilsJunPro.leooCheckPageStatusJunPro(
                      context,
                      status,
                      onTap: () {
                        status =
                            LeooCommonUtilsJunPro.leooPageStatusLoadingJunPro;
                        LeooCodeUtilsJunPro.onSetState(this);
                        getBlackList();
                      },
                    )
                  : SmartRefresher(
                      controller: _refreshController,
                      header: const ClassicHeader(),
                      footer: const ClassicFooter(),
                      enablePullUp: blackList.length >=
                          LeooAppConfigJunPro.leooListSizeJunPro,
                      onRefresh: () {
                        page = 1;
                        getBlackList();
                      },
                      onLoading: () {
                        page++;
                        getBlackList();
                      },
                      child: ListView.builder(
                          physics: const BouncingScrollPhysics(),
                          itemCount: blackList.length,
                          itemBuilder: (BuildContext itemContext, int index) {
                            return getListChildWidget(blackList[index], index);
                          }),
                    ),
            )
          ],
        ),
      ),
    );
  }

  Widget getListChildWidget(LeooUserEntity item, int index) {
    return Padding(
      padding: EdgeInsets.all(15.w),
      child: Row(
        children: <Widget>[
          ClipOval(
            child: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
              item.header,
              width: 50.w,
              height: 50.w,
              load: LeooIconsJunPro.leooLoadHeadJunPro,
            ),
          ),
          SizedBox(width: 10.w),
          Expanded(
            child: Text(item.getNameAge(),
                style:
                    LeooTextJunPro.leooGetTextStyleJunPro(20, FontWeight.bold),
                maxLines: 1,
                overflow: TextOverflow.ellipsis),
          ),
          SizedBox(width: 10.w),
          LeooButtonWidgetJunPro(
            S.of(context).blackRemove,
            LeooTextJunPro.leooGetTextStyleJunPro(16, FontWeight.bold),
            color: LeooColorsJunPro.leooRedJunPro,
            shape: const RoundedRectangleBorder(
              borderRadius: BorderRadius.all(Radius.circular(12)),
            ),
            padding: EdgeInsets.fromLTRB(15.5.w, 5.5.w, 15.5.w, 5.5.w),
            onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
              LeooDialogUtilsJunPro.instance.showLoadingDialog(context);
              LeooMainDaoJunPro.leooCancelBlacklistJunPro(item.id).then((res) {
                Navigator.pop(context);
                if (res.result) {
                  blackList.removeAt(index);
                  if (blackList.isEmpty) {
                    status = LeooCommonUtilsJunPro.leooPageStatusEmptyJunPro;
                  }
                  EMClient.getInstance.contactManager
                      .removeUserFromBlockList(item.id.toString());
                  LeooCodeUtilsJunPro.onSetState(this);
                  LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
                      S.of(context).appComplete(S.of(context).blackCancel));
                } else {
                  LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
                }
              });
            }),
          ),
        ],
      ),
    );
  }
}
