import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leooappconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoowidgetutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoobuttonwidgetjunpro.dart';

///客服联系页面
class LeooCustomerJunPro extends StatefulWidget {
  const LeooCustomerJunPro({Key? key}) : super(key: key);

  @override
  _LeooCustomerState createState() => _LeooCustomerState();
}

class _LeooCustomerState extends State<LeooCustomerJunPro> {
  @override
  Widget build(BuildContext context) {
    return Scaffold(
      resizeToAvoidBottomInset: false,
      body: SafeArea(
        maintainBottomViewPadding: true,
        child: Column(
          children: <Widget>[
            LeooWidgetUtilsJunPro.leooGetAppBarWidgetJunPro(
                context, S.of(context).mineCustomer),
            Expanded(
              child: Column(
                children: [
                  SizedBox(height: 30.w),
                  LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                      LeooIconsJunPro.leooCustomerJunPro,
                      width: 90.w,
                      height: 90.w),
                  SizedBox(height: 20.w),
                  LeooButtonWidgetJunPro(
                    LeooAppConfigJunPro.getLeooCustomerEmailJunPro(),
                    LeooTextJunPro.leooGetTextStyleJunPro(16, FontWeight.w600),
                    mainAxisSize: MainAxisSize.min,
                    iconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                        LeooIconsJunPro.leooCustomerCopyJunPro,
                        width: 40.w,
                        height: 40.w),
                    iconPadding: 4.w,
                    padding: EdgeInsets.fromLTRB(32.w, 5.w, 5.w, 5.w),
                    color: LeooColorsJunPro.leooPopBgJunPro,
                    shape: const RoundedRectangleBorder(
                      borderRadius: BorderRadius.all(Radius.circular(20)),
                    ),
                    right: true,
                    onPressed: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() =>
                        LeooCommonUtilsJunPro.leooCopyJunPro(context,
                            LeooAppConfigJunPro.getLeooCustomerEmailJunPro())),
                  ),
                  Padding(
                      padding: EdgeInsets.fromLTRB(40.w, 10.w, 40.w, 60.w),
                      child: Text(S.of(context).customerTip,
                          style: LeooTextJunPro.leooGetTextStyleHintJunPro(16),
                          textAlign: TextAlign.center)),
                  Padding(
                    padding: EdgeInsets.only(left: 35.w, right: 35.w),
                    child: LeooButtonWidgetJunPro(
                      S.of(context).customerContact,
                      LeooTextJunPro.leooGetTextStyleJunPro(
                          20, FontWeight.bold),
                      color: LeooColorsJunPro.leooAppJunPro,
                      colorRight: LeooColorsJunPro.leooApp2JunPro,
                      shape: const RoundedRectangleBorder(
                        borderRadius: BorderRadius.all(Radius.circular(20)),
                      ),
                      onPressed:
                          LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                        LeooCommonUtilsJunPro.leooLaunchOutURLJunPro(context,
                            'mailto:${LeooAppConfigJunPro.getLeooCustomerEmailJunPro()}',
                            email: true);
                      }),
                    ),
                  ),
                ],
              ),
            )
          ],
        ),
      ),
    );
  }
}
