import 'package:firebase_analytics/firebase_analytics.dart';
import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leooappconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoomaindaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoonetjunpro/leooapphostjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoodialogutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoowidgetutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoobuttonwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leooedittextwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoowidgetjunpro/leookeyboardheightwidgetjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoosetjunpro/leoocustomerjunpro.dart';

///删除账号
class LeooDeleteJunPro extends StatefulWidget {
  const LeooDeleteJunPro({Key? key}) : super(key: key);

  @override
  _LeooDeleteState createState() => _LeooDeleteState();
}

class _LeooDeleteState extends State<LeooDeleteJunPro> {
  String? checkItem;
  String? moreString;
  FocusNode focusNode = FocusNode();

  @override
  void initState() {
    super.initState();
    FirebaseAnalytics.instance.logEvent(name: '用户来到删除账号');
  }

  void chipClick(String name, bool choice) {
    if (choice) {
      checkItem = name;
    } else {
      checkItem = null;
    }
    LeooCodeUtilsJunPro.onSetState(this);
  }

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
        behavior: HitTestBehavior.opaque,
        onTap: () {
          focusNode.unfocus();
        },
        child: Scaffold(
          resizeToAvoidBottomInset: false,
          body: SafeArea(
            maintainBottomViewPadding: true,
            child: Column(
              children: <Widget>[
                LeooWidgetUtilsJunPro.leooGetAppBarWidgetJunPro(
                    context, S.of(context).delete),
                Expanded(
                  child: SingleChildScrollView(
                    physics: const BouncingScrollPhysics(),
                    child: Padding(
                      padding: EdgeInsets.all(15.w),
                      child: Column(
                        children: <Widget>[
                          Column(
                            mainAxisAlignment: MainAxisAlignment.spaceAround,
                            crossAxisAlignment: CrossAxisAlignment.start,
                            children: <Widget>[
                              Text(
                                S.of(context).deleteWhy,
                                style: LeooTextJunPro.leooGetTextStyleJunPro(
                                    20, FontWeight.bold),
                              ),
                              SizedBox(height: 10.w),
                              Wrap(
                                spacing: 15.w,
                                runSpacing: 15.w,
                                children: <Widget>[
                                  getLabelChildWidget(
                                      S.of(context).deleteItem1),
                                  getLabelChildWidget(
                                      S.of(context).deleteItem2),
                                  getLabelChildWidget(S.of(context).deleteItem3)
                                ],
                              ),
                              SizedBox(height: 20.w),
                              Text(
                                S.of(context).deleteMore,
                                style: LeooTextJunPro.leooGetTextStyleJunPro(
                                    20, FontWeight.bold),
                              ),
                              SizedBox(height: 10.w),
                              LeooEditTextWidgetJunPro(
                                  keyboardType: ITextInputType.text,
                                  hintText: S.of(context).deleteMoreTip,
                                  hintStyle:
                                      LeooTextJunPro.leooGetTextStyleHintJunPro(
                                          18, FontWeight.bold),
                                  minLines: 6,
                                  maxLines: 6,
                                  inputText: moreString ?? '',
                                  textStyle:
                                      LeooTextJunPro.leooGetTextStyleJunPro(
                                          18, FontWeight.bold),
                                  fieldCallBack: (content) {
                                    moreString = content;
                                    LeooCodeUtilsJunPro.onSetState(this);
                                  },
                                  focusNode: focusNode,
                                  inputBorder: OutlineInputBorder(
                                    borderSide: BorderSide.none,
                                    borderRadius: BorderRadius.circular(20),
                                  ),
                                  contentPadding: EdgeInsets.all(15.w),
                                  fillColor: Colors.white.withOpacity(.1),
                                  inputMaxLength:
                                      LeooAppConfigJunPro.leooTextSize200JunPro)
                            ],
                          ),
                          SizedBox(height: 60.w),
                          Padding(
                            padding: EdgeInsets.only(left: 20.w, right: 20.w),
                            child: LeooButtonWidgetJunPro(
                              S.of(context).mineCustomer,
                              LeooTextJunPro.leooGetTextStyleBlackJunPro(
                                  20, FontWeight.bold),
                              color: Colors.white,
                              iconPadding: 2.5.w,
                              iconData:
                                  LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                                LeooIconsJunPro.leooCustomerItemJunPro,
                                width: 24.w,
                                height: 24.w,
                              ),
                              shape: const RoundedRectangleBorder(
                                borderRadius:
                                    BorderRadius.all(Radius.circular(20)),
                              ),
                              onPressed:
                                  LeooNavigatorUtilsJunPro.leooDebounceJunPro(
                                      () {
                                LeooNavigatorUtilsJunPro
                                    .leooNavigatorPushJunPro(
                                        context,
                                        const LeooCustomerJunPro(),
                                        'LeooCustomerJunPro');
                              }),
                            ),
                          ),
                          LeooButtonWidgetJunPro(
                            S.of(context).delete,
                            LeooTextJunPro.leooGetTextStyleRedJunPro(
                                20, FontWeight.bold),
                            onPressed:
                                LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                              if (checkItem?.isEmpty != false) {
                                LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
                                    S.of(context).deleteTypeTip, true);
                              } else if (moreString?.isEmpty != false) {
                                LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
                                    S.of(context).deleteWord, true);
                              } else if (LeooAppHostJunPro.leooModeJunPro &&
                                  moreString!.length < 50) {
                                LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
                                    S.of(context).deleteWord50, true);
                              } else {
                                LeooDialogUtilsJunPro.instance
                                    .showCustomDialog(context,
                                        content: S.of(context).deleteTitle,
                                        right: S.of(context).deleteOk)
                                    .then((value) {
                                  if (value == true) {
                                    LeooDialogUtilsJunPro.instance
                                        .showLoadingDialog(context);
                                    LeooMainDaoJunPro.leooDeleteJunPro(
                                            '$checkItem,$moreString')
                                        .then((res) {
                                      Navigator.pop(context);
                                      if (res.result) {
                                        LeooCommonUtilsJunPro
                                            .leooShowCustomToastJunPro(S
                                                .of(context)
                                                .appComplete(
                                                    S.of(context).delete));
                                        LeooNavigatorUtilsJunPro
                                            .leooGoSplashJunPro(context);
                                      } else {
                                        LeooCommonUtilsJunPro
                                            .leooShowErrorToastJunPro(res);
                                      }
                                    });
                                  }
                                });
                              }
                            }),
                          ),
                          Padding(
                            padding: EdgeInsets.only(left: 50.w, right: 50.w),
                            child: Text(S.of(context).deleteTip,
                                style: LeooTextJunPro.leooGetTextStyleRedJunPro(
                                    16),
                                textAlign: TextAlign.center),
                          ),
                        ],
                      ),
                    ),
                  ),
                ),
                const LeooKeyBoardHeightWidgetJunPro(),
              ],
            ),
          ),
        ));
  }

  Widget getLabelChildWidget(String item) {
    return InkWell(
      child: Container(
        decoration: ShapeDecoration(
          color: checkItem == item
              ? LeooColorsJunPro.leooAppJunPro
              : LeooColorsJunPro.leooBtnBgJunPro,
          shape: const RoundedRectangleBorder(
            borderRadius: BorderRadius.all(Radius.circular(20)),
          ),
        ),
        padding: EdgeInsets.fromLTRB(25.w, 14.w, 25.w, 14.w),
        child: Text(
          item,
          style: checkItem == item
              ? LeooTextJunPro.leooGetTextStyleJunPro(18, FontWeight.bold)
              : LeooTextJunPro.leooGetTextStyleHintJunPro(18, FontWeight.bold),
        ),
      ),
      onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(
          () => chipClick(item, checkItem != item)),
    );
  }
}
