import 'package:flutter/material.dart';
import 'package:flutter_html/flutter_html.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoowidgetutilsjunpro.dart';

class LeooFAQJunPro extends StatefulWidget {
  const LeooFAQJunPro({Key? key}) : super(key: key);

  @override
  _LeooFAQState createState() => _LeooFAQState();
}

class _LeooFAQState extends State<LeooFAQJunPro> {
  int status = LeooCommonUtilsJunPro.leooPageStatusLoadingJunPro;
  String faqString = '''
    <h1>
      <span style="font-size:18px;color:#FFE500;"><strong>Recharge</strong></span>
    </h1>
    <p class="MsoNormal">
        <strong>1. How to buy coins.</strong>
    </p>
    <p class="MsoNormal">
        ME→BUY COINS
    </p>
    <p class="MsoNormal">
        <strong>2. I&nbsp;purchase&nbsp;coins&nbsp;and&nbsp;it&nbsp;was
    not been credited to my account.</strong>
    </p>
    <p class="MsoNormal">
        You can try to reboot your phone first, or
    contact our customer service provide the screenshot of recharge, our customer service representative will help you with it.
    </p>
    <p class="MsoNormal">
        <strong>3. I want a refund.</strong>
    </p>
    <p class="MsoNormal">
        Sorry, the coins you get after recharging can only be used for making calls.
    Due to technical obstacles, we do not provide refund service for the time
    being, please recharge carefully.
    </p>
    <p class="MsoNormal">
        <strong>4. Subscription paid but not effective</strong>
    </p>
    <p class="MsoNormal">
        Click the &quot;Subscribe&quot; button in
    the personal center to subscribe. If the subscription payment is completed but
    not effective, you can find &quot;Purchases restored&quot; in
    &quot;Settings&quot;.For Manual recovery, if it still does not
    take effect, please contact customer service representative.
    </p>
    <p class="MsoNormal">
        <strong>5.Why can&#39;t I buy coins or subscribe</strong>
    </p>
    <p class="MsoNormal">
        Check your network and update the app to
    the latest version.Restart the app or restart the device.Contact google play or app store to check
    if your account is activated.If the above 3 steps do not work, please
    contact our customer service or leave a message in the feedback to provide
    us with your phone model and operating system version, we will get in touch with you and
    solve your problem.
    </p>
    <p class="MsoNormal">
        <br/>
    </p>
    <h1>
        <span style="font-size:18px;color:#FFE500;"><strong>Account</strong></span>
    </h1>
    <p class="MsoListParagraph" style="margin-left:18.0pt;text-indent:-18.0pt;">
        <strong>1.&nbsp;</strong><strong>Why is my account blocked?</strong>
    </p>
    <p class="MsoNormal">
        All blocked accounts are caused by illegal
    use of APP, such as involving child pornography or malicious bad reviews, etc.&nbsp;
    </p>
    <p class="MsoListParagraph" style="margin-left:18.0pt;text-indent:-18.0pt;">
        <strong>2.&nbsp;</strong><strong>Multiple account issues</strong>
    </p>
    <p class="MsoNormal">
        Only 3 accounts can be registered for one
    device. If the system prompts you to have multiple accounts, please log in with
    your previously registered account.
    </p>
    <p class="MsoListParagraph" style="margin-left:18.0pt;text-indent:-18.0pt;">
        <strong>3.&nbsp;</strong><strong>How&nbsp;to&nbsp;delete/remove&nbsp;my&nbsp;account</strong>
    </p>
    <p class="MsoNormal">
        Sorry, we currently do not support the
    function of deleting accounts. Rest assured that your personal account
    information and privacy are completely confidential. If you don’t want to use
    the app, please uninstall it.
    </p>
    <p class="MsoNormal">
        <br/>
    </p>
    <h1>
        <span style="font-size:18px;color:#FFE500;"><strong>Call problem</strong></span>
    </h1>
    <p class="MsoListParagraph" style="margin-left:18.0pt;text-indent:-18.0pt;">
        <strong>1.&nbsp;</strong><strong>Why can&#39;t I make a video call?</strong>
    </p>
    <p class="MsoNormal">
        Make sure you have authorized the app to
    access your phone&#39;s camera and microphone.Make sure your internet connection is
    normal.Reinstall or update our app to the latest version.If none of the above methods work, please
    contact customer service or leave a message in feedback and provide us with
    your phone model and operating system. The customer specialist will get in
    touch with you to solve your problem.
    </p>
    <p class="MsoListParagraph" style="margin-left:18.0pt;text-indent:-18.0pt;">
        <strong>2.&nbsp;</strong><strong>Are&nbsp;there&nbsp;males&nbsp;on&nbsp;here/how&nbsp;can&nbsp;I&nbsp;chat&nbsp;with&nbsp;males?</strong>
    </p>
    <p class="MsoNormal">
        Sorry currently this app only has female
    models.
    </p>
    <p class="MsoNormal">
        <br/>
    </p>
  ''';

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      resizeToAvoidBottomInset: false,
      body: SafeArea(
        maintainBottomViewPadding: true,
        child: Column(
          children: <Widget>[
            LeooWidgetUtilsJunPro.leooGetAppBarWidgetJunPro(
                context, S.of(context).mineFAQ),
            Expanded(
              child: SingleChildScrollView(
                physics: const BouncingScrollPhysics(),
                child: Column(
                  children: [
                    Html(
                      data: faqString,
                      style: {
                        'html': Style(color: LeooColorsJunPro.leooTextJunPro),
                      },
                    ),
                  ],
                ),
              ),
            ),
          ],
        ),
      ),
    );
  }
}
