import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leooappconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoomaindaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoodialogutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoowidgetutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoobuttonwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leooedittextwidgetjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoowidgetjunpro/leookeyboardheightwidgetjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoosetjunpro/leoocustomerjunpro.dart';

///反馈
class LeooFeedbackJunPro extends StatefulWidget {
  const LeooFeedbackJunPro({Key? key}) : super(key: key);

  @override
  _LeooFeedbackState createState() => _LeooFeedbackState();
}

class _LeooFeedbackState extends State<LeooFeedbackJunPro> {
  String? checkItem;
  String? moreString;
  FocusNode focusNode = FocusNode();

  void chipClick(String item, bool choice) {
    if (choice) {
      checkItem = item;
    } else {
      checkItem = null;
    }
    LeooCodeUtilsJunPro.onSetState(this);
  }

  @override
  Widget build(BuildContext context) {
    return GestureDetector(
        behavior: HitTestBehavior.opaque,
        onTap: () {
          focusNode.unfocus();
        },
        child: Scaffold(
          resizeToAvoidBottomInset: false,
          body: SafeArea(
            maintainBottomViewPadding: true,
            child: Column(
              children: <Widget>[
                LeooWidgetUtilsJunPro.leooGetAppBarWidgetJunPro(
                    context, S.of(context).feed),
                Expanded(
                  child: SingleChildScrollView(
                    physics: const BouncingScrollPhysics(),
                    child: Padding(
                      padding: EdgeInsets.all(15.w),
                      child: Column(
                        children: <Widget>[
                          Column(
                            mainAxisAlignment: MainAxisAlignment.spaceAround,
                            crossAxisAlignment: CrossAxisAlignment.start,
                            children: <Widget>[
                              Text(
                                S.of(context).feedQuesTitle,
                                style: LeooTextJunPro.leooGetTextStyleJunPro(
                                    20, FontWeight.bold),
                              ),
                              SizedBox(height: 10.w),
                              Wrap(
                                spacing: 15.w,
                                runSpacing: 15.w,
                                children: <Widget>[
                                  getLabelChildWidget(S.of(context).feedQues1),
                                  getLabelChildWidget(S.of(context).feedQues2),
                                  getLabelChildWidget(S.of(context).feedQues3),
                                ],
                              ),
                              SizedBox(height: 20.w),
                              Text(
                                S.of(context).feedOtherTitle,
                                style: LeooTextJunPro.leooGetTextStyleJunPro(
                                    20, FontWeight.bold),
                              ),
                              SizedBox(height: 10.w),
                              LeooEditTextWidgetJunPro(
                                  keyboardType: ITextInputType.text,
                                  hintText: S.of(context).feedOtherTip,
                                  hintStyle:
                                      LeooTextJunPro.leooGetTextStyleHintJunPro(
                                          18, FontWeight.bold),
                                  minLines: 6,
                                  maxLines: 6,
                                  inputText: moreString ?? '',
                                  textStyle:
                                      LeooTextJunPro.leooGetTextStyleJunPro(
                                          18, FontWeight.bold),
                                  fieldCallBack: (content) {
                                    moreString = content;
                                    LeooCodeUtilsJunPro.onSetState(this);
                                  },
                                  focusNode: focusNode,
                                  inputBorder: OutlineInputBorder(
                                    borderSide: BorderSide.none,
                                    borderRadius: BorderRadius.circular(20),
                                  ),
                                  contentPadding: EdgeInsets.all(15.w),
                                  fillColor: Colors.white.withOpacity(.1),
                                  inputMaxLength: LeooAppConfigJunPro
                                      .leooTextSize200JunPro),
                            ],
                          ),
                          SizedBox(height: 60.w),
                          Padding(
                            padding: EdgeInsets.only(left: 20.w, right: 20.w),
                            child: LeooButtonWidgetJunPro(
                              S.of(context).appSubmit,
                              LeooTextJunPro.leooGetTextStyleJunPro(
                                  20, FontWeight.bold),
                              color: LeooColorsJunPro.leooAppJunPro,
                              colorRight: LeooColorsJunPro.leooApp2JunPro,
                              shape: const RoundedRectangleBorder(
                                borderRadius:
                                    BorderRadius.all(Radius.circular(20)),
                              ),
                              onPressed:
                                  LeooNavigatorUtilsJunPro.leooDebounceJunPro(
                                      () {
                                if (checkItem == null) {
                                  LeooCommonUtilsJunPro
                                      .leooShowCustomToastJunPro(
                                          S.of(context).feedQuesTypeTip, true);
                                } else if (moreString?.isEmpty != false) {
                                  LeooCommonUtilsJunPro
                                      .leooShowCustomToastJunPro(
                                          S.of(context).feedOtherTip2, true);
                                } else {
                                  LeooDialogUtilsJunPro.instance
                                      .showLoadingDialog(context);
                                  LeooMainDaoJunPro.leooFeedBackJunPro(
                                          '$checkItem,$moreString')
                                      .then((res) {
                                    Navigator.pop(context);
                                    if (res.result) {
                                      LeooCommonUtilsJunPro
                                          .leooShowCustomToastJunPro(S
                                              .of(context)
                                              .appComplete(S.of(context).feed));
                                      Navigator.pop(context);
                                    } else {
                                      LeooCommonUtilsJunPro
                                          .leooShowErrorToastJunPro(res);
                                    }
                                  });
                                }
                              }),
                            ),
                          ),
                          SizedBox(height: 15.w),
                          Padding(
                            padding: EdgeInsets.only(left: 20.w, right: 20.w),
                            child: LeooButtonWidgetJunPro(
                              S.of(context).mineCustomer,
                              LeooTextJunPro.leooGetTextStyleBlackJunPro(
                                  20, FontWeight.bold),
                              color: Colors.white,
                              iconPadding: 2.5.w,
                              iconData:
                                  LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                                LeooIconsJunPro.leooCustomerItemJunPro,
                                width: 24.w,
                                height: 24.w,
                              ),
                              shape: const RoundedRectangleBorder(
                                borderRadius:
                                    BorderRadius.all(Radius.circular(20)),
                              ),
                              onPressed:
                                  LeooNavigatorUtilsJunPro.leooDebounceJunPro(
                                      () {
                                LeooNavigatorUtilsJunPro
                                    .leooNavigatorPushJunPro(
                                        context,
                                        const LeooCustomerJunPro(),
                                        'LeooCustomerJunPro');
                              }),
                            ),
                          ),
                        ],
                      ),
                    ),
                  ),
                ),
                const LeooKeyBoardHeightWidgetJunPro(),
              ],
            ),
          ),
        ));
  }

  Widget getLabelChildWidget(String item) {
    return InkWell(
      child: Container(
        decoration: ShapeDecoration(
          color: checkItem == item
              ? LeooColorsJunPro.leooAppJunPro
              : LeooColorsJunPro.leooBtnBgJunPro,
          shape: const RoundedRectangleBorder(
            borderRadius: BorderRadius.all(Radius.circular(20)),
          ),
        ),
        padding: EdgeInsets.fromLTRB(25.w, 14.w, 25.w, 14.w),
        child: Text(
          item,
          style: checkItem == item
              ? LeooTextJunPro.leooGetTextStyleJunPro(18, FontWeight.bold)
              : LeooTextJunPro.leooGetTextStyleHintJunPro(18, FontWeight.bold),
        ),
      ),
      onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
        chipClick(item, checkItem != item);
      }),
    );
  }
}
