import 'dart:io';

import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:in_app_update/in_app_update.dart';
import 'package:launch_review/launch_review.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leooappjunpro/leoonetconfigjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoonetjunpro/leooapphostjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooproviderjunpro/leoothemeproviderjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooproviderjunpro/leoouserproviderjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoodialogutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoomediautilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoowidgetutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoobuttonwidgetjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoomainjunpro/leoomainjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoomainjunpro/leoowebviewjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoosetjunpro/leoocustomerjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leoosetjunpro/leoodeletejunpro.dart';
import 'package:path_provider/path_provider.dart';
import 'package:provider/provider.dart';
import 'package:video_compress/video_compress.dart';

///设置
class LeooSettingJunPro extends StatefulWidget {
  const LeooSettingJunPro({Key? key}) : super(key: key);

  @override
  _LeooSettingState createState() => _LeooSettingState();
}

class _LeooSettingState extends State<LeooSettingJunPro> {
  String? _cacheSizeStr;
  bool updateAvailable = false;
  bool availableVersionCode = false;

  @override
  void initState() {
    super.initState();
    loadCache();
    if (Platform.isAndroid) {
      InAppUpdate.checkForUpdate().then((info) {
        LeooNetConfigJunPro.leooPrintLogJunPro(
            'checkForUpdate: ${info.toString()}');
        availableVersionCode = info.availableVersionCode != null;
        updateAvailable =
            info.updateAvailability == UpdateAvailability.updateAvailable;
        LeooCodeUtilsJunPro.onSetState(this);
      }).catchError((e) {
        LeooNetConfigJunPro.leooPrintLogJunPro(
            'checkForUpdate catchError: ${e.toString()}');
      });
    }
  }

  @override
  Widget build(BuildContext context) {
    return Consumer2<LeooUserProviderJunPro, LeooThemeProviderJunPro>(builder:
        (_, LeooUserProviderJunPro userProvider,
            LeooThemeProviderJunPro themeProvider, __) {
      return Scaffold(
        resizeToAvoidBottomInset: false,
        body: SafeArea(
          maintainBottomViewPadding: true,
          child: Column(
            children: <Widget>[
              LeooWidgetUtilsJunPro.leooGetAppBarWidgetJunPro(
                  context, S.of(context).setting),
              Expanded(
                child: SingleChildScrollView(
                  physics: const BouncingScrollPhysics(),
                  child: Column(
                    crossAxisAlignment: CrossAxisAlignment.center,
                    children: <Widget>[
                      LeooButtonWidgetJunPro(
                        S.of(context).mineCustomer,
                        LeooTextJunPro.leooGetTextStyleJunPro(
                            16, FontWeight.bold),
                        mainAxisAlignment: MainAxisAlignment.spaceBetween,
                        iconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                          LeooIconsJunPro.leooMineRightJunPro,
                          width: 40.w,
                          height: 40.w,
                        ),
                        padding: EdgeInsets.fromLTRB(15.w, 10.w, 15.w, 10.w),
                        right: true,
                        textExpanded: true,
                        onPressed:
                            LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                          LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
                              context,
                              const LeooCustomerJunPro(),
                              'LeooCustomerJunPro');
                        }),
                      ),
                      LeooButtonWidgetJunPro(
                        S.of(context).splashTerm,
                        LeooTextJunPro.leooGetTextStyleJunPro(
                            16, FontWeight.bold),
                        mainAxisAlignment: MainAxisAlignment.spaceBetween,
                        iconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                          LeooIconsJunPro.leooMineRightJunPro,
                          width: 40.w,
                          height: 40.w,
                        ),
                        padding: EdgeInsets.fromLTRB(15.w, 10.w, 15.w, 10.w),
                        right: true,
                        textExpanded: true,
                        onPressed:
                            LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                          LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
                              context,
                              LeooWebViewJunPro(S.of(context).splashTerm,
                                  LeooNetConfigJunPro.leooTermsUrlJunPro),
                              'LeooWebViewJunPro');
                        }),
                      ),
                      LeooButtonWidgetJunPro(
                        S.of(context).splashPrivacy,
                        LeooTextJunPro.leooGetTextStyleJunPro(
                            16, FontWeight.bold),
                        mainAxisAlignment: MainAxisAlignment.spaceBetween,
                        iconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                          LeooIconsJunPro.leooMineRightJunPro,
                          width: 40.w,
                          height: 40.w,
                        ),
                        padding: EdgeInsets.fromLTRB(15.w, 10.w, 15.w, 10.w),
                        right: true,
                        textExpanded: true,
                        onPressed:
                            LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                          return LeooNavigatorUtilsJunPro
                              .leooNavigatorPushJunPro(
                                  context,
                                  LeooWebViewJunPro(S.of(context).splashPrivacy,
                                      LeooNetConfigJunPro.leooPrivacyUrlJunPro),
                                  'LeooWebViewJunPro');
                        }),
                      ),
                      LeooButtonWidgetJunPro(
                        Platform.isAndroid
                            ? S.of(context).rateG
                            : S.of(context).rateA,
                        LeooTextJunPro.leooGetTextStyleJunPro(
                            16, FontWeight.bold),
                        mainAxisAlignment: MainAxisAlignment.spaceBetween,
                        iconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                          LeooIconsJunPro.leooMineRightJunPro,
                          width: 40.w,
                          height: 40.w,
                        ),
                        padding: EdgeInsets.fromLTRB(15.w, 10.w, 15.w, 10.w),
                        right: true,
                        textExpanded: true,
                        onPressed:
                            LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                          LaunchReview.launch(
                              androidAppId: LeooNetConfigJunPro.leooAppIdJunPro,
                              iOSAppId: LeooNetConfigJunPro.leooIosIdJunPro);
                        }),
                      ),
                      Stack(
                        alignment: Alignment.centerRight,
                        children: <Widget>[
                          Positioned(
                              right: 60.w,
                              child: Text(_cacheSizeStr ?? '',
                                  style:
                                      LeooTextJunPro.leooGetTextStyleHintJunPro(
                                          16))),
                          LeooButtonWidgetJunPro(
                            S.of(context).cache,
                            LeooTextJunPro.leooGetTextStyleJunPro(
                                16, FontWeight.bold),
                            mainAxisAlignment: MainAxisAlignment.spaceBetween,
                            iconData:
                                LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                              LeooIconsJunPro.leooMineRightJunPro,
                              width: 40.w,
                              height: 40.w,
                            ),
                            padding:
                                EdgeInsets.fromLTRB(15.w, 10.w, 15.w, 10.w),
                            right: true,
                            textExpanded: true,
                            onPressed:
                                LeooNavigatorUtilsJunPro.leooDebounceJunPro(
                                    () => clearCache()),
                          ),
                        ],
                      ),
                      LeooButtonWidgetJunPro(
                        S.of(context).delete,
                        LeooTextJunPro.leooGetTextStyleJunPro(
                            16, FontWeight.bold),
                        mainAxisAlignment: MainAxisAlignment.spaceBetween,
                        iconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                          LeooIconsJunPro.leooMineRightJunPro,
                          width: 40.w,
                          height: 40.w,
                        ),
                        padding: EdgeInsets.fromLTRB(15.w, 10.w, 15.w, 10.w),
                        right: true,
                        textExpanded: true,
                        onPressed:
                            LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                          LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(
                              context,
                              const LeooDeleteJunPro(),
                              'LeooDeleteJunPro');
                        }),
                      ),
                      Stack(
                        alignment: Alignment.centerRight,
                        children: <Widget>[
                          Positioned(
                              right: 60.w,
                              child: Text(
                                  LeooAppHostJunPro.leooModeJunPro &&
                                          (updateAvailable ||
                                              LeooMainJunPro.leooUpdateJunPro)
                                      ? S.of(context).versionNew
                                      : '${LeooMediaUtilsJunPro.instance.packageInfo.version} (${LeooMediaUtilsJunPro.instance.packageInfo.buildNumber})',
                                  style: LeooAppHostJunPro.leooModeJunPro &&
                                          (updateAvailable ||
                                              LeooMainJunPro.leooUpdateJunPro)
                                      ? LeooTextJunPro
                                          .leooGetTextStyleAppJunPro(16)
                                      : LeooTextJunPro
                                          .leooGetTextStyleHintJunPro(16))),
                          LeooButtonWidgetJunPro(
                            S.of(context).version,
                            LeooTextJunPro.leooGetTextStyleJunPro(
                                16, FontWeight.bold),
                            mainAxisAlignment: MainAxisAlignment.spaceBetween,
                            iconData:
                                LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                              LeooIconsJunPro.leooMineRightJunPro,
                              width: 40.w,
                              height: 40.w,
                            ),
                            padding:
                                EdgeInsets.fromLTRB(15.w, 10.w, 15.w, 10.w),
                            right: true,
                            textExpanded: true,
                            onPressed:
                                LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                              if (LeooAppHostJunPro.leooModeJunPro) {
                                if (updateAvailable) {
                                  InAppUpdate.startFlexibleUpdate();
                                } else {
                                  LeooCommonUtilsJunPro
                                      .leooShowCustomToastJunPro(
                                          S.of(context).versionNo);
                                }
                              }
                            }),
                          ),
                        ],
                      ),
                      SizedBox(height: 80.w),
                      Padding(
                        padding: EdgeInsets.only(
                          left: 35.w,
                          right: 35.w,
                        ),
                        child: LeooButtonWidgetJunPro(
                          S.of(context).out,
                          LeooTextJunPro.leooGetTextStyleJunPro(
                              20, FontWeight.bold),
                          color: LeooColorsJunPro.leooAppJunPro,
                          colorRight: LeooColorsJunPro.leooApp2JunPro,
                          shape: const RoundedRectangleBorder(
                            borderRadius: BorderRadius.all(Radius.circular(20)),
                          ),
                          onPressed:
                              LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
                            showExitDialog();
                          }),
                        ),
                      ),
                    ],
                  ),
                ),
              )
            ],
          ),
        ),
      );
    });
  }

  void showExitDialog() {
    LeooDialogUtilsJunPro.instance
        .showCustomDialog(context,
            content: S.of(context).outTitle, right: S.of(context).out)
        .then((value) {
      if (value == true) {
        LeooNavigatorUtilsJunPro.leooGoSplashJunPro(context);
      }
    });
  }

  ///加载缓存
  Future loadCache() async {
    try {
      Directory tempDir = await getTemporaryDirectory();
      double value = await _getTotalSizeOfFilesInDir(tempDir);
      LeooNetConfigJunPro.leooPrintLogJunPro('临时目录大小: ' + value.toString());
      _cacheSizeStr = _renderSize(value);
      LeooCodeUtilsJunPro.onSetState(this);
    } catch (err) {
      LeooNetConfigJunPro.leooPrintLogJunPro(err);
    }
  }

  /// 递归方式 计算文件的大小
  Future<double> _getTotalSizeOfFilesInDir(final FileSystemEntity file) async {
    try {
      if (file is File) {
        int length = await file.length();
        return double.parse(length.toString());
      }
      if (file is Directory) {
        final List<FileSystemEntity> children = file.listSync();
        double total = 0;
        for (final FileSystemEntity child in children) {
          total += await _getTotalSizeOfFilesInDir(child);
        }
        return total;
      }
      return 0;
    } catch (e) {
      LeooNetConfigJunPro.leooPrintLogJunPro(e);
      return 0;
    }
  }

  void clearCache() async {
    //此处展示加载loading
    LeooDialogUtilsJunPro.instance.showLoadingDialog(context);
    try {
      Directory tempDir = await getTemporaryDirectory();
      //删除缓存目录
      await delDir(tempDir);
      await loadCache();
      await VideoCompress.deleteAllCache();
      LeooCommonUtilsJunPro.leooShowCustomToastJunPro(
          S.of(context).appComplete(S.of(context).cache));
    } catch (e) {
      LeooNetConfigJunPro.leooPrintLogJunPro(e);
      LeooCommonUtilsJunPro.leooShowCustomToastJunPro(S.of(context).cacheErr);
    } finally {
      //此处隐藏加载loading
      Navigator.pop(context);
    }
  }

  ///递归方式删除目录
  Future delDir(FileSystemEntity file) async {
    try {
      if (file is Directory) {
        final List<FileSystemEntity> children = file.listSync();
        for (final FileSystemEntity child in children) {
          await delDir(child);
        }
      }
      await file.delete();
    } catch (e) {
      LeooNetConfigJunPro.leooPrintLogJunPro(e);
    }
  }

  ///格式化文件大小
  _renderSize(double value) {
    List<String> unitArr = ['B', 'K', 'M', 'G'];
    int index = 0;
    while (value > 1024) {
      index++;
      value = value / 1024;
    }
    String size = value.toStringAsFixed(2);
    return size + unitArr[index];
  }
}
