import 'package:flutter/cupertino.dart';
import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/generated/l10n.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leoocustomtabsjunpro.dart'
    as custom_tabs;
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leootabbarwidgetjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leootopjunpro/leootoplistjunpro.dart';

///排行榜
class LeooTopItemJunPro extends StatefulWidget {
  final int index;

  const LeooTopItemJunPro(this.index, {Key? key}) : super(key: key);

  @override
  _LeooTopItemState createState() => _LeooTopItemState();
}

class _LeooTopItemState extends State<LeooTopItemJunPro>
    with AutomaticKeepAliveClientMixin<LeooTopItemJunPro> {
  @override
  bool get wantKeepAlive => true;

  @override
  Widget build(BuildContext context) {
    super.build(context);
    return LeooTabBarWidgetJunPro(
      [
        custom_tabs.Tab(text: S.of(context).topDaily),
        custom_tabs.Tab(text: S.of(context).topWeek),
        custom_tabs.Tab(text: S.of(context).topMonthly),
      ],
      [
        LeooTopListJunPro(widget.index, 1),
        LeooTopListJunPro(widget.index, 7),
        LeooTopListJunPro(widget.index, 30),
      ],
      type: LeooTabBarWidgetJunPro.leooTaoTop2JunPro,
      alignment: Alignment.bottomCenter,
      isScrollable: true,
      height: 35.w,
      indicatorHeight: 40.w,
      margin: EdgeInsets.only(top: 10.w, bottom: 10.w),
    );
  }
}
