import 'package:flutter/material.dart';
import 'package:flutter_screenutil/flutter_screenutil.dart';
import 'package:leoo_junpro/leooflagjunpro/leoodaojunpro/leoomaindaojunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leootopentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leooentityjunpro/leoouserentity.dart';
import 'package:leoo_junpro/leooflagjunpro/leoostringjunpro/leoostylejunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocodeutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoocommonutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leooutilsjunpro/leoonavigatorutilsjunpro.dart';
import 'package:leoo_junpro/leooflagjunpro/leoowidgetjunpro/leootextwidgetjunpro.dart';
import 'package:leoo_junpro/leooimpjunpro/leooinfojunpro/leooinfojunpro.dart';
import 'package:leoo_junpro/leoorouterjunpro.dart';
import 'package:pull_to_refresh/pull_to_refresh.dart';

///排行榜列表
class LeooTopListJunPro extends StatefulWidget {
  final int index;
  final int days;

  const LeooTopListJunPro(this.index, this.days, {Key? key}) : super(key: key);

  @override
  _LeooTopListState createState() => _LeooTopListState();
}

class _LeooTopListState extends State<LeooTopListJunPro>
    with RouteAware, AutomaticKeepAliveClientMixin<LeooTopListJunPro> {
  @override
  bool get wantKeepAlive => true;
  final RefreshController _refreshController = RefreshController();
  List<LeooTopEntity> topList = [];
  int status = LeooCommonUtilsJunPro.leooPageStatusLoadingJunPro;

  void getTopList() {
    LeooMainDaoJunPro.leooTopListJunPro(widget.index, widget.days).then((res) {
      if (res.result) {
        topList = res.data;
        if (topList.isEmpty) {
          status = LeooCommonUtilsJunPro.leooPageStatusEmptyJunPro;
        } else {
          status = LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro;
        }
        LeooCodeUtilsJunPro.onSetState(this);
        _refreshController.refreshCompleted();
        _refreshController.loadComplete();
      } else {
        if (topList.isEmpty) {
          status = LeooCommonUtilsJunPro.leooPageStatusErrorJunPro;
          LeooCodeUtilsJunPro.onSetState(this);
        } else {
          _refreshController.refreshFailed();
        }
        LeooCommonUtilsJunPro.leooShowErrorToastJunPro(res);
      }
    });
  }

  @override
  void initState() {
    super.initState();
    getTopList();
  }

  @override
  void didChangeDependencies() {
    super.didChangeDependencies();
    LeooRouterJunPro.leooRouteObserverJunPro
        .subscribe(this, ModalRoute.of(context) as PageRoute<dynamic>);
  }

  @override
  void didPopNext() {
    super.didPopNext();
    LeooCommonUtilsJunPro.leooCheckIsCurrentJunPro(context, () {
      getTopList();
    });
  }

  @override
  void dispose() {
    LeooRouterJunPro.leooRouteObserverJunPro.unsubscribe(this);
    super.dispose();
  }

  @override
  Widget build(BuildContext context) {
    super.build(context);
    return status != LeooCommonUtilsJunPro.leooPageStatusSuccessJunPro
        ? Padding(
            padding: EdgeInsets.only(top: 70.w),
            child: LeooCommonUtilsJunPro.leooCheckPageStatusJunPro(
              context,
              status,
              onTap: () {
                status = LeooCommonUtilsJunPro.leooPageStatusLoadingJunPro;
                LeooCodeUtilsJunPro.onSetState(this);
                getTopList();
              },
            ),
          )
        : SmartRefresher(
            controller: _refreshController,
            header: const ClassicHeader(),
            footer: const ClassicFooter(),
            enablePullUp: false,
            onRefresh: () {
              getTopList();
            },
            child: SingleChildScrollView(
              physics: const BouncingScrollPhysics(),
              child: Column(
                children: [
                  SizedBox(height: 10.w),
                  Row(
                    children: [
                      SizedBox(width: 20.w),
                      Expanded(
                        child: topList.length > 1
                            ? getTopChildWidget(2, topList[1])
                            : Container(),
                      ),
                      Expanded(
                        child: getTopChildWidget(1, topList[0]),
                      ),
                      Expanded(
                        child: topList.length > 2
                            ? getTopChildWidget(3, topList[2])
                            : Container(),
                      ),
                      SizedBox(width: 20.w),
                    ],
                  ),
                  SizedBox(height: 22.w),
                  if (topList.length > 3)
                    ListView.builder(
                        physics: const BouncingScrollPhysics(),
                        itemCount: topList.length - 3,
                        shrinkWrap: true,
                        itemBuilder: (BuildContext itemContext, int index) {
                          LeooTopEntity item = topList[index + 3];
                          return getListChildWidget(index + 4, item,
                              '${widget.index}${widget.days}${item.userId}topList${index + 3}');
                        }),
                ],
              ),
            ),
          );
  }

  Widget getTopChildWidget(int index, LeooTopEntity item) {
    String hero = '${widget.index}${widget.days}${item.userId}topList$index';
    return InkWell(
      child: Column(
        children: [
          Padding(
            padding: EdgeInsets.only(
                top: index == 1
                    ? 0
                    : index == 2
                        ? 20.w
                        : 40.w),
            child: Stack(
              alignment: Alignment.topRight,
              children: [
                Hero(
                  tag: hero,
                  transitionOnUserGestures: true,
                  child: Container(
                    width: index == 1 ? 90.w : 80.w,
                    height: index == 1 ? 90.w : 80.w,
                    decoration: ShapeDecoration(
                      shape: CircleBorder(
                        side: BorderSide(
                          color: index == 1
                              ? LeooColorsJunPro.leooTopHead1JunPro
                              : index == 2
                                  ? LeooColorsJunPro.leooTopHead2JunPro
                                  : LeooColorsJunPro.leooTopHead3JunPro,
                          width: 3.w,
                        ),
                      ),
                    ),
                    child: ClipOval(
                      child: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                        item.header,
                        width: index == 1 ? 90.w : 80.w,
                        height: index == 1 ? 90.w : 80.w,
                        load: LeooIconsJunPro.leooLoadHeadJunPro,
                      ),
                    ),
                  ),
                ),
                LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                  LeooIconsJunPro.leooTopJunPro +
                      '$index' +
                      LeooIconsJunPro.leooImageEndUrlJunPro,
                  width: 20.w,
                  height: 20.w,
                ),
              ],
            ),
          ),
          SizedBox(height: 10.w),
          Text(item.nickname ?? '',
              style: LeooTextJunPro.leooGetTextStyleJunPro(20, FontWeight.bold),
              maxLines: 1,
              overflow: TextOverflow.ellipsis),
          SizedBox(height: 5.w),
          LeooTextWidgetJunPro(
            '${item.value}',
            LeooTextJunPro.leooGetTextStyleJunPro(16, FontWeight.bold),
            iconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                LeooIconsJunPro.leooTopItemJunPro +
                    '${widget.index}' +
                    LeooIconsJunPro.leooImageEndUrlJunPro,
                width: 24.w,
                height: 24.w),
            padding: EdgeInsets.only(right: 10.w),
            decoration: ShapeDecoration(
              shape: const StadiumBorder(),
              color: Colors.black.withOpacity(.2),
            ),
            iconPadding: 2.5.w,
            mainAxisSize: MainAxisSize.min,
          ),
        ],
      ),
      onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
        LeooUserEntity infoEntity = LeooUserEntity(
          id: item.userId,
          nickname: item.nickname,
          header: item.header,
        );
        LeooNavigatorUtilsJunPro.leooInfoPageJunPro
                ?.call(context, item.userId, infoEntity: infoEntity) ??
            LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(context,
                LeooInfoJunPro(item.userId, infoEntity, hero), 'LeooInfoJunPro',
                add: true);
      }),
    );
  }

  Widget getListChildWidget(int index, LeooTopEntity item, String hero) {
    return InkWell(
      child: Padding(
        padding: EdgeInsets.fromLTRB(0, 15.w, 15.w, 15.w),
        child: Row(
          children: <Widget>[
            SizedBox(
              width: 44.w,
              child: Text('$index',
                  style: LeooTextJunPro.leooGetTextStyleJunPro(
                      20, FontWeight.bold),
                  textAlign: TextAlign.center),
            ),
            Stack(
              alignment: Alignment.centerRight,
              children: [
                Hero(
                  tag: hero,
                  transitionOnUserGestures: true,
                  child: ClipOval(
                    child: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                      item.header,
                      width: 50.w,
                      height: 50.w,
                      load: LeooIconsJunPro.leooLoadHeadJunPro,
                    ),
                  ),
                ),
              ],
            ),
            SizedBox(width: 10.w),
            Expanded(
              child: Text(item.nickname ?? '',
                  style: LeooTextJunPro.leooGetTextStyleJunPro(
                      20, FontWeight.bold),
                  maxLines: 1,
                  overflow: TextOverflow.ellipsis),
            ),
            LeooTextWidgetJunPro(
              '${item.value}',
              LeooTextJunPro.leooGetTextStyleJunPro(16, FontWeight.bold),
              iconData: LeooCommonUtilsJunPro.leooGetLoadWidgetJunPro(
                  LeooIconsJunPro.leooTopItemJunPro +
                      '${widget.index}' +
                      LeooIconsJunPro.leooImageEndUrlJunPro,
                  width: 24.w,
                  height: 24.w),
              padding: EdgeInsets.only(right: 10.w),
              decoration: ShapeDecoration(
                shape: const StadiumBorder(),
                color: Colors.black.withOpacity(.2),
              ),
              iconPadding: 2.5.w,
              mainAxisSize: MainAxisSize.min,
            ),
          ],
        ),
      ),
      onTap: LeooNavigatorUtilsJunPro.leooDebounceJunPro(() {
        LeooUserEntity infoEntity = LeooUserEntity(
          id: item.userId,
          nickname: item.nickname,
          header: item.header,
        );
        LeooNavigatorUtilsJunPro.leooInfoPageJunPro
                ?.call(context, item.userId, infoEntity: infoEntity) ??
            LeooNavigatorUtilsJunPro.leooNavigatorPushJunPro(context,
                LeooInfoJunPro(item.userId, infoEntity, hero), 'LeooInfoJunPro',
                add: true);
      }),
    );
  }
}
